// SocketTools 10 Build 1468
// Copyright 2023 Catalyst Development Corporation
// All rights reserved
// 
// This file is licensed to you pursuant to the terms of the
// product license agreement included with the original software,
// and is protected by copyright law and international treaties.
// Unauthorized reproduction or distribution may result in severe
// criminal penalties.
// 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Data;
using System.Drawing;
using System.Diagnostics;
using System.Windows.Forms;

namespace ListFiles
{
    internal class formMain : System.Windows.Forms.Form 
    { 
        #region "Windows Form Designer generated code "
        public formMain() : base() 
        { 
            // This call is required by the Windows Form Designer.
            InitializeComponent(); 
        } 

        // Form overrides dispose to clean up the component list.
        protected override void Dispose( bool Disposing ) 
        { 
            if ( Disposing ) 
            { 
                if ( !( components == null ) ) 
                { 
                    components.Dispose(); 
                } 
            } 
            base.Dispose( Disposing ); 
        } 
        
        // Required by the Windows Form Designer
        private System.ComponentModel.IContainer components; 
        public System.Windows.Forms.ToolTip ToolTip1; 
        public System.Windows.Forms.RadioButton optText; 
        public System.Windows.Forms.RadioButton optBinary; 
        public System.Windows.Forms.GroupBox frameMode; 
        public System.Windows.Forms.Button cmdView; 
        public System.Windows.Forms.Button cmdClose; 
        public System.Windows.Forms.ListBox listFiles; 
        public System.Windows.Forms.Button cmdDownload; 
        public System.Windows.Forms.Button cmdList; 
        public System.Windows.Forms.TextBox editDirectory; 
        public System.Windows.Forms.Button cmdConnect; 
        public System.Windows.Forms.Label lblDirectory; 
        // NOTE: The following procedure is required by the Windows Form Designer
        // It can be modified using the Windows Form Designer.
        // Do not modify it using the code editor.
        internal System.Windows.Forms.StatusBar sbInfo; 
        internal System.Windows.Forms.ProgressBar pbTransfer; 
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() 
        { 
            this.components = new System.ComponentModel.Container(); 
            this.ToolTip1 = new System.Windows.Forms.ToolTip( this.components ); 
            this.frameMode = new System.Windows.Forms.GroupBox(); 
            this.optText = new System.Windows.Forms.RadioButton(); 
            this.optBinary = new System.Windows.Forms.RadioButton(); 
            this.cmdView = new System.Windows.Forms.Button(); 
            this.cmdClose = new System.Windows.Forms.Button(); 
            this.listFiles = new System.Windows.Forms.ListBox(); 
            this.cmdDownload = new System.Windows.Forms.Button(); 
            this.cmdList = new System.Windows.Forms.Button(); 
            this.editDirectory = new System.Windows.Forms.TextBox(); 
            this.cmdConnect = new System.Windows.Forms.Button(); 
            this.lblDirectory = new System.Windows.Forms.Label(); 
            this.sbInfo = new System.Windows.Forms.StatusBar(); 
            this.pbTransfer = new System.Windows.Forms.ProgressBar(); 
            this.frameMode.SuspendLayout(); 
            this.SuspendLayout(); 
            // 
            // frameMode
            // 
            this.frameMode.BackColor = System.Drawing.SystemColors.Control; 
            this.frameMode.Controls.Add( this.optText ); 
            this.frameMode.Controls.Add( this.optBinary ); 
            this.frameMode.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.frameMode.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.frameMode.Location = new System.Drawing.Point( 396, 220 ); 
            this.frameMode.Name = "frameMode"; 
            this.frameMode.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.frameMode.Size = new System.Drawing.Size( 81, 61 ); 
            this.frameMode.TabIndex = 10; 
            this.frameMode.TabStop = false; 
            this.frameMode.Text = "Mode"; 
            // 
            // optText
            // 
            this.optText.BackColor = System.Drawing.SystemColors.Control; 
            this.optText.Cursor = System.Windows.Forms.Cursors.Default; 
            this.optText.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.optText.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.optText.Location = new System.Drawing.Point( 8, 40 ); 
            this.optText.Name = "optText"; 
            this.optText.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.optText.Size = new System.Drawing.Size( 57, 13 ); 
            this.optText.TabIndex = 12; 
            this.optText.TabStop = true; 
            this.optText.Text = "Text"; 
            // 
            // optBinary
            // 
            this.optBinary.BackColor = System.Drawing.SystemColors.Control; 
            this.optBinary.Checked = true; 
            this.optBinary.Cursor = System.Windows.Forms.Cursors.Default; 
            this.optBinary.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.optBinary.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.optBinary.Location = new System.Drawing.Point( 8, 20 ); 
            this.optBinary.Name = "optBinary"; 
            this.optBinary.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.optBinary.Size = new System.Drawing.Size( 65, 17 ); 
            this.optBinary.TabIndex = 11; 
            this.optBinary.TabStop = true; 
            this.optBinary.Text = "Binary"; 
            // 
            // cmdView
            // 
            this.cmdView.BackColor = System.Drawing.SystemColors.Control; 
            this.cmdView.Cursor = System.Windows.Forms.Cursors.Default; 
            this.cmdView.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.cmdView.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.cmdView.Location = new System.Drawing.Point( 396, 108 ); 
            this.cmdView.Name = "cmdView"; 
            this.cmdView.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.cmdView.Size = new System.Drawing.Size( 81, 25 ); 
            this.cmdView.TabIndex = 9; 
            this.cmdView.Text = "View"; 
            // 
            // cmdClose
            // 
            this.cmdClose.BackColor = System.Drawing.SystemColors.Control; 
            this.cmdClose.Cursor = System.Windows.Forms.Cursors.Default; 
            this.cmdClose.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.cmdClose.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.cmdClose.Location = new System.Drawing.Point( 396, 140 ); 
            this.cmdClose.Name = "cmdClose"; 
            this.cmdClose.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.cmdClose.Size = new System.Drawing.Size( 81, 25 ); 
            this.cmdClose.TabIndex = 8; 
            this.cmdClose.Text = "Close"; 
            // 
            // listFiles
            // 
            this.listFiles.BackColor = System.Drawing.SystemColors.Window; 
            this.listFiles.Cursor = System.Windows.Forms.Cursors.Default; 
            this.listFiles.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.listFiles.ForeColor = System.Drawing.SystemColors.WindowText; 
            this.listFiles.ItemHeight = 14; 
            this.listFiles.Location = new System.Drawing.Point( 12, 44 ); 
            this.listFiles.Name = "listFiles"; 
            this.listFiles.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.listFiles.Size = new System.Drawing.Size( 365, 228 ); 
            this.listFiles.TabIndex = 6; 
            // 
            // cmdDownload
            // 
            this.cmdDownload.BackColor = System.Drawing.SystemColors.Control; 
            this.cmdDownload.Cursor = System.Windows.Forms.Cursors.Default; 
            this.cmdDownload.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.cmdDownload.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.cmdDownload.Location = new System.Drawing.Point( 396, 76 ); 
            this.cmdDownload.Name = "cmdDownload"; 
            this.cmdDownload.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.cmdDownload.Size = new System.Drawing.Size( 81, 25 ); 
            this.cmdDownload.TabIndex = 5; 
            this.cmdDownload.Text = "Download"; 
            // 
            // cmdList
            // 
            this.cmdList.BackColor = System.Drawing.SystemColors.Control; 
            this.cmdList.Cursor = System.Windows.Forms.Cursors.Default; 
            this.cmdList.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.cmdList.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.cmdList.Location = new System.Drawing.Point( 396, 44 ); 
            this.cmdList.Name = "cmdList"; 
            this.cmdList.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.cmdList.Size = new System.Drawing.Size( 81, 25 ); 
            this.cmdList.TabIndex = 4; 
            this.cmdList.Text = "List Files"; 
            // 
            // editDirectory
            // 
            this.editDirectory.AcceptsReturn = true; 
            this.editDirectory.AutoSize = false; 
            this.editDirectory.BackColor = System.Drawing.SystemColors.Window; 
            this.editDirectory.Cursor = System.Windows.Forms.Cursors.IBeam; 
            this.editDirectory.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.editDirectory.ForeColor = System.Drawing.SystemColors.WindowText; 
            this.editDirectory.Location = new System.Drawing.Point( 64, 12 ); 
            this.editDirectory.MaxLength = 0; 
            this.editDirectory.Name = "editDirectory"; 
            this.editDirectory.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.editDirectory.Size = new System.Drawing.Size( 313, 21 ); 
            this.editDirectory.TabIndex = 2; 
            this.editDirectory.Text = ""; 
            // 
            // cmdConnect
            // 
            this.cmdConnect.BackColor = System.Drawing.SystemColors.Control; 
            this.cmdConnect.Cursor = System.Windows.Forms.Cursors.Default; 
            this.cmdConnect.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.cmdConnect.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.cmdConnect.Location = new System.Drawing.Point( 396, 12 ); 
            this.cmdConnect.Name = "cmdConnect"; 
            this.cmdConnect.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.cmdConnect.Size = new System.Drawing.Size( 81, 25 ); 
            this.cmdConnect.TabIndex = 0; 
            this.cmdConnect.Text = "Connect"; 
            // 
            // lblDirectory
            // 
            this.lblDirectory.BackColor = System.Drawing.SystemColors.Control; 
            this.lblDirectory.Cursor = System.Windows.Forms.Cursors.Default; 
            this.lblDirectory.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.lblDirectory.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.lblDirectory.Location = new System.Drawing.Point( 12, 16 ); 
            this.lblDirectory.Name = "lblDirectory"; 
            this.lblDirectory.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.lblDirectory.Size = new System.Drawing.Size( 49, 13 ); 
            this.lblDirectory.TabIndex = 1; 
            this.lblDirectory.Text = "&Directory:"; 
            // 
            // sbInfo
            // 
            this.sbInfo.Location = new System.Drawing.Point( 0, 292 ); 
            this.sbInfo.Name = "sbInfo"; 
            this.sbInfo.Size = new System.Drawing.Size( 487, 22 ); 
            this.sbInfo.TabIndex = 11; 
            // 
            // pbTransfer
            // 
            this.pbTransfer.Location = new System.Drawing.Point( 272, 292 ); 
            this.pbTransfer.Name = "pbTransfer"; 
            this.pbTransfer.Size = new System.Drawing.Size( 200, 20 ); 
            this.pbTransfer.TabIndex = 12; 
            // 
            // formMain
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size( 5, 13 ); 
            this.BackColor = System.Drawing.SystemColors.Control; 
            this.ClientSize = new System.Drawing.Size( 487, 314 ); 
            this.Controls.Add( this.pbTransfer ); 
            this.Controls.Add( this.sbInfo ); 
            this.Controls.Add( this.frameMode ); 
            this.Controls.Add( this.cmdView ); 
            this.Controls.Add( this.cmdClose ); 
            this.Controls.Add( this.listFiles ); 
            this.Controls.Add( this.cmdDownload ); 
            this.Controls.Add( this.cmdList ); 
            this.Controls.Add( this.editDirectory ); 
            this.Controls.Add( this.cmdConnect ); 
            this.Controls.Add( this.lblDirectory ); 
            this.Cursor = System.Windows.Forms.Cursors.Default; 
            this.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog; 
            this.Location = new System.Drawing.Point( 3, 22 ); 
            this.MaximizeBox = false; 
            this.MinimizeBox = false; 
            this.Name = "formMain"; 
            this.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen; 
            this.Text = "SocketTools ListFiles Example"; 
            this.frameMode.ResumeLayout( false ); 
            this.ResumeLayout( false ); 
            
            // events handled by ftpClient_OnProgress
            ftpClient.OnProgress += new SocketTools.FtpClient.OnProgressEventHandler( ftpClient_OnProgress ); 
            // events handled by listFiles_SelectedIndexChanged
            listFiles.SelectedIndexChanged += new System.EventHandler( listFiles_SelectedIndexChanged ); 
            // events handled by listFiles_DoubleClick
            listFiles.DoubleClick += new System.EventHandler( listFiles_DoubleClick ); 
            // events handled by formMain_Load
            base.Load += new System.EventHandler( formMain_Load ); 
            // events handled by editDirectory_Enter
            editDirectory.Enter += new System.EventHandler( editDirectory_Enter ); 
            // events handled by cmdConnect_Click
            cmdConnect.Click += new System.EventHandler( cmdConnect_Click ); 
            // events handled by cmdList_Click
            cmdList.Click += new System.EventHandler( cmdList_Click ); 
            // events handled by cmdDownload_Click
            cmdDownload.Click += new System.EventHandler( cmdDownload_Click ); 
            // events handled by cmdView_Click
            cmdView.Click += new System.EventHandler( cmdView_Click ); 
            // events handled by cmdClose_Click
            cmdClose.Click += new System.EventHandler( cmdClose_Click ); 
        } 
        
		[STAThread]
		public static void Main()
		{
			Application.Run( new formMain() );
		}
		
		#endregion 
        
        private const int ftpParentDirectory = -1; 
        
        private SocketTools.FtpClient ftpClient = new SocketTools.FtpClient(); 
        private SocketTools.FtpClient.FileInformation[] ftpFileList; 
        private int nFileCount = 0; 
        
        private void UpdateForm( bool bEnabled ) 
        { 
            if ( ftpClient.IsConnected ) 
            { 
                cmdConnect.Text = "Disconnect"; 
                cmdConnect.Enabled = true; 
            } 
            else 
            { 
                cmdConnect.Text = "Connect"; 
                cmdConnect.Enabled = true; 
            } 
            
            cmdList.Enabled = bEnabled; 
            cmdDownload.Enabled = bEnabled; 
            cmdView.Enabled = bEnabled; 
            editDirectory.Enabled = bEnabled; 
        } 
        
        
        private void Connect() 
        { 
            formConnect dlgConnect = new formConnect(); 
            int nOptions = 0; 
            bool bConnected = false; 
            
            if ( ftpClient.IsConnected )
             { 
                return; } 
            
            
            listFiles.Items.Clear(); 
            editDirectory.Text = ""; 
            
            //  Show the connection dialog and get the information
            //  needed to call the Connect method
            dlgConnect.ShowDialog(); 
            if ( dlgConnect.Canceled )
                return;
            
            cmdConnect.Enabled = false; 
            
            bConnected = ftpClient.Connect( dlgConnect.HostName, dlgConnect.RemotePort, dlgConnect.UserName, dlgConnect.Password, dlgConnect.Account, dlgConnect.Timeout, ( ( SocketTools.FtpClient.FtpOptions )( dlgConnect.Options ) ) ); 
            
            if ( !( bConnected ) ) 
            { 
                Interaction.MsgBox( ftpClient.LastErrorString, MsgBoxStyle.Exclamation, null ); 
                UpdateForm( false ); 
                return; 
            } 
            
            UpdateFileList(); 
            UpdateForm( true ); 
        } 
        
        
        private void UpdateFileList() 
        { 
            SocketTools.FtpClient.FileInformation fileInfo = new SocketTools.FtpClient.FileInformation(); 
            string strDirectory = null; 
            string strFileName = null; 
            bool bResult = false; 
            
            //  Update the form and clear the listbox while we are
            //  retrieving the file list from the server
            UpdateForm( false ); 
            listFiles.Items.Clear(); 
            sbInfo.Text = ""; 
            
            //  Clear the current list of files and reset the count
            nFileCount = 0; 
            ftpFileList = new SocketTools.FtpClient.FileInformation[ nFileCount + 1 ]; 
            
            //  Update the current working directory that is displayed
            ftpClient.GetDirectory( ref strDirectory ); 
            editDirectory.Text = strDirectory; 
            
            //  Open the current working directory; note that it would
            //  be possible to specify wildcards here if desired
            if ( !( ftpClient.OpenDirectory() ) ) 
            { 
                Interaction.MsgBox( ftpClient.LastErrorString, MsgBoxStyle.Exclamation, null ); 
                UpdateForm( true ); 
                return; 
            } 
            
            //  The first entry in the file list will be the parent
            //  directory; this will allow clients to navigate up
            //  the file system
            listFiles.Items.Add( "[..]" ); 
            
            bResult = ftpClient.GetFirstFile( ref fileInfo ); 
            
            while ( bResult ) 
            {
				if ( fileInfo.FileName != "." && fileInfo.FileName != ".." )
				{
					ftpFileList[ nFileCount ] = fileInfo; 
                
					if ( fileInfo.IsDirectory ) 
					{ 
						strFileName = "[" + fileInfo.FileName + "]"; 
					} 
					else 
					{ 
						strFileName = fileInfo.FileName; 
					} 

					listFiles.Items.Add( strFileName ); 
                
					//  Increase the size of the ftpFileList array and then
					//  return information about the next file
					nFileCount = nFileCount + 1; 
					SocketTools.FtpClient.FileInformation[] tempFileList = new SocketTools.FtpClient.FileInformation[ nFileCount + 1 ]; 
					System.Array.Copy( ftpFileList, tempFileList, Math.Min( ftpFileList.Length, tempFileList.Length ) ); 
					ftpFileList = tempFileList; 
				}
                bResult = ftpClient.GetNextFile( ref fileInfo ); 
            } 
            
            ftpClient.CloseDirectory(); 
            UpdateForm( true ); 
        } 
        
        
        private void ftpClient_OnProgress( object sender, SocketTools.FtpClient.ProgressEventArgs e ) 
        { 
            pbTransfer.Value = e.Percent; 
        } 
        
        
        private void listFiles_SelectedIndexChanged( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            int nIndex = 0; 
            
            if ( nFileCount > 0 ) 
            { 
                nIndex = listFiles.SelectedIndex - 1; 
                
                //  If the index value is ftpParentDirectory then this
                //  is not an actual file in our file list
                if ( nIndex == ftpParentDirectory ) 
                { 
                    sbInfo.Text = ""; 
                    return; 
                } 
                
                if ( ftpFileList[ nIndex ].IsDirectory ) 
                { 
                    sbInfo.Text = ftpFileList[ nIndex ].FileName + " is a directory"; 
                } 
                else 
                { 
                    sbInfo.Text = ftpFileList[ nIndex ].FileName + ", " + System.Convert.ToString( ftpFileList[ nIndex ].FileSize ) + " bytes"; 
                } 
            } 
        } 
        
        
        private void listFiles_DoubleClick( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            int nIndex = 0; 
            bool bIsDirectory = false; 
            string strDirectory = null; 
            
            if ( listFiles.SelectedIndex == -1 )
             { 
                return; } 
            
            
            nIndex = listFiles.SelectedIndex - 1; 
            if ( nIndex == ftpParentDirectory ) 
            { 
                bIsDirectory = true; 
                strDirectory = ".."; 
            } 
            else 
            { 
                bIsDirectory = ftpFileList[ nIndex ].IsDirectory; 
                if ( bIsDirectory ) 
                { 
                    strDirectory = ftpFileList[ nIndex ].FileName; 
                } 
            } 
            
            if ( bIsDirectory ) 
            { 
                UpdateForm( false ); 
                
                if ( !( ftpClient.ChangeDirectory( strDirectory ) ) ) 
                { 
                    Interaction.MsgBox( ftpClient.LastErrorString, MsgBoxStyle.Exclamation, null ); 
                    UpdateForm( true ); 
                    return; 
                } 
                
                UpdateFileList(); 
            } 
            else 
            { 
                //  If a binary transfer mode has been selected, presume
                //  the user wants to store the file; otherwise display
                //  the contents of the file
                if ( optBinary.Checked ) 
                { 
                    DownloadFile(); 
                } 
                else 
                { 
                    ViewFile(); 
                } 
            } 
        } 
        
        
        private void DownloadFile() 
        { 
            SaveFileDialog saveDialog = new SaveFileDialog(); 
            short hFile = 0; 
            string strLocalFile = null; 
            string strRemoteFile = null; 
            int nIndex = 0; 
            
            if ( listFiles.SelectedIndex == -1 )
             { 
                return; } 
            
            
            nIndex = listFiles.SelectedIndex - 1; 
            if ( ftpFileList[ nIndex ].IsDirectory ) 
            { 
                Interaction.MsgBox( "The selected file is a directory", MsgBoxStyle.Exclamation, null ); 
                return; 
            } 
            
            strRemoteFile = ftpFileList[ nIndex ].FileName; 
            
            saveDialog.FileName = strRemoteFile; 
            saveDialog.Filter = "All Files (*.*)|*.*"; 
            saveDialog.OverwritePrompt = true; 
            saveDialog.CheckPathExists = true; 
            
            if ( saveDialog.ShowDialog() != DialogResult.OK ) 
            { 
                return; 
            } 
            
            strLocalFile = saveDialog.FileName; 
            
            UpdateForm( false ); 
            pbTransfer.Value = 0; 
            
            if ( optBinary.Checked ) 
            { 
                ftpClient.FileType = SocketTools.FtpClient.FtpFileType.fileBinary; 
            } 
            else 
            { 
                ftpClient.FileType = SocketTools.FtpClient.FtpFileType.fileText; 
            } 
            
            if ( ftpClient.GetFile( strLocalFile, strRemoteFile ) ) 
            { 
                Interaction.MsgBox( "Download completed successfully", MsgBoxStyle.Information, null ); 
            } 
            else 
            { 
                Interaction.MsgBox( ftpClient.LastErrorString, MsgBoxStyle.Exclamation, null ); 
            } 
            
            pbTransfer.Value = 0; 
            UpdateForm( true ); 
        } 
        
        
        private void ViewFile() 
        { 
            formViewFile dlgViewFile = new formViewFile(); 
            string strFileName = null; 
            string strBuffer = null; 
            int nIndex = 0; 
            int nResult = 0; 
            
            if ( listFiles.SelectedIndex == -1 )
             { 
                return; } 
            
            nIndex = listFiles.SelectedIndex - 1; 
            
            if ( ftpFileList[ nIndex ].IsDirectory ) 
            { 
                Interaction.MsgBox( "The selected file is a directory", MsgBoxStyle.Exclamation, null ); 
                return; 
            } 
            
            strFileName = ftpFileList[ nIndex ].FileName; 
            
            if ( optBinary.Checked ) 
            { 
                nResult = System.Convert.ToInt32( Interaction.MsgBox( "Are you sure you want to view a binary file?", ( ( Microsoft.VisualBasic.MsgBoxStyle )( System.Convert.ToInt32( MsgBoxStyle.YesNo ) + System.Convert.ToInt32( MsgBoxStyle.Question ) ) ), null ) ); 
                if ( nResult == System.Convert.ToDouble( MsgBoxResult.No ) )
                 { 
                    return; } 
                
                ftpClient.FileType = SocketTools.FtpClient.FtpFileType.fileBinary; 
            } 
            else 
            { 
                ftpClient.FileType = SocketTools.FtpClient.FtpFileType.fileText; 
            } 
            
            UpdateForm( false ); 
            pbTransfer.Value = 0; 
            
            if ( !( ftpClient.GetData( strFileName, ref strBuffer ) ) ) 
            { 
                Interaction.MsgBox( ftpClient.LastErrorString, MsgBoxStyle.Exclamation, null ); 
                UpdateForm( true ); 
                return; 
            } 
            
            pbTransfer.Value = 0; 
            
            //  Display the contents of the file that was downloaded
            dlgViewFile.Text = strFileName; 
            dlgViewFile.editText.Text = strBuffer; 
            dlgViewFile.ShowDialog(); 
            
            UpdateForm( true ); 
        } 
        
        
        private void Disconnect() 
        { 
            if ( ftpClient.IsConnected )
             { 
                ftpClient.Disconnect(); } 
            
            
            listFiles.Items.Clear(); 
            editDirectory.Text = ""; 
            sbInfo.Text = ""; 
            
            UpdateForm( false ); 
        } 
        
        
        private void formMain_Load( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            UpdateForm( false ); 
        } 
        
        
        private void editDirectory_Enter( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            editDirectory.SelectionStart = 0; 
            editDirectory.SelectionLength = editDirectory.Text.Length; 
        } 
        
        
        private void cmdConnect_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            if ( ftpClient.IsConnected ) 
            { 
                Disconnect(); 
            } 
            else 
            { 
                Connect(); 
            } 
        } 
        
        
        private void cmdList_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            string strDirectory = null; 
            
            string transTemp0 = editDirectory.Text; 
            strDirectory =  transTemp0.Trim(); 
            if (  strDirectory.Length == 0 ) 
            { 
                Interaction.MsgBox( "Please enter a directory name", MsgBoxStyle.Information, null ); 
                editDirectory.Focus(); 
                return; 
            } 
            
            UpdateForm( false ); 
            
            if ( !( ftpClient.ChangeDirectory( strDirectory ) ) ) 
            { 
                Interaction.MsgBox( ftpClient.LastErrorString, MsgBoxStyle.Exclamation, null ); 
                UpdateForm( true ); 
                return; 
            } 
            
            UpdateFileList(); 
        } 
        
        
        private void cmdDownload_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            DownloadFile(); 
        } 
        
        
        private void cmdView_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            ViewFile(); 
        } 
        
        
        private void cmdClose_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            this.Close(); 
        } 
    } 
} 
