// SocketTools 10 Build 1468
// Copyright 2023 Catalyst Development Corporation
// All rights reserved
// 
// This file is licensed to you pursuant to the terms of the
// product license agreement included with the original software,
// and is protected by copyright law and international treaties.
// Unauthorized reproduction or distribution may result in severe
// criminal penalties.
// 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Data;
using System.Drawing;
using System.Diagnostics;
using System.Windows.Forms;
using SocketTools;

namespace SendMail
{
    internal class formOptions : System.Windows.Forms.Form 
    { 
        #region 'Windows Form Designer generated code' 
        public formOptions() : base() 
        { 
            // This call is required by the Windows Form Designer.
            InitializeComponent(); 
        } 

		// Form overrides dispose to clean up the component list.
        protected override void Dispose( bool Disposing ) 
        { 
            if ( Disposing ) 
            { 
                if ( !( components == null ) ) 
                { 
                    components.Dispose(); 
                } 
            } 
            base.Dispose( Disposing ); 
        } 
        
        // Required by the Windows Form Designer
        private System.ComponentModel.IContainer components; 
        public System.Windows.Forms.ToolTip ToolTip1; 
        public System.Windows.Forms.TextBox editOrganization; 
        public System.Windows.Forms.TextBox editSenderAddress; 
        public System.Windows.Forms.TextBox editSenderName; 
        public System.Windows.Forms.Label lblOrganization; 
        public System.Windows.Forms.Label lblSenderAddress; 
        public System.Windows.Forms.Label lblName; 
        public System.Windows.Forms.GroupBox frameSender; 
        public System.Windows.Forms.Button cmdApply; 
        public System.Windows.Forms.Button cmdCancel; 
        public System.Windows.Forms.Button cmdOK; 
        public System.Windows.Forms.TextBox editRelayPort; 
        public System.Windows.Forms.TextBox editRelayServer; 
        public System.Windows.Forms.Label lblRelayPort; 
        public System.Windows.Forms.Label lblRelayServer; 
        public System.Windows.Forms.GroupBox frameServer; 
        // NOTE: The following procedure is required by the Windows Form Designer
        // It can be modified using the Windows Form Designer.
        // Do not modify it using the code editor.
        internal System.Windows.Forms.Label lblUserName; 
        internal System.Windows.Forms.TextBox editUserName; 
        internal System.Windows.Forms.Label lblPassword; 
        public System.Windows.Forms.RadioButton optServer1; 
        internal System.Windows.Forms.TextBox editPassword; 
        public System.Windows.Forms.RadioButton optServer2; 

        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() 
        { 
            this.components = new System.ComponentModel.Container(); 
            this.ToolTip1 = new System.Windows.Forms.ToolTip( this.components ); 
            this.frameSender = new System.Windows.Forms.GroupBox(); 
            this.editOrganization = new System.Windows.Forms.TextBox(); 
            this.editSenderAddress = new System.Windows.Forms.TextBox(); 
            this.editSenderName = new System.Windows.Forms.TextBox(); 
            this.lblSenderAddress = new System.Windows.Forms.Label(); 
            this.lblOrganization = new System.Windows.Forms.Label(); 
            this.lblName = new System.Windows.Forms.Label(); 
            this.cmdApply = new System.Windows.Forms.Button(); 
            this.cmdCancel = new System.Windows.Forms.Button(); 
            this.cmdOK = new System.Windows.Forms.Button(); 
            this.frameServer = new System.Windows.Forms.GroupBox(); 
            this.editPassword = new System.Windows.Forms.TextBox(); 
            this.editUserName = new System.Windows.Forms.TextBox(); 
            this.editRelayPort = new System.Windows.Forms.TextBox(); 
            this.editRelayServer = new System.Windows.Forms.TextBox(); 
            this.optServer2 = new System.Windows.Forms.RadioButton(); 
            this.optServer1 = new System.Windows.Forms.RadioButton(); 
            this.lblRelayPort = new System.Windows.Forms.Label(); 
            this.lblUserName = new System.Windows.Forms.Label(); 
            this.lblPassword = new System.Windows.Forms.Label(); 
            this.lblRelayServer = new System.Windows.Forms.Label(); 
            this.frameSender.SuspendLayout(); 
            this.frameServer.SuspendLayout(); 
            this.SuspendLayout(); 
            // 
            // frameSender
            // 
            this.frameSender.BackColor = System.Drawing.SystemColors.Control; 
            this.frameSender.Controls.Add( this.editOrganization ); 
            this.frameSender.Controls.Add( this.editSenderAddress ); 
            this.frameSender.Controls.Add( this.editSenderName ); 
            this.frameSender.Controls.Add( this.lblSenderAddress ); 
            this.frameSender.Controls.Add( this.lblOrganization ); 
            this.frameSender.Controls.Add( this.lblName ); 
            this.frameSender.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.frameSender.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.frameSender.Location = new System.Drawing.Point( 8, 12 ); 
            this.frameSender.Name = "frameSender"; 
            this.frameSender.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.frameSender.Size = new System.Drawing.Size( 405, 105 ); 
            this.frameSender.TabIndex = 0; 
            this.frameSender.TabStop = false; 
            this.frameSender.Text = "Sender"; 
            // 
            // editOrganization
            // 
            this.editOrganization.AcceptsReturn = true; 
            this.editOrganization.AutoSize = false; 
            this.editOrganization.BackColor = System.Drawing.SystemColors.Window; 
            this.editOrganization.Cursor = System.Windows.Forms.Cursors.IBeam; 
            this.editOrganization.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.editOrganization.ForeColor = System.Drawing.SystemColors.WindowText; 
            this.editOrganization.Location = new System.Drawing.Point( 93, 68 ); 
            this.editOrganization.MaxLength = 0; 
            this.editOrganization.Name = "editOrganization"; 
            this.editOrganization.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.editOrganization.Size = new System.Drawing.Size( 288, 21 ); 
            this.editOrganization.TabIndex = 5; 
            this.editOrganization.Text = ""; 
            // 
            // editSenderAddress
            // 
            this.editSenderAddress.AcceptsReturn = true; 
            this.editSenderAddress.AutoSize = false; 
            this.editSenderAddress.BackColor = System.Drawing.SystemColors.Window; 
            this.editSenderAddress.Cursor = System.Windows.Forms.Cursors.IBeam; 
            this.editSenderAddress.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.editSenderAddress.ForeColor = System.Drawing.SystemColors.WindowText; 
            this.editSenderAddress.Location = new System.Drawing.Point( 93, 44 ); 
            this.editSenderAddress.MaxLength = 0; 
            this.editSenderAddress.Name = "editSenderAddress"; 
            this.editSenderAddress.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.editSenderAddress.Size = new System.Drawing.Size( 288, 21 ); 
            this.editSenderAddress.TabIndex = 3; 
            this.editSenderAddress.Text = ""; 
            // 
            // editSenderName
            // 
            this.editSenderName.AcceptsReturn = true; 
            this.editSenderName.AutoSize = false; 
            this.editSenderName.BackColor = System.Drawing.SystemColors.Window; 
            this.editSenderName.Cursor = System.Windows.Forms.Cursors.IBeam; 
            this.editSenderName.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.editSenderName.ForeColor = System.Drawing.SystemColors.WindowText; 
            this.editSenderName.Location = new System.Drawing.Point( 93, 20 ); 
            this.editSenderName.MaxLength = 0; 
            this.editSenderName.Name = "editSenderName"; 
            this.editSenderName.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.editSenderName.Size = new System.Drawing.Size( 288, 21 ); 
            this.editSenderName.TabIndex = 1; 
            this.editSenderName.Text = ""; 
            // 
            // lblSenderAddress
            // 
            this.lblSenderAddress.BackColor = System.Drawing.SystemColors.Control; 
            this.lblSenderAddress.Cursor = System.Windows.Forms.Cursors.Default; 
            this.lblSenderAddress.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.lblSenderAddress.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.lblSenderAddress.Location = new System.Drawing.Point( 8, 48 ); 
            this.lblSenderAddress.Name = "lblSenderAddress"; 
            this.lblSenderAddress.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.lblSenderAddress.Size = new System.Drawing.Size( 83, 17 ); 
            this.lblSenderAddress.TabIndex = 2; 
            this.lblSenderAddress.Text = "Email Address:"; 
            // 
            // lblOrganization
            // 
            this.lblOrganization.BackColor = System.Drawing.SystemColors.Control; 
            this.lblOrganization.Cursor = System.Windows.Forms.Cursors.Default; 
            this.lblOrganization.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.lblOrganization.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.lblOrganization.Location = new System.Drawing.Point( 8, 72 ); 
            this.lblOrganization.Name = "lblOrganization"; 
            this.lblOrganization.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.lblOrganization.Size = new System.Drawing.Size( 74, 17 ); 
            this.lblOrganization.TabIndex = 4; 
            this.lblOrganization.Text = "Organization:"; 
            // 
            // lblName
            // 
            this.lblName.BackColor = System.Drawing.SystemColors.Control; 
            this.lblName.Cursor = System.Windows.Forms.Cursors.Default; 
            this.lblName.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.lblName.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.lblName.Location = new System.Drawing.Point( 8, 24 ); 
            this.lblName.Name = "lblName"; 
            this.lblName.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.lblName.Size = new System.Drawing.Size( 65, 17 ); 
            this.lblName.TabIndex = 0; 
            this.lblName.Text = "Full Name:"; 
            // 
            // cmdApply
            // 
            this.cmdApply.BackColor = System.Drawing.SystemColors.Control; 
            this.cmdApply.Cursor = System.Windows.Forms.Cursors.Default; 
            this.cmdApply.Enabled = false; 
            this.cmdApply.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.cmdApply.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.cmdApply.Location = new System.Drawing.Point( 344, 279 ); 
            this.cmdApply.Name = "cmdApply"; 
            this.cmdApply.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.cmdApply.Size = new System.Drawing.Size( 73, 25 ); 
            this.cmdApply.TabIndex = 4; 
            this.cmdApply.Text = "Apply"; 
            // 
            // cmdCancel
            // 
            this.cmdCancel.BackColor = System.Drawing.SystemColors.Control; 
            this.cmdCancel.Cursor = System.Windows.Forms.Cursors.Default; 
            this.cmdCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel; 
            this.cmdCancel.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.cmdCancel.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.cmdCancel.Location = new System.Drawing.Point( 264, 279 ); 
            this.cmdCancel.Name = "cmdCancel"; 
            this.cmdCancel.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.cmdCancel.Size = new System.Drawing.Size( 73, 25 ); 
            this.cmdCancel.TabIndex = 3; 
            this.cmdCancel.Text = "Cancel"; 
            // 
            // cmdOK
            // 
            this.cmdOK.BackColor = System.Drawing.SystemColors.Control; 
            this.cmdOK.Cursor = System.Windows.Forms.Cursors.Default; 
            this.cmdOK.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.cmdOK.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.cmdOK.Location = new System.Drawing.Point( 184, 279 ); 
            this.cmdOK.Name = "cmdOK"; 
            this.cmdOK.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.cmdOK.Size = new System.Drawing.Size( 73, 25 ); 
            this.cmdOK.TabIndex = 2; 
            this.cmdOK.Text = "OK"; 
            // 
            // frameServer
            // 
            this.frameServer.BackColor = System.Drawing.SystemColors.Control; 
            this.frameServer.Controls.Add( this.editPassword ); 
            this.frameServer.Controls.Add( this.editUserName ); 
            this.frameServer.Controls.Add( this.editRelayPort ); 
            this.frameServer.Controls.Add( this.editRelayServer ); 
            this.frameServer.Controls.Add( this.optServer2 ); 
            this.frameServer.Controls.Add( this.optServer1 ); 
            this.frameServer.Controls.Add( this.lblRelayPort ); 
            this.frameServer.Controls.Add( this.lblUserName ); 
            this.frameServer.Controls.Add( this.lblPassword ); 
            this.frameServer.Controls.Add( this.lblRelayServer ); 
            this.frameServer.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.frameServer.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.frameServer.Location = new System.Drawing.Point( 8, 120 ); 
            this.frameServer.Name = "frameServer"; 
            this.frameServer.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.frameServer.Size = new System.Drawing.Size( 405, 147 ); 
            this.frameServer.TabIndex = 1; 
            this.frameServer.TabStop = false; 
            this.frameServer.Text = "Server"; 
            // 
            // editPassword
            // 
            this.editPassword.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.editPassword.Location = new System.Drawing.Point( 93, 111 ); 
            this.editPassword.Name = "editPassword"; 
            this.editPassword.PasswordChar = Microsoft.VisualBasic.Strings.ChrW( 42 ); 
            this.editPassword.Size = new System.Drawing.Size( 182, 20 ); 
            this.editPassword.TabIndex = 9; 
            this.editPassword.Text = ""; 
            // 
            // editUserName
            // 
            this.editUserName.Location = new System.Drawing.Point( 93, 87 ); 
            this.editUserName.Name = "editUserName"; 
            this.editUserName.Size = new System.Drawing.Size( 182, 20 ); 
            this.editUserName.TabIndex = 7; 
            this.editUserName.Text = ""; 
            // 
            // editRelayPort
            // 
            this.editRelayPort.AcceptsReturn = true; 
            this.editRelayPort.AutoSize = false; 
            this.editRelayPort.BackColor = System.Drawing.SystemColors.Window; 
            this.editRelayPort.Cursor = System.Windows.Forms.Cursors.IBeam; 
            this.editRelayPort.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.editRelayPort.ForeColor = System.Drawing.SystemColors.WindowText; 
            this.editRelayPort.Location = new System.Drawing.Point( 328, 61 ); 
            this.editRelayPort.MaxLength = 0; 
            this.editRelayPort.Name = "editRelayPort"; 
            this.editRelayPort.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.editRelayPort.Size = new System.Drawing.Size( 53, 21 ); 
            this.editRelayPort.TabIndex = 5; 
            this.editRelayPort.Text = ""; 
            // 
            // editRelayServer
            // 
            this.editRelayServer.AcceptsReturn = true; 
            this.editRelayServer.AutoSize = false; 
            this.editRelayServer.BackColor = System.Drawing.SystemColors.Window; 
            this.editRelayServer.Cursor = System.Windows.Forms.Cursors.IBeam; 
            this.editRelayServer.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.editRelayServer.ForeColor = System.Drawing.SystemColors.WindowText; 
            this.editRelayServer.Location = new System.Drawing.Point( 93, 61 ); 
            this.editRelayServer.MaxLength = 0; 
            this.editRelayServer.Name = "editRelayServer"; 
            this.editRelayServer.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.editRelayServer.Size = new System.Drawing.Size( 182, 21 ); 
            this.editRelayServer.TabIndex = 3; 
            this.editRelayServer.Text = ""; 
            // 
            // optServer2
            // 
            this.optServer2.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.optServer2.Location = new System.Drawing.Point( 10, 34 ); 
            this.optServer2.Name = "optServer2"; 
            this.optServer2.Size = new System.Drawing.Size( 373, 24 ); 
            this.optServer2.TabIndex = 10; 
            this.optServer2.Text = "Send all messages through the specified relay server"; 
            // 
            // optServer1
            // 
            this.optServer1.Location = new System.Drawing.Point( 10, 14 ); 
            this.optServer1.Name = "optServer1"; 
            this.optServer1.Size = new System.Drawing.Size( 373, 24 ); 
            this.optServer1.TabIndex = 11; 
            this.optServer1.Text = "Send all messages directly to the recipient"; 
            // 
            // lblRelayPort
            // 
            this.lblRelayPort.BackColor = System.Drawing.SystemColors.Control; 
            this.lblRelayPort.Cursor = System.Windows.Forms.Cursors.Default; 
            this.lblRelayPort.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.lblRelayPort.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.lblRelayPort.Location = new System.Drawing.Point( 293, 65 ); 
            this.lblRelayPort.Name = "lblRelayPort"; 
            this.lblRelayPort.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.lblRelayPort.Size = new System.Drawing.Size( 30, 13 ); 
            this.lblRelayPort.TabIndex = 4; 
            this.lblRelayPort.Text = "Port:"; 
            // 
            // lblUserName
            // 
            this.lblUserName.Location = new System.Drawing.Point( 30, 89 ); 
            this.lblUserName.Name = "lblUserName"; 
            this.lblUserName.Size = new System.Drawing.Size( 63, 16 ); 
            this.lblUserName.TabIndex = 6; 
            this.lblUserName.Text = "User Name:"; 
            // 
            // lblPassword
            // 
            this.lblPassword.Location = new System.Drawing.Point( 30, 113 ); 
            this.lblPassword.Name = "lblPassword"; 
            this.lblPassword.Size = new System.Drawing.Size( 60, 17 ); 
            this.lblPassword.TabIndex = 8; 
            this.lblPassword.Text = "Password:"; 
            // 
            // lblRelayServer
            // 
            this.lblRelayServer.BackColor = System.Drawing.SystemColors.Control; 
            this.lblRelayServer.Cursor = System.Windows.Forms.Cursors.Default; 
            this.lblRelayServer.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.lblRelayServer.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.lblRelayServer.Location = new System.Drawing.Point( 30, 65 ); 
            this.lblRelayServer.Name = "lblRelayServer"; 
            this.lblRelayServer.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.lblRelayServer.Size = new System.Drawing.Size( 56, 17 ); 
            this.lblRelayServer.TabIndex = 2; 
            this.lblRelayServer.Text = "Server:"; 
            // 
            // formOptions
            // 
            this.AcceptButton = this.cmdOK; 
            this.AutoScaleBaseSize = new System.Drawing.Size( 5, 13 ); 
            this.BackColor = System.Drawing.SystemColors.Control; 
            this.CancelButton = this.cmdCancel; 
            this.ClientSize = new System.Drawing.Size( 424, 310 ); 
            this.ControlBox = false; 
            this.Controls.Add( this.frameSender ); 
            this.Controls.Add( this.cmdApply ); 
            this.Controls.Add( this.cmdCancel ); 
            this.Controls.Add( this.cmdOK ); 
            this.Controls.Add( this.frameServer ); 
            this.Cursor = System.Windows.Forms.Cursors.Default; 
            this.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog; 
            this.Location = new System.Drawing.Point( 178, 137 ); 
            this.MaximizeBox = false; 
            this.MinimizeBox = false; 
            this.Name = "formOptions"; 
            this.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.ShowInTaskbar = false; 
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent; 
            this.Text = "SendMail Options"; 
            this.frameSender.ResumeLayout( false ); 
            this.frameServer.ResumeLayout( false ); 
            this.ResumeLayout( false ); 
            
            // events handled by formOptions_Load
            base.Load += new System.EventHandler( formOptions_Load ); 
            // events handled by editSenderName_TextChanged
            editSenderName.TextChanged += new System.EventHandler( editSenderName_TextChanged ); 
            // events handled by editSenderName_Enter
            editSenderName.Enter += new System.EventHandler( editSenderName_Enter ); 
            // events handled by editSenderAddress_TextChanged
            editSenderAddress.TextChanged += new System.EventHandler( editSenderAddress_TextChanged ); 
            // events handled by editSenderAddress_Enter
            editSenderAddress.Enter += new System.EventHandler( editSenderAddress_Enter ); 
            // events handled by editOrganization_TextChanged
            editOrganization.TextChanged += new System.EventHandler( editOrganization_TextChanged ); 
            // events handled by editOrganization_Enter
            editOrganization.Enter += new System.EventHandler( editOrganization_Enter ); 
            // events handled by editRelayServer_TextChanged
            editRelayServer.TextChanged += new System.EventHandler( editRelayServer_TextChanged ); 
            // events handled by editRelayServer_Enter
            editRelayServer.Enter += new System.EventHandler( editRelayServer_Enter ); 
            // events handled by editRelayPort_TextChanged
            editRelayPort.TextChanged += new System.EventHandler( editRelayPort_TextChanged ); 
            // events handled by editRelayPort_Enter
            editRelayPort.Enter += new System.EventHandler( editRelayPort_Enter );
            // events handled by optServer1_CheckChanged
            optServer1.CheckedChanged += new EventHandler(optServer1_CheckedChanged);
            // events handled by optServer2_CheckChanged
            optServer2.CheckedChanged += new EventHandler(optServer2_CheckedChanged);
            // events handled by cmdOK_Click
            cmdOK.Click += new System.EventHandler( cmdOK_Click ); 
            // events handled by cmdCancel_Click
            cmdCancel.Click += new System.EventHandler( cmdCancel_Click ); 
            // events handled by cmdApply_Click
            cmdApply.Click += new System.EventHandler( cmdApply_Click ); 
        } 
        #endregion 
        
        private void formOptions_Load( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            modOptions.LoadOptions(); 
            UpdateForm( false ); 
        } 
        
        private void editSenderName_TextChanged( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            UpdateForm( true ); 
        } 
        
        private void editSenderName_Enter( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            editSenderName.SelectionStart = 0; 
            editSenderName.SelectionLength = editSenderName.Text.Length; 
        } 
        
        private void editSenderAddress_TextChanged( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            UpdateForm( true ); 
        } 

		private void editSenderAddress_Enter( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            editSenderAddress.SelectionStart = 0; 
            editSenderAddress.SelectionLength = editSenderAddress.Text.Length;
        } 
        
        private void editOrganization_TextChanged( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            UpdateForm( true ); 
        } 

		private void editOrganization_Enter( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            editOrganization.SelectionStart = 0; 
            editOrganization.SelectionLength = editOrganization.Text.Length;
        } 
        
        private void editRelayServer_TextChanged( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            UpdateForm( true ); 
        } 
        
        private void editRelayServer_Enter( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            editRelayServer.SelectionStart = 0; 
            editRelayServer.SelectionLength = editRelayServer.Text.Length;
        } 
        
        private void editRelayPort_TextChanged( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            UpdateForm( true ); 
        } 
        
        private void editRelayPort_Enter( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            editRelayPort.SelectionStart = 0; 
            editRelayPort.SelectionLength = editRelayPort.Text.Length;
        }

        private void optServer1_CheckedChanged(System.Object eventSender, System.EventArgs eventArgs)
        {
            if ( optServer1.Checked )
            {
                UpdateForm(true);
            }
        }

        private void optServer2_CheckedChanged(System.Object eventSender, System.EventArgs eventArgs)
        {
            if ( optServer2.Checked )
            {
                UpdateForm(true);
            }
        }

        private void cmdOK_Click(System.Object eventSender, System.EventArgs eventArgs) 
        { 
            UpdateForm( true ); 
            
            if ( modOptions.g_bRelayMessages && modOptions.g_strRelayServer.Length == 0 ) 
            { 
                Interaction.MsgBox( "A relay server host name or IP address must be specified", MsgBoxStyle.Exclamation, null ); 
                editRelayServer.Focus(); 
                return; 
            } 
            
            modOptions.SaveOptions(); 
            this.Close(); 
        } 
        
        private void cmdCancel_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            this.Close(); 
        } 
        
        private void cmdApply_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            UpdateForm( true ); 
            
            if ( modOptions.g_bRelayMessages && modOptions.g_strRelayServer.Length == 0 ) 
            { 
                Interaction.MsgBox( "A relay server host name or IP address must be specified", MsgBoxStyle.Exclamation, null ); 
                editRelayServer.Focus(); 
                return; 
            } 
            
            modOptions.SaveOptions(); 
            cmdApply.Enabled = false; 
        } 
        
        public void UpdateForm( bool bValidate ) 
        { 
            bool bModified = false; 
            
            if ( bValidate ) 
            { 
                if ( editSenderName.Text != modOptions.g_strSenderName )
                { 
                    bModified = true; 
                } 
                if ( editSenderAddress.Text != modOptions.g_strSenderAddress )
                { 
                    bModified = true; 
                } 
                if ( editOrganization.Text != modOptions.g_strOrganization )
                { 
                    bModified = true; 
                } 
                
                modOptions.g_strSenderName =  editSenderName.Text.Trim();
                modOptions.g_strSenderAddress = editSenderAddress.Text.Trim();
                modOptions.g_strOrganization = editOrganization.Text.Trim();
                modOptions.g_bAuthenticate = false; 
                
                if ( optServer1.Checked == true ) 
                { 
                    if ( modOptions.g_bRelayMessages == true )
                    { 
                        bModified = true; 
                    } 
                    modOptions.g_bRelayMessages = false; 
                } 
                else 
                { 
                    if ( modOptions.g_bRelayMessages == false )
                    { 
                        bModified = true; 
                    } 
                    modOptions.g_bRelayMessages = true; 
                } 
                
                if ( modOptions.g_bRelayMessages ) 
                { 
                    if ( editRelayServer.Text != modOptions.g_strRelayServer )
                    { 
                        bModified = true; 
                    } 
                    
					if ( Conversion.Val( editRelayPort.Text ) != modOptions.g_nRelayPort )
                    { 
                        bModified = true; 
                    }

                    if ( editRelayPort.Text.Length == 0 )
                    {
                        editRelayPort.Text = SocketTools.SmtpClient.smtpPortDefault.ToString();
                    }

                    modOptions.g_strRelayServer = editRelayServer.Text.Trim();
                    modOptions.g_nRelayPort = (int)Conversion.Val( editRelayPort.Text.Trim() );
                    modOptions.g_strUserName = editUserName.Text.Trim();
                    modOptions.g_strPassword = editPassword.Text.Trim();
                    
                    if ( modOptions.g_strUserName.Length > 0 && modOptions.g_strPassword.Length > 0 ) 
                    { 
                        modOptions.g_bAuthenticate = true; 
                    } 
                } 
                
                cmdApply.Enabled = bModified; 
            } 
            else 
            { 
                editSenderName.Text = modOptions.g_strSenderName; 
                editSenderAddress.Text = modOptions.g_strSenderAddress; 
                editOrganization.Text = modOptions.g_strOrganization; 
                
                if ( modOptions.g_bRelayMessages ) 
                { 
                    optServer1.Checked = false; 
                    optServer2.Checked = true; 
                } 
                else 
                { 
                    optServer1.Checked = true; 
                    optServer2.Checked = false; 
                } 
                
                editRelayServer.Text = modOptions.g_strRelayServer; 
                editRelayPort.Text = System.Convert.ToString( modOptions.g_nRelayPort ); 
                editUserName.Text = modOptions.g_strUserName; 
                editPassword.Text = modOptions.g_strPassword; 
            } 
            
            lblRelayServer.Enabled = modOptions.g_bRelayMessages; 
            lblRelayPort.Enabled = modOptions.g_bRelayMessages; 
            lblUserName.Enabled = modOptions.g_bRelayMessages; 
            lblPassword.Enabled = modOptions.g_bRelayMessages; 
            
            editRelayServer.Enabled = modOptions.g_bRelayMessages; 
            editRelayPort.Enabled = modOptions.g_bRelayMessages; 
            editUserName.Enabled = modOptions.g_bRelayMessages; 
            editPassword.Enabled = modOptions.g_bRelayMessages; 
        } 
    } 
} 
