' SocketTools 10 Build 1468
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'
Option Strict Off
Option Explicit On

Imports SocketTools.DnsClient
Imports SocketTools.MailMessage
Imports SocketTools.SmtpClient

Friend Class formMain
    Inherits System.Windows.Forms.Form
#Region "Windows Form Designer generated code "
    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()
    End Sub
    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal Disposing As Boolean)
        If Disposing Then
            If Not components Is Nothing Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(Disposing)
    End Sub
    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer
    Public ToolTip1 As System.Windows.Forms.ToolTip
    Public WithEvents editMessageHTML As System.Windows.Forms.TextBox
    Public WithEvents editMessageText As System.Windows.Forms.TextBox
    Public WithEvents cmdBrowse As System.Windows.Forms.Button
    Public WithEvents comboAttachment As System.Windows.Forms.ComboBox
    Public WithEvents editBcc As System.Windows.Forms.TextBox
    Public WithEvents editCc As System.Windows.Forms.TextBox
    Public WithEvents editSubject As System.Windows.Forms.TextBox
    Public WithEvents editTo As System.Windows.Forms.TextBox
    Public WithEvents editFrom As System.Windows.Forms.TextBox
    Public WithEvents lblAttachment As System.Windows.Forms.Label
    Public WithEvents lblBcc As System.Windows.Forms.Label
    Public WithEvents lblCc As System.Windows.Forms.Label
    Public WithEvents lblSubject As System.Windows.Forms.Label
    Public WithEvents lblTo As System.Windows.Forms.Label
    Public WithEvents lblFrom As System.Windows.Forms.Label
    Public WithEvents menuNewMessage As System.Windows.Forms.MenuItem
    Public WithEvents menuSeparator1 As System.Windows.Forms.MenuItem
    Public WithEvents menuFileAttach As System.Windows.Forms.MenuItem
    Public WithEvents menuSaveMessage As System.Windows.Forms.MenuItem
    Public WithEvents menuSeparator2 As System.Windows.Forms.MenuItem
    Public WithEvents menuCloseFile As System.Windows.Forms.MenuItem
    Public WithEvents menuFile As System.Windows.Forms.MenuItem
    Public WithEvents menuFormatCharSets As System.Windows.Forms.MenuItem
    Public WithEvents menuFormatEncodings As System.Windows.Forms.MenuItem
    Public WithEvents menuSeparator4 As System.Windows.Forms.MenuItem
    Public WithEvents menuFormatPlainText As System.Windows.Forms.MenuItem
    Public WithEvents menuFormatStyledText As System.Windows.Forms.MenuItem
    Public WithEvents menuFormat As System.Windows.Forms.MenuItem
    Public WithEvents menuMessageSend As System.Windows.Forms.MenuItem
    Public WithEvents menuSeparator5 As System.Windows.Forms.MenuItem
    Public WithEvents menuMessagePriorities As System.Windows.Forms.MenuItem
    Public WithEvents menuSeparator6 As System.Windows.Forms.MenuItem
    Public WithEvents menuMessageOptions As System.Windows.Forms.MenuItem
    Public WithEvents menuMessage As System.Windows.Forms.MenuItem
    Public MainMenu1 As System.Windows.Forms.MainMenu
    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.
    'Do not modify it using the code editor.
    Friend WithEvents ctlProgress As System.Windows.Forms.ProgressBar
    Public WithEvents menuCharSet1 As System.Windows.Forms.MenuItem
    Public WithEvents menuCharSet2 As System.Windows.Forms.MenuItem
    Public WithEvents menuCharSet3 As System.Windows.Forms.MenuItem
    Public WithEvents menuCharSet4 As System.Windows.Forms.MenuItem
    Public WithEvents menuCharSet5 As System.Windows.Forms.MenuItem
    Public WithEvents menuEncoding1 As System.Windows.Forms.MenuItem
    Public WithEvents menuEncoding2 As System.Windows.Forms.MenuItem
    Public WithEvents menuPriority1 As System.Windows.Forms.MenuItem
    Public WithEvents menuPriority2 As System.Windows.Forms.MenuItem
    Public WithEvents menuPriority3 As System.Windows.Forms.MenuItem
    Public WithEvents menuPriority4 As System.Windows.Forms.MenuItem
    Public WithEvents menuPriority5 As System.Windows.Forms.MenuItem
    Friend WithEvents ctlStatus As System.Windows.Forms.StatusBar
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(formMain))
        Me.ToolTip1 = New System.Windows.Forms.ToolTip(Me.components)
        Me.editMessageHTML = New System.Windows.Forms.TextBox
        Me.editMessageText = New System.Windows.Forms.TextBox
        Me.cmdBrowse = New System.Windows.Forms.Button
        Me.comboAttachment = New System.Windows.Forms.ComboBox
        Me.editBcc = New System.Windows.Forms.TextBox
        Me.editCc = New System.Windows.Forms.TextBox
        Me.editSubject = New System.Windows.Forms.TextBox
        Me.editTo = New System.Windows.Forms.TextBox
        Me.editFrom = New System.Windows.Forms.TextBox
        Me.lblAttachment = New System.Windows.Forms.Label
        Me.lblBcc = New System.Windows.Forms.Label
        Me.lblCc = New System.Windows.Forms.Label
        Me.lblSubject = New System.Windows.Forms.Label
        Me.lblTo = New System.Windows.Forms.Label
        Me.lblFrom = New System.Windows.Forms.Label
        Me.menuCharSet1 = New System.Windows.Forms.MenuItem
        Me.menuCharSet2 = New System.Windows.Forms.MenuItem
        Me.menuCharSet3 = New System.Windows.Forms.MenuItem
        Me.menuCharSet4 = New System.Windows.Forms.MenuItem
        Me.menuCharSet5 = New System.Windows.Forms.MenuItem
        Me.menuEncoding1 = New System.Windows.Forms.MenuItem
        Me.menuEncoding2 = New System.Windows.Forms.MenuItem
        Me.menuPriority1 = New System.Windows.Forms.MenuItem
        Me.menuPriority2 = New System.Windows.Forms.MenuItem
        Me.menuPriority3 = New System.Windows.Forms.MenuItem
        Me.menuPriority4 = New System.Windows.Forms.MenuItem
        Me.menuPriority5 = New System.Windows.Forms.MenuItem
        Me.MainMenu1 = New System.Windows.Forms.MainMenu
        Me.menuFile = New System.Windows.Forms.MenuItem
        Me.menuNewMessage = New System.Windows.Forms.MenuItem
        Me.menuSeparator1 = New System.Windows.Forms.MenuItem
        Me.menuFileAttach = New System.Windows.Forms.MenuItem
        Me.menuSaveMessage = New System.Windows.Forms.MenuItem
        Me.menuSeparator2 = New System.Windows.Forms.MenuItem
        Me.menuCloseFile = New System.Windows.Forms.MenuItem
        Me.menuFormat = New System.Windows.Forms.MenuItem
        Me.menuFormatCharSets = New System.Windows.Forms.MenuItem
        Me.menuFormatEncodings = New System.Windows.Forms.MenuItem
        Me.menuSeparator4 = New System.Windows.Forms.MenuItem
        Me.menuFormatPlainText = New System.Windows.Forms.MenuItem
        Me.menuFormatStyledText = New System.Windows.Forms.MenuItem
        Me.menuMessage = New System.Windows.Forms.MenuItem
        Me.menuMessageSend = New System.Windows.Forms.MenuItem
        Me.menuSeparator5 = New System.Windows.Forms.MenuItem
        Me.menuMessagePriorities = New System.Windows.Forms.MenuItem
        Me.menuSeparator6 = New System.Windows.Forms.MenuItem
        Me.menuMessageOptions = New System.Windows.Forms.MenuItem
        Me.ctlProgress = New System.Windows.Forms.ProgressBar
        Me.ctlStatus = New System.Windows.Forms.StatusBar
        Me.SuspendLayout()
        '
        'editMessageHTML
        '
        Me.editMessageHTML.AcceptsReturn = True
        Me.editMessageHTML.AutoSize = False
        Me.editMessageHTML.BackColor = System.Drawing.SystemColors.Window
        Me.editMessageHTML.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.editMessageHTML.Font = New System.Drawing.Font("Courier New", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.editMessageHTML.ForeColor = System.Drawing.SystemColors.WindowText
        Me.editMessageHTML.Location = New System.Drawing.Point(247, 164)
        Me.editMessageHTML.MaxLength = 0
        Me.editMessageHTML.Multiline = True
        Me.editMessageHTML.Name = "editMessageHTML"
        Me.editMessageHTML.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.editMessageHTML.ScrollBars = System.Windows.Forms.ScrollBars.Both
        Me.editMessageHTML.Size = New System.Drawing.Size(237, 145)
        Me.editMessageHTML.TabIndex = 14
        Me.editMessageHTML.Text = ""
        Me.editMessageHTML.Visible = False
        Me.editMessageHTML.WordWrap = False
        '
        'editMessageText
        '
        Me.editMessageText.AcceptsReturn = True
        Me.editMessageText.AutoSize = False
        Me.editMessageText.BackColor = System.Drawing.SystemColors.Window
        Me.editMessageText.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.editMessageText.Font = New System.Drawing.Font("Courier New", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.editMessageText.ForeColor = System.Drawing.SystemColors.WindowText
        Me.editMessageText.Location = New System.Drawing.Point(4, 164)
        Me.editMessageText.MaxLength = 0
        Me.editMessageText.Multiline = True
        Me.editMessageText.Name = "editMessageText"
        Me.editMessageText.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.editMessageText.ScrollBars = System.Windows.Forms.ScrollBars.Both
        Me.editMessageText.Size = New System.Drawing.Size(245, 145)
        Me.editMessageText.TabIndex = 13
        Me.editMessageText.Text = ""
        Me.editMessageText.WordWrap = False
        '
        'cmdBrowse
        '
        Me.cmdBrowse.BackColor = System.Drawing.SystemColors.Control
        Me.cmdBrowse.Cursor = System.Windows.Forms.Cursors.Default
        Me.cmdBrowse.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.cmdBrowse.ForeColor = System.Drawing.SystemColors.ControlText
        Me.cmdBrowse.Image = CType(resources.GetObject("cmdBrowse.Image"), System.Drawing.Image)
        Me.cmdBrowse.Location = New System.Drawing.Point(312, 132)
        Me.cmdBrowse.Name = "cmdBrowse"
        Me.cmdBrowse.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.cmdBrowse.Size = New System.Drawing.Size(25, 21)
        Me.cmdBrowse.TabIndex = 12
        Me.cmdBrowse.TextAlign = System.Drawing.ContentAlignment.BottomCenter
        '
        'comboAttachment
        '
        Me.comboAttachment.BackColor = System.Drawing.SystemColors.Window
        Me.comboAttachment.Cursor = System.Windows.Forms.Cursors.Default
        Me.comboAttachment.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.comboAttachment.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.comboAttachment.ForeColor = System.Drawing.SystemColors.WindowText
        Me.comboAttachment.Location = New System.Drawing.Point(72, 132)
        Me.comboAttachment.Name = "comboAttachment"
        Me.comboAttachment.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.comboAttachment.Size = New System.Drawing.Size(233, 22)
        Me.comboAttachment.TabIndex = 11
        Me.comboAttachment.TabStop = False
        '
        'editBcc
        '
        Me.editBcc.AcceptsReturn = True
        Me.editBcc.AutoSize = False
        Me.editBcc.BackColor = System.Drawing.SystemColors.Window
        Me.editBcc.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.editBcc.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.editBcc.ForeColor = System.Drawing.SystemColors.WindowText
        Me.editBcc.Location = New System.Drawing.Point(72, 108)
        Me.editBcc.MaxLength = 0
        Me.editBcc.Name = "editBcc"
        Me.editBcc.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.editBcc.Size = New System.Drawing.Size(265, 21)
        Me.editBcc.TabIndex = 9
        Me.editBcc.Text = ""
        '
        'editCc
        '
        Me.editCc.AcceptsReturn = True
        Me.editCc.AutoSize = False
        Me.editCc.BackColor = System.Drawing.SystemColors.Window
        Me.editCc.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.editCc.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.editCc.ForeColor = System.Drawing.SystemColors.WindowText
        Me.editCc.Location = New System.Drawing.Point(72, 84)
        Me.editCc.MaxLength = 0
        Me.editCc.Name = "editCc"
        Me.editCc.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.editCc.Size = New System.Drawing.Size(265, 21)
        Me.editCc.TabIndex = 7
        Me.editCc.Text = ""
        '
        'editSubject
        '
        Me.editSubject.AcceptsReturn = True
        Me.editSubject.AutoSize = False
        Me.editSubject.BackColor = System.Drawing.SystemColors.Window
        Me.editSubject.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.editSubject.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.editSubject.ForeColor = System.Drawing.SystemColors.WindowText
        Me.editSubject.Location = New System.Drawing.Point(72, 60)
        Me.editSubject.MaxLength = 0
        Me.editSubject.Name = "editSubject"
        Me.editSubject.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.editSubject.Size = New System.Drawing.Size(265, 21)
        Me.editSubject.TabIndex = 5
        Me.editSubject.Text = ""
        '
        'editTo
        '
        Me.editTo.AcceptsReturn = True
        Me.editTo.AutoSize = False
        Me.editTo.BackColor = System.Drawing.SystemColors.Window
        Me.editTo.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.editTo.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.editTo.ForeColor = System.Drawing.SystemColors.WindowText
        Me.editTo.Location = New System.Drawing.Point(72, 36)
        Me.editTo.MaxLength = 0
        Me.editTo.Name = "editTo"
        Me.editTo.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.editTo.Size = New System.Drawing.Size(265, 21)
        Me.editTo.TabIndex = 3
        Me.editTo.Text = ""
        '
        'editFrom
        '
        Me.editFrom.AcceptsReturn = True
        Me.editFrom.AutoSize = False
        Me.editFrom.BackColor = System.Drawing.SystemColors.Window
        Me.editFrom.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.editFrom.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.editFrom.ForeColor = System.Drawing.SystemColors.WindowText
        Me.editFrom.Location = New System.Drawing.Point(72, 12)
        Me.editFrom.MaxLength = 0
        Me.editFrom.Name = "editFrom"
        Me.editFrom.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.editFrom.Size = New System.Drawing.Size(265, 21)
        Me.editFrom.TabIndex = 1
        Me.editFrom.Text = ""
        '
        'lblAttachment
        '
        Me.lblAttachment.BackColor = System.Drawing.SystemColors.Control
        Me.lblAttachment.Cursor = System.Windows.Forms.Cursors.Default
        Me.lblAttachment.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblAttachment.ForeColor = System.Drawing.SystemColors.ControlText
        Me.lblAttachment.Location = New System.Drawing.Point(8, 136)
        Me.lblAttachment.Name = "lblAttachment"
        Me.lblAttachment.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.lblAttachment.Size = New System.Drawing.Size(61, 17)
        Me.lblAttachment.TabIndex = 10
        Me.lblAttachment.Text = "&Attachment:"
        '
        'lblBcc
        '
        Me.lblBcc.BackColor = System.Drawing.SystemColors.Control
        Me.lblBcc.Cursor = System.Windows.Forms.Cursors.Default
        Me.lblBcc.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblBcc.ForeColor = System.Drawing.SystemColors.ControlText
        Me.lblBcc.Location = New System.Drawing.Point(8, 112)
        Me.lblBcc.Name = "lblBcc"
        Me.lblBcc.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.lblBcc.Size = New System.Drawing.Size(61, 17)
        Me.lblBcc.TabIndex = 8
        Me.lblBcc.Text = "&Bcc:"
        '
        'lblCc
        '
        Me.lblCc.BackColor = System.Drawing.SystemColors.Control
        Me.lblCc.Cursor = System.Windows.Forms.Cursors.Default
        Me.lblCc.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblCc.ForeColor = System.Drawing.SystemColors.ControlText
        Me.lblCc.Location = New System.Drawing.Point(8, 88)
        Me.lblCc.Name = "lblCc"
        Me.lblCc.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.lblCc.Size = New System.Drawing.Size(61, 17)
        Me.lblCc.TabIndex = 6
        Me.lblCc.Text = "&Cc:"
        '
        'lblSubject
        '
        Me.lblSubject.BackColor = System.Drawing.SystemColors.Control
        Me.lblSubject.Cursor = System.Windows.Forms.Cursors.Default
        Me.lblSubject.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblSubject.ForeColor = System.Drawing.SystemColors.ControlText
        Me.lblSubject.Location = New System.Drawing.Point(8, 64)
        Me.lblSubject.Name = "lblSubject"
        Me.lblSubject.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.lblSubject.Size = New System.Drawing.Size(61, 17)
        Me.lblSubject.TabIndex = 4
        Me.lblSubject.Text = "&Subject:"
        '
        'lblTo
        '
        Me.lblTo.BackColor = System.Drawing.SystemColors.Control
        Me.lblTo.Cursor = System.Windows.Forms.Cursors.Default
        Me.lblTo.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblTo.ForeColor = System.Drawing.SystemColors.ControlText
        Me.lblTo.Location = New System.Drawing.Point(8, 40)
        Me.lblTo.Name = "lblTo"
        Me.lblTo.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.lblTo.Size = New System.Drawing.Size(61, 17)
        Me.lblTo.TabIndex = 2
        Me.lblTo.Text = "&To:"
        '
        'lblFrom
        '
        Me.lblFrom.BackColor = System.Drawing.SystemColors.Control
        Me.lblFrom.Cursor = System.Windows.Forms.Cursors.Default
        Me.lblFrom.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblFrom.ForeColor = System.Drawing.SystemColors.ControlText
        Me.lblFrom.Location = New System.Drawing.Point(8, 16)
        Me.lblFrom.Name = "lblFrom"
        Me.lblFrom.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.lblFrom.Size = New System.Drawing.Size(61, 17)
        Me.lblFrom.TabIndex = 0
        Me.lblFrom.Text = "&From:"
        '
        'menuCharSet1
        '
        Me.menuCharSet1.Checked = True
        Me.menuCharSet1.Index = 0
        Me.menuCharSet1.Text = "Western European"
        '
        'menuCharSet2
        '
        Me.menuCharSet2.Index = 1
        Me.menuCharSet2.Text = "Eastern European"
        '
        'menuCharSet3
        '
        Me.menuCharSet3.Index = 2
        Me.menuCharSet3.Text = "Cyrillic"
        '
        'menuCharSet4
        '
        Me.menuCharSet4.Index = 3
        Me.menuCharSet4.Text = "Greek"
        '
        'menuCharSet5
        '
        Me.menuCharSet5.Index = 4
        Me.menuCharSet5.Text = "Turkish"
        '
        'menuEncoding1
        '
        Me.menuEncoding1.Checked = True
        Me.menuEncoding1.Index = 0
        Me.menuEncoding1.Text = "7 Bit Text"
        '
        'menuEncoding2
        '
        Me.menuEncoding2.Index = 1
        Me.menuEncoding2.Text = "Quoted Printable"
        '
        'menuPriority1
        '
        Me.menuPriority1.Index = 0
        Me.menuPriority1.Text = "Highest"
        '
        'menuPriority2
        '
        Me.menuPriority2.Index = 1
        Me.menuPriority2.Text = "High"
        '
        'menuPriority3
        '
        Me.menuPriority3.Checked = True
        Me.menuPriority3.Index = 2
        Me.menuPriority3.Text = "Normal"
        '
        'menuPriority4
        '
        Me.menuPriority4.Index = 3
        Me.menuPriority4.Text = "Low"
        '
        'menuPriority5
        '
        Me.menuPriority5.Index = 4
        Me.menuPriority5.Text = "Lowest"
        '
        'MainMenu1
        '
        Me.MainMenu1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.menuFile, Me.menuFormat, Me.menuMessage})
        '
        'menuFile
        '
        Me.menuFile.Index = 0
        Me.menuFile.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.menuNewMessage, Me.menuSeparator1, Me.menuFileAttach, Me.menuSaveMessage, Me.menuSeparator2, Me.menuCloseFile})
        Me.menuFile.Text = "&File"
        '
        'menuNewMessage
        '
        Me.menuNewMessage.Index = 0
        Me.menuNewMessage.Shortcut = System.Windows.Forms.Shortcut.CtrlN
        Me.menuNewMessage.Text = "&New Message"
        '
        'menuSeparator1
        '
        Me.menuSeparator1.Index = 1
        Me.menuSeparator1.Text = "-"
        '
        'menuFileAttach
        '
        Me.menuFileAttach.Index = 2
        Me.menuFileAttach.Text = "&Attach File"
        '
        'menuSaveMessage
        '
        Me.menuSaveMessage.Index = 3
        Me.menuSaveMessage.Text = "&Save Message"
        '
        'menuSeparator2
        '
        Me.menuSeparator2.Index = 4
        Me.menuSeparator2.Text = "-"
        '
        'menuCloseFile
        '
        Me.menuCloseFile.Index = 5
        Me.menuCloseFile.Text = "Close"
        '
        'menuFormat
        '
        Me.menuFormat.Index = 1
        Me.menuFormat.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.menuFormatCharSets, Me.menuFormatEncodings, Me.menuSeparator4, Me.menuFormatPlainText, Me.menuFormatStyledText})
        Me.menuFormat.Text = "F&ormat"
        '
        'menuFormatCharSets
        '
        Me.menuFormatCharSets.Index = 0
        Me.menuFormatCharSets.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.menuCharSet1, Me.menuCharSet2, Me.menuCharSet3, Me.menuCharSet4, Me.menuCharSet5})
        Me.menuFormatCharSets.Text = "Character Set"
        '
        'menuFormatEncodings
        '
        Me.menuFormatEncodings.Index = 1
        Me.menuFormatEncodings.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.menuEncoding1, Me.menuEncoding2})
        Me.menuFormatEncodings.Text = "Encoding"
        '
        'menuSeparator4
        '
        Me.menuSeparator4.Index = 2
        Me.menuSeparator4.Text = "-"
        '
        'menuFormatPlainText
        '
        Me.menuFormatPlainText.Checked = True
        Me.menuFormatPlainText.Index = 3
        Me.menuFormatPlainText.Text = "Plain Text"
        '
        'menuFormatStyledText
        '
        Me.menuFormatStyledText.Index = 4
        Me.menuFormatStyledText.Text = "Styled Text (HTML)"
        '
        'menuMessage
        '
        Me.menuMessage.Index = 2
        Me.menuMessage.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.menuMessageSend, Me.menuSeparator5, Me.menuMessagePriorities, Me.menuSeparator6, Me.menuMessageOptions})
        Me.menuMessage.Text = "&Message"
        '
        'menuMessageSend
        '
        Me.menuMessageSend.Index = 0
        Me.menuMessageSend.Text = "Send Message"
        '
        'menuSeparator5
        '
        Me.menuSeparator5.Index = 1
        Me.menuSeparator5.Text = "-"
        '
        'menuMessagePriorities
        '
        Me.menuMessagePriorities.Index = 2
        Me.menuMessagePriorities.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.menuPriority1, Me.menuPriority2, Me.menuPriority3, Me.menuPriority4, Me.menuPriority5})
        Me.menuMessagePriorities.Text = "Priority"
        '
        'menuSeparator6
        '
        Me.menuSeparator6.Index = 3
        Me.menuSeparator6.Text = "-"
        '
        'menuMessageOptions
        '
        Me.menuMessageOptions.Index = 4
        Me.menuMessageOptions.Text = "Options"
        '
        'ctlProgress
        '
        Me.ctlProgress.Location = New System.Drawing.Point(302, 379)
        Me.ctlProgress.Name = "ctlProgress"
        Me.ctlProgress.Size = New System.Drawing.Size(225, 14)
        Me.ctlProgress.TabIndex = 16
        '
        'ctlStatus
        '
        Me.ctlStatus.Location = New System.Drawing.Point(0, 399)
        Me.ctlStatus.Name = "ctlStatus"
        Me.ctlStatus.Size = New System.Drawing.Size(542, 17)
        Me.ctlStatus.TabIndex = 17
        '
        'formMain
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.BackColor = System.Drawing.SystemColors.Control
        Me.ClientSize = New System.Drawing.Size(542, 416)
        Me.Controls.Add(Me.ctlProgress)
        Me.Controls.Add(Me.editMessageHTML)
        Me.Controls.Add(Me.editMessageText)
        Me.Controls.Add(Me.editBcc)
        Me.Controls.Add(Me.editCc)
        Me.Controls.Add(Me.editSubject)
        Me.Controls.Add(Me.editTo)
        Me.Controls.Add(Me.editFrom)
        Me.Controls.Add(Me.cmdBrowse)
        Me.Controls.Add(Me.comboAttachment)
        Me.Controls.Add(Me.lblAttachment)
        Me.Controls.Add(Me.lblBcc)
        Me.Controls.Add(Me.lblCc)
        Me.Controls.Add(Me.lblSubject)
        Me.Controls.Add(Me.lblTo)
        Me.Controls.Add(Me.lblFrom)
        Me.Controls.Add(Me.ctlStatus)
        Me.Cursor = System.Windows.Forms.Cursors.Default
        Me.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Location = New System.Drawing.Point(179, 203)
        Me.Menu = Me.MainMenu1
        Me.MinimumSize = New System.Drawing.Size(550, 450)
        Me.Name = "formMain"
        Me.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.StartPosition = System.Windows.Forms.FormStartPosition.Manual
        Me.Text = "SocketTools SendMail Example"
        Me.ResumeLayout(False)

    End Sub
#End Region

    Private bShowOptions As Boolean
    Private nMessageCharSet As Integer
    Private nMessageEncoding As Integer
    Private nMessagePriority As Integer

    Dim mailMessage As New SocketTools.MailMessage
    Dim dnsClient As New SocketTools.DnsClient
    Dim WithEvents smtpClient As New SocketTools.SmtpClient

    '
    ' Initialize the controls on the form and load any options
    ' that were stored (see options.bas module)
    '
    Private Sub formMain_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
        If Not mailMessage.Initialize() Then
            MsgBox("Unable to initialize SocketTools component", MsgBoxStyle.Exclamation)
            End
        End If

        If Not dnsClient.Initialize() Then
            MsgBox("Unable to initialize SocketTools component", MsgBoxStyle.Exclamation)
            End
        End If

        If Not smtpClient.Initialize() Then
            MsgBox("Unable to initialize SocketTools component", MsgBoxStyle.Exclamation)
            End
        End If

        nMessageCharSet = MimeCharacterSet.charsetUSASCII
        nMessageEncoding = MimeEncoding.encoding7Bit
        nMessagePriority = 3 ' Normal

        LoadOptions()
        bShowOptions = True ' Show options when form initializes

        If Len(g_strSenderAddress) > 0 Then
            editFrom.Text = Chr(34) & g_strSenderName & Chr(34) & " <" & g_strSenderAddress & ">"
        End If

        UpdateMenu()
        formMain_Resize(eventSender, eventArgs)
    End Sub

    Private Sub formMain_Activated(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Activated
        If bShowOptions Then
            Dim dlgOptions As New formOptions

            bShowOptions = False
            dlgOptions.ShowDialog()
        End If
    End Sub

    '
    ' Resize controls when the user resizes the form
    '
    Private Sub formMain_Resize(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Resize
        editFrom.Width = (ClientRectangle.Width - editFrom.Left) - 10
        editTo.Width = (ClientRectangle.Width - editTo.Left) - 10
        editSubject.Width = (ClientRectangle.Width - editSubject.Left) - 10
        editCc.Width = (ClientRectangle.Width - editCc.Left) - 10
        editBcc.Width = (ClientRectangle.Width - editBcc.Left) - 10
        cmdBrowse.Left = (ClientRectangle.Width - cmdBrowse.Width) - 10
        comboAttachment.Width = (cmdBrowse.Left - comboAttachment.Left) - 10
        editMessageText.Height = (ClientRectangle.Height - editMessageText.Top) - ctlStatus.Height - 10
        editMessageText.Width = (ClientRectangle.Width - editMessageText.Left) - 5
        editMessageHTML.Left = editMessageText.Left
        editMessageHTML.Top = editMessageText.Top
        editMessageHTML.Height = (ClientRectangle.Height - editMessageHTML.Top) - ctlStatus.Height - 10
        editMessageHTML.Width = ClientRectangle.Width - editMessageHTML.Left - 5
        ctlProgress.Left = (ClientRectangle.Width - ctlProgress.Width) - 10
        ctlProgress.Top = (ClientRectangle.Height - ctlStatus.Height)
    End Sub

    Private Sub formMain_Closed(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Closed
        mailMessage.Uninitialize()
        dnsClient.Uninitialize()
        smtpClient.Uninitialize()
    End Sub

    '
    ' Clear the current message
    '
    Public Sub menuNewMessage_Popup(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles menuNewMessage.Popup
        menuNewMessage_Click(eventSender, eventArgs)
    End Sub

    Public Sub menuNewMessage_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles menuNewMessage.Click
        mailMessage.ClearMessage()

        editFrom.Text = ""
        editTo.Text = ""
        editSubject.Text = ""
        editCc.Text = ""
        editBcc.Text = ""
        editMessageText.Text = ""
        editMessageHTML.Text = ""
        comboAttachment.Items.Clear()

        If Len(g_strSenderAddress) > 0 Then
            editFrom.Text = Chr(34) & g_strSenderName & Chr(34) & " <" & g_strSenderAddress & ">"
        End If
    End Sub
    '
    ' Save the current message to a file. The CreateMessage helper function
    ' is called, and then the user is prompted for a file to save the
    ' message to
    '
    Public Sub menuSaveMessage_Popup(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles menuSaveMessage.Popup
        menuSaveMessage_Click(eventSender, eventArgs)
    End Sub

    Public Sub menuSaveMessage_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles menuSaveMessage.Click
        Dim saveDialog As New SaveFileDialog

        If Not CreateMessage() Then
            MsgBox("Unable to create message" & mailMessage.LastErrorString, MsgBoxStyle.Exclamation)
            Exit Sub
        End If

        saveDialog.DefaultExt = ".txt"
        saveDialog.Title = "Save Message"
        saveDialog.FileName = ""
        saveDialog.FilterIndex = 1
        saveDialog.OverwritePrompt = True
        saveDialog.CheckPathExists = True
        saveDialog.Filter = "Text Files (*.txt)|*.txt|" & "E-Mail Message Files (*.eml)|*.eml|" & "All Files (*.*)|*.*"

        If saveDialog.ShowDialog() <> Windows.Forms.DialogResult.OK Then
            Exit Sub
        End If

        On Error GoTo 0

        If Not mailMessage.ExportMessage(saveDialog.FileName) Then
            MsgBox("Unable to save message to " & saveDialog.FileName & vbCrLf & mailMessage.LastErrorString, MsgBoxStyle.Exclamation)
            Exit Sub
        End If
    End Sub

    '
    ' Select a file to be attached to the message and add it to the
    ' combo box control which lists the current file attachments.
    ' Note that this does not actually attach the file to the current
    ' message; that is done in the CreateMessage helper function
    '
    Public Sub menuFileAttach_Popup(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles menuFileAttach.Popup
        menuFileAttach_Click(eventSender, eventArgs)
    End Sub

    Public Sub menuFileAttach_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles menuFileAttach.Click
        Dim openDialog As New OpenFileDialog

        openDialog.Title = "Attach File"
        openDialog.DefaultExt = ".txt"
        openDialog.FileName = ""
        openDialog.FilterIndex = 1
        openDialog.Filter = "All Files (*.*)|*.*"
        openDialog.CheckPathExists = True
        openDialog.CheckFileExists = True

        If openDialog.ShowDialog() <> Windows.Forms.DialogResult.OK Then
            Exit Sub
        End If

        comboAttachment.Items.Add(openDialog.FileName)
        comboAttachment.SelectedIndex = comboAttachment.Items.Count - 1
    End Sub

    Public Sub menuCloseFile_Popup(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles menuCloseFile.Popup
        menuCloseFile_Click(eventSender, eventArgs)
    End Sub
    Public Sub menuCloseFile_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles menuCloseFile.Click
        Me.Close()
    End Sub

    '
    ' Display the multiline edit control which contains the plain text
    ' version of the message
    '
    Public Sub menuFormatPlainText_Popup(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles menuFormatPlainText.Popup
        menuFormatPlainText_Click(eventSender, eventArgs)
    End Sub

    Public Sub menuFormatPlainText_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles menuFormatPlainText.Click
        editMessageText.Visible = True
        editMessageHTML.Visible = False
        menuFormatPlainText.Checked = True
        menuFormatStyledText.Checked = False
        ctlStatus.Text = "Enter the plain text version of your message"
    End Sub
    '
    ' Display the multiline edit control which contains the styled (HTML)
    ' text version of the message. See the CreateMessage helper function
    ' for how the sample handles HTML text. A more sophisticated approach
    ' would be to actually create an HTML editor, but that is beyond the
    ' scope of this example.
    '
    Public Sub menuFormatStyledText_Popup(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles menuFormatStyledText.Popup
        menuFormatStyledText_Click(eventSender, eventArgs)
    End Sub
    Public Sub menuFormatStyledText_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles menuFormatStyledText.Click
        editMessageText.Visible = False
        editMessageHTML.Visible = True
        menuFormatPlainText.Checked = False
        menuFormatStyledText.Checked = True
        ctlStatus.Text = "Enter the styled text version of your message"
    End Sub

    '
    ' Call the CreateMessage helper function to create the message and
    ' then deliver it to the specified recipients
    '
    Public Sub menuMessageSend_Popup(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles menuMessageSend.Popup
        menuMessageSend_Click(eventSender, eventArgs)
    End Sub

    Public Sub menuMessageSend_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles menuMessageSend.Click
        Dim strSender As String
        Dim strRecipient As String
        Dim strDomain As String
        Dim nPos As Integer
        Dim nDelivered As Integer
        Dim nIndex As Integer

        If Not CreateMessage() Then
            ctlStatus.Text = mailMessage.LastErrorString
            MsgBox("Unable to create a new message" & vbCrLf & mailMessage.LastErrorString, MsgBoxStyle.Exclamation)
            Exit Sub
        End If

        strSender = mailMessage.Sender
        If Len(strSender) = 0 Then
            MsgBox("There is no valid sender for this message", MsgBoxStyle.Exclamation)
            Exit Sub
        End If

        If mailMessage.Recipients = 0 Then
            MsgBox("There are no recipients for this message", MsgBoxStyle.Information)
            Exit Sub
        End If

        ctlProgress.Minimum = 0
        ctlProgress.Maximum = 100
        ctlProgress.Value = 0
        nDelivered = 0

        For nIndex = 0 To mailMessage.Recipients - 1
            strRecipient = mailMessage.Recipient(nIndex)
            smtpClient.Reset()

            '
            ' The user has specified that a relay server is to be used
            ' (under the Message | Options menu) then set those properties
            ' so that our message will always be routed through that server
            '
            If g_bRelayMessages Then
                smtpClient.HostName = g_strRelayServer
                smtpClient.RemotePort = g_nRelayPort
                If g_bAuthenticate Then
                    smtpClient.UserName = g_strUserName
                    smtpClient.Password = g_strPassword
                End If
                smtpClient.Extended = True
            Else
                nPos = InStr(strRecipient, "@")
                strDomain = ""
                If nPos > 0 Then strDomain = Mid(strRecipient, nPos)
                dnsClient.HostName = strDomain
                If dnsClient.MailExchanges = 0 Then
                    smtpClient.HostName = dnsClient.HostName
                    smtpClient.RemotePort = smtpPortDefault
                Else
                    smtpClient.HostName = dnsClient.MailExchange(0)
                    smtpClient.RemotePort = smtpPortDefault
                End If
            End If

            If Not smtpClient.Connect() Then
                MsgBox(smtpClient.LastErrorString, MsgBoxStyle.Exclamation)
                Exit For
            End If

            ctlProgress.Value = 0
            ctlStatus.Text = "Sending message to " & strRecipient

            If Not smtpClient.SendMessage(strSender, strRecipient, mailMessage.Message) Then
                ctlStatus.Text = mailMessage.LastErrorString
                MsgBox("Unable to send message" & vbCrLf & smtpClient.LastErrorString, MsgBoxStyle.Exclamation)
                smtpClient.Disconnect()
                Exit For
            End If

            smtpClient.Disconnect()
            nDelivered = nDelivered + 1
        Next

        ctlProgress.Value = 0
        ctlStatus.Text = ""

        If nDelivered > 0 Then
            ctlStatus.Text = "Message delivered to " & nDelivered & " recipient(s)"
        End If

    End Sub

    '
    ' Display the options dialog which allows the user to enter
    ' some default values and select whether or not a relay server
    ' should be used to deliver messages
    '
    Public Sub menuMessageOptions_Popup(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles menuMessageOptions.Popup
        menuMessageOptions_Click(eventSender, eventArgs)
    End Sub

    Public Sub menuMessageOptions_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles menuMessageOptions.Click
        Dim dlgOptions As New formOptions
        dlgOptions.ShowDialog()
    End Sub

    Private Sub cmdBrowse_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdBrowse.Click
        menuFileAttach_Click(menuFileAttach, New System.EventArgs)
    End Sub

    '
    ' A helper function which uses the ComposeMessage method to create a
    ' message, followed by attaching each of the listed files to the
    ' message. This function is called when the user selects the menu option
    ' to send a message or save the message to a text file
    '
    Private Function CreateMessage() As Boolean
        Dim strFontName As String
        Dim strFontSize As String
        Dim strMessageHTML As String
        Dim nIndex As Integer

        CreateMessage = True

        '
        ' If the user has entered any HTML text, then make sure that it is
        ' properly formed HTML and specify a font and font size to use;
        ' this is hard-coded, but an application would obviously want to
        ' make something like font selection customizable
        '
        If Len(Trim(editMessageHTML.Text)) = 0 Then
            strMessageHTML = ""
        Else
            strFontName = "Arial"
            strFontSize = "3"
            strMessageHTML = "<html><head><title>" & editSubject.Text & "</title></head>" & "<body><font " & "face=" & Chr(34) & strFontName & Chr(34) & " " & "size=" & Chr(34) & strFontSize & Chr(34) & ">" & vbCrLf & editMessageHTML.Text & vbCrLf & "</font></body></html>"
        End If

        '
        ' Use the ComposeMessage method to do all of the hard work of
        ' creating the actual message
        '
        If Not mailMessage.ComposeMessage(editFrom.Text, editTo.Text, editCc.Text, editBcc.Text, editSubject.Text, editMessageText.Text, strMessageHTML, nMessageCharSet, nMessageEncoding) Then
            CreateMessage = False
            Exit Function
        End If

        '
        ' Attach each file that was selected by the user
        '
        For nIndex = 0 To comboAttachment.Items.Count - 1
            If Not mailMessage.AttachFile(comboAttachment.Items.Item(nIndex)) Then
                CreateMessage = False
                Exit Function
            End If
        Next

        Select Case nMessagePriority
            Case 1
                mailMessage.Priority = "1 (Highest)"
            Case 2
                mailMessage.Priority = "2 (High)"
            Case 3
                mailMessage.Priority = "3 (Normal)"
            Case 4
                mailMessage.Priority = "4 (Low)"
            Case 5
                mailMessage.Priority = "5 (Lowest)"
        End Select

        '
        ' Set the Organization property to the name of the current user's
        ' organization or company; this is specified in the options dialog
        '
        mailMessage.Organization = g_strOrganization

    End Function

    Private Sub smtpClient_OnProgress(ByVal sender As Object, ByVal e As SocketTools.SmtpClient.ProgressEventArgs) Handles smtpClient.OnProgress
        ctlProgress.Value = e.Percent
    End Sub

    Private Sub UpdateMenu()
        menuCharSet1.Checked = False
        menuCharSet2.Checked = False
        menuCharSet3.Checked = False
        menuCharSet4.Checked = False
        menuCharSet5.Checked = False

        Select Case nMessageCharSet
            Case SocketTools.MailMessage.MimeCharacterSet.charsetISO8859_1
                menuCharSet1.Checked = True

            Case SocketTools.MailMessage.MimeCharacterSet.charsetISO8859_2
                menuCharSet2.Checked = True

            Case SocketTools.MailMessage.MimeCharacterSet.charsetISO8859_5
                menuCharSet3.Checked = True

            Case SocketTools.MailMessage.MimeCharacterSet.charsetISO8859_7
                menuCharSet4.Checked = True

            Case SocketTools.MailMessage.MimeCharacterSet.charsetISO8859_9
                menuCharSet5.Checked = True
        End Select

        menuEncoding1.Checked = False
        menuEncoding2.Checked = False

        Select Case nMessageEncoding
            Case SocketTools.MailMessage.MimeEncoding.encoding7Bit
                menuEncoding1.Checked = True

            Case SocketTools.MailMessage.MimeEncoding.encodingQuoted
                menuEncoding2.Checked = True
        End Select

        menuPriority1.Checked = False
        menuPriority2.Checked = False
        menuPriority3.Checked = False
        menuPriority4.Checked = False
        menuPriority5.Checked = False

        Select Case nMessagePriority
            Case 1 ' Highest
                menuPriority1.Checked = True

            Case 2 ' High
                menuPriority2.Checked = True

            Case 3 ' Normal
                menuPriority3.Checked = True

            Case 4 ' Low
                menuPriority4.Checked = True

            Case 5 ' Lowest
                menuPriority5.Checked = True
        End Select

    End Sub

    Private Sub menuCharSet1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuCharSet1.Click
        nMessageCharSet = SocketTools.MailMessage.MimeCharacterSet.charsetISO8859_1
        UpdateMenu()
    End Sub

    Private Sub menuCharSet2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuCharSet2.Click
        nMessageCharSet = SocketTools.MailMessage.MimeCharacterSet.charsetISO8859_2
        UpdateMenu()
    End Sub

    Private Sub menuCharSet3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuCharSet3.Click
        nMessageCharSet = SocketTools.MailMessage.MimeCharacterSet.charsetISO8859_5
        UpdateMenu()
    End Sub

    Private Sub menuCharSet4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuCharSet4.Click
        nMessageCharSet = SocketTools.MailMessage.MimeCharacterSet.charsetISO8859_7
        UpdateMenu()
    End Sub

    Private Sub menuCharSet5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuCharSet5.Click
        nMessageCharSet = SocketTools.MailMessage.MimeCharacterSet.charsetISO8859_9
        UpdateMenu()
    End Sub

    Private Sub menuEncoding1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuEncoding1.Click
        nMessageEncoding = SocketTools.MailMessage.MimeEncoding.encoding7Bit
        UpdateMenu()
    End Sub

    Private Sub menuEncoding2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuEncoding2.Click
        nMessageEncoding = SocketTools.MailMessage.MimeEncoding.encodingQuoted
        UpdateMenu()
    End Sub

    Private Sub menuPriority1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuPriority1.Click
        nMessagePriority = 1 ' Highest
        UpdateMenu()
    End Sub

    Private Sub menuPriority2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuPriority2.Click
        nMessagePriority = 2 ' High
        UpdateMenu()
    End Sub

    Private Sub menuPriority3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuPriority3.Click
        nMessagePriority = 3 ' Normal
        UpdateMenu()
    End Sub

    Private Sub menuPriority4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuPriority4.Click
        nMessagePriority = 4 ' Low
        UpdateMenu()
    End Sub

    Private Sub menuPriority5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuPriority5.Click
        nMessagePriority = 5 ' Lowest
        UpdateMenu()
    End Sub
End Class
