// SocketTools 10 Build 1468
// Copyright 2023 Catalyst Development Corporation
// All rights reserved
// 
// This file is licensed to you pursuant to the terms of the
// product license agreement included with the original software,
// and is protected by copyright law and international treaties.
// Unauthorized reproduction or distribution may result in severe
// criminal penalties.

using System;
using System.Collections;
using System.Data;
using System.Drawing;
using System.Diagnostics;
using System.Windows.Forms;
using Microsoft.VisualBasic;

namespace Ping
{
    internal class formMain : System.Windows.Forms.Form 
    { 
        #region "Windows Form Designer generated code "
        public formMain() : base() 
        { 
            // This call is required by the Windows Form Designer.
            InitializeComponent();

            // Events handled by icmpClient_OnEcho
            icmpClient.OnEcho += new SocketTools.IcmpClient.OnEchoEventHandler(icmpClient_OnEcho);
            // Events handled by icmpClient_OnReply
            icmpClient.OnReply += new SocketTools.IcmpClient.OnReplyEventHandler(icmpClient_OnReply);
            // Events handled by icmpTimer_Tick
            icmpTimer.Tick += new System.EventHandler(icmpTimer_Tick);
        } 

        // Form overrides dispose to clean up the component list.
        protected override void Dispose( bool Disposing ) 
        { 
            if ( Disposing ) 
            { 
                if ( !( components == null ) ) 
                { 
                    components.Dispose(); 
                } 
            } 
            base.Dispose( Disposing ); 
        } 
        
        // Required by the Windows Form Designer
        private System.ComponentModel.IContainer components; 
        public System.Windows.Forms.ToolTip ToolTip1; 
        public System.Windows.Forms.Timer icmpTimer; 
        public System.Windows.Forms.TextBox editHostName; 
        public System.Windows.Forms.Button cmdAction; 
        public System.Windows.Forms.TextBox textOutput; 
        public System.Windows.Forms.Label Label1; 
        public System.Windows.Forms.Label labelRecv; 
        public System.Windows.Forms.Label labelLoss; 
        public System.Windows.Forms.Label Label5; 
        public System.Windows.Forms.Label Label4; 
        public System.Windows.Forms.Label labelSend; 
        public System.Windows.Forms.Label Label2; 
        // NOTE: The following procedure is required by the Windows Form Designer
        // It can be modified using the Windows Form Designer.
        // Do not modify it using the code editor.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() 
        { 
            this.components = new System.ComponentModel.Container(); 
            this.ToolTip1 = new System.Windows.Forms.ToolTip( this.components ); 
            this.icmpTimer = new System.Windows.Forms.Timer( this.components ); 
            this.editHostName = new System.Windows.Forms.TextBox(); 
            this.cmdAction = new System.Windows.Forms.Button(); 
            this.textOutput = new System.Windows.Forms.TextBox(); 
            this.Label1 = new System.Windows.Forms.Label(); 
            this.labelRecv = new System.Windows.Forms.Label(); 
            this.labelLoss = new System.Windows.Forms.Label(); 
            this.Label5 = new System.Windows.Forms.Label(); 
            this.Label4 = new System.Windows.Forms.Label(); 
            this.labelSend = new System.Windows.Forms.Label(); 
            this.Label2 = new System.Windows.Forms.Label(); 
            this.SuspendLayout(); 
            // 
            // icmpTimer
            // 
            this.icmpTimer.Interval = 1000; 
            // 
            // editHostName
            // 
            this.editHostName.AcceptsReturn = true; 
            this.editHostName.AutoSize = false; 
            this.editHostName.BackColor = System.Drawing.SystemColors.Window; 
            this.editHostName.Cursor = System.Windows.Forms.Cursors.IBeam; 
            this.editHostName.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.editHostName.ForeColor = System.Drawing.SystemColors.WindowText; 
            this.editHostName.Location = new System.Drawing.Point( 56, 8 ); 
            this.editHostName.MaxLength = 0; 
            this.editHostName.Name = "editHostName"; 
            this.editHostName.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.editHostName.Size = new System.Drawing.Size( 185, 19 ); 
            this.editHostName.TabIndex = 0; 
            this.editHostName.Text = ""; 
            // 
            // cmdAction
            // 
            this.cmdAction.BackColor = System.Drawing.SystemColors.Control; 
            this.cmdAction.Cursor = System.Windows.Forms.Cursors.Default; 
            this.cmdAction.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.cmdAction.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.cmdAction.Location = new System.Drawing.Point( 158, 224 ); 
            this.cmdAction.Name = "cmdAction"; 
            this.cmdAction.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.cmdAction.Size = new System.Drawing.Size( 81, 25 ); 
            this.cmdAction.TabIndex = 2; 
            // 
            // textOutput
            // 
            this.textOutput.AcceptsReturn = true; 
            this.textOutput.AutoSize = false; 
            this.textOutput.BackColor = System.Drawing.SystemColors.Window; 
            this.textOutput.Cursor = System.Windows.Forms.Cursors.IBeam; 
            this.textOutput.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.textOutput.ForeColor = System.Drawing.SystemColors.WindowText; 
            this.textOutput.Location = new System.Drawing.Point( 8, 32 ); 
            this.textOutput.MaxLength = 0; 
            this.textOutput.Multiline = true; 
            this.textOutput.Name = "textOutput"; 
            this.textOutput.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.textOutput.ScrollBars = System.Windows.Forms.ScrollBars.Vertical; 
            this.textOutput.Size = new System.Drawing.Size( 377, 153 ); 
            this.textOutput.TabIndex = 1; 
            this.textOutput.Text = ""; 
            // 
            // Label1
            // 
            this.Label1.AutoSize = true; 
            this.Label1.BackColor = System.Drawing.Color.Transparent; 
            this.Label1.Cursor = System.Windows.Forms.Cursors.Default; 
            this.Label1.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.Label1.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.Label1.Location = new System.Drawing.Point( 8, 10 ); 
            this.Label1.Name = "Label1"; 
            this.Label1.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.Label1.Size = new System.Drawing.Size( 44, 16 ); 
            this.Label1.TabIndex = 11; 
            this.Label1.Text = "&System:"; 
            // 
            // labelRecv
            // 
            this.labelRecv.BackColor = System.Drawing.SystemColors.Control; 
            this.labelRecv.Cursor = System.Windows.Forms.Cursors.Default; 
            this.labelRecv.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.labelRecv.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.labelRecv.Location = new System.Drawing.Point( 232, 192 ); 
            this.labelRecv.Name = "labelRecv"; 
            this.labelRecv.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.labelRecv.Size = new System.Drawing.Size( 65, 13 ); 
            this.labelRecv.TabIndex = 8; 
            // 
            // labelLoss
            // 
            this.labelLoss.BackColor = System.Drawing.SystemColors.Control; 
            this.labelLoss.Cursor = System.Windows.Forms.Cursors.Default; 
            this.labelLoss.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.labelLoss.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.labelLoss.Location = new System.Drawing.Point( 344, 192 ); 
            this.labelLoss.Name = "labelLoss"; 
            this.labelLoss.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.labelLoss.Size = new System.Drawing.Size( 39, 13 ); 
            this.labelLoss.TabIndex = 3; 
            // 
            // Label5
            // 
            this.Label5.AutoSize = true; 
            this.Label5.BackColor = System.Drawing.SystemColors.Control; 
            this.Label5.Cursor = System.Windows.Forms.Cursors.Default; 
            this.Label5.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.Label5.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.Label5.Location = new System.Drawing.Point( 304, 192 ); 
            this.Label5.Name = "Label5"; 
            this.Label5.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.Label5.Size = new System.Drawing.Size( 30, 16 ); 
            this.Label5.TabIndex = 7; 
            this.Label5.Text = "Loss:"; 
            // 
            // Label4
            // 
            this.Label4.AutoSize = true; 
            this.Label4.BackColor = System.Drawing.SystemColors.Control; 
            this.Label4.Cursor = System.Windows.Forms.Cursors.Default; 
            this.Label4.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.Label4.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.Label4.Location = new System.Drawing.Point( 168, 192 ); 
            this.Label4.Name = "Label4"; 
            this.Label4.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.Label4.Size = new System.Drawing.Size( 53, 16 ); 
            this.Label4.TabIndex = 6; 
            this.Label4.Text = "Received:"; 
            // 
            // labelSend
            // 
            this.labelSend.BackColor = System.Drawing.SystemColors.Control; 
            this.labelSend.Cursor = System.Windows.Forms.Cursors.Default; 
            this.labelSend.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.labelSend.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.labelSend.Location = new System.Drawing.Point( 96, 192 ); 
            this.labelSend.Name = "labelSend"; 
            this.labelSend.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.labelSend.Size = new System.Drawing.Size( 65, 13 ); 
            this.labelSend.TabIndex = 5; 
            // 
            // Label2
            // 
            this.Label2.AutoSize = true; 
            this.Label2.BackColor = System.Drawing.SystemColors.Control; 
            this.Label2.Cursor = System.Windows.Forms.Cursors.Default; 
            this.Label2.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.Label2.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.Label2.Location = new System.Drawing.Point( 8, 192 ); 
            this.Label2.Name = "Label2"; 
            this.Label2.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.Label2.Size = new System.Drawing.Size( 72, 16 ); 
            this.Label2.TabIndex = 4; 
            this.Label2.Text = "Packets Sent:"; 
            // 
            // formMain
            // 
            this.AcceptButton = this.cmdAction; 
            this.AutoScaleBaseSize = new System.Drawing.Size( 5, 13 ); 
            this.BackColor = System.Drawing.SystemColors.Control; 
            this.ClientSize = new System.Drawing.Size( 397, 262 ); 
            this.Controls.Add( this.editHostName ); 
            this.Controls.Add( this.cmdAction ); 
            this.Controls.Add( this.textOutput ); 
            this.Controls.Add( this.Label1 ); 
            this.Controls.Add( this.labelRecv ); 
            this.Controls.Add( this.labelLoss ); 
            this.Controls.Add( this.Label5 ); 
            this.Controls.Add( this.Label4 ); 
            this.Controls.Add( this.labelSend ); 
            this.Controls.Add( this.Label2 ); 
            this.Cursor = System.Windows.Forms.Cursors.Default; 
            this.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.ForeColor = System.Drawing.SystemColors.WindowText; 
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle; 
            this.Location = new System.Drawing.Point( 151, 124 ); 
            this.MaximizeBox = false; 
            this.Name = "formMain"; 
            this.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.StartPosition = System.Windows.Forms.FormStartPosition.Manual; 
            this.Text = "SocketTools - Ping Example"; 
            this.ResumeLayout( false ); 
            
            // events handled by formMain_Load
            base.Load += new System.EventHandler( formMain_Load ); 
            // events handled by formMain_Closed
            base.Closed += new System.EventHandler( formMain_Closed ); 
            // events handled by cmdAction_Click
            cmdAction.Click += new System.EventHandler( cmdAction_Click ); 
        } 
        
		[STAThread]
		public static void Main()
		{
			Application.Run( new formMain() );
		}
		
		#endregion 
        
        public SocketTools.IcmpClient icmpClient = new SocketTools.IcmpClient(); 
        
        private void formMain_Load( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            if ( !( icmpClient.Initialize() ) ) 
            { 
                Interaction.MsgBox( "Unable to initialize SocketTools component", MsgBoxStyle.Exclamation, null ); 
                System.Environment.Exit( 0 ); 
            } 
            
            cmdAction.Text = "Start"; 
            icmpClient.AutoResolve = false; 
            labelSend.Text = "0"; 
            labelRecv.Text = "0"; 
            labelLoss.Text = "0%"; 
        } 
        
        
        private void formMain_Closed( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            icmpClient.Uninitialize(); 
            System.Environment.Exit( 0 ); 
        } 
        
        
        private void cmdAction_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            string strHostName = null; 
            if ( cmdAction.Text == "Start" ) 
            { 
                strHostName = editHostName.Text.Trim();
                if ( strHostName.Length == 0 ) 
                { 
                    Interaction.MsgBox( "Please enter a host name or IP address", MsgBoxStyle.Exclamation, null ); 
                    editHostName.Focus(); 
                    return; 
                } 
                
                cmdAction.Text = "Stop"; 
                textOutput.Text = ""; 
                labelSend.Text = "0"; 
                labelRecv.Text = "0"; 
                labelLoss.Text = "0%"; 
                
                icmpClient.Reset(); 
                icmpClient.HostName = strHostName; 
                icmpTimer.Interval = 1000; 
                icmpTimer.Enabled = true; 
            } 
            else 
            { 
                cmdAction.Text = "Start"; 
                icmpTimer.Enabled = false; 
            } 
        } 
        
        
        private void icmpClient_OnEcho( object sender, SocketTools.IcmpClient.EchoEventArgs e ) 
        { 
            short Percent = 0; 
            
            if ( icmpClient.SendCount > 1 ) 
            { 
                Percent = System.Convert.ToInt16( 100 - ( ( icmpClient.RecvCount / icmpClient.SendCount ) * 100 ) ); 
                labelLoss.Text = System.Convert.ToString( Percent ) + "%"; 
            } 
            
            labelSend.Text = System.Convert.ToString( icmpClient.SendCount ); 
        } 
        
        
        private void icmpClient_OnReply( object sender, SocketTools.IcmpClient.ReplyEventArgs e ) 
        { 
            textOutput.AppendText(e.PacketSize.ToString() + " bytes received, icmp_seq=" + e.SequenceId.ToString() + ", time=" + e.TripTime.ToString() + " ms" + "\r\n");
            labelRecv.Text = System.Convert.ToString( icmpClient.RecvCount ); 
        } 

        
        private void icmpTimer_Tick( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            if ( !( icmpTimer.Enabled ) | icmpClient.IsBlocked ) 
            { 
                return; 
            } 
            
            if ( !( icmpClient.Echo() ) ) 
            { 
                cmdAction.Text = "Start"; 
                icmpTimer.Enabled = false; 
                Interaction.MsgBox( icmpClient.LastErrorString, MsgBoxStyle.Exclamation, null ); 
            } 
        } 
    } 
} 
