// SocketTools 10 Build 1468
// Copyright 2023 Catalyst Development Corporation
// All rights reserved
// 
// This file is licensed to you pursuant to the terms of the
// product license agreement included with the original software,
// and is protected by copyright law and international treaties.
// Unauthorized reproduction or distribution may result in severe
// criminal penalties.

using System;
using System.Collections;
using System.Data;
using System.Drawing;
using System.Diagnostics;
using System.Windows.Forms;
using Microsoft.VisualBasic;

namespace RemoteShell
{
    internal class formMain : System.Windows.Forms.Form 
    { 
        #region "Windows Form Designer generated code "
        public formMain() : base() 
        { 
            // This call is required by the Windows Form Designer.
            InitializeComponent(); 
        } 

        // Form overrides dispose to clean up the component list.
        protected override void Dispose( bool Disposing ) 
        { 
            if ( Disposing ) 
            { 
                if ( !( components == null ) ) 
                { 
                    components.Dispose(); 
                } 
            } 
            base.Dispose( Disposing ); 
        } 
        
        // Required by the Windows Form Designer
        private System.ComponentModel.IContainer components; 
        public System.Windows.Forms.ToolTip ToolTip1; 
        public System.Windows.Forms.TextBox textOutput; 
        public System.Windows.Forms.ComboBox comboPort; 
        public System.Windows.Forms.TextBox editCommand; 
        public System.Windows.Forms.TextBox editPassword; 
        public System.Windows.Forms.TextBox editUserName; 
        public System.Windows.Forms.TextBox editHostName; 
        public System.Windows.Forms.Button cmdAction; 
        public System.Windows.Forms.Label Label5; 
        public System.Windows.Forms.Label Label4; 
        public System.Windows.Forms.Label Label3; 
        public System.Windows.Forms.Label Label2; 
        public System.Windows.Forms.Label Label1; 
        // NOTE: The following procedure is required by the Windows Form Designer
        // It can be modified using the Windows Form Designer.
        // Do not modify it using the code editor.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() 
        { 
            this.components = new System.ComponentModel.Container(); 
            this.ToolTip1 = new System.Windows.Forms.ToolTip( this.components ); 
            this.textOutput = new System.Windows.Forms.TextBox(); 
            this.comboPort = new System.Windows.Forms.ComboBox(); 
            this.editCommand = new System.Windows.Forms.TextBox(); 
            this.editPassword = new System.Windows.Forms.TextBox(); 
            this.editUserName = new System.Windows.Forms.TextBox(); 
            this.editHostName = new System.Windows.Forms.TextBox(); 
            this.cmdAction = new System.Windows.Forms.Button(); 
            this.Label5 = new System.Windows.Forms.Label(); 
            this.Label4 = new System.Windows.Forms.Label(); 
            this.Label3 = new System.Windows.Forms.Label(); 
            this.Label2 = new System.Windows.Forms.Label(); 
            this.Label1 = new System.Windows.Forms.Label(); 
            this.SuspendLayout(); 
            // 
            // textOutput
            // 
            this.textOutput.AcceptsReturn = true; 
            this.textOutput.AutoSize = false; 
            this.textOutput.BackColor = System.Drawing.SystemColors.Window; 
            this.textOutput.Cursor = System.Windows.Forms.Cursors.IBeam; 
            this.textOutput.Font = new System.Drawing.Font( "Courier New", 9.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.textOutput.ForeColor = System.Drawing.SystemColors.WindowText; 
            this.textOutput.Location = new System.Drawing.Point( 8, 84 ); 
            this.textOutput.MaxLength = 0; 
            this.textOutput.Multiline = true; 
            this.textOutput.Name = "textOutput"; 
            this.textOutput.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.textOutput.ScrollBars = System.Windows.Forms.ScrollBars.Both; 
            this.textOutput.Size = new System.Drawing.Size( 513, 241 ); 
            this.textOutput.TabIndex = 11; 
            this.textOutput.Text = ""; 
            this.textOutput.WordWrap = false; 
            // 
            // comboPort
            // 
            this.comboPort.BackColor = System.Drawing.SystemColors.Window; 
            this.comboPort.Cursor = System.Windows.Forms.Cursors.Default; 
            this.comboPort.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList; 
            this.comboPort.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.comboPort.ForeColor = System.Drawing.SystemColors.WindowText; 
            this.comboPort.Location = new System.Drawing.Point( 336, 4 ); 
            this.comboPort.Name = "comboPort"; 
            this.comboPort.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.comboPort.Size = new System.Drawing.Size( 185, 22 ); 
            this.comboPort.TabIndex = 3; 
            // 
            // editCommand
            // 
            this.editCommand.AcceptsReturn = true; 
            this.editCommand.AutoSize = false; 
            this.editCommand.BackColor = System.Drawing.SystemColors.Window; 
            this.editCommand.Cursor = System.Windows.Forms.Cursors.IBeam; 
            this.editCommand.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.editCommand.ForeColor = System.Drawing.SystemColors.WindowText; 
            this.editCommand.Location = new System.Drawing.Point( 78, 52 ); 
            this.editCommand.MaxLength = 0; 
            this.editCommand.Name = "editCommand"; 
            this.editCommand.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.editCommand.Size = new System.Drawing.Size( 443, 19 ); 
            this.editCommand.TabIndex = 9; 
            this.editCommand.Text = ""; 
            // 
            // editPassword
            // 
            this.editPassword.AcceptsReturn = true; 
            this.editPassword.AutoSize = false; 
            this.editPassword.BackColor = System.Drawing.SystemColors.Window; 
            this.editPassword.Cursor = System.Windows.Forms.Cursors.IBeam; 
            this.editPassword.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.editPassword.ForeColor = System.Drawing.SystemColors.WindowText; 
            this.editPassword.Location = new System.Drawing.Point( 336, 28 ); 
            this.editPassword.MaxLength = 0; 
            this.editPassword.Name = "editPassword"; 
            this.editPassword.PasswordChar = Microsoft.VisualBasic.Strings.ChrW( 42 ); 
            this.editPassword.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.editPassword.Size = new System.Drawing.Size( 185, 19 ); 
            this.editPassword.TabIndex = 7; 
            this.editPassword.Text = ""; 
            // 
            // editUserName
            // 
            this.editUserName.AcceptsReturn = true; 
            this.editUserName.AutoSize = false; 
            this.editUserName.BackColor = System.Drawing.SystemColors.Window; 
            this.editUserName.Cursor = System.Windows.Forms.Cursors.IBeam; 
            this.editUserName.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.editUserName.ForeColor = System.Drawing.SystemColors.WindowText; 
            this.editUserName.Location = new System.Drawing.Point( 78, 28 ); 
            this.editUserName.MaxLength = 0; 
            this.editUserName.Name = "editUserName"; 
            this.editUserName.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.editUserName.Size = new System.Drawing.Size( 179, 19 ); 
            this.editUserName.TabIndex = 5; 
            this.editUserName.Text = ""; 
            // 
            // editHostName
            // 
            this.editHostName.AcceptsReturn = true; 
            this.editHostName.AutoSize = false; 
            this.editHostName.BackColor = System.Drawing.SystemColors.Window; 
            this.editHostName.Cursor = System.Windows.Forms.Cursors.IBeam; 
            this.editHostName.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.editHostName.ForeColor = System.Drawing.SystemColors.WindowText; 
            this.editHostName.Location = new System.Drawing.Point( 78, 6 ); 
            this.editHostName.MaxLength = 0; 
            this.editHostName.Name = "editHostName"; 
            this.editHostName.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.editHostName.Size = new System.Drawing.Size( 179, 19 ); 
            this.editHostName.TabIndex = 1; 
            this.editHostName.Text = ""; 
            // 
            // cmdAction
            // 
            this.cmdAction.BackColor = System.Drawing.SystemColors.Control; 
            this.cmdAction.Cursor = System.Windows.Forms.Cursors.Default; 
            this.cmdAction.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.cmdAction.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.cmdAction.Location = new System.Drawing.Point( 222, 334 ); 
            this.cmdAction.Name = "cmdAction"; 
            this.cmdAction.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.cmdAction.Size = new System.Drawing.Size( 89, 27 ); 
            this.cmdAction.TabIndex = 10; 
            this.cmdAction.Text = "Execute"; 
            // 
            // Label5
            // 
            this.Label5.AutoSize = true; 
            this.Label5.BackColor = System.Drawing.SystemColors.Control; 
            this.Label5.Cursor = System.Windows.Forms.Cursors.Default; 
            this.Label5.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.Label5.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.Label5.Location = new System.Drawing.Point( 272, 8 ); 
            this.Label5.Name = "Label5"; 
            this.Label5.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.Label5.Size = new System.Drawing.Size( 27, 16 ); 
            this.Label5.TabIndex = 2; 
            this.Label5.Text = "Port:"; 
            // 
            // Label4
            // 
            this.Label4.AutoSize = true; 
            this.Label4.BackColor = System.Drawing.SystemColors.Control; 
            this.Label4.Cursor = System.Windows.Forms.Cursors.Default; 
            this.Label4.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.Label4.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.Label4.Location = new System.Drawing.Point( 10, 54 ); 
            this.Label4.Name = "Label4"; 
            this.Label4.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.Label4.Size = new System.Drawing.Size( 58, 16 ); 
            this.Label4.TabIndex = 8; 
            this.Label4.Text = "Command:"; 
            // 
            // Label3
            // 
            this.Label3.AutoSize = true; 
            this.Label3.BackColor = System.Drawing.SystemColors.Control; 
            this.Label3.Cursor = System.Windows.Forms.Cursors.Default; 
            this.Label3.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.Label3.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.Label3.Location = new System.Drawing.Point( 272, 32 ); 
            this.Label3.Name = "Label3"; 
            this.Label3.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.Label3.Size = new System.Drawing.Size( 55, 16 ); 
            this.Label3.TabIndex = 6; 
            this.Label3.Text = "Password:"; 
            // 
            // Label2
            // 
            this.Label2.AutoSize = true; 
            this.Label2.BackColor = System.Drawing.SystemColors.Control; 
            this.Label2.Cursor = System.Windows.Forms.Cursors.Default; 
            this.Label2.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.Label2.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.Label2.Location = new System.Drawing.Point( 10, 30 ); 
            this.Label2.Name = "Label2"; 
            this.Label2.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.Label2.Size = new System.Drawing.Size( 58, 16 ); 
            this.Label2.TabIndex = 4; 
            this.Label2.Text = "Username:"; 
            // 
            // Label1
            // 
            this.Label1.AutoSize = true; 
            this.Label1.BackColor = System.Drawing.SystemColors.Control; 
            this.Label1.Cursor = System.Windows.Forms.Cursors.Default; 
            this.Label1.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.Label1.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.Label1.Location = new System.Drawing.Point( 10, 8 ); 
            this.Label1.Name = "Label1"; 
            this.Label1.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.Label1.Size = new System.Drawing.Size( 57, 16 ); 
            this.Label1.TabIndex = 0; 
            this.Label1.Text = "Hostname:"; 
            // 
            // formMain
            // 
            this.AcceptButton = this.cmdAction; 
            this.AutoScaleBaseSize = new System.Drawing.Size( 5, 13 ); 
            this.BackColor = System.Drawing.SystemColors.Control; 
            this.ClientSize = new System.Drawing.Size( 529, 369 ); 
            this.Controls.Add( this.textOutput ); 
            this.Controls.Add( this.comboPort ); 
            this.Controls.Add( this.editCommand ); 
            this.Controls.Add( this.editPassword ); 
            this.Controls.Add( this.editUserName ); 
            this.Controls.Add( this.editHostName ); 
            this.Controls.Add( this.cmdAction ); 
            this.Controls.Add( this.Label5 ); 
            this.Controls.Add( this.Label4 ); 
            this.Controls.Add( this.Label3 ); 
            this.Controls.Add( this.Label2 ); 
            this.Controls.Add( this.Label1 ); 
            this.Cursor = System.Windows.Forms.Cursors.Default; 
            this.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.ForeColor = System.Drawing.SystemColors.WindowText; 
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog; 
            this.Location = new System.Drawing.Point( 220, 198 ); 
            this.MaximizeBox = false; 
            this.MinimizeBox = false; 
            this.Name = "formMain"; 
            this.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.StartPosition = System.Windows.Forms.FormStartPosition.Manual; 
            this.Text = "SocketTools Remote Command Example"; 
            this.ResumeLayout( false ); 
            
            // events handled by formMain_Load
            base.Load += new System.EventHandler( formMain_Load ); 
            // events handled by formMain_Closed
            base.Closed += new System.EventHandler( formMain_Closed ); 
            // events handled by cmdAction_Click
            cmdAction.Click += new System.EventHandler( cmdAction_Click ); 
        } 
        
		[STAThread]
		public static void Main()
		{
			Application.Run( new formMain() );
		}
        
        #endregion 
        
        public SocketTools.RshClient rshClient = new SocketTools.RshClient(); 
        
        private void formMain_Load( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            if ( !( rshClient.Initialize() ) ) 
            { 
                Interaction.MsgBox( "Unable to initialize SocketTools component", MsgBoxStyle.Exclamation, null ); 
                System.Environment.Exit( 0 ); 
            } 
            
            // Hard coded choices in remote execution methods:
            // exec requires user password authentication
            // shell will run the command with just a username
            comboPort.Items.Add( System.Convert.ToString( SocketTools.RshClient.rshPortExecute ) ); 
            comboPort.Items.Add( System.Convert.ToString( SocketTools.RshClient.rshPortShell ) ); 
            comboPort.SelectedIndex = 0; 
        } 
        
        
        private void formMain_Closed( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            rshClient.Uninitialize(); 
        } 
        
        
        private void cmdAction_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            string strBuffer = null; string strLine = null; 
            int nLength = 0; int nIndex = 0; 
            
            // Code here will establish a connection with remote command server
            // and submit the user entered command.
            
            if ( rshClient.IsConnected ) 
            { 
                rshClient.Cancel(); 
                return; 
            } 
            
            rshClient.HostName = editHostName.Text.Trim(); 
            rshClient.UserName = editUserName.Text.Trim(); 
            rshClient.Password = editPassword.Text.Trim();
            rshClient.RemotePort = int.Parse( comboPort.Text.Trim() ); 
            rshClient.Timeout = 10; //  seconds
            rshClient.Command = editCommand.Text.Trim();
            
            if ( rshClient.Command.Length == 0 ) 
            { 
                Interaction.MsgBox( "No command to execute on remote host", (Microsoft.VisualBasic.MsgBoxStyle)(0), null ); 
                return; 
            } 
            
            //  If the user has selected the rexec port then a password
            //  is required to authenticate the session
            
            if ( comboPort.SelectedIndex == 0 ) 
            { 
                if ( rshClient.Password.Length == 0 ) 
                { 
                    Interaction.MsgBox( "A password is required to execute this command", (Microsoft.VisualBasic.MsgBoxStyle)(0), null ); 
                    return; 
                } 
            } 
            
            cmdAction.Enabled = false; 
            
            if ( !( rshClient.Execute() ) ) 
            { 
                Interaction.MsgBox( rshClient.LastErrorString, MsgBoxStyle.Exclamation, null ); 
                cmdAction.Enabled = true; 
                return; 
            } 
            
            cmdAction.Text = "Cancel"; 
            cmdAction.Enabled = true; 
            
            do 
            { 
                nLength = rshClient.Read( ref strBuffer, 1024 ); 
                if ( nLength < 1 )
					break;
                
                nIndex = strBuffer.IndexOf(  System.Convert.ToChar( 10 ) ); 
                while ( nIndex > -1 ) 
                { 
                    strLine = Strings.Mid( strBuffer, 1, nIndex ); 
                    strBuffer =  strBuffer.Substring( nIndex + 1 ); 
                    nIndex = strBuffer.IndexOf(  System.Convert.ToChar( 10 ) ); 
                    textOutput.AppendText( strLine +  System.Convert.ToChar( 10 ) ); 
                } 
                
                textOutput.AppendText( strBuffer ); 
            } 
            while ( true ); 
            
            if ( nLength == -1 ) 
            { 
                Interaction.MsgBox( rshClient.LastErrorString, MsgBoxStyle.Exclamation, null ); 
            } 
            
            rshClient.Disconnect(); 
            cmdAction.Text = "Execute"; 
            
        } 
        
        
        public void menuExit_Popup( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            menuExit_Click( eventSender, eventArgs ); 
        } 
        
        
        public void menuExit_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            this.Close(); 
        } 
    } 
} 
