'   SocketTools 10 .NET Edition
'   Copyright 2023 Catalyst Development Corporation
'   All rights reserved
'
'   This file is licensed to you pursuant to the terms of the
'   product license agreement included with the original software,
'   and is protected by copyright law and international treaties.
'   Unauthorized reproduction or distribution may result in severe
'   criminal penalties.
'
Option Strict Off
Option Explicit On

Imports SocketTools.ImapClient

Friend Class formMain
    Inherits System.Windows.Forms.Form
    Dim WithEvents imapClient As New SocketTools.ImapClient

#Region "Windows Form Designer generated code "
    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()
    End Sub
    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal Disposing As Boolean)
        If Disposing Then
            If Not components Is Nothing Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(Disposing)
    End Sub
    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer
    Public ToolTip1 As System.Windows.Forms.ToolTip
    Public WithEvents cmdRefresh As System.Windows.Forms.Button
    Public WithEvents comboMailbox As System.Windows.Forms.ComboBox
    Public WithEvents editTimeout As System.Windows.Forms.TextBox
    Public WithEvents cmdView As System.Windows.Forms.Button
    Public WithEvents editPassword As System.Windows.Forms.TextBox
    Public WithEvents editUserName As System.Windows.Forms.TextBox
    Public WithEvents editHostName As System.Windows.Forms.TextBox
    Public WithEvents cmdConnect As System.Windows.Forms.Button
    Public WithEvents editHostPort As System.Windows.Forms.TextBox
    Public WithEvents textMessage As System.Windows.Forms.TextBox
    Public WithEvents lblMailbox As System.Windows.Forms.Label
    Public WithEvents lblTimeout As System.Windows.Forms.Label
    Public WithEvents lblStatus As System.Windows.Forms.Label
    Public WithEvents lblPassword As System.Windows.Forms.Label
    Public WithEvents lblUserName As System.Windows.Forms.Label
    Public WithEvents lblPort As System.Windows.Forms.Label
    Public WithEvents lblServer As System.Windows.Forms.Label
    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.
    'Do not modify it using the code editor.
    Friend WithEvents listMessages As System.Windows.Forms.ListView
    Friend WithEvents ColumnHeader1 As System.Windows.Forms.ColumnHeader
    Friend WithEvents ColumnHeader2 As System.Windows.Forms.ColumnHeader
    Friend WithEvents ColumnHeader3 As System.Windows.Forms.ColumnHeader
    Friend WithEvents ColumnHeader4 As System.Windows.Forms.ColumnHeader
    Friend WithEvents ProgressBar1 As System.Windows.Forms.ProgressBar
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Me.ToolTip1 = New System.Windows.Forms.ToolTip(Me.components)
        Me.cmdRefresh = New System.Windows.Forms.Button()
        Me.comboMailbox = New System.Windows.Forms.ComboBox()
        Me.editTimeout = New System.Windows.Forms.TextBox()
        Me.cmdView = New System.Windows.Forms.Button()
        Me.editPassword = New System.Windows.Forms.TextBox()
        Me.editUserName = New System.Windows.Forms.TextBox()
        Me.editHostName = New System.Windows.Forms.TextBox()
        Me.cmdConnect = New System.Windows.Forms.Button()
        Me.editHostPort = New System.Windows.Forms.TextBox()
        Me.textMessage = New System.Windows.Forms.TextBox()
        Me.lblMailbox = New System.Windows.Forms.Label()
        Me.lblTimeout = New System.Windows.Forms.Label()
        Me.lblStatus = New System.Windows.Forms.Label()
        Me.lblPassword = New System.Windows.Forms.Label()
        Me.lblUserName = New System.Windows.Forms.Label()
        Me.lblPort = New System.Windows.Forms.Label()
        Me.lblServer = New System.Windows.Forms.Label()
        Me.listMessages = New System.Windows.Forms.ListView()
        Me.ColumnHeader1 = CType(New System.Windows.Forms.ColumnHeader(), System.Windows.Forms.ColumnHeader)
        Me.ColumnHeader2 = CType(New System.Windows.Forms.ColumnHeader(), System.Windows.Forms.ColumnHeader)
        Me.ColumnHeader3 = CType(New System.Windows.Forms.ColumnHeader(), System.Windows.Forms.ColumnHeader)
        Me.ColumnHeader4 = CType(New System.Windows.Forms.ColumnHeader(), System.Windows.Forms.ColumnHeader)
        Me.ProgressBar1 = New System.Windows.Forms.ProgressBar()
        Me.SuspendLayout()
        '
        'cmdRefresh
        '
        Me.cmdRefresh.BackColor = System.Drawing.SystemColors.Control
        Me.cmdRefresh.Cursor = System.Windows.Forms.Cursors.Default
        Me.cmdRefresh.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.cmdRefresh.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.cmdRefresh.ForeColor = System.Drawing.SystemColors.ControlText
        Me.cmdRefresh.Location = New System.Drawing.Point(520, 35)
        Me.cmdRefresh.Name = "cmdRefresh"
        Me.cmdRefresh.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.cmdRefresh.Size = New System.Drawing.Size(80, 28)
        Me.cmdRefresh.TabIndex = 13
        Me.cmdRefresh.Text = "Refresh"
        Me.cmdRefresh.UseVisualStyleBackColor = False
        '
        'comboMailbox
        '
        Me.comboMailbox.BackColor = System.Drawing.SystemColors.Window
        Me.comboMailbox.Cursor = System.Windows.Forms.Cursors.Default
        Me.comboMailbox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.comboMailbox.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.comboMailbox.ForeColor = System.Drawing.SystemColors.WindowText
        Me.comboMailbox.Location = New System.Drawing.Point(76, 68)
        Me.comboMailbox.Name = "comboMailbox"
        Me.comboMailbox.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.comboMailbox.Size = New System.Drawing.Size(165, 22)
        Me.comboMailbox.Sorted = True
        Me.comboMailbox.TabIndex = 11
        '
        'editTimeout
        '
        Me.editTimeout.AcceptsReturn = True
        Me.editTimeout.BackColor = System.Drawing.SystemColors.Window
        Me.editTimeout.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.editTimeout.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.editTimeout.ForeColor = System.Drawing.SystemColors.WindowText
        Me.editTimeout.Location = New System.Drawing.Point(408, 12)
        Me.editTimeout.MaxLength = 0
        Me.editTimeout.Name = "editTimeout"
        Me.editTimeout.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.editTimeout.Size = New System.Drawing.Size(37, 20)
        Me.editTimeout.TabIndex = 5
        Me.editTimeout.Text = "20"
        '
        'cmdView
        '
        Me.cmdView.BackColor = System.Drawing.SystemColors.Control
        Me.cmdView.Cursor = System.Windows.Forms.Cursors.Default
        Me.cmdView.Enabled = False
        Me.cmdView.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.cmdView.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.cmdView.ForeColor = System.Drawing.SystemColors.ControlText
        Me.cmdView.Location = New System.Drawing.Point(520, 66)
        Me.cmdView.Name = "cmdView"
        Me.cmdView.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.cmdView.Size = New System.Drawing.Size(80, 28)
        Me.cmdView.TabIndex = 14
        Me.cmdView.Text = "View"
        Me.cmdView.UseVisualStyleBackColor = False
        '
        'editPassword
        '
        Me.editPassword.AcceptsReturn = True
        Me.editPassword.BackColor = System.Drawing.SystemColors.Window
        Me.editPassword.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.editPassword.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.editPassword.ForeColor = System.Drawing.SystemColors.WindowText
        Me.editPassword.Location = New System.Drawing.Point(312, 40)
        Me.editPassword.MaxLength = 0
        Me.editPassword.Name = "editPassword"
        Me.editPassword.PasswordChar = Global.Microsoft.VisualBasic.ChrW(42)
        Me.editPassword.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.editPassword.Size = New System.Drawing.Size(165, 20)
        Me.editPassword.TabIndex = 9
        '
        'editUserName
        '
        Me.editUserName.AcceptsReturn = True
        Me.editUserName.BackColor = System.Drawing.SystemColors.Window
        Me.editUserName.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.editUserName.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.editUserName.ForeColor = System.Drawing.SystemColors.WindowText
        Me.editUserName.Location = New System.Drawing.Point(76, 40)
        Me.editUserName.MaxLength = 0
        Me.editUserName.Name = "editUserName"
        Me.editUserName.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.editUserName.Size = New System.Drawing.Size(165, 20)
        Me.editUserName.TabIndex = 7
        '
        'editHostName
        '
        Me.editHostName.AcceptsReturn = True
        Me.editHostName.BackColor = System.Drawing.SystemColors.Window
        Me.editHostName.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.editHostName.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.editHostName.ForeColor = System.Drawing.SystemColors.WindowText
        Me.editHostName.Location = New System.Drawing.Point(76, 12)
        Me.editHostName.MaxLength = 0
        Me.editHostName.Name = "editHostName"
        Me.editHostName.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.editHostName.Size = New System.Drawing.Size(165, 20)
        Me.editHostName.TabIndex = 1
        '
        'cmdConnect
        '
        Me.cmdConnect.BackColor = System.Drawing.SystemColors.Control
        Me.cmdConnect.Cursor = System.Windows.Forms.Cursors.Default
        Me.cmdConnect.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.cmdConnect.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.cmdConnect.ForeColor = System.Drawing.SystemColors.ControlText
        Me.cmdConnect.Location = New System.Drawing.Point(520, 4)
        Me.cmdConnect.Name = "cmdConnect"
        Me.cmdConnect.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.cmdConnect.Size = New System.Drawing.Size(80, 28)
        Me.cmdConnect.TabIndex = 12
        Me.cmdConnect.Text = "Connect"
        Me.cmdConnect.UseVisualStyleBackColor = False
        '
        'editHostPort
        '
        Me.editHostPort.AcceptsReturn = True
        Me.editHostPort.BackColor = System.Drawing.SystemColors.Window
        Me.editHostPort.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.editHostPort.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.editHostPort.ForeColor = System.Drawing.SystemColors.WindowText
        Me.editHostPort.Location = New System.Drawing.Point(312, 12)
        Me.editHostPort.MaxLength = 0
        Me.editHostPort.Name = "editHostPort"
        Me.editHostPort.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.editHostPort.Size = New System.Drawing.Size(37, 20)
        Me.editHostPort.TabIndex = 3
        Me.editHostPort.Text = "143"
        '
        'textMessage
        '
        Me.textMessage.AcceptsReturn = True
        Me.textMessage.BackColor = System.Drawing.SystemColors.Window
        Me.textMessage.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.textMessage.Font = New System.Drawing.Font("Courier New", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.textMessage.ForeColor = System.Drawing.SystemColors.WindowText
        Me.textMessage.Location = New System.Drawing.Point(4, 100)
        Me.textMessage.MaxLength = 0
        Me.textMessage.Multiline = True
        Me.textMessage.Name = "textMessage"
        Me.textMessage.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.textMessage.ScrollBars = System.Windows.Forms.ScrollBars.Both
        Me.textMessage.Size = New System.Drawing.Size(601, 345)
        Me.textMessage.TabIndex = 16
        Me.textMessage.Visible = False
        Me.textMessage.WordWrap = False
        '
        'lblMailbox
        '
        Me.lblMailbox.BackColor = System.Drawing.SystemColors.Control
        Me.lblMailbox.Cursor = System.Windows.Forms.Cursors.Default
        Me.lblMailbox.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblMailbox.ForeColor = System.Drawing.SystemColors.ControlText
        Me.lblMailbox.Location = New System.Drawing.Point(12, 72)
        Me.lblMailbox.Name = "lblMailbox"
        Me.lblMailbox.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.lblMailbox.Size = New System.Drawing.Size(61, 13)
        Me.lblMailbox.TabIndex = 10
        Me.lblMailbox.Text = "Mailbox:"
        '
        'lblTimeout
        '
        Me.lblTimeout.BackColor = System.Drawing.SystemColors.Control
        Me.lblTimeout.Cursor = System.Windows.Forms.Cursors.Default
        Me.lblTimeout.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblTimeout.ForeColor = System.Drawing.SystemColors.ControlText
        Me.lblTimeout.Location = New System.Drawing.Point(360, 16)
        Me.lblTimeout.Name = "lblTimeout"
        Me.lblTimeout.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.lblTimeout.Size = New System.Drawing.Size(48, 13)
        Me.lblTimeout.TabIndex = 4
        Me.lblTimeout.Text = "Timeout:"
        '
        'lblStatus
        '
        Me.lblStatus.BackColor = System.Drawing.SystemColors.Control
        Me.lblStatus.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.lblStatus.Cursor = System.Windows.Forms.Cursors.Default
        Me.lblStatus.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblStatus.ForeColor = System.Drawing.SystemColors.ControlText
        Me.lblStatus.Location = New System.Drawing.Point(4, 452)
        Me.lblStatus.Name = "lblStatus"
        Me.lblStatus.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.lblStatus.Size = New System.Drawing.Size(373, 21)
        Me.lblStatus.TabIndex = 17
        '
        'lblPassword
        '
        Me.lblPassword.BackColor = System.Drawing.SystemColors.Control
        Me.lblPassword.Cursor = System.Windows.Forms.Cursors.Default
        Me.lblPassword.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblPassword.ForeColor = System.Drawing.SystemColors.ControlText
        Me.lblPassword.Location = New System.Drawing.Point(252, 44)
        Me.lblPassword.Name = "lblPassword"
        Me.lblPassword.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.lblPassword.Size = New System.Drawing.Size(60, 15)
        Me.lblPassword.TabIndex = 8
        Me.lblPassword.Text = "Password:"
        '
        'lblUserName
        '
        Me.lblUserName.BackColor = System.Drawing.SystemColors.Control
        Me.lblUserName.Cursor = System.Windows.Forms.Cursors.Default
        Me.lblUserName.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblUserName.ForeColor = System.Drawing.SystemColors.ControlText
        Me.lblUserName.Location = New System.Drawing.Point(12, 44)
        Me.lblUserName.Name = "lblUserName"
        Me.lblUserName.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.lblUserName.Size = New System.Drawing.Size(64, 13)
        Me.lblUserName.TabIndex = 6
        Me.lblUserName.Text = "User Name:"
        '
        'lblPort
        '
        Me.lblPort.BackColor = System.Drawing.SystemColors.Control
        Me.lblPort.Cursor = System.Windows.Forms.Cursors.Default
        Me.lblPort.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblPort.ForeColor = System.Drawing.SystemColors.ControlText
        Me.lblPort.Location = New System.Drawing.Point(281, 16)
        Me.lblPort.Name = "lblPort"
        Me.lblPort.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.lblPort.Size = New System.Drawing.Size(30, 15)
        Me.lblPort.TabIndex = 2
        Me.lblPort.Text = "Port:"
        '
        'lblServer
        '
        Me.lblServer.BackColor = System.Drawing.SystemColors.Control
        Me.lblServer.Cursor = System.Windows.Forms.Cursors.Default
        Me.lblServer.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblServer.ForeColor = System.Drawing.SystemColors.ControlText
        Me.lblServer.Location = New System.Drawing.Point(12, 16)
        Me.lblServer.Name = "lblServer"
        Me.lblServer.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.lblServer.Size = New System.Drawing.Size(64, 13)
        Me.lblServer.TabIndex = 0
        Me.lblServer.Text = "Mail Server:"
        '
        'listMessages
        '
        Me.listMessages.Columns.AddRange(New System.Windows.Forms.ColumnHeader() {Me.ColumnHeader1, Me.ColumnHeader2, Me.ColumnHeader3, Me.ColumnHeader4})
        Me.listMessages.FullRowSelect = True
        Me.listMessages.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable
        Me.listMessages.Location = New System.Drawing.Point(4, 100)
        Me.listMessages.MultiSelect = False
        Me.listMessages.Name = "listMessages"
        Me.listMessages.Size = New System.Drawing.Size(601, 345)
        Me.listMessages.TabIndex = 18
        Me.listMessages.UseCompatibleStateImageBehavior = False
        Me.listMessages.View = System.Windows.Forms.View.Details
        '
        'ColumnHeader1
        '
        Me.ColumnHeader1.Text = ""
        Me.ColumnHeader1.Width = 30
        '
        'ColumnHeader2
        '
        Me.ColumnHeader2.Text = "From"
        Me.ColumnHeader2.Width = 150
        '
        'ColumnHeader3
        '
        Me.ColumnHeader3.Text = "Subject"
        Me.ColumnHeader3.Width = 250
        '
        'ColumnHeader4
        '
        Me.ColumnHeader4.Text = "Date"
        Me.ColumnHeader4.Width = 150
        '
        'ProgressBar1
        '
        Me.ProgressBar1.Location = New System.Drawing.Point(378, 452)
        Me.ProgressBar1.Name = "ProgressBar1"
        Me.ProgressBar1.Size = New System.Drawing.Size(228, 21)
        Me.ProgressBar1.TabIndex = 19
        '
        'formMain
        '
        Me.AcceptButton = Me.cmdConnect
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.BackColor = System.Drawing.SystemColors.Control
        Me.ClientSize = New System.Drawing.Size(611, 475)
        Me.Controls.Add(Me.ProgressBar1)
        Me.Controls.Add(Me.listMessages)
        Me.Controls.Add(Me.cmdRefresh)
        Me.Controls.Add(Me.comboMailbox)
        Me.Controls.Add(Me.editTimeout)
        Me.Controls.Add(Me.cmdView)
        Me.Controls.Add(Me.editPassword)
        Me.Controls.Add(Me.editUserName)
        Me.Controls.Add(Me.editHostName)
        Me.Controls.Add(Me.cmdConnect)
        Me.Controls.Add(Me.editHostPort)
        Me.Controls.Add(Me.textMessage)
        Me.Controls.Add(Me.lblMailbox)
        Me.Controls.Add(Me.lblTimeout)
        Me.Controls.Add(Me.lblStatus)
        Me.Controls.Add(Me.lblPassword)
        Me.Controls.Add(Me.lblUserName)
        Me.Controls.Add(Me.lblServer)
        Me.Controls.Add(Me.lblPort)
        Me.Cursor = System.Windows.Forms.Cursors.Default
        Me.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        Me.Location = New System.Drawing.Point(275, 205)
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.Name = "formMain"
        Me.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.StartPosition = System.Windows.Forms.FormStartPosition.Manual
        Me.Text = "SocketTools ListMail Example"
        Me.ResumeLayout(False)
        Me.PerformLayout()

    End Sub
#End Region

    Private Sub formMain_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
        If Not imapClient.Initialize() Then
            MsgBox("Unable to initialize SocketTools component", MsgBoxStyle.Exclamation)
            End
        End If

        cmdConnect.Enabled = True
        cmdRefresh.Enabled = False
        cmdView.Enabled = False

        comboMailbox.Enabled = False
        textMessage.Visible = False
        listMessages.Visible = True

        ProgressBar1.Minimum = 0
        ProgressBar1.Maximum = 100
        ProgressBar1.Value = 0
    End Sub

    Private Sub cmdConnect_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdConnect.Click
        Dim strHostName As String
        Dim strHostPort As String
        Dim strTimeout As String
        Dim strUserName As String
        Dim strPassword As String
        Dim nHostPort As Integer
        Dim nTimeout As Integer
        Dim nIndex As Integer
        Dim nInbox As Integer

        If imapClient.IsConnected Then
            ' Disconnect from mail server
            imapClient.Disconnect()

            ' Update user interface
            comboMailbox.Items.Clear()
            comboMailbox.Enabled = False
            listMessages.Items.Clear()
            listMessages.Visible = True
            textMessage.Text = ""
            textMessage.Visible = False

            cmdRefresh.Enabled = False
            cmdView.Enabled = False
            cmdView.Text = "View"
            cmdConnect.Text = "Connect"
            Exit Sub
        End If

        strHostName = Trim(editHostName.Text)
        If Len(strHostName) = 0 Then
            MsgBox("Please specify the server host name or address", MsgBoxStyle.Information)
            editHostName.Text = ""
            editHostName.Focus()
            Exit Sub
        End If

        strHostPort = Trim(editHostPort.Text)
        If Len(strHostPort) > 0 Then
            nHostPort = Val(strHostPort)
            If nHostPort < 0 Or nHostPort > 65535 Then
                MsgBox("Please specify a valid port number", MsgBoxStyle.Exclamation)
                editHostPort.Text = ""
                editHostPort.Focus()
                Exit Sub
            ElseIf nHostPort = 0 Then
                nHostPort = imapPortDefault
                editHostPort.Text = CStr(nHostPort)
            End If
        Else
            MsgBox("Please specify a server port number", MsgBoxStyle.Information)
            editHostPort.Text = ""
            editHostPort.Focus()
            Exit Sub
        End If

        strTimeout = Trim(editTimeout.Text)
        If Len(strTimeout) > 0 Then
            nTimeout = Val(strTimeout)
            editTimeout.Text = CStr(nTimeout)
        Else
            MsgBox("Please specify a timeout value in seconds", MsgBoxStyle.Information)
            editTimeout.Text = ""
            editTimeout.Focus()
            Exit Sub
        End If

        strUserName = Trim(editUserName.Text)
        If Len(strUserName) = 0 Then
            MsgBox("Please specify a user name", MsgBoxStyle.Information)
            editUserName.Text = ""
            editUserName.Focus()
            Exit Sub
        End If

        strPassword = Trim(editPassword.Text)
        If Len(strPassword) = 0 Then
            MsgBox("Please specify a password", MsgBoxStyle.Information)
            editPassword.Text = ""
            editPassword.Focus()
            Exit Sub
        End If

        cmdConnect.Enabled = False

        If Not imapClient.Connect(strHostName, nHostPort, strUserName, strPassword, nTimeout) Then
            lblStatus.Text = imapClient.LastErrorString
            MsgBox(imapClient.LastErrorString, MsgBoxStyle.Exclamation)
            cmdConnect.Enabled = True
            Exit Sub
        End If

        comboMailbox.Items.Clear()

        If imapClient.Mailboxes = 0 Then
            MsgBox("There are no mailboxes available", MsgBoxStyle.Exclamation)
            imapClient.Disconnect()
            cmdConnect.Enabled = True
            Exit Sub
        End If

        For nIndex = 0 To imapClient.Mailboxes - 1
            comboMailbox.Items.Add(imapClient.Mailbox(nIndex))
        Next

        nInbox = -1
        For nIndex = 0 To comboMailbox.Items.Count - 1
            If String.Compare(comboMailbox.Items.Item(nIndex), "Inbox", True) = 0 Then
                nInbox = nIndex
                Exit For
            End If

        Next

        comboMailbox.Enabled = True
        comboMailbox.SelectedIndex = nInbox
        cmdConnect.Text = "Disconnect"
    End Sub

    Private Sub cmdRefresh_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdRefresh.Click
        Dim nMessageCount As Integer
        Dim nMessage As Integer
        Dim strFrom As String
        Dim strSubject As String
        Dim strDate As String
        Dim lvItem As Windows.Forms.ListViewItem

        cmdConnect.Enabled = False
        cmdRefresh.Enabled = False
        cmdView.Enabled = False
        comboMailbox.Enabled = False

        nMessageCount = imapClient.MessageCount

        listMessages.Items.Clear()
        If nMessageCount > 0 Then ProgressBar1.Maximum = nMessageCount
        ProgressBar1.Value = 0

        For nMessage = 1 To nMessageCount
            lblStatus.Text = "Checking message " & nMessage & " of " & nMessageCount
            lblStatus.Refresh()

            strFrom = ""
            strSubject = ""
            strDate = ""

            imapClient.GetHeader(nMessage, 0, "From", strFrom)
            imapClient.GetHeader(nMessage, 0, "Subject", strSubject)
            imapClient.GetHeader(nMessage, 0, "Date", strDate)

            lvItem = listMessages.Items.Add(CStr(nMessage))
            lvItem.SubItems.Add(strFrom)
            lvItem.SubItems.Add(strSubject)
            lvItem.SubItems.Add(strDate)

            ProgressBar1.Value = nMessage
            System.Windows.Forms.Application.DoEvents()
        Next

        lblStatus.Text = "You have " & nMessageCount & " messages in this mailbox"
        lblStatus.Refresh()

        ProgressBar1.Value = 0
        ProgressBar1.Maximum = 100

        cmdConnect.Enabled = True
        cmdRefresh.Enabled = True
        cmdView.Enabled = True
        comboMailbox.Enabled = True
    End Sub

    Private Sub cmdView_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdView.Click
        Dim nMessage As Integer = 0
        Dim strMessage As String = ""
        Dim lvItem As Windows.Forms.ListViewItem

        If cmdView.Text = "View" Then
            lvItem = listMessages.SelectedItems(0)
            nMessage = CInt(lvItem.Text)

            lblStatus.Text = "Retrieving message " & nMessage & " from server"
            lblStatus.Refresh()

            cmdConnect.Enabled = False
            cmdRefresh.Enabled = False
            cmdView.Enabled = False
            ProgressBar1.Maximum = 100
            ProgressBar1.Value = 0

            If Not imapClient.GetMessage(nMessage, 0, strMessage) Then
                lblStatus.Text = imapClient.LastErrorString
                MsgBox(imapClient.LastErrorString, MsgBoxStyle.Exclamation)
                cmdConnect.Enabled = True
                cmdView.Enabled = True
                cmdRefresh.Enabled = True
                ProgressBar1.Value = 0
                Exit Sub
            End If

            cmdConnect.Enabled = True
            cmdView.Enabled = True
            cmdView.Text = "Close"
            ProgressBar1.Value = 0
            listMessages.Visible = False
            textMessage.Text = strMessage
            textMessage.Visible = True
            textMessage.SelectionStart = 0
            textMessage.SelectionLength = 0
            textMessage.Focus()
            lblStatus.Text = "Viewing message " & nMessage & " (" & Len(strMessage) & " bytes)"
        Else
            cmdView.Text = "View"
            cmdRefresh.Enabled = True
            textMessage.Text = ""
            textMessage.Visible = False
            listMessages.Visible = True
            listMessages.Focus()
            lblStatus.Text = ""
        End If
    End Sub

    Private Sub comboMailbox_SelectedIndexChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles comboMailbox.SelectedIndexChanged
        Dim strMailbox As String

        If cmdView.Text <> "View" Then
            cmdView_Click(cmdView, New System.EventArgs)
        End If

        strMailbox = comboMailbox.Text

        If Not imapClient.SelectMailbox(strMailbox) Then
            lblStatus.Text = imapClient.LastErrorString
            MsgBox(imapClient.LastErrorString, MsgBoxStyle.Exclamation)
            comboMailbox.SelectedIndex = -1
            Exit Sub
        End If

        cmdRefresh_Click(cmdRefresh, New System.EventArgs)
    End Sub

    Private Sub listMessages_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles listMessages.DoubleClick
        If listMessages.Items.Count > 0 And cmdView.Enabled Then
            cmdView_Click(cmdView, New System.EventArgs)
        End If
    End Sub

    Private Sub imapClient_OnProgress(ByVal sender As Object, ByVal e As SocketTools.ImapClient.ProgressEventArgs) Handles imapClient.OnProgress
        ProgressBar1.Value = e.Percent
    End Sub
End Class