// SocketTools 10 Build 1468
// Copyright 2023 Catalyst Development Corporation
// All rights reserved
// 
// This file is licensed to you pursuant to the terms of the
// product license agreement included with the original software,
// and is protected by copyright law and international treaties.
// Unauthorized reproduction or distribution may result in severe
// criminal penalties.
//
using System;
using System.Collections;
using System.Data;
using System.Drawing;
using System.Diagnostics;
using System.Windows.Forms;
using Microsoft.VisualBasic;
using SocketTools;

namespace SecureShell2
{
    public class Form2 : System.Windows.Forms.Form 
    { 
        public string HostName = ""; 
        public int RemotePort = SocketTools.SshClient.sshPortDefault;
        public string UserName = "";
        public string Password = "";
        public SocketTools.Terminal.TerminalEmulation Emulation = SocketTools.Terminal.TerminalEmulation.ANSI;
        public bool Canceled = false; 
        
        #region ' Windows Form Designer generated code '
        public Form2() : base() 
        { 
            // This call is required by the Windows Form Designer.
            InitializeComponent(); 
            
            // Add any initialization after the InitializeComponent() call
        } 
        
        // Form overrides dispose to clean up the component list.
        protected override void Dispose( bool disposing ) 
        { 
            if ( disposing ) 
            { 
                if ( !( ( components == null ) ) ) 
                { 
                    components.Dispose(); 
                } 
            } 
            base.Dispose( disposing ); 
        } 
        
        
        // Required by the Windows Form Designer
        private System.ComponentModel.IContainer components; 
        
        // NOTE: The following procedure is required by the Windows Form Designer
        // It can be modified using the Windows Form Designer.  
        // Do not modify it using the code editor.
        internal System.Windows.Forms.Label label1; 
        internal System.Windows.Forms.TextBox textBox1; 
        internal System.Windows.Forms.Label label2; 
        internal System.Windows.Forms.TextBox textBox2; 
        internal System.Windows.Forms.Label label3;
        internal System.Windows.Forms.Label label4;
        internal System.Windows.Forms.TextBox textBox3;
        internal System.Windows.Forms.Label label5;
        internal System.Windows.Forms.TextBox textBox4;
        internal System.Windows.Forms.ComboBox comboBox1; 
        internal System.Windows.Forms.Button button1; 
        internal System.Windows.Forms.Button button2;

        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() 
        {
            this.label1 = new System.Windows.Forms.Label();
            this.textBox1 = new System.Windows.Forms.TextBox();
            this.label2 = new System.Windows.Forms.Label();
            this.textBox2 = new System.Windows.Forms.TextBox();
            this.label3 = new System.Windows.Forms.Label();
            this.comboBox1 = new System.Windows.Forms.ComboBox();
            this.button1 = new System.Windows.Forms.Button();
            this.button2 = new System.Windows.Forms.Button();
            this.label4 = new System.Windows.Forms.Label();
            this.label5 = new System.Windows.Forms.Label();
            this.textBox3 = new System.Windows.Forms.TextBox();
            this.textBox4 = new System.Windows.Forms.TextBox();
            this.SuspendLayout();
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(9, 20);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(64, 14);
            this.label1.TabIndex = 0;
            this.label1.Text = "Host Name:";
            // 
            // textBox1
            // 
            this.textBox1.Location = new System.Drawing.Point(73, 17);
            this.textBox1.Name = "textBox1";
            this.textBox1.Size = new System.Drawing.Size(141, 20);
            this.textBox1.TabIndex = 1;
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(224, 19);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(28, 17);
            this.label2.TabIndex = 10;
            this.label2.Text = "Port:";
            // 
            // textBox2
            // 
            this.textBox2.Location = new System.Drawing.Point(256, 17);
            this.textBox2.Name = "textBox2";
            this.textBox2.Size = new System.Drawing.Size(35, 20);
            this.textBox2.TabIndex = 11;
            this.textBox2.Text = "22";
            // 
            // label3
            // 
            this.label3.Location = new System.Drawing.Point(9, 99);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(64, 14);
            this.label3.TabIndex = 6;
            this.label3.Text = "Emulation:";
            // 
            // comboBox1
            // 
            this.comboBox1.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBox1.Items.AddRange(new object[] {
            "None",
            "ANSI",
            "VT100",
            "VT220"});
            this.comboBox1.Location = new System.Drawing.Point(73, 95);
            this.comboBox1.Name = "comboBox1";
            this.comboBox1.Size = new System.Drawing.Size(141, 21);
            this.comboBox1.TabIndex = 7;
            // 
            // button1
            // 
            this.button1.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.button1.Location = new System.Drawing.Point(74, 126);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(80, 30);
            this.button1.TabIndex = 8;
            this.button1.Text = "Connect";
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // button2
            // 
            this.button2.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.button2.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.button2.Location = new System.Drawing.Point(160, 126);
            this.button2.Name = "button2";
            this.button2.Size = new System.Drawing.Size(80, 30);
            this.button2.TabIndex = 9;
            this.button2.Text = "Cancel";
            this.button2.Click += new System.EventHandler(this.button2_Click);
            // 
            // label4
            // 
            this.label4.AutoSize = true;
            this.label4.Location = new System.Drawing.Point(9, 46);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(60, 13);
            this.label4.TabIndex = 2;
            this.label4.Text = "UserName:";
            // 
            // label5
            // 
            this.label5.AutoSize = true;
            this.label5.Location = new System.Drawing.Point(9, 72);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(56, 13);
            this.label5.TabIndex = 4;
            this.label5.Text = "Password:";
            // 
            // textBox3
            // 
            this.textBox3.Location = new System.Drawing.Point(73, 43);
            this.textBox3.Name = "textBox3";
            this.textBox3.Size = new System.Drawing.Size(141, 20);
            this.textBox3.TabIndex = 3;
            // 
            // textBox4
            // 
            this.textBox4.Location = new System.Drawing.Point(73, 69);
            this.textBox4.Name = "textBox4";
            this.textBox4.PasswordChar = '*';
            this.textBox4.Size = new System.Drawing.Size(141, 20);
            this.textBox4.TabIndex = 5;
            // 
            // Form2
            // 
            this.AcceptButton = this.button1;
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.CancelButton = this.button2;
            this.ClientSize = new System.Drawing.Size(314, 168);
            this.Controls.Add(this.textBox4);
            this.Controls.Add(this.textBox3);
            this.Controls.Add(this.label5);
            this.Controls.Add(this.label4);
            this.Controls.Add(this.comboBox1);
            this.Controls.Add(this.textBox2);
            this.Controls.Add(this.textBox1);
            this.Controls.Add(this.button2);
            this.Controls.Add(this.button1);
            this.Controls.Add(this.label3);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.label1);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "Form2";
            this.ShowInTaskbar = false;
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
            this.Text = "Connection";
            this.Load += new System.EventHandler(this.Form2_Load);
            this.ResumeLayout(false);
            this.PerformLayout();

        } 
        #endregion 
        
        private void Form2_Load( object sender, System.EventArgs e ) 
        { 
            if ( RemotePort == 0 ) 
            { 
                RemotePort = SocketTools.SshClient.sshPortDefault; 
            } 
            
            textBox1.Text = HostName; 
            textBox2.Text = RemotePort.ToString();
            textBox3.Text = UserName;
            textBox4.Text = Password;

            switch ( Emulation ) 
            {
                case SocketTools.Terminal.TerminalEmulation.None:
                    comboBox1.Text = "None"; 
                    break;
                case SocketTools.Terminal.TerminalEmulation.ANSI:
                    comboBox1.Text = "ANSI"; 
                    break;
                case SocketTools.Terminal.TerminalEmulation.VT100:
                    comboBox1.Text = "VT100"; 
                    break;
                case SocketTools.Terminal.TerminalEmulation.VT220:
                    comboBox1.Text = "vT220"; 
                    break;
            }
        } 
        
        private void button1_Click( System.Object sender, System.EventArgs e ) 
        { 
            HostName = textBox1.Text.Trim(); 
            if ( HostName.Length == 0 ) 
            { 
                MessageBox.Show( "Please specify the name or address of a server" ); 
                textBox1.Focus(); 
                return; 
            } 
            
            RemotePort = Int32.Parse( textBox2.Text.Trim() ); 
            if ( RemotePort < 1 | RemotePort > 65535 ) 
            { 
                MessageBox.Show( "Please specify a valid port number" ); 
                textBox2.Focus(); 
                return; 
            }

            UserName = textBox3.Text.Trim();
            if ( UserName.Length == 0 )
            {
                MessageBox.Show( "Please specify a username to connect to this server" );
                textBox3.Focus();
                return;
            }

            Password = textBox4.Text.Trim();
            if ( Password.Length == 0 )
            {
                MessageBox.Show( "Please specify a password to connect to this server" );
                textBox4.Focus();
                return;
            }

            switch ( comboBox1.Text ) 
            {
                case "None":
                    Emulation = SocketTools.Terminal.TerminalEmulation.None; 
                    break;
                case "ANSI":
                    Emulation = SocketTools.Terminal.TerminalEmulation.ANSI; 
                    break;
                case "VT100":
                    Emulation = SocketTools.Terminal.TerminalEmulation.VT100; 
                    break;
                case "VT220":
                    Emulation = SocketTools.Terminal.TerminalEmulation.VT220; 
                    break;
            }
            
            Canceled = false; 
            this.Hide(); 
        } 
        
        private void button2_Click( System.Object sender, System.EventArgs e ) 
        { 
            Canceled = true; 
            this.Hide(); 
        }
    } 
} 
