' SocketTools 10 Build 1468
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'
Option Strict Off
Option Explicit On

Imports SocketTools.FtpClient

Friend Class formConnect
    Inherits System.Windows.Forms.Form
#Region "Windows Form Designer generated code "
    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()
    End Sub
    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal Disposing As Boolean)
        If Disposing Then
            If Not components Is Nothing Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(Disposing)
    End Sub
    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer
    Public ToolTip1 As System.Windows.Forms.ToolTip
    Public WithEvents editTimeout As System.Windows.Forms.TextBox
    Public WithEvents editAccount As System.Windows.Forms.TextBox
    Public WithEvents chkPassive As System.Windows.Forms.CheckBox
    Public WithEvents comboPort As System.Windows.Forms.ComboBox
    Public WithEvents cmdCancel As System.Windows.Forms.Button
    Public WithEvents cmdConnect As System.Windows.Forms.Button
    Public WithEvents comboOptions As System.Windows.Forms.ComboBox
    Public WithEvents editPassword As System.Windows.Forms.TextBox
    Public WithEvents editUserName As System.Windows.Forms.TextBox
    Public WithEvents editHostName As System.Windows.Forms.TextBox
    Public WithEvents lblTimeout As System.Windows.Forms.Label
    Public WithEvents lblAccount As System.Windows.Forms.Label
    Public WithEvents lblRemotePort As System.Windows.Forms.Label
    Public WithEvents lblConnection As System.Windows.Forms.Label
    Public WithEvents lblPassword As System.Windows.Forms.Label
    Public WithEvents lblUserName As System.Windows.Forms.Label
    Public WithEvents lblHostName As System.Windows.Forms.Label
    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Me.ToolTip1 = New System.Windows.Forms.ToolTip(Me.components)
        Me.editTimeout = New System.Windows.Forms.TextBox()
        Me.editAccount = New System.Windows.Forms.TextBox()
        Me.chkPassive = New System.Windows.Forms.CheckBox()
        Me.comboPort = New System.Windows.Forms.ComboBox()
        Me.cmdCancel = New System.Windows.Forms.Button()
        Me.cmdConnect = New System.Windows.Forms.Button()
        Me.comboOptions = New System.Windows.Forms.ComboBox()
        Me.editPassword = New System.Windows.Forms.TextBox()
        Me.editUserName = New System.Windows.Forms.TextBox()
        Me.editHostName = New System.Windows.Forms.TextBox()
        Me.lblTimeout = New System.Windows.Forms.Label()
        Me.lblAccount = New System.Windows.Forms.Label()
        Me.lblRemotePort = New System.Windows.Forms.Label()
        Me.lblConnection = New System.Windows.Forms.Label()
        Me.lblPassword = New System.Windows.Forms.Label()
        Me.lblUserName = New System.Windows.Forms.Label()
        Me.lblHostName = New System.Windows.Forms.Label()
        Me.SuspendLayout()
        '
        'editTimeout
        '
        Me.editTimeout.AcceptsReturn = True
        Me.editTimeout.BackColor = System.Drawing.SystemColors.Window
        Me.editTimeout.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.editTimeout.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.editTimeout.ForeColor = System.Drawing.SystemColors.WindowText
        Me.editTimeout.Location = New System.Drawing.Point(180, 40)
        Me.editTimeout.MaxLength = 0
        Me.editTimeout.Name = "editTimeout"
        Me.editTimeout.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.editTimeout.Size = New System.Drawing.Size(25, 21)
        Me.editTimeout.TabIndex = 5
        Me.editTimeout.Text = "20"
        '
        'editAccount
        '
        Me.editAccount.AcceptsReturn = True
        Me.editAccount.BackColor = System.Drawing.SystemColors.Window
        Me.editAccount.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.editAccount.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.editAccount.ForeColor = System.Drawing.SystemColors.WindowText
        Me.editAccount.Location = New System.Drawing.Point(76, 124)
        Me.editAccount.MaxLength = 0
        Me.editAccount.Name = "editAccount"
        Me.editAccount.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.editAccount.Size = New System.Drawing.Size(225, 21)
        Me.editAccount.TabIndex = 12
        '
        'chkPassive
        '
        Me.chkPassive.BackColor = System.Drawing.SystemColors.Control
        Me.chkPassive.Cursor = System.Windows.Forms.Cursors.Default
        Me.chkPassive.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.chkPassive.ForeColor = System.Drawing.SystemColors.ControlText
        Me.chkPassive.Location = New System.Drawing.Point(216, 43)
        Me.chkPassive.Name = "chkPassive"
        Me.chkPassive.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.chkPassive.Size = New System.Drawing.Size(93, 17)
        Me.chkPassive.TabIndex = 6
        Me.chkPassive.Text = "Passive Mode"
        Me.chkPassive.UseVisualStyleBackColor = False
        '
        'comboPort
        '
        Me.comboPort.BackColor = System.Drawing.SystemColors.Window
        Me.comboPort.Cursor = System.Windows.Forms.Cursors.Default
        Me.comboPort.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.comboPort.ForeColor = System.Drawing.SystemColors.WindowText
        Me.comboPort.Location = New System.Drawing.Point(76, 40)
        Me.comboPort.Name = "comboPort"
        Me.comboPort.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.comboPort.Size = New System.Drawing.Size(45, 22)
        Me.comboPort.TabIndex = 3
        Me.comboPort.Text = "Combo1"
        '
        'cmdCancel
        '
        Me.cmdCancel.BackColor = System.Drawing.SystemColors.Control
        Me.cmdCancel.Cursor = System.Windows.Forms.Cursors.Default
        Me.cmdCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.cmdCancel.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.cmdCancel.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.cmdCancel.ForeColor = System.Drawing.SystemColors.ControlText
        Me.cmdCancel.Location = New System.Drawing.Point(172, 192)
        Me.cmdCancel.Name = "cmdCancel"
        Me.cmdCancel.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.cmdCancel.Size = New System.Drawing.Size(81, 25)
        Me.cmdCancel.TabIndex = 16
        Me.cmdCancel.Text = "Cancel"
        Me.cmdCancel.UseVisualStyleBackColor = False
        '
        'cmdConnect
        '
        Me.cmdConnect.BackColor = System.Drawing.SystemColors.Control
        Me.cmdConnect.Cursor = System.Windows.Forms.Cursors.Default
        Me.cmdConnect.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.cmdConnect.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.cmdConnect.ForeColor = System.Drawing.SystemColors.ControlText
        Me.cmdConnect.Location = New System.Drawing.Point(76, 192)
        Me.cmdConnect.Name = "cmdConnect"
        Me.cmdConnect.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.cmdConnect.Size = New System.Drawing.Size(81, 25)
        Me.cmdConnect.TabIndex = 15
        Me.cmdConnect.Text = "Connect"
        Me.cmdConnect.UseVisualStyleBackColor = False
        '
        'comboOptions
        '
        Me.comboOptions.BackColor = System.Drawing.SystemColors.Window
        Me.comboOptions.Cursor = System.Windows.Forms.Cursors.Default
        Me.comboOptions.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.comboOptions.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.comboOptions.ForeColor = System.Drawing.SystemColors.WindowText
        Me.comboOptions.Location = New System.Drawing.Point(76, 152)
        Me.comboOptions.Name = "comboOptions"
        Me.comboOptions.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.comboOptions.Size = New System.Drawing.Size(225, 22)
        Me.comboOptions.TabIndex = 14
        '
        'editPassword
        '
        Me.editPassword.AcceptsReturn = True
        Me.editPassword.BackColor = System.Drawing.SystemColors.Window
        Me.editPassword.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.editPassword.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.editPassword.ForeColor = System.Drawing.SystemColors.WindowText
        Me.editPassword.Location = New System.Drawing.Point(76, 96)
        Me.editPassword.MaxLength = 0
        Me.editPassword.Name = "editPassword"
        Me.editPassword.PasswordChar = Global.Microsoft.VisualBasic.ChrW(42)
        Me.editPassword.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.editPassword.Size = New System.Drawing.Size(225, 21)
        Me.editPassword.TabIndex = 10
        '
        'editUserName
        '
        Me.editUserName.AcceptsReturn = True
        Me.editUserName.BackColor = System.Drawing.SystemColors.Window
        Me.editUserName.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.editUserName.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.editUserName.ForeColor = System.Drawing.SystemColors.WindowText
        Me.editUserName.Location = New System.Drawing.Point(76, 68)
        Me.editUserName.MaxLength = 0
        Me.editUserName.Name = "editUserName"
        Me.editUserName.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.editUserName.Size = New System.Drawing.Size(225, 21)
        Me.editUserName.TabIndex = 8
        '
        'editHostName
        '
        Me.editHostName.AcceptsReturn = True
        Me.editHostName.BackColor = System.Drawing.SystemColors.Window
        Me.editHostName.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.editHostName.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.editHostName.ForeColor = System.Drawing.SystemColors.WindowText
        Me.editHostName.Location = New System.Drawing.Point(76, 12)
        Me.editHostName.MaxLength = 0
        Me.editHostName.Name = "editHostName"
        Me.editHostName.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.editHostName.Size = New System.Drawing.Size(225, 21)
        Me.editHostName.TabIndex = 1
        '
        'lblTimeout
        '
        Me.lblTimeout.BackColor = System.Drawing.SystemColors.Control
        Me.lblTimeout.Cursor = System.Windows.Forms.Cursors.Default
        Me.lblTimeout.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblTimeout.ForeColor = System.Drawing.SystemColors.ControlText
        Me.lblTimeout.Location = New System.Drawing.Point(126, 44)
        Me.lblTimeout.Name = "lblTimeout"
        Me.lblTimeout.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.lblTimeout.Size = New System.Drawing.Size(47, 13)
        Me.lblTimeout.TabIndex = 4
        Me.lblTimeout.Text = "Timeout:"
        '
        'lblAccount
        '
        Me.lblAccount.BackColor = System.Drawing.SystemColors.Control
        Me.lblAccount.Cursor = System.Windows.Forms.Cursors.Default
        Me.lblAccount.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblAccount.ForeColor = System.Drawing.SystemColors.ControlText
        Me.lblAccount.Location = New System.Drawing.Point(8, 128)
        Me.lblAccount.Name = "lblAccount"
        Me.lblAccount.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.lblAccount.Size = New System.Drawing.Size(61, 13)
        Me.lblAccount.TabIndex = 11
        Me.lblAccount.Text = "&Account:"
        '
        'lblRemotePort
        '
        Me.lblRemotePort.BackColor = System.Drawing.SystemColors.Control
        Me.lblRemotePort.Cursor = System.Windows.Forms.Cursors.Default
        Me.lblRemotePort.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblRemotePort.ForeColor = System.Drawing.SystemColors.ControlText
        Me.lblRemotePort.Location = New System.Drawing.Point(8, 44)
        Me.lblRemotePort.Name = "lblRemotePort"
        Me.lblRemotePort.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.lblRemotePort.Size = New System.Drawing.Size(37, 13)
        Me.lblRemotePort.TabIndex = 2
        Me.lblRemotePort.Text = "Port:"
        '
        'lblConnection
        '
        Me.lblConnection.BackColor = System.Drawing.SystemColors.Control
        Me.lblConnection.Cursor = System.Windows.Forms.Cursors.Default
        Me.lblConnection.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblConnection.ForeColor = System.Drawing.SystemColors.ControlText
        Me.lblConnection.Location = New System.Drawing.Point(8, 156)
        Me.lblConnection.Name = "lblConnection"
        Me.lblConnection.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.lblConnection.Size = New System.Drawing.Size(61, 13)
        Me.lblConnection.TabIndex = 13
        Me.lblConnection.Text = "&Connection:"
        '
        'lblPassword
        '
        Me.lblPassword.BackColor = System.Drawing.SystemColors.Control
        Me.lblPassword.Cursor = System.Windows.Forms.Cursors.Default
        Me.lblPassword.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblPassword.ForeColor = System.Drawing.SystemColors.ControlText
        Me.lblPassword.Location = New System.Drawing.Point(8, 100)
        Me.lblPassword.Name = "lblPassword"
        Me.lblPassword.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.lblPassword.Size = New System.Drawing.Size(61, 13)
        Me.lblPassword.TabIndex = 9
        Me.lblPassword.Text = "&Password:"
        '
        'lblUserName
        '
        Me.lblUserName.BackColor = System.Drawing.SystemColors.Control
        Me.lblUserName.Cursor = System.Windows.Forms.Cursors.Default
        Me.lblUserName.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblUserName.ForeColor = System.Drawing.SystemColors.ControlText
        Me.lblUserName.Location = New System.Drawing.Point(8, 72)
        Me.lblUserName.Name = "lblUserName"
        Me.lblUserName.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.lblUserName.Size = New System.Drawing.Size(61, 13)
        Me.lblUserName.TabIndex = 7
        Me.lblUserName.Text = "&User Name:"
        '
        'lblHostName
        '
        Me.lblHostName.BackColor = System.Drawing.SystemColors.Control
        Me.lblHostName.Cursor = System.Windows.Forms.Cursors.Default
        Me.lblHostName.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblHostName.ForeColor = System.Drawing.SystemColors.ControlText
        Me.lblHostName.Location = New System.Drawing.Point(8, 16)
        Me.lblHostName.Name = "lblHostName"
        Me.lblHostName.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.lblHostName.Size = New System.Drawing.Size(60, 13)
        Me.lblHostName.TabIndex = 0
        Me.lblHostName.Text = "Host &Name:"
        '
        'formConnect
        '
        Me.AcceptButton = Me.cmdConnect
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.BackColor = System.Drawing.SystemColors.Control
        Me.CancelButton = Me.cmdCancel
        Me.ClientSize = New System.Drawing.Size(330, 228)
        Me.ControlBox = False
        Me.Controls.Add(Me.editTimeout)
        Me.Controls.Add(Me.editAccount)
        Me.Controls.Add(Me.chkPassive)
        Me.Controls.Add(Me.comboPort)
        Me.Controls.Add(Me.cmdCancel)
        Me.Controls.Add(Me.cmdConnect)
        Me.Controls.Add(Me.comboOptions)
        Me.Controls.Add(Me.editPassword)
        Me.Controls.Add(Me.editUserName)
        Me.Controls.Add(Me.editHostName)
        Me.Controls.Add(Me.lblTimeout)
        Me.Controls.Add(Me.lblAccount)
        Me.Controls.Add(Me.lblRemotePort)
        Me.Controls.Add(Me.lblConnection)
        Me.Controls.Add(Me.lblPassword)
        Me.Controls.Add(Me.lblUserName)
        Me.Controls.Add(Me.lblHostName)
        Me.Cursor = System.Windows.Forms.Cursors.Default
        Me.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        Me.Location = New System.Drawing.Point(3, 22)
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.Name = "formConnect"
        Me.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.ShowInTaskbar = False
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "Connection"
        Me.ResumeLayout(False)

    End Sub
#End Region

    Public HostName As String
    Public RemotePort As Integer
    Public UserName As String
    Public Password As String
    Public Account As String
    Public Timeout As Integer
    Public Options As Integer
    Public Canceled As Boolean

    Private Sub UpdateForm()
        If Len(editHostName.Text) = 0 Or Len(comboPort.Text) = 0 Or Len(editUserName.Text) = 0 Or Len(editPassword.Text) = 0 Then
            cmdConnect.Enabled = False
            cmdCancel.Enabled = True
        Else
            cmdConnect.Enabled = True
            cmdCancel.Enabled = True
        End If

        If editUserName.Text = "anonymous" Then
            editPassword.PasswordChar = CChar("")
        Else
            editPassword.PasswordChar = CChar("*")
        End If
    End Sub

    Private Sub formConnect_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
        ' Initialize the port combobox to specify the standard
        ' and secure port numbers
        comboPort.Items.Add(CStr(ftpPortDefault))
        comboPort.Items.Add(CStr(ftpPortSecure))
        comboPort.SelectedIndex = 0

        ' Initialize the options combobox to specify the
        ' connection options
        comboOptions.Items.Add("Standard")
        comboOptions.Items.Add("Secure, Implicit")
        comboOptions.Items.Add("Secure, Explicit")
        comboOptions.SelectedIndex = 0

        ' Default to passive mode transfers to avoid potential
        ' problems with firewalls or NAT routers
        chkPassive.CheckState = System.Windows.Forms.CheckState.Checked

        UpdateForm()
    End Sub

    Private Sub editHostName_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles editHostName.TextChanged
        UpdateForm()
    End Sub

    Private Sub editHostName_Enter(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles editHostName.Enter
        editHostName.SelectionStart = 0
        editHostName.SelectionLength = Len(editHostName.Text)
    End Sub

    Private Sub comboPort_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles comboPort.TextChanged
        UpdateForm()
    End Sub

    Private Sub comboPort_KeyPress(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.KeyPressEventArgs) Handles comboPort.KeyPress
        Dim KeyAscii As Integer = Asc(eventArgs.KeyChar)
        If KeyAscii < Asc("0") Or KeyAscii > Asc("9") Then
            Beep()
            KeyAscii = 0
        End If
        If KeyAscii = 0 Then
            eventArgs.Handled = True
        End If
    End Sub

    Private Sub editPassword_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles editPassword.TextChanged
        UpdateForm()
    End Sub

    Private Sub editPassword_Enter(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles editPassword.Enter
        editPassword.SelectionStart = 0
        editPassword.SelectionLength = Len(editPassword.Text)
    End Sub

    Private Sub editUserName_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles editUserName.TextChanged
        UpdateForm()
    End Sub

    Private Sub editUserName_Enter(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles editUserName.Enter
        editUserName.SelectionStart = 0
        editUserName.SelectionLength = Len(editUserName.Text)
    End Sub

    Private Sub cmdCancel_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdCancel.Click
        Canceled = True
        Me.Hide()
    End Sub

    Private Sub cmdConnect_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdConnect.Click
        HostName = Trim(editHostName.Text)
        RemotePort = Val(comboPort.Text)
        UserName = Trim(editUserName.Text)
        Password = Trim(editPassword.Text)
        Account = Trim(editPassword.Text)
        Timeout = Val(editTimeout.Text)
        Options = 0
        Canceled = False

        Select Case comboOptions.SelectedIndex
            Case 0
                Options = FtpOptions.optionDefault
            Case 1
                Options = FtpOptions.optionImplicitSSL
            Case 2
                Options = FtpOptions.optionExplicitSSL
        End Select

        If chkPassive.CheckState = System.Windows.Forms.CheckState.Checked Then
            Options = Options Or FtpOptions.optionPassive
        End If

        Me.Hide()
    End Sub
End Class