'   SocketTools 10 .NET Edition
'   Copyright 2023 Catalyst Development Corporation
'   All rights reserved
'
'   This file is licensed to you pursuant to the terms of the
'   product license agreement included with the original software,
'   and is protected by copyright law and international treaties.
'   Unauthorized reproduction or distribution may result in severe
'   criminal penalties.
'
Option Strict Off
Option Explicit On

Imports SocketTools.IcmpClient

Friend Class formMain
    Inherits System.Windows.Forms.Form
#Region "Windows Form Designer generated code "
    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()
    End Sub
    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal Disposing As Boolean)
        If Disposing Then
            If Not components Is Nothing Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(Disposing)
    End Sub
    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer
    Public ToolTip1 As System.Windows.Forms.ToolTip
    Public WithEvents icmpTimer As System.Windows.Forms.Timer
    Public WithEvents editHostName As System.Windows.Forms.TextBox
    Public WithEvents cmdAction As System.Windows.Forms.Button
    Public WithEvents textOutput As System.Windows.Forms.TextBox
    Public WithEvents Label1 As System.Windows.Forms.Label
    Public WithEvents labelRecv As System.Windows.Forms.Label
    Public WithEvents labelLoss As System.Windows.Forms.Label
    Public WithEvents Label5 As System.Windows.Forms.Label
    Public WithEvents Label4 As System.Windows.Forms.Label
    Public WithEvents labelSend As System.Windows.Forms.Label
    Public WithEvents Label2 As System.Windows.Forms.Label
    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Me.ToolTip1 = New System.Windows.Forms.ToolTip(Me.components)
        Me.icmpTimer = New System.Windows.Forms.Timer(Me.components)
        Me.editHostName = New System.Windows.Forms.TextBox()
        Me.cmdAction = New System.Windows.Forms.Button()
        Me.textOutput = New System.Windows.Forms.TextBox()
        Me.Label1 = New System.Windows.Forms.Label()
        Me.labelRecv = New System.Windows.Forms.Label()
        Me.labelLoss = New System.Windows.Forms.Label()
        Me.Label5 = New System.Windows.Forms.Label()
        Me.Label4 = New System.Windows.Forms.Label()
        Me.labelSend = New System.Windows.Forms.Label()
        Me.Label2 = New System.Windows.Forms.Label()
        Me.SuspendLayout()
        '
        'icmpTimer
        '
        Me.icmpTimer.Interval = 1000
        '
        'editHostName
        '
        Me.editHostName.AcceptsReturn = True
        Me.editHostName.BackColor = System.Drawing.SystemColors.Window
        Me.editHostName.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.editHostName.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.editHostName.ForeColor = System.Drawing.SystemColors.WindowText
        Me.editHostName.Location = New System.Drawing.Point(56, 8)
        Me.editHostName.MaxLength = 0
        Me.editHostName.Name = "editHostName"
        Me.editHostName.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.editHostName.Size = New System.Drawing.Size(185, 19)
        Me.editHostName.TabIndex = 0
        '
        'cmdAction
        '
        Me.cmdAction.BackColor = System.Drawing.SystemColors.Control
        Me.cmdAction.Cursor = System.Windows.Forms.Cursors.Default
        Me.cmdAction.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.cmdAction.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.cmdAction.ForeColor = System.Drawing.SystemColors.ControlText
        Me.cmdAction.Location = New System.Drawing.Point(153, 224)
        Me.cmdAction.Name = "cmdAction"
        Me.cmdAction.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.cmdAction.Size = New System.Drawing.Size(90, 30)
        Me.cmdAction.TabIndex = 2
        Me.cmdAction.UseVisualStyleBackColor = False
        '
        'textOutput
        '
        Me.textOutput.AcceptsReturn = True
        Me.textOutput.BackColor = System.Drawing.SystemColors.Window
        Me.textOutput.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.textOutput.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.textOutput.ForeColor = System.Drawing.SystemColors.WindowText
        Me.textOutput.Location = New System.Drawing.Point(8, 32)
        Me.textOutput.MaxLength = 0
        Me.textOutput.Multiline = True
        Me.textOutput.Name = "textOutput"
        Me.textOutput.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.textOutput.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.textOutput.Size = New System.Drawing.Size(377, 153)
        Me.textOutput.TabIndex = 1
        '
        'Label1
        '
        Me.Label1.AutoSize = True
        Me.Label1.BackColor = System.Drawing.Color.Transparent
        Me.Label1.Cursor = System.Windows.Forms.Cursors.Default
        Me.Label1.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label1.ForeColor = System.Drawing.SystemColors.ControlText
        Me.Label1.Location = New System.Drawing.Point(8, 10)
        Me.Label1.Name = "Label1"
        Me.Label1.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.Label1.Size = New System.Drawing.Size(46, 14)
        Me.Label1.TabIndex = 11
        Me.Label1.Text = "&System:"
        '
        'labelRecv
        '
        Me.labelRecv.BackColor = System.Drawing.SystemColors.Control
        Me.labelRecv.Cursor = System.Windows.Forms.Cursors.Default
        Me.labelRecv.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.labelRecv.ForeColor = System.Drawing.SystemColors.ControlText
        Me.labelRecv.Location = New System.Drawing.Point(232, 192)
        Me.labelRecv.Name = "labelRecv"
        Me.labelRecv.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.labelRecv.Size = New System.Drawing.Size(65, 13)
        Me.labelRecv.TabIndex = 8
        '
        'labelLoss
        '
        Me.labelLoss.BackColor = System.Drawing.SystemColors.Control
        Me.labelLoss.Cursor = System.Windows.Forms.Cursors.Default
        Me.labelLoss.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.labelLoss.ForeColor = System.Drawing.SystemColors.ControlText
        Me.labelLoss.Location = New System.Drawing.Point(344, 192)
        Me.labelLoss.Name = "labelLoss"
        Me.labelLoss.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.labelLoss.Size = New System.Drawing.Size(39, 13)
        Me.labelLoss.TabIndex = 3
        '
        'Label5
        '
        Me.Label5.AutoSize = True
        Me.Label5.BackColor = System.Drawing.SystemColors.Control
        Me.Label5.Cursor = System.Windows.Forms.Cursors.Default
        Me.Label5.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label5.ForeColor = System.Drawing.SystemColors.ControlText
        Me.Label5.Location = New System.Drawing.Point(304, 192)
        Me.Label5.Name = "Label5"
        Me.Label5.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.Label5.Size = New System.Drawing.Size(34, 14)
        Me.Label5.TabIndex = 7
        Me.Label5.Text = "Loss:"
        '
        'Label4
        '
        Me.Label4.AutoSize = True
        Me.Label4.BackColor = System.Drawing.SystemColors.Control
        Me.Label4.Cursor = System.Windows.Forms.Cursors.Default
        Me.Label4.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label4.ForeColor = System.Drawing.SystemColors.ControlText
        Me.Label4.Location = New System.Drawing.Point(168, 192)
        Me.Label4.Name = "Label4"
        Me.Label4.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.Label4.Size = New System.Drawing.Size(55, 14)
        Me.Label4.TabIndex = 6
        Me.Label4.Text = "Received:"
        '
        'labelSend
        '
        Me.labelSend.BackColor = System.Drawing.SystemColors.Control
        Me.labelSend.Cursor = System.Windows.Forms.Cursors.Default
        Me.labelSend.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.labelSend.ForeColor = System.Drawing.SystemColors.ControlText
        Me.labelSend.Location = New System.Drawing.Point(96, 192)
        Me.labelSend.Name = "labelSend"
        Me.labelSend.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.labelSend.Size = New System.Drawing.Size(65, 13)
        Me.labelSend.TabIndex = 5
        '
        'Label2
        '
        Me.Label2.AutoSize = True
        Me.Label2.BackColor = System.Drawing.SystemColors.Control
        Me.Label2.Cursor = System.Windows.Forms.Cursors.Default
        Me.Label2.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label2.ForeColor = System.Drawing.SystemColors.ControlText
        Me.Label2.Location = New System.Drawing.Point(8, 192)
        Me.Label2.Name = "Label2"
        Me.Label2.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.Label2.Size = New System.Drawing.Size(73, 14)
        Me.Label2.TabIndex = 4
        Me.Label2.Text = "Packets Sent:"
        '
        'formMain
        '
        Me.AcceptButton = Me.cmdAction
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.BackColor = System.Drawing.SystemColors.Control
        Me.ClientSize = New System.Drawing.Size(397, 262)
        Me.Controls.Add(Me.editHostName)
        Me.Controls.Add(Me.cmdAction)
        Me.Controls.Add(Me.textOutput)
        Me.Controls.Add(Me.Label1)
        Me.Controls.Add(Me.labelRecv)
        Me.Controls.Add(Me.labelLoss)
        Me.Controls.Add(Me.Label5)
        Me.Controls.Add(Me.Label4)
        Me.Controls.Add(Me.labelSend)
        Me.Controls.Add(Me.Label2)
        Me.Cursor = System.Windows.Forms.Cursors.Default
        Me.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.ForeColor = System.Drawing.SystemColors.WindowText
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle
        Me.Location = New System.Drawing.Point(151, 124)
        Me.MaximizeBox = False
        Me.Name = "formMain"
        Me.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.StartPosition = System.Windows.Forms.FormStartPosition.Manual
        Me.Text = "SocketTools - Ping Example"
        Me.ResumeLayout(False)
        Me.PerformLayout()

    End Sub
#End Region

    Dim WithEvents icmpClient As New SocketTools.IcmpClient

    Private Sub formMain_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
        If Not icmpClient.Initialize() Then
            MsgBox("Unable to initialize SocketTools component", MsgBoxStyle.Exclamation)
            End
        End If

        cmdAction.Text = "Start"
        icmpClient.AutoResolve = False
        labelSend.Text = "0"
        labelRecv.Text = "0"
        labelLoss.Text = "0%"
    End Sub

    Private Sub formMain_Closed(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Closed
        icmpClient.Uninitialize()
        End
    End Sub

    Private Sub cmdAction_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdAction.Click
        Dim strHostName As String
        If cmdAction.Text = "Start" Then

            strHostName = Trim(editHostName.Text)
            If Len(strHostName) = 0 Then
                MsgBox("Please enter a host name or IP address", MsgBoxStyle.Exclamation)
                editHostName.Focus()
                Exit Sub
            End If

            cmdAction.Text = "Stop"
            textOutput.Text = ""
            labelSend.Text = "0"
            labelRecv.Text = "0"
            labelLoss.Text = "0%"

            icmpClient.Reset()
            icmpClient.HostName = strHostName
            icmpTimer.Interval = 1000
            icmpTimer.Enabled = True
        Else
            cmdAction.Text = "Start"
            icmpTimer.Enabled = False
        End If
    End Sub

    Private Sub icmpClient_OnEcho(ByVal sender As Object, ByVal e As SocketTools.IcmpClient.EchoEventArgs) Handles icmpClient.OnEcho
        Dim Percent As Integer

        If icmpClient.SendCount > 1 Then
            Percent = 100 - ((icmpClient.RecvCount / icmpClient.SendCount) * 100)
            labelLoss.Text = CStr(Percent) + "%"
        End If

        labelSend.Text = CStr(icmpClient.SendCount)
    End Sub

    Private Sub icmpClient_OnReply(ByVal sender As Object, ByVal e As SocketTools.IcmpClient.ReplyEventArgs) Handles icmpClient.OnReply
        textOutput.AppendText(CStr(e.PacketSize) & " bytes received, icmp_seq=" & CStr(e.SequenceId) & ", time=" & CStr(e.TripTime) & " ms" & vbCrLf)
        labelRecv.Text = CStr(icmpClient.RecvCount)
    End Sub

    Private Sub icmpTimer_Tick(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles icmpTimer.Tick
        If Not icmpTimer.Enabled Or icmpClient.IsBlocked Then
            Exit Sub
        End If

        If Not icmpClient.Echo() Then
            cmdAction.Text = "Start"
            icmpTimer.Enabled = False
            MsgBox(icmpClient.LastErrorString, MsgBoxStyle.Exclamation)
        End If
    End Sub
End Class