// SocketTools 10 Build 1468
// Copyright 2023 Catalyst Development Corporation
// All rights reserved
// 
// This file is licensed to you pursuant to the terms of the
// product license agreement included with the original software,
// and is protected by copyright law and international treaties.
// Unauthorized reproduction or distribution may result in severe
// criminal penalties.

using System;
using System.Collections;
using System.Data;
using System.Drawing;
using System.Diagnostics;
using System.Windows.Forms;
using Microsoft.VisualBasic;
using SocketTools;

namespace CheckMail
{
    internal class formMain : System.Windows.Forms.Form 
    { 
        #region "Windows Form Designer generated code" 
        public formMain() : base() 
        {
            // This call is required by the Windows Form Designer.
            InitializeComponent();
        }

        // Form overrides dispose to clean up the component list.
        protected override void Dispose( bool Disposing ) 
        { 
            if ( Disposing ) 
            { 
                if ( !( components == null ) ) 
                { 
                    components.Dispose(); 
                } 
            } 
            base.Dispose( Disposing ); 
        } 
        
        // Required by the Windows Form Designer
        private System.ComponentModel.IContainer components; 
        public System.Windows.Forms.ToolTip ToolTip1; 
        public System.Windows.Forms.Button cmdView; 
        public System.Windows.Forms.Button cmdDelete; 
        public System.Windows.Forms.TextBox txtPassword; 
        public System.Windows.Forms.TextBox txtUserName; 
        public System.Windows.Forms.TextBox txtServer; 
        public System.Windows.Forms.Button cmdCheckMail; 
        public System.Windows.Forms.TextBox txtPort; 
        public System.Windows.Forms.TextBox txtMessage; 
        public System.Windows.Forms.Label lblStatus; 
        public System.Windows.Forms.Label lblPassword; 
        public System.Windows.Forms.Label lblUserName; 
        public System.Windows.Forms.Label lblPort; 
        public System.Windows.Forms.Label lblServer; 
        // NOTE: The following procedure is required by the Windows Form Designer
        // It can be modified using the Windows Form Designer.
        // Do not modify it using the code editor.
        internal System.Windows.Forms.ProgressBar ProgressBar1; 
        internal System.Windows.Forms.ListView listMessages; 
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() 
        { 
            this.components = new System.ComponentModel.Container();
            this.ToolTip1 = new System.Windows.Forms.ToolTip(this.components);
            this.cmdView = new System.Windows.Forms.Button();
            this.cmdDelete = new System.Windows.Forms.Button();
            this.txtPassword = new System.Windows.Forms.TextBox();
            this.txtUserName = new System.Windows.Forms.TextBox();
            this.txtServer = new System.Windows.Forms.TextBox();
            this.cmdCheckMail = new System.Windows.Forms.Button();
            this.txtPort = new System.Windows.Forms.TextBox();
            this.txtMessage = new System.Windows.Forms.TextBox();
            this.lblStatus = new System.Windows.Forms.Label();
            this.lblPassword = new System.Windows.Forms.Label();
            this.lblUserName = new System.Windows.Forms.Label();
            this.lblPort = new System.Windows.Forms.Label();
            this.lblServer = new System.Windows.Forms.Label();
            this.ProgressBar1 = new System.Windows.Forms.ProgressBar();
            this.listMessages = new System.Windows.Forms.ListView();
            this.SuspendLayout();
            // 
            // cmdView
            // 
            this.cmdView.BackColor = System.Drawing.SystemColors.Control;
            this.cmdView.Cursor = System.Windows.Forms.Cursors.Default;
            this.cmdView.Enabled = false;
            this.cmdView.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.cmdView.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.cmdView.ForeColor = System.Drawing.SystemColors.ControlText;
            this.cmdView.Location = new System.Drawing.Point(426, 35);
            this.cmdView.Name = "cmdView";
            this.cmdView.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.cmdView.Size = new System.Drawing.Size(90, 30);
            this.cmdView.TabIndex = 9;
            this.cmdView.Text = "View";
            this.cmdView.UseVisualStyleBackColor = false;
            this.cmdView.Click += new System.EventHandler(this.cmdView_Click);
            // 
            // cmdDelete
            // 
            this.cmdDelete.BackColor = System.Drawing.SystemColors.Control;
            this.cmdDelete.Cursor = System.Windows.Forms.Cursors.Default;
            this.cmdDelete.Enabled = false;
            this.cmdDelete.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.cmdDelete.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.cmdDelete.ForeColor = System.Drawing.SystemColors.ControlText;
            this.cmdDelete.Location = new System.Drawing.Point(426, 66);
            this.cmdDelete.Name = "cmdDelete";
            this.cmdDelete.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.cmdDelete.Size = new System.Drawing.Size(90, 30);
            this.cmdDelete.TabIndex = 10;
            this.cmdDelete.Text = "Delete";
            this.cmdDelete.UseVisualStyleBackColor = false;
            this.cmdDelete.Click += new System.EventHandler(this.cmdDelete_Click);
            // 
            // txtPassword
            // 
            this.txtPassword.AcceptsReturn = true;
            this.txtPassword.BackColor = System.Drawing.SystemColors.Window;
            this.txtPassword.Cursor = System.Windows.Forms.Cursors.IBeam;
            this.txtPassword.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.txtPassword.ForeColor = System.Drawing.SystemColors.WindowText;
            this.txtPassword.Location = new System.Drawing.Point(88, 68);
            this.txtPassword.MaxLength = 0;
            this.txtPassword.Name = "txtPassword";
            this.txtPassword.PasswordChar = '*';
            this.txtPassword.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.txtPassword.Size = new System.Drawing.Size(225, 20);
            this.txtPassword.TabIndex = 5;
            // 
            // txtUserName
            // 
            this.txtUserName.AcceptsReturn = true;
            this.txtUserName.BackColor = System.Drawing.SystemColors.Window;
            this.txtUserName.Cursor = System.Windows.Forms.Cursors.IBeam;
            this.txtUserName.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.txtUserName.ForeColor = System.Drawing.SystemColors.WindowText;
            this.txtUserName.Location = new System.Drawing.Point(88, 40);
            this.txtUserName.MaxLength = 0;
            this.txtUserName.Name = "txtUserName";
            this.txtUserName.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.txtUserName.Size = new System.Drawing.Size(225, 20);
            this.txtUserName.TabIndex = 3;
            // 
            // txtServer
            // 
            this.txtServer.AcceptsReturn = true;
            this.txtServer.BackColor = System.Drawing.SystemColors.Window;
            this.txtServer.Cursor = System.Windows.Forms.Cursors.IBeam;
            this.txtServer.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.txtServer.ForeColor = System.Drawing.SystemColors.WindowText;
            this.txtServer.Location = new System.Drawing.Point(88, 12);
            this.txtServer.MaxLength = 0;
            this.txtServer.Name = "txtServer";
            this.txtServer.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.txtServer.Size = new System.Drawing.Size(225, 20);
            this.txtServer.TabIndex = 1;
            // 
            // cmdCheckMail
            // 
            this.cmdCheckMail.BackColor = System.Drawing.SystemColors.Control;
            this.cmdCheckMail.Cursor = System.Windows.Forms.Cursors.Default;
            this.cmdCheckMail.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.cmdCheckMail.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.cmdCheckMail.ForeColor = System.Drawing.SystemColors.ControlText;
            this.cmdCheckMail.Location = new System.Drawing.Point(426, 4);
            this.cmdCheckMail.Name = "cmdCheckMail";
            this.cmdCheckMail.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.cmdCheckMail.Size = new System.Drawing.Size(90, 30);
            this.cmdCheckMail.TabIndex = 8;
            this.cmdCheckMail.Text = "Check Mail";
            this.cmdCheckMail.UseVisualStyleBackColor = false;
            this.cmdCheckMail.Click += new System.EventHandler(this.cmdCheckMail_Click);
            // 
            // txtPort
            // 
            this.txtPort.AcceptsReturn = true;
            this.txtPort.BackColor = System.Drawing.SystemColors.Window;
            this.txtPort.Cursor = System.Windows.Forms.Cursors.IBeam;
            this.txtPort.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.txtPort.ForeColor = System.Drawing.SystemColors.WindowText;
            this.txtPort.Location = new System.Drawing.Point(356, 12);
            this.txtPort.MaxLength = 0;
            this.txtPort.Name = "txtPort";
            this.txtPort.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.txtPort.Size = new System.Drawing.Size(37, 20);
            this.txtPort.TabIndex = 7;
            this.txtPort.Text = "110";
            // 
            // txtMessage
            // 
            this.txtMessage.AcceptsReturn = true;
            this.txtMessage.BackColor = System.Drawing.SystemColors.Window;
            this.txtMessage.Cursor = System.Windows.Forms.Cursors.IBeam;
            this.txtMessage.Font = new System.Drawing.Font("Courier New", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.txtMessage.ForeColor = System.Drawing.SystemColors.WindowText;
            this.txtMessage.Location = new System.Drawing.Point(4, 100);
            this.txtMessage.MaxLength = 0;
            this.txtMessage.Multiline = true;
            this.txtMessage.Name = "txtMessage";
            this.txtMessage.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.txtMessage.ScrollBars = System.Windows.Forms.ScrollBars.Both;
            this.txtMessage.Size = new System.Drawing.Size(516, 250);
            this.txtMessage.TabIndex = 14;
            this.txtMessage.Visible = false;
            this.txtMessage.WordWrap = false;
            // 
            // lblStatus
            // 
            this.lblStatus.BackColor = System.Drawing.SystemColors.Control;
            this.lblStatus.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
            this.lblStatus.Cursor = System.Windows.Forms.Cursors.Default;
            this.lblStatus.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.lblStatus.ForeColor = System.Drawing.SystemColors.ControlText;
            this.lblStatus.Location = new System.Drawing.Point(4, 353);
            this.lblStatus.Name = "lblStatus";
            this.lblStatus.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.lblStatus.Size = new System.Drawing.Size(373, 21);
            this.lblStatus.TabIndex = 12;
            // 
            // lblPassword
            // 
            this.lblPassword.BackColor = System.Drawing.SystemColors.Control;
            this.lblPassword.Cursor = System.Windows.Forms.Cursors.Default;
            this.lblPassword.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.lblPassword.ForeColor = System.Drawing.SystemColors.ControlText;
            this.lblPassword.Location = new System.Drawing.Point(15, 72);
            this.lblPassword.Name = "lblPassword";
            this.lblPassword.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.lblPassword.Size = new System.Drawing.Size(70, 15);
            this.lblPassword.TabIndex = 4;
            this.lblPassword.Text = "Password:";
            // 
            // lblUserName
            // 
            this.lblUserName.BackColor = System.Drawing.SystemColors.Control;
            this.lblUserName.Cursor = System.Windows.Forms.Cursors.Default;
            this.lblUserName.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.lblUserName.ForeColor = System.Drawing.SystemColors.ControlText;
            this.lblUserName.Location = new System.Drawing.Point(15, 44);
            this.lblUserName.Name = "lblUserName";
            this.lblUserName.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.lblUserName.Size = new System.Drawing.Size(70, 15);
            this.lblUserName.TabIndex = 2;
            this.lblUserName.Text = "User Name:";
            // 
            // lblPort
            // 
            this.lblPort.BackColor = System.Drawing.SystemColors.Control;
            this.lblPort.Cursor = System.Windows.Forms.Cursors.Default;
            this.lblPort.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.lblPort.ForeColor = System.Drawing.SystemColors.ControlText;
            this.lblPort.Location = new System.Drawing.Point(324, 16);
            this.lblPort.Name = "lblPort";
            this.lblPort.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.lblPort.Size = new System.Drawing.Size(29, 13);
            this.lblPort.TabIndex = 6;
            this.lblPort.Text = "Port:";
            // 
            // lblServer
            // 
            this.lblServer.BackColor = System.Drawing.SystemColors.Control;
            this.lblServer.Cursor = System.Windows.Forms.Cursors.Default;
            this.lblServer.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.lblServer.ForeColor = System.Drawing.SystemColors.ControlText;
            this.lblServer.Location = new System.Drawing.Point(15, 16);
            this.lblServer.Name = "lblServer";
            this.lblServer.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.lblServer.Size = new System.Drawing.Size(70, 15);
            this.lblServer.TabIndex = 0;
            this.lblServer.Text = "Mail Server:";
            // 
            // ProgressBar1
            // 
            this.ProgressBar1.Location = new System.Drawing.Point(292, 353);
            this.ProgressBar1.Name = "ProgressBar1";
            this.ProgressBar1.Size = new System.Drawing.Size(229, 21);
            this.ProgressBar1.TabIndex = 15;
            // 
            // listMessages
            // 
            this.listMessages.FullRowSelect = true;
            this.listMessages.Location = new System.Drawing.Point(4, 100);
            this.listMessages.Name = "listMessages";
            this.listMessages.Size = new System.Drawing.Size(516, 250);
            this.listMessages.TabIndex = 16;
            this.listMessages.UseCompatibleStateImageBehavior = false;
            this.listMessages.View = System.Windows.Forms.View.Details;
            this.listMessages.DoubleClick += new System.EventHandler(this.listMessages_DoubleClick);
            // 
            // formMain
            // 
            this.AcceptButton = this.cmdCheckMail;
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.BackColor = System.Drawing.SystemColors.Control;
            this.ClientSize = new System.Drawing.Size(527, 380);
            this.Controls.Add(this.listMessages);
            this.Controls.Add(this.ProgressBar1);
            this.Controls.Add(this.cmdView);
            this.Controls.Add(this.cmdDelete);
            this.Controls.Add(this.txtPassword);
            this.Controls.Add(this.txtUserName);
            this.Controls.Add(this.txtServer);
            this.Controls.Add(this.cmdCheckMail);
            this.Controls.Add(this.txtPort);
            this.Controls.Add(this.txtMessage);
            this.Controls.Add(this.lblStatus);
            this.Controls.Add(this.lblPort);
            this.Controls.Add(this.lblServer);
            this.Controls.Add(this.lblUserName);
            this.Controls.Add(this.lblPassword);
            this.Cursor = System.Windows.Forms.Cursors.Default;
            this.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
            this.Location = new System.Drawing.Point(275, 225);
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "formMain";
            this.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "SocketTools CheckMail Example";
            this.Closed += new System.EventHandler(this.formMain_Closed);
            this.Load += new System.EventHandler(this.formMain_Load);
            this.ResumeLayout(false);
            this.PerformLayout();

		} 
        
		[STAThread]
		public static void Main()
		{
            Application.EnableVisualStyles();
            Application.DoEvents();
			Application.Run( new formMain() );
		}

        #endregion 
        
        //  ListView column header constants
        private const int lvcDate = 0; 
        private const int lvcSubject = 1; 
        
        //  Post Office Protocol object
        public SocketTools.PopClient popClient = new SocketTools.PopClient(); 
        
        private string GetHeaderValue( string strHeaders, string strHeaderName ) 
        { 
            string getHeaderValueReturn = null;
            int nPos1 = 0; 
            int nPos2 = 0; 
            int nStart = 0; 
            
            nPos1 =  strHeaders.IndexOf( strHeaderName + ":" ) + 1; 
            if ( nPos1 == 0 ) 
            { 
                getHeaderValueReturn = ""; 
                return getHeaderValueReturn; 
            } 
            
            strHeaders = strHeaders.Substring( nPos1 ); 
            
            string transTemp0 = " "; 
            nPos1 = strHeaders.IndexOf( transTemp0 ) + 1; 
            nStart = 1; 
            do 
            { 
                nPos2 = Strings.InStr( nStart, strHeaders, System.Convert.ToString(  System.Convert.ToChar( 13 ) ) +  System.Convert.ToChar( 10 ), (Microsoft.VisualBasic.CompareMethod)(0) ); 
                nStart = nPos2 + 3; 
                //  If there is a tab after the <crlf>, the header is multi-line
                //  so find the end of the next line
            } 
            while ( ( char.Parse( Strings.Mid( strHeaders, nPos2 + 2, 1 ) ) ==  System.Convert.ToChar( 9 ) ) ); 
            
            if ( nPos1 < nPos2 ) 
            { 
                getHeaderValueReturn = Strings.Mid( strHeaders, nPos1 + 1, ( nPos2 - nPos1 ) - 1 ); 
            } 
            else 
            { 
                getHeaderValueReturn = ""; 
            } 
            
            return getHeaderValueReturn;
        } 
        
        
        private void cmdCheckMail_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            ListViewItem lvItem = null; 
            string strHeaders = null; 
            int nMessages = 0; 
            int nIndex = 0; 
            
            ProgressBar1.Value = 0; 
            popClient.HostName = txtServer.Text.Trim(); 
            popClient.UserName = txtUserName.Text.Trim(); 
            popClient.Password = txtPassword.Text.Trim(); 
            
            if ( !( popClient.Connect() ) ) 
            { 
                Interaction.MsgBox( popClient.LastErrorString, MsgBoxStyle.Exclamation, null ); 
                return; 
            } 
            
            nMessages = popClient.MessageCount; 
            
            if ( ( nMessages != 0 ) ) 
            { 
                cmdDelete.Enabled = true; 
                cmdView.Enabled = true; 
            } 
            else 
            { 
                cmdDelete.Enabled = false; 
                cmdView.Enabled = false; 
            } 
            
            listMessages.Items.Clear(); 
            
            for ( nIndex=1; nIndex <= popClient.LastMessage; nIndex++ ) 
            { 
                lblStatus.Text = "Downloading Message " + nIndex + " Headers"; 
                ProgressBar1.Value = System.Convert.ToInt32( ( System.Convert.ToDouble( nIndex ) / System.Convert.ToDouble( nMessages ) ) * 100.0D ); 
                lblStatus.Refresh(); 
                
                popClient.GetHeaders( nIndex, ref strHeaders ); 
                lvItem = listMessages.Items.Add( GetHeaderValue( strHeaders, "From" ) ); 
                lvItem.SubItems.Add( GetHeaderValue( strHeaders, "Date" ) ); 
                lvItem.SubItems.Add( GetHeaderValue( strHeaders, "Subject" ) ); 
            } 
            
            lblStatus.Text = "You have " + nMessages + " messages."; 
            lblStatus.Refresh(); 
            ProgressBar1.Value = 0; 
            
            popClient.Disconnect(); 
        } 
        
        
        private void cmdDelete_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            ListViewItem lvItem = null; 
            int nIndex = 0; 
            bool bDeleted = false; 
            
            bDeleted = false; 
            
            if ( Interaction.MsgBox( "Are you sure you want to delete these messages?", ( ( Microsoft.VisualBasic.MsgBoxStyle )( System.Convert.ToInt32( MsgBoxStyle.Question ) + System.Convert.ToInt32( MsgBoxStyle.YesNo ) ) ), System.Reflection.Assembly.GetExecutingAssembly().GetName().Name ) == MsgBoxResult.No ) 
            { 
                listMessages.Focus(); 
                return; 
            } 
            
            popClient.HostName = txtServer.Text.Trim(); 
            popClient.UserName = txtUserName.Text.Trim(); 
            popClient.Password = txtPassword.Text.Trim(); 
            
            if ( !( popClient.Connect() ) ) 
            { 
                Interaction.MsgBox( popClient.LastErrorString, MsgBoxStyle.Exclamation, null ); 
                popClient.Disconnect(); 
                return; 
            } 
            
            for ( nIndex=listMessages.Items.Count - 1; nIndex >= 0; nIndex+=-1 ) 
            { 
                if ( listMessages.Items[ nIndex ].Selected == true ) 
                { 
                    if ( !( popClient.DeleteMessage( nIndex + 1 ) ) ) 
                    { 
                        Interaction.MsgBox( popClient.LastErrorString, MsgBoxStyle.Exclamation, null ); 
                        popClient.Disconnect(); 
                        return; 
                    } 
                    bDeleted = true; 
                } 
            } 
            
            popClient.Disconnect(); 
            listMessages.Focus(); 
            
            if ( ( bDeleted ) ) 
            { 
                // If messages were deleted, then use cmdCheckMail to redisplay messages
                cmdCheckMail_Click( cmdCheckMail, new System.EventArgs() ); 
            } 
            else 
            { 
                Interaction.MsgBox( "No messages were deleted", MsgBoxStyle.Information, null ); 
            } 
            
            listMessages.Focus(); 
        } 
        
        
        private void cmdView_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            int nMessage = 0; 
            string strMessage = null; 
            
            if ( ( cmdView.Text == "Close" ) ) 
            { 
                listMessages.Visible = true; 
                txtMessage.Visible = false; 
                cmdDelete.Enabled = true; 
                cmdCheckMail.Enabled = true; 
                cmdView.Text = "View"; 
                txtMessage.Text = ""; 
                listMessages.Focus(); 
            } 
            else 
            { 
                cmdCheckMail.Enabled = false; 
                
                for ( nMessage=0; nMessage <= listMessages.Items.Count - 1; nMessage++ ) 
                { 
                    if ( ( listMessages.Items[ nMessage ].Selected == true ) ) 
                    { 
                        nMessage = nMessage + 1; 
                        break;
                    } 
                } 
                
                popClient.HostName = txtServer.Text.Trim(); 
                popClient.UserName = txtUserName.Text.Trim(); 
                popClient.Password = txtPassword.Text.Trim(); 
                
                if ( !( popClient.Connect() ) ) 
                { 
                    Interaction.MsgBox( popClient.LastErrorString, MsgBoxStyle.Exclamation, null ); 
                    popClient.Disconnect(); 
                    return; 
                } 
                
                // Get the entire message and put it in strMessage
                if ( !( popClient.GetMessage( nMessage, ref strMessage ) ) ) 
                { 
                    Interaction.MsgBox( popClient.LastErrorString, MsgBoxStyle.Exclamation, null ); 
                    popClient.Disconnect(); 
                    return; 
                } 
                
                popClient.Disconnect(); 
                
                listMessages.Visible = false; 
                txtMessage.Visible = true; 
                cmdDelete.Enabled = false; 
                cmdView.Text = "Close"; 
                txtMessage.Text = strMessage; // Put the message in the text box
            } 
            
        } 
        
        
        private void formMain_Load( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            if ( !( popClient.Initialize() ) ) 
            { 
                Interaction.MsgBox( "Unable to initialize SocketTools component", MsgBoxStyle.Exclamation, null ); 
                System.Environment.Exit( 0 ); 
            } 
            
            ProgressBar1.Value = 0; 
            ColumnHeader colHeader = null; 
            listMessages.View = View.Details; 
            colHeader = listMessages.Columns.Add( "From", 175, HorizontalAlignment.Left ); 
            colHeader = listMessages.Columns.Add( "Date", 175, HorizontalAlignment.Left ); 
            colHeader = listMessages.Columns.Add( "Subject", 350, HorizontalAlignment.Left ); 
        } 
        
        
        private void formMain_Closed( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            popClient.Uninitialize(); 
        } 
        
        
        private void listMessages_DoubleClick( object sender, System.EventArgs e ) 
        { 
            if ( listMessages.Items.Count > 0 )
             { 
                cmdView_Click( cmdView, new System.EventArgs() ); } 
            
        } 
    } 
} 
