// SocketTools 10 Build 1468
// Copyright 2023 Catalyst Development Corporation
// All rights reserved
// 
// This file is licensed to you pursuant to the terms of the
// product license agreement included with the original software,
// and is protected by copyright law and international treaties.
// Unauthorized reproduction or distribution may result in severe
// criminal penalties.
// 

using System;
using System.Collections;
using System.Data;
using System.Drawing;
using System.Diagnostics;
using System.Windows.Forms;
using SocketTools;

namespace EchoClient
{
    internal class formMain : System.Windows.Forms.Form 
    { 
        #region '"Windows Form Designer generated code "' 
        public formMain() : base() 
        { 
            
            // This call is required by the Windows Form Designer.
            InitializeComponent(); 
        } 
        // Form overrides dispose to clean up the component list.
        protected override void Dispose( bool Disposing ) 
        { 
            if ( Disposing ) 
            { 
                if ( !( components == null ) ) 
                { 
                    components.Dispose(); 
                } 
            } 
            base.Dispose( Disposing ); 
        } 
        
        // Required by the Windows Form Designer
        private System.ComponentModel.IContainer components; 
        public System.Windows.Forms.ToolTip ToolTip1; 
        public System.Windows.Forms.TextBox viewOutput; 
        public System.Windows.Forms.TextBox editInput; 
        public System.Windows.Forms.MenuItem menuConnect; 
        public System.Windows.Forms.MenuItem menuDisconnect; 
        public System.Windows.Forms.MenuItem menuSeparator1; 
        public System.Windows.Forms.MenuItem menuExit; 
        public System.Windows.Forms.MenuItem menuConnection; 
        public System.Windows.Forms.MainMenu MainMenu1;
		private System.Windows.Forms.Timer Timer1; 
        // NOTE: The following procedure is required by the Windows Form Designer
        // It can be modified using the Windows Form Designer.
        // Do not modify it using the code editor.
        public System.Windows.Forms.Button btnSend; 

        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() 
        { 
            this.components = new System.ComponentModel.Container();
            this.ToolTip1 = new System.Windows.Forms.ToolTip(this.components);
            this.btnSend = new System.Windows.Forms.Button();
            this.viewOutput = new System.Windows.Forms.TextBox();
            this.editInput = new System.Windows.Forms.TextBox();
            this.MainMenu1 = new System.Windows.Forms.MainMenu(this.components);
            this.menuConnection = new System.Windows.Forms.MenuItem();
            this.menuConnect = new System.Windows.Forms.MenuItem();
            this.menuDisconnect = new System.Windows.Forms.MenuItem();
            this.menuSeparator1 = new System.Windows.Forms.MenuItem();
            this.menuExit = new System.Windows.Forms.MenuItem();
            this.Timer1 = new System.Windows.Forms.Timer(this.components);
            this.SuspendLayout();
            // 
            // btnSend
            // 
            this.btnSend.BackColor = System.Drawing.SystemColors.Control;
            this.btnSend.Cursor = System.Windows.Forms.Cursors.Default;
            this.btnSend.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.btnSend.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.btnSend.ForeColor = System.Drawing.SystemColors.ControlText;
            this.btnSend.Location = new System.Drawing.Point(348, 232);
            this.btnSend.Name = "btnSend";
            this.btnSend.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.btnSend.Size = new System.Drawing.Size(57, 24);
            this.btnSend.TabIndex = 2;
            this.btnSend.Text = "Send";
            this.btnSend.UseVisualStyleBackColor = false;
            this.btnSend.Click += new System.EventHandler(this.btnSend_Click);
            // 
            // viewOutput
            // 
            this.viewOutput.AcceptsReturn = true;
            this.viewOutput.BackColor = System.Drawing.SystemColors.Window;
            this.viewOutput.BorderStyle = System.Windows.Forms.BorderStyle.None;
            this.viewOutput.Cursor = System.Windows.Forms.Cursors.Arrow;
            this.viewOutput.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.viewOutput.ForeColor = System.Drawing.SystemColors.WindowText;
            this.viewOutput.Location = new System.Drawing.Point(4, 8);
            this.viewOutput.MaxLength = 0;
            this.viewOutput.Multiline = true;
            this.viewOutput.Name = "viewOutput";
            this.viewOutput.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.viewOutput.ScrollBars = System.Windows.Forms.ScrollBars.Both;
            this.viewOutput.Size = new System.Drawing.Size(413, 217);
            this.viewOutput.TabIndex = 0;
            this.viewOutput.TabStop = false;
            this.viewOutput.WordWrap = false;
            this.viewOutput.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.viewOutput_KeyPress);
            // 
            // editInput
            // 
            this.editInput.AcceptsReturn = true;
            this.editInput.BackColor = System.Drawing.SystemColors.Window;
            this.editInput.Cursor = System.Windows.Forms.Cursors.IBeam;
            this.editInput.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.editInput.ForeColor = System.Drawing.SystemColors.WindowText;
            this.editInput.Location = new System.Drawing.Point(0, 232);
            this.editInput.MaxLength = 0;
            this.editInput.Name = "editInput";
            this.editInput.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.editInput.Size = new System.Drawing.Size(341, 24);
            this.editInput.TabIndex = 1;
            this.editInput.TextChanged += new System.EventHandler(this.editInput_TextChanged);
            // 
            // MainMenu1
            // 
            this.MainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuConnection});
            // 
            // menuConnection
            // 
            this.menuConnection.Index = 0;
            this.menuConnection.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuConnect,
            this.menuDisconnect,
            this.menuSeparator1,
            this.menuExit});
            this.menuConnection.Text = "Connection";
            // 
            // menuConnect
            // 
            this.menuConnect.Index = 0;
            this.menuConnect.Text = "&Connect";
            this.menuConnect.Click += new System.EventHandler(this.menuConnect_Click);
            // 
            // menuDisconnect
            // 
            this.menuDisconnect.Index = 1;
            this.menuDisconnect.Text = "&Disconnect";
            this.menuDisconnect.Click += new System.EventHandler(this.menuDisconnect_Click);
            // 
            // menuSeparator1
            // 
            this.menuSeparator1.Index = 2;
            this.menuSeparator1.Text = "-";
            // 
            // menuExit
            // 
            this.menuExit.Index = 3;
            this.menuExit.Text = "E&xit";
            this.menuExit.Click += new System.EventHandler(this.menuExit_Click);
            // 
            // Timer1
            // 
            this.Timer1.Tick += new System.EventHandler(this.Timer1_Tick);
            // 
            // formMain
            // 
            this.AcceptButton = this.btnSend;
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.BackColor = System.Drawing.SystemColors.Control;
            this.ClientSize = new System.Drawing.Size(456, 271);
            this.Controls.Add(this.btnSend);
            this.Controls.Add(this.viewOutput);
            this.Controls.Add(this.editInput);
            this.Cursor = System.Windows.Forms.Cursors.Default;
            this.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.ForeColor = System.Drawing.SystemColors.WindowText;
            this.Location = new System.Drawing.Point(220, 252);
            this.Menu = this.MainMenu1;
            this.Name = "formMain";
            this.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.StartPosition = System.Windows.Forms.FormStartPosition.Manual;
            this.Text = "Echo Client";
            this.Activated += new System.EventHandler(this.formMain_Activated);
            this.Closed += new System.EventHandler(this.formMain_Closed);
            this.Load += new System.EventHandler(this.formMain_Load);
            this.Resize += new System.EventHandler(this.formMain_Resize);
            this.ResumeLayout(false);

		} 
        
		[STAThread]
		public static void Main()
		{
            Application.EnableVisualStyles();
            Application.DoEvents();
            Application.Run(new formMain());
		}
		#endregion 
        
        public SocketTools.SocketWrench sockClient = new SocketTools.SocketWrench(); 
        private bool g_bInitialized; 
        private bool g_bCanceled; 
        
		private void formMain_Load( System.Object eventSender, System.EventArgs eventArgs ) 
		{ 
			g_bInitialized = false; 
			g_bCanceled = false; 

			// Create event handlers
			sockClient.OnConnect += new System.EventHandler( sockClient_OnConnect );
			sockClient.OnDisconnect += new System.EventHandler( sockClient_OnDisconnect );
			sockClient.OnRead += new System.EventHandler( sockClient_OnRead );
		} 
        
		private void formMain_Activated( System.Object eventSender, System.EventArgs eventArgs ) 
		{ 
			if ( g_bInitialized == false ) 
			{ 
				g_bInitialized = true; 
				UpdateForm(); 
				menuConnect_Click( menuConnect, new System.EventArgs() ); 
			} 
		} 

		private void btnSend_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            string strBuffer; 
            int cchBuffer; 
            int nBytesWritten; 
            int nBytesRead; 
            
            if ( btnSend.Text == "Cancel" ) 
            { 
                // 
                //  If the button caption reads 'Cancel' then this means
                //  that we are in the process of reading data from the
                //  server, and the user wishes to cancel the operation
                // 
                g_bCanceled = true; 
                btnSend.Enabled = false; 
                sockClient.Cancel(); 
                return; 
            } 
            
            btnSend.Enabled = false; 
            
            nBytesWritten = 0; 
            nBytesRead = 0; 
            
            // 
            //  Send the string entered by the user, terminated with
            //  a carriage-return/linefeed sequence; this is commonly
            //  used as an 'end of line' delimiter by the text-based
            //  Internet application protocols such as FTP and SMTP.
            // 
            strBuffer = editInput.Text +  System.Convert.ToChar( 13 ) +  System.Convert.ToChar( 10 ); 
            cchBuffer = strBuffer.Length; 
            
            editInput.Text = ""; 
            
            // 
            //  Write the data to the socket
            // 
            nBytesWritten = sockClient.Write( strBuffer, cchBuffer ); 
            
            if ( nBytesWritten == -1 ) 
            { 
				MessageBox.Show(sockClient.LastErrorString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return; 
            } 
            
            // 
            //  If this is not a blocking socket, then exit after
            //  sending the data; when the server echoes the data
            //  back to us, the control's Read event will fire
            // 
            if ( sockClient.Blocking == false ) 
            { 
                return; 
            } 
            
            // 
            //  Because this is a blocking connection, give the user
            //  the opportunity to cancel the blocking read and
            //  return control back to the application; this will be
            //  implemented using the global flag g_bCanceled, along
            //  with the Cancel method
            // 
            g_bCanceled = false; 
            btnSend.Text = "Cancel"; 
            btnSend.Enabled = true; 
            
            // 
            //  Read the data echoed back from the server. The most
            //  important aspect of this code is that we do not make
            //  the assumption that we will be able to read all of
            //  the data in a single operation. Instead, we use a loop
            //  to read until the number of bytes read matches the
            //  number of bytes written.
            // 
            while ( nBytesRead < nBytesWritten & g_bCanceled == false ) 
            { 
                
                cchBuffer = sockClient.Read( ref strBuffer, nBytesWritten ); 
                
                if ( cchBuffer > 0 ) 
                { 
                    // 
                    //  The read on the socket has returned at least one
                    //  byte of data; update the total number of bytes read
                    //  and the viewOutput edit control
                    // 
                    nBytesRead = nBytesRead + cchBuffer; 
                    viewOutput.SelectionStart = 65535; 
                    viewOutput.SelectionLength = 0; 
                    viewOutput.SelectedText = strBuffer; 
                    viewOutput.Refresh(); 
                    
                } 
                else if ( cchBuffer == 0 ) 
                { 
                    // 
                    //  The server has closed the connection; we must close
                    //  our side of the connection and let the user know
                    //  that the client session is terminated
                    // 
                    menuDisconnect_Click( menuDisconnect, new System.EventArgs() ); 
                    MessageBox.Show( "The remote host has closed the connection", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    break;
                } 
                else 
                { 
                    // The read on the socket has failed with an error
                    switch ( sockClient.LastError ) 
                    {
						// The operation was canceled by the user
                        case SocketTools.SocketWrench.ErrorCode.errorOperationCanceled:
                            break;

						// The user disconnected from the server
                        case SocketTools.SocketWrench.ErrorCode.errorNotConnected:
                            break;
                            
						// The operation timed out waiting for a response
                        case SocketTools.SocketWrench.ErrorCode.errorOperationTimeout:
                            break;

						// An unexpected error occurred during the read
						default:
                            MessageBox.Show( "An unexpected error has occurred (Error " + sockClient.LastError + ")", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation );
                            break;
                    }
					break;                    
                } 
            } 
            
            btnSend.Text = "Send"; 
            UpdateForm(); 
        } 
        
        private void editInput_TextChanged( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            UpdateForm(); 
        } 
        
		private void formMain_Resize( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            if ( WindowState != System.Windows.Forms.FormWindowState.Minimized ) 
            { 
                viewOutput.Top = 0; 
                viewOutput.Left = 0; 
                viewOutput.Height = ClientRectangle.Height - editInput.Height; 
                viewOutput.Width = ClientRectangle.Width; 
                editInput.Top = ClientRectangle.Height - editInput.Height; 
                editInput.Left = 0; 
                editInput.Width = ClientRectangle.Width - btnSend.Width; 
                btnSend.Height = editInput.Height; 
                btnSend.Top = ClientRectangle.Height - btnSend.Height; 
                btnSend.Left = ClientRectangle.Width - btnSend.Width; 
            } 
        } 
        
        private void formMain_Closed( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            sockClient.Disconnect();
        } 
        
        public void menuConnect_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            formConnect dlg = new formConnect(); 
            
            dlg.ShowDialog(); 
            if ( dlg.m_bCanceled )
             { 
                return; } 
            
            
            sockClient.Reset(); 
            sockClient.Blocking = dlg.m_bBlocking; 
            sockClient.Secure = dlg.m_bSecure; 
            
            if (! sockClient.Connect( dlg.m_strHostName, dlg.m_nHostPort, dlg.m_nTimeout )) 
            { 
                MessageBox.Show( sockClient.LastErrorString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation );
                return; 
            } 

			if (! sockClient.Blocking )
			{
				Timer1.Interval = dlg.m_nTimeout * 1000;
				Timer1.Enabled = true;
			}
            
            UpdateForm(); 
            
            if ( sockClient.IsConnected ) 
            { 
                editInput.Text = ""; viewOutput.Text = ""; 
                editInput.Focus(); 
            } 
        } 
        
        public void menuDisconnect_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            sockClient.Disconnect(); 
            UpdateForm(); 
        } 
        
        public void menuExit_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            if ( sockClient.IsConnected ) 
                sockClient.Disconnect(); 

            System.Environment.Exit( 0 ); 
        } 
        
        private void sockClient_OnConnect( System.Object sender, System.EventArgs e ) 
        { 
            // 
            //  This event is called when a non-blocking (asynchronous)
            //  connection attempt has completed
            // 
            Debug.WriteLine( "OnConnect: Connection established with remote host" ); 
			Timer1.Enabled = false;
			
            UpdateForm(); 
            
            viewOutput.Text = ""; 
            editInput.Text = ""; 
            editInput.Focus(); 
        } 
        
        private void sockClient_OnDisconnect( System.Object sender, System.EventArgs e ) 
        { 
            // 
            //  This event is called when the remote host closes
            //  the connection. Note that we must still explicitly
            //  close our socket.
            // 
            Debug.WriteLine( "OnDisconnect: Remote host terminated connection with client" ); 
            menuDisconnect_Click( menuDisconnect, new System.EventArgs() ); 
            MessageBox.Show( "The remote server has closed the connection", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation );
            
        } 
        
        private void sockClient_OnRead( System.Object sender, System.EventArgs e ) 
        { 
            // 
            //  This event is fired when data is written by the server to
            //  the client. This event is only fired when the control is
            //  in non-blocking mode (when the Blocking property is set
            //  to False); the code for the blocking read is in the Click
            //  event for the btnSend control
            // 
            string strBuffer = ""; 
            int cchBuffer = 0;
            
            Debug.WriteLine( "OnRead: Data sent by remote host" ); 
            // 
            //  Read the data echoed back from the server. The most
            //  important aspect of this code is that we do not make
            //  the assumption that we will be able to read all of
            //  the data in a single operation.
            // 
            while (true) 
            { 
                cchBuffer = sockClient.Read( ref strBuffer, 4096 ); 
                
                if ( cchBuffer > 0 ) 
                { 
                    viewOutput.SelectionStart = 65535; 
                    viewOutput.SelectionLength = 0; 
                    viewOutput.SelectedText = strBuffer; 
                    viewOutput.Refresh(); 
                } 
                else if ( cchBuffer == 0 ) 
                { 
                    // 
                    //  If the number of bytes read is 0, then this means
                    //  that the server has closed the connection; the
                    //  control's Disconnect event will fire
                    // 
                    break;
                } 
                else 
                { 
                    //  The read on the socket has failed with an error
                    switch ( sockClient.LastError ) 
                    {
						//  The read operation was canceled by the user
						case SocketTools.SocketWrench.ErrorCode.errorOperationCanceled:
                            break;

						// The connection has been closed
						case SocketTools.SocketWrench.ErrorCode.errorNotConnected:
                            break;

						//  There is no more data to read at this time; if the server
						//  sends more data, another Read event will fire
						case SocketTools.SocketWrench.ErrorCode.errorOperationWouldBlock:
                            break;

						//  An unexpected error occurred during the read
						default:
                            MessageBox.Show( "An unexpected error occurred (Error " + sockClient.LastError + ")", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation );
                            break;
                    }
                    break;
                } 
            }
        } 
        
        private void viewOutput_KeyPress( System.Object eventSender, System.Windows.Forms.KeyPressEventArgs eventArgs ) 
        { 
            if ( eventArgs.KeyChar > 31 )
				eventArgs.Handled = true; 
        } 
        
		private void Timer1_Tick(object sender, System.EventArgs e)
		{
			Timer1.Enabled = false;
			sockClient.Disconnect();
			MessageBox.Show( "Unable to establish connection with the remote host", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation );
		} 

		private void UpdateForm() 
		{ 
			if ( sockClient.IsConnected ) 
			{ 
				menuConnect.Enabled = false; 
				menuDisconnect.Enabled = true; 
				editInput.Enabled = true; 
				if ( editInput.Text.Length > 0 )
				{ 
					btnSend.Enabled = true;
				} 
				else
				{
					btnSend.Enabled = false;
				} 
			} 
			else 
			{ 
				menuConnect.Enabled = true; 
				menuDisconnect.Enabled = false; 
				editInput.Enabled = false; 
				btnSend.Enabled = false; 
			} 
		}
	} 
} 
