// SocketTools 10 Build 1468
// Copyright 2023 Catalyst Development Corporation
// All rights reserved
// 
// This file is licensed to you pursuant to the terms of the
// product license agreement included with the original software,
// and is protected by copyright law and international treaties.
// Unauthorized reproduction or distribution may result in severe
// criminal penalties.

using System;
using System.Collections;
using System.Data;
using System.Drawing;
using System.Diagnostics;
using System.Windows.Forms;
using Microsoft.VisualBasic;
using SocketTools;

namespace GetPage
{
    internal class formMain : System.Windows.Forms.Form 
    { 
        #region "Windows Form Designer generated code "
        public formMain() : base() 
        { 
            // This call is required by the Windows Form Designer.
            InitializeComponent(); 
        } 

        // Form overrides dispose to clean up the component list.
        protected override void Dispose( bool Disposing ) 
        { 
            if ( Disposing ) 
            { 
                if ( !( components == null ) ) 
                { 
                    components.Dispose(); 
                } 
            } 
            base.Dispose( Disposing ); 
        } 
        
        // Required by the Windows Form Designer
        private System.ComponentModel.IContainer components; 
        public System.Windows.Forms.ToolTip ToolTip1; 
        public System.Windows.Forms.Button cmdAction; 
        public System.Windows.Forms.TextBox editView; 
        public System.Windows.Forms.TextBox editAddress; 
        public System.Windows.Forms.Label labelStatus; 
        public System.Windows.Forms.Label labelAddress; 
        public System.Windows.Forms.MenuItem menuSaveAs; 
        public System.Windows.Forms.MenuItem menuSeperator1; 
        public System.Windows.Forms.MenuItem menuExit; 
        public System.Windows.Forms.MenuItem menuFile; 
        public System.Windows.Forms.MainMenu MainMenu1; 
        // NOTE: The following procedure is required by the Windows Form Designer
        // It can be modified using the Windows Form Designer.
        // Do not modify it using the code editor.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() 
        { 
            this.components = new System.ComponentModel.Container();
            this.ToolTip1 = new System.Windows.Forms.ToolTip(this.components);
            this.cmdAction = new System.Windows.Forms.Button();
            this.editView = new System.Windows.Forms.TextBox();
            this.editAddress = new System.Windows.Forms.TextBox();
            this.labelStatus = new System.Windows.Forms.Label();
            this.labelAddress = new System.Windows.Forms.Label();
            this.MainMenu1 = new System.Windows.Forms.MainMenu(this.components);
            this.menuFile = new System.Windows.Forms.MenuItem();
            this.menuSaveAs = new System.Windows.Forms.MenuItem();
            this.menuSeperator1 = new System.Windows.Forms.MenuItem();
            this.menuExit = new System.Windows.Forms.MenuItem();
            this.SuspendLayout();
            // 
            // cmdAction
            // 
            this.cmdAction.BackColor = System.Drawing.SystemColors.Control;
            this.cmdAction.Cursor = System.Windows.Forms.Cursors.Default;
            this.cmdAction.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.cmdAction.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.cmdAction.ForeColor = System.Drawing.SystemColors.ControlText;
            this.cmdAction.Location = new System.Drawing.Point(440, 8);
            this.cmdAction.Name = "cmdAction";
            this.cmdAction.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.cmdAction.Size = new System.Drawing.Size(57, 21);
            this.cmdAction.TabIndex = 2;
            this.cmdAction.Text = "Get";
            this.cmdAction.UseVisualStyleBackColor = false;
            this.cmdAction.Click += new System.EventHandler(this.cmdAction_Click);
            // 
            // editView
            // 
            this.editView.AcceptsReturn = true;
            this.editView.BackColor = System.Drawing.SystemColors.Window;
            this.editView.Cursor = System.Windows.Forms.Cursors.IBeam;
            this.editView.Font = new System.Drawing.Font("Courier New", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.editView.ForeColor = System.Drawing.SystemColors.WindowText;
            this.editView.Location = new System.Drawing.Point(0, 32);
            this.editView.MaxLength = 0;
            this.editView.Multiline = true;
            this.editView.Name = "editView";
            this.editView.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.editView.ScrollBars = System.Windows.Forms.ScrollBars.Both;
            this.editView.Size = new System.Drawing.Size(237, 141);
            this.editView.TabIndex = 3;
            this.editView.WordWrap = false;
            this.editView.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.editView_KeyPress);
            // 
            // editAddress
            // 
            this.editAddress.AcceptsReturn = true;
            this.editAddress.BackColor = System.Drawing.SystemColors.Window;
            this.editAddress.Cursor = System.Windows.Forms.Cursors.IBeam;
            this.editAddress.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.editAddress.ForeColor = System.Drawing.SystemColors.WindowText;
            this.editAddress.Location = new System.Drawing.Point(64, 8);
            this.editAddress.MaxLength = 0;
            this.editAddress.Name = "editAddress";
            this.editAddress.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.editAddress.Size = new System.Drawing.Size(353, 20);
            this.editAddress.TabIndex = 1;
            this.editAddress.Text = "http://test.sockettools.com/";
            this.editAddress.Enter += new System.EventHandler(this.editAddress_Enter);
            // 
            // labelStatus
            // 
            this.labelStatus.BackColor = System.Drawing.SystemColors.Control;
            this.labelStatus.Cursor = System.Windows.Forms.Cursors.Default;
            this.labelStatus.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.labelStatus.ForeColor = System.Drawing.SystemColors.ControlText;
            this.labelStatus.Location = new System.Drawing.Point(0, 292);
            this.labelStatus.Name = "labelStatus";
            this.labelStatus.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.labelStatus.Size = new System.Drawing.Size(497, 17);
            this.labelStatus.TabIndex = 4;
            // 
            // labelAddress
            // 
            this.labelAddress.BackColor = System.Drawing.SystemColors.Control;
            this.labelAddress.Cursor = System.Windows.Forms.Cursors.Default;
            this.labelAddress.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.labelAddress.ForeColor = System.Drawing.SystemColors.ControlText;
            this.labelAddress.Location = new System.Drawing.Point(8, 10);
            this.labelAddress.Name = "labelAddress";
            this.labelAddress.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.labelAddress.Size = new System.Drawing.Size(53, 17);
            this.labelAddress.TabIndex = 0;
            this.labelAddress.Text = "&Address:";
            // 
            // MainMenu1
            // 
            this.MainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuFile});
            // 
            // menuFile
            // 
            this.menuFile.Index = 0;
            this.menuFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuSaveAs,
            this.menuSeperator1,
            this.menuExit});
            this.menuFile.Text = "&File";
            // 
            // menuSaveAs
            // 
            this.menuSaveAs.Index = 0;
            this.menuSaveAs.Text = "Save &As...";
            this.menuSaveAs.Click += new System.EventHandler(this.menuSaveAs_Click);
            this.menuSaveAs.Popup += new System.EventHandler(this.menuSaveAs_Popup);
            // 
            // menuSeperator1
            // 
            this.menuSeperator1.Index = 1;
            this.menuSeperator1.Text = "-";
            // 
            // menuExit
            // 
            this.menuExit.Index = 2;
            this.menuExit.Text = "E&xit";
            this.menuExit.Click += new System.EventHandler(this.menuExit_Click);
            this.menuExit.Popup += new System.EventHandler(this.menuExit_Popup);
            // 
            // formMain
            // 
            this.AcceptButton = this.cmdAction;
            this.AutoScaleBaseSize = new System.Drawing.Size(6, 13);
            this.BackColor = System.Drawing.SystemColors.Control;
            this.ClientSize = new System.Drawing.Size(503, 312);
            this.Controls.Add(this.cmdAction);
            this.Controls.Add(this.editView);
            this.Controls.Add(this.editAddress);
            this.Controls.Add(this.labelStatus);
            this.Controls.Add(this.labelAddress);
            this.Cursor = System.Windows.Forms.Cursors.Default;
            this.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.ForeColor = System.Drawing.SystemColors.WindowText;
            this.KeyPreview = true;
            this.Location = new System.Drawing.Point(237, 189);
            this.Menu = this.MainMenu1;
            this.Name = "formMain";
            this.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.StartPosition = System.Windows.Forms.FormStartPosition.Manual;
            this.Text = "SocketTools GetPage Example";
            this.Closed += new System.EventHandler(this.formMain_Closed);
            this.Load += new System.EventHandler(this.formMain_Load);
            this.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.formMain_KeyPress);
            this.Resize += new System.EventHandler(this.formMain_Resize);
            this.ResumeLayout(false);
            this.PerformLayout();

        } 
         
		[STAThread]
		public static void Main()
		{
            Application.EnableVisualStyles();
            Application.DoEvents();
			Application.Run( new formMain() );
		}
       
        #endregion 
        
        public SocketTools.HttpClient httpClient = new SocketTools.HttpClient(); 
        public bool bCanceled = false;
        
        private void UpdateForm( bool bEnable ) 
        { 
            if ( bEnable ) 
            { 
                cmdAction.Enabled = true; 
                cmdAction.Text = "Get"; 
                editView.Enabled = true; 
                menuSaveAs.Enabled = (editView.Text.Length > 0);
                menuExit.Enabled = true; 
            } 
            else 
            { 
                editView.Enabled = false; 
                menuSaveAs.Enabled = false; 
                menuExit.Enabled = false; 
            } 
        } 
        
        
        private string GetBaseFileName( ref string strResource ) 
        { 
            string getBaseFileNameReturn = null;
            int nIndex = 0; 
            int nStartPos = 0; 
            int nEndPos = 0; 
            
            nStartPos = 1; 
            
            for ( nIndex = strResource.Length; nIndex >= 1; nIndex-- ) 
            { 
				string strToken = Strings.Mid(strResource, nIndex, 1);
				
				if (strToken == "." || strToken == "#" || strToken == "?")
				{
					if ( nEndPos == 0 )
						nEndPos = nIndex - 1;
				}
				else if (strToken == "/" || strToken == @"\")
				{
					nStartPos = nIndex + 1; 
					break;
				}
            } 
            
            if ( nEndPos == 0 ) 
            { 
                getBaseFileNameReturn = strResource.Substring( nStartPos ); 
            } 
            else 
            { 
                getBaseFileNameReturn = Strings.Mid( strResource, nStartPos, nEndPos - nStartPos + 1 ); 
            } 

            return getBaseFileNameReturn;
        } 
        
        
        private void formMain_Load( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            //  Create an instance of the object and initialize it with
            //  the runtime license key; this key is created whenever the
            //  product is installed with a serial number.
            if ( !( httpClient.Initialize() ) ) 
            { 
                Interaction.MsgBox( "Unable to initialize SocketTools component", MsgBoxStyle.Exclamation, null ); 
                System.Environment.Exit( 0 ); 
            } 
            
            UpdateForm( true ); 
        } 
        
        
        private void formMain_Closed( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            httpClient.Uninitialize(); 
        } 
        
        
        private void formMain_Resize( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            if ( WindowState != System.Windows.Forms.FormWindowState.Minimized ) 
            { 
                // 
                //  Adjust the controls based on the new width and/or
                //  height of the form
                // 
                editAddress.Width = ClientRectangle.Width - cmdAction.Width - 80; 
                cmdAction.Left = ClientRectangle.Width - 65; 
                editView.Width = ClientRectangle.Width; 
                editView.Height = ClientRectangle.Height - editView.Top - labelStatus.Height; 
                labelStatus.Width = ClientRectangle.Width; 
                labelStatus.Top = ClientRectangle.Height - labelStatus.Height; 
            } 
        } 
        
        
        private void cmdAction_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            string strBuffer = null; 
            string strContentType = null; 
            
            if ( cmdAction.Text == "Cancel" ) 
            { 
                bCanceled = true; 
                cmdAction.Enabled = false; 
                if ( httpClient.Status > SocketTools.HttpClient.HttpStatus.statusIdle ) 
                { 
                    httpClient.Cancel(); 
                } 
                return; 
            } 
            
            UpdateForm( false ); 
            
            try 
            { 
                httpClient.URL =  editAddress.Text.Trim();
            } 
            catch ( Exception ex ) 
            { 
                Interaction.MsgBox( "Please enter a valid resource URL", MsgBoxStyle.Exclamation, null ); 
                editAddress.Focus(); 
                return; 
            } 
            
            cmdAction.Text = "Cancel"; 
            labelStatus.Text = ""; 
            editView.Text = ""; 
            
            if ( !( httpClient.Connect() ) ) 
            { 
                labelStatus.Text = "Error " + httpClient.LastError + ": " + httpClient.LastErrorString; 
                Interaction.MsgBox( httpClient.LastErrorString, MsgBoxStyle.Exclamation, null ); 
                UpdateForm( true ); 
                return; 
            } 
            
            labelStatus.Text = "Requesting " + httpClient.Resource + " from server..."; 
            
            if ( !( httpClient.GetData( httpClient.Resource, ref strBuffer, SocketTools.HttpClient.HttpTransferOptions.transferConvert ) ) ) 
            { 
                labelStatus.Text = "Error " + httpClient.LastError + ": " + httpClient.LastErrorString; 
                Interaction.MsgBox( httpClient.LastErrorString, MsgBoxStyle.Exclamation, null ); 
                httpClient.Disconnect(); 
                UpdateForm( true ); 
                return; 
            } 
            
            httpClient.GetHeader( "Content-Type", ref strContentType ); 
            httpClient.Disconnect(); 
            
            labelStatus.Text = "Downloaded " + strBuffer.Length + " bytes of " + httpClient.Resource; 
            
            string transTemp1 = "text/"; 
            if (  strContentType.IndexOf( transTemp1 ) + 1 == 0 ) 
            { 
                Interaction.MsgBox( "The resource is not textual and cannot be displayed", MsgBoxStyle.Information, null ); 
            } 
            else 
            { 
                editView.Text = strBuffer; 
            } 
            
            // 
            //  Update the form controls
            // 
            UpdateForm( true ); 
        } 
        
        
        private void editAddress_Enter( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            editAddress.SelectionStart = 0; 
            editAddress.SelectionLength = editAddress.Text.Length; 
        } 
        
        
        private void editView_KeyPress( System.Object eventSender, System.Windows.Forms.KeyPressEventArgs eventArgs ) 
        { 
            short KeyAscii = System.Convert.ToInt16(  System.Convert.ToInt32( eventArgs.KeyChar ) ); 
            if ( KeyAscii != 3 )
             { 
                KeyAscii = 0; } 
            
            if ( KeyAscii == 0 ) 
            { 
                eventArgs.Handled = true; 
            } 
        } 
        
        
        private void formMain_KeyPress( System.Object eventSender, System.Windows.Forms.KeyPressEventArgs eventArgs ) 
        { 
            short KeyAscii = System.Convert.ToInt16(  System.Convert.ToInt32( eventArgs.KeyChar ) ); 
            if ( ( KeyAscii == 13 & cmdAction.Text != "Cancel" ) | ( KeyAscii == 27 & cmdAction.Text == "Cancel" ) ) 
            { 
                KeyAscii = 0; 
                cmdAction_Click( cmdAction, new System.EventArgs() ); 
            } 
            if ( KeyAscii == 0 ) 
            { 
                eventArgs.Handled = true; 
            } 
        } 
        
        
        public void menuExit_Popup( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            menuExit_Click( eventSender, eventArgs ); 
        } 
        
        public void menuExit_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            this.Close(); 
        } 
        
        
        public void menuSaveAs_Popup( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            menuSaveAs_Click( eventSender, eventArgs ); 
        } 
        
        
        public void menuSaveAs_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            SaveFileDialog saveDialog = new SaveFileDialog(); 
            short hFile = 0; 
            string strFileName = null; 
            int nPos = 0; 
            
            strFileName = httpClient.Resource;
            if ( strFileName == "" || strFileName == "/" )
			{ 
                strFileName = "index.htm";
			} 
            
            saveDialog.DefaultExt = "htm"; 
            saveDialog.FileName = strFileName; 
            saveDialog.Filter = "Web Page (*.htm;*.html)|*.htm;*.html|Text (*.txt)|*.txt|All Files (*.*)|*.*"; 
            saveDialog.FilterIndex = 1; 
            saveDialog.OverwritePrompt = true; 
            saveDialog.CheckPathExists = true; 
            
            if ( saveDialog.ShowDialog() != DialogResult.OK ) 
            { 
                return; 
            } 

            try 
            { 
                
                strFileName = saveDialog.FileName; 
                
                hFile = System.Convert.ToInt16( FileSystem.FreeFile() ); 
                FileSystem.FileOpen( hFile, strFileName, OpenMode.Binary, OpenAccess.Write, (Microsoft.VisualBasic.OpenShare)(-1), -1 ); 
                FileSystem.FilePut( hFile, editView.Text, -1, false ); 
                FileSystem.FileClose( hFile ); 
            } 
            catch  
            { 
				return;
            } 
        } 
    } 
} 
