' SocketTools 10 Build 1468
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'
Option Strict Off
Option Explicit On

Friend Class formOptions
    Inherits System.Windows.Forms.Form
#Region "Windows Form Designer generated code "
    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()
    End Sub
    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal Disposing As Boolean)
        If Disposing Then
            If Not components Is Nothing Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(Disposing)
    End Sub
    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer
    Public ToolTip1 As System.Windows.Forms.ToolTip
    Public WithEvents editOrganization As System.Windows.Forms.TextBox
    Public WithEvents editSenderAddress As System.Windows.Forms.TextBox
    Public WithEvents editSenderName As System.Windows.Forms.TextBox
    Public WithEvents lblOrganization As System.Windows.Forms.Label
    Public WithEvents lblSenderAddress As System.Windows.Forms.Label
    Public WithEvents lblName As System.Windows.Forms.Label
    Public WithEvents frameSender As System.Windows.Forms.GroupBox
    Public WithEvents cmdApply As System.Windows.Forms.Button
    Public WithEvents cmdCancel As System.Windows.Forms.Button
    Public WithEvents cmdOK As System.Windows.Forms.Button
    Public WithEvents editRelayPort As System.Windows.Forms.TextBox
    Public WithEvents editRelayServer As System.Windows.Forms.TextBox
    Public WithEvents lblRelayPort As System.Windows.Forms.Label
    Public WithEvents lblRelayServer As System.Windows.Forms.Label
    Public WithEvents frameServer As System.Windows.Forms.GroupBox
    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.
    'Do not modify it using the code editor.
    Friend WithEvents lblUserName As System.Windows.Forms.Label
    Friend WithEvents editUserName As System.Windows.Forms.TextBox
    Friend WithEvents lblPassword As System.Windows.Forms.Label
    Public WithEvents optServer1 As System.Windows.Forms.RadioButton
    Friend WithEvents editPassword As System.Windows.Forms.TextBox
    Public WithEvents optServer2 As System.Windows.Forms.RadioButton
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Me.ToolTip1 = New System.Windows.Forms.ToolTip(Me.components)
        Me.frameSender = New System.Windows.Forms.GroupBox()
        Me.editOrganization = New System.Windows.Forms.TextBox()
        Me.editSenderAddress = New System.Windows.Forms.TextBox()
        Me.editSenderName = New System.Windows.Forms.TextBox()
        Me.lblSenderAddress = New System.Windows.Forms.Label()
        Me.lblOrganization = New System.Windows.Forms.Label()
        Me.lblName = New System.Windows.Forms.Label()
        Me.cmdApply = New System.Windows.Forms.Button()
        Me.cmdCancel = New System.Windows.Forms.Button()
        Me.cmdOK = New System.Windows.Forms.Button()
        Me.frameServer = New System.Windows.Forms.GroupBox()
        Me.editPassword = New System.Windows.Forms.TextBox()
        Me.editUserName = New System.Windows.Forms.TextBox()
        Me.editRelayPort = New System.Windows.Forms.TextBox()
        Me.editRelayServer = New System.Windows.Forms.TextBox()
        Me.optServer2 = New System.Windows.Forms.RadioButton()
        Me.optServer1 = New System.Windows.Forms.RadioButton()
        Me.lblRelayPort = New System.Windows.Forms.Label()
        Me.lblUserName = New System.Windows.Forms.Label()
        Me.lblPassword = New System.Windows.Forms.Label()
        Me.lblRelayServer = New System.Windows.Forms.Label()
        Me.frameSender.SuspendLayout()
        Me.frameServer.SuspendLayout()
        Me.SuspendLayout()
        '
        'frameSender
        '
        Me.frameSender.BackColor = System.Drawing.SystemColors.Control
        Me.frameSender.Controls.Add(Me.editOrganization)
        Me.frameSender.Controls.Add(Me.editSenderAddress)
        Me.frameSender.Controls.Add(Me.editSenderName)
        Me.frameSender.Controls.Add(Me.lblSenderAddress)
        Me.frameSender.Controls.Add(Me.lblOrganization)
        Me.frameSender.Controls.Add(Me.lblName)
        Me.frameSender.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.frameSender.ForeColor = System.Drawing.SystemColors.ControlText
        Me.frameSender.Location = New System.Drawing.Point(8, 12)
        Me.frameSender.Name = "frameSender"
        Me.frameSender.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.frameSender.Size = New System.Drawing.Size(405, 105)
        Me.frameSender.TabIndex = 0
        Me.frameSender.TabStop = False
        Me.frameSender.Text = "Sender"
        '
        'editOrganization
        '
        Me.editOrganization.AcceptsReturn = True
        Me.editOrganization.BackColor = System.Drawing.SystemColors.Window
        Me.editOrganization.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.editOrganization.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.editOrganization.ForeColor = System.Drawing.SystemColors.WindowText
        Me.editOrganization.Location = New System.Drawing.Point(93, 68)
        Me.editOrganization.MaxLength = 0
        Me.editOrganization.Name = "editOrganization"
        Me.editOrganization.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.editOrganization.Size = New System.Drawing.Size(288, 21)
        Me.editOrganization.TabIndex = 5
        '
        'editSenderAddress
        '
        Me.editSenderAddress.AcceptsReturn = True
        Me.editSenderAddress.BackColor = System.Drawing.SystemColors.Window
        Me.editSenderAddress.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.editSenderAddress.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.editSenderAddress.ForeColor = System.Drawing.SystemColors.WindowText
        Me.editSenderAddress.Location = New System.Drawing.Point(93, 44)
        Me.editSenderAddress.MaxLength = 0
        Me.editSenderAddress.Name = "editSenderAddress"
        Me.editSenderAddress.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.editSenderAddress.Size = New System.Drawing.Size(288, 21)
        Me.editSenderAddress.TabIndex = 3
        '
        'editSenderName
        '
        Me.editSenderName.AcceptsReturn = True
        Me.editSenderName.BackColor = System.Drawing.SystemColors.Window
        Me.editSenderName.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.editSenderName.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.editSenderName.ForeColor = System.Drawing.SystemColors.WindowText
        Me.editSenderName.Location = New System.Drawing.Point(93, 20)
        Me.editSenderName.MaxLength = 0
        Me.editSenderName.Name = "editSenderName"
        Me.editSenderName.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.editSenderName.Size = New System.Drawing.Size(288, 21)
        Me.editSenderName.TabIndex = 1
        '
        'lblSenderAddress
        '
        Me.lblSenderAddress.BackColor = System.Drawing.SystemColors.Control
        Me.lblSenderAddress.Cursor = System.Windows.Forms.Cursors.Default
        Me.lblSenderAddress.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblSenderAddress.ForeColor = System.Drawing.SystemColors.ControlText
        Me.lblSenderAddress.Location = New System.Drawing.Point(8, 48)
        Me.lblSenderAddress.Name = "lblSenderAddress"
        Me.lblSenderAddress.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.lblSenderAddress.Size = New System.Drawing.Size(83, 17)
        Me.lblSenderAddress.TabIndex = 2
        Me.lblSenderAddress.Text = "Email Address:"
        '
        'lblOrganization
        '
        Me.lblOrganization.BackColor = System.Drawing.SystemColors.Control
        Me.lblOrganization.Cursor = System.Windows.Forms.Cursors.Default
        Me.lblOrganization.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblOrganization.ForeColor = System.Drawing.SystemColors.ControlText
        Me.lblOrganization.Location = New System.Drawing.Point(8, 72)
        Me.lblOrganization.Name = "lblOrganization"
        Me.lblOrganization.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.lblOrganization.Size = New System.Drawing.Size(74, 17)
        Me.lblOrganization.TabIndex = 4
        Me.lblOrganization.Text = "Organization:"
        '
        'lblName
        '
        Me.lblName.BackColor = System.Drawing.SystemColors.Control
        Me.lblName.Cursor = System.Windows.Forms.Cursors.Default
        Me.lblName.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblName.ForeColor = System.Drawing.SystemColors.ControlText
        Me.lblName.Location = New System.Drawing.Point(8, 24)
        Me.lblName.Name = "lblName"
        Me.lblName.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.lblName.Size = New System.Drawing.Size(65, 17)
        Me.lblName.TabIndex = 0
        Me.lblName.Text = "Full Name:"
        '
        'cmdApply
        '
        Me.cmdApply.BackColor = System.Drawing.SystemColors.Control
        Me.cmdApply.Cursor = System.Windows.Forms.Cursors.Default
        Me.cmdApply.Enabled = False
        Me.cmdApply.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.cmdApply.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.cmdApply.ForeColor = System.Drawing.SystemColors.ControlText
        Me.cmdApply.Location = New System.Drawing.Point(344, 279)
        Me.cmdApply.Name = "cmdApply"
        Me.cmdApply.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.cmdApply.Size = New System.Drawing.Size(73, 25)
        Me.cmdApply.TabIndex = 4
        Me.cmdApply.Text = "Apply"
        Me.cmdApply.UseVisualStyleBackColor = False
        '
        'cmdCancel
        '
        Me.cmdCancel.BackColor = System.Drawing.SystemColors.Control
        Me.cmdCancel.Cursor = System.Windows.Forms.Cursors.Default
        Me.cmdCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.cmdCancel.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.cmdCancel.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.cmdCancel.ForeColor = System.Drawing.SystemColors.ControlText
        Me.cmdCancel.Location = New System.Drawing.Point(264, 279)
        Me.cmdCancel.Name = "cmdCancel"
        Me.cmdCancel.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.cmdCancel.Size = New System.Drawing.Size(73, 25)
        Me.cmdCancel.TabIndex = 3
        Me.cmdCancel.Text = "Cancel"
        Me.cmdCancel.UseVisualStyleBackColor = False
        '
        'cmdOK
        '
        Me.cmdOK.BackColor = System.Drawing.SystemColors.Control
        Me.cmdOK.Cursor = System.Windows.Forms.Cursors.Default
        Me.cmdOK.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.cmdOK.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.cmdOK.ForeColor = System.Drawing.SystemColors.ControlText
        Me.cmdOK.Location = New System.Drawing.Point(184, 279)
        Me.cmdOK.Name = "cmdOK"
        Me.cmdOK.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.cmdOK.Size = New System.Drawing.Size(73, 25)
        Me.cmdOK.TabIndex = 2
        Me.cmdOK.Text = "OK"
        Me.cmdOK.UseVisualStyleBackColor = False
        '
        'frameServer
        '
        Me.frameServer.BackColor = System.Drawing.SystemColors.Control
        Me.frameServer.Controls.Add(Me.editPassword)
        Me.frameServer.Controls.Add(Me.editUserName)
        Me.frameServer.Controls.Add(Me.editRelayPort)
        Me.frameServer.Controls.Add(Me.editRelayServer)
        Me.frameServer.Controls.Add(Me.optServer2)
        Me.frameServer.Controls.Add(Me.optServer1)
        Me.frameServer.Controls.Add(Me.lblRelayPort)
        Me.frameServer.Controls.Add(Me.lblUserName)
        Me.frameServer.Controls.Add(Me.lblPassword)
        Me.frameServer.Controls.Add(Me.lblRelayServer)
        Me.frameServer.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.frameServer.ForeColor = System.Drawing.SystemColors.ControlText
        Me.frameServer.Location = New System.Drawing.Point(8, 120)
        Me.frameServer.Name = "frameServer"
        Me.frameServer.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.frameServer.Size = New System.Drawing.Size(405, 147)
        Me.frameServer.TabIndex = 1
        Me.frameServer.TabStop = False
        Me.frameServer.Text = "Server"
        '
        'editPassword
        '
        Me.editPassword.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.editPassword.Location = New System.Drawing.Point(93, 111)
        Me.editPassword.Name = "editPassword"
        Me.editPassword.PasswordChar = Global.Microsoft.VisualBasic.ChrW(42)
        Me.editPassword.Size = New System.Drawing.Size(182, 20)
        Me.editPassword.TabIndex = 9
        '
        'editUserName
        '
        Me.editUserName.Location = New System.Drawing.Point(93, 87)
        Me.editUserName.Name = "editUserName"
        Me.editUserName.Size = New System.Drawing.Size(182, 20)
        Me.editUserName.TabIndex = 7
        '
        'editRelayPort
        '
        Me.editRelayPort.AcceptsReturn = True
        Me.editRelayPort.BackColor = System.Drawing.SystemColors.Window
        Me.editRelayPort.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.editRelayPort.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.editRelayPort.ForeColor = System.Drawing.SystemColors.WindowText
        Me.editRelayPort.Location = New System.Drawing.Point(328, 61)
        Me.editRelayPort.MaxLength = 0
        Me.editRelayPort.Name = "editRelayPort"
        Me.editRelayPort.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.editRelayPort.Size = New System.Drawing.Size(53, 21)
        Me.editRelayPort.TabIndex = 5
        '
        'editRelayServer
        '
        Me.editRelayServer.AcceptsReturn = True
        Me.editRelayServer.BackColor = System.Drawing.SystemColors.Window
        Me.editRelayServer.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.editRelayServer.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.editRelayServer.ForeColor = System.Drawing.SystemColors.WindowText
        Me.editRelayServer.Location = New System.Drawing.Point(93, 61)
        Me.editRelayServer.MaxLength = 0
        Me.editRelayServer.Name = "editRelayServer"
        Me.editRelayServer.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.editRelayServer.Size = New System.Drawing.Size(182, 21)
        Me.editRelayServer.TabIndex = 3
        '
        'optServer2
        '
        Me.optServer2.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.optServer2.Location = New System.Drawing.Point(10, 34)
        Me.optServer2.Name = "optServer2"
        Me.optServer2.Size = New System.Drawing.Size(373, 24)
        Me.optServer2.TabIndex = 10
        Me.optServer2.Text = "Send all messages through the specified relay server"
        '
        'optServer1
        '
        Me.optServer1.Location = New System.Drawing.Point(10, 14)
        Me.optServer1.Name = "optServer1"
        Me.optServer1.Size = New System.Drawing.Size(373, 24)
        Me.optServer1.TabIndex = 11
        Me.optServer1.Text = "Send all messages directly to the recipient"
        '
        'lblRelayPort
        '
        Me.lblRelayPort.BackColor = System.Drawing.SystemColors.Control
        Me.lblRelayPort.Cursor = System.Windows.Forms.Cursors.Default
        Me.lblRelayPort.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblRelayPort.ForeColor = System.Drawing.SystemColors.ControlText
        Me.lblRelayPort.Location = New System.Drawing.Point(293, 65)
        Me.lblRelayPort.Name = "lblRelayPort"
        Me.lblRelayPort.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.lblRelayPort.Size = New System.Drawing.Size(30, 13)
        Me.lblRelayPort.TabIndex = 4
        Me.lblRelayPort.Text = "Port:"
        '
        'lblUserName
        '
        Me.lblUserName.Location = New System.Drawing.Point(30, 89)
        Me.lblUserName.Name = "lblUserName"
        Me.lblUserName.Size = New System.Drawing.Size(63, 16)
        Me.lblUserName.TabIndex = 6
        Me.lblUserName.Text = "User Name:"
        '
        'lblPassword
        '
        Me.lblPassword.Location = New System.Drawing.Point(30, 113)
        Me.lblPassword.Name = "lblPassword"
        Me.lblPassword.Size = New System.Drawing.Size(60, 17)
        Me.lblPassword.TabIndex = 8
        Me.lblPassword.Text = "Password:"
        '
        'lblRelayServer
        '
        Me.lblRelayServer.BackColor = System.Drawing.SystemColors.Control
        Me.lblRelayServer.Cursor = System.Windows.Forms.Cursors.Default
        Me.lblRelayServer.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblRelayServer.ForeColor = System.Drawing.SystemColors.ControlText
        Me.lblRelayServer.Location = New System.Drawing.Point(30, 65)
        Me.lblRelayServer.Name = "lblRelayServer"
        Me.lblRelayServer.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.lblRelayServer.Size = New System.Drawing.Size(56, 17)
        Me.lblRelayServer.TabIndex = 2
        Me.lblRelayServer.Text = "Server:"
        '
        'formOptions
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.BackColor = System.Drawing.SystemColors.Control
        Me.CancelButton = Me.cmdCancel
        Me.ClientSize = New System.Drawing.Size(424, 310)
        Me.ControlBox = False
        Me.Controls.Add(Me.frameSender)
        Me.Controls.Add(Me.cmdApply)
        Me.Controls.Add(Me.cmdCancel)
        Me.Controls.Add(Me.cmdOK)
        Me.Controls.Add(Me.frameServer)
        Me.Cursor = System.Windows.Forms.Cursors.Default
        Me.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        Me.Location = New System.Drawing.Point(178, 137)
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.Name = "formOptions"
        Me.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.ShowInTaskbar = False
        Me.StartPosition = System.Windows.Forms.FormStartPosition.Manual
        Me.Text = "SendMail Options"
        Me.frameSender.ResumeLayout(False)
        Me.frameServer.ResumeLayout(False)
        Me.frameServer.PerformLayout()
        Me.ResumeLayout(False)

    End Sub
#End Region

    Private Sub formOptions_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
        LoadOptions()
        UpdateForm(False)
    End Sub

    Private Sub editSenderName_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles editSenderName.TextChanged
        UpdateForm(True)
    End Sub

    Private Sub editSenderName_Enter(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles editSenderName.Enter
        editSenderName.SelectionStart = 0
        editSenderName.SelectionLength = Len(editSenderName.Text)
    End Sub

    Private Sub editSenderAddress_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles editSenderAddress.TextChanged
        UpdateForm(True)
    End Sub

    Private Sub editSenderAddress_Enter(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles editSenderAddress.Enter
        editSenderAddress.SelectionStart = 0
        editSenderAddress.SelectionLength = Len(editSenderAddress.Text)
    End Sub

    Private Sub editOrganization_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles editOrganization.TextChanged
        UpdateForm(True)
    End Sub

    Private Sub editOrganization_Enter(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles editOrganization.Enter
        editOrganization.SelectionStart = 0
        editOrganization.SelectionLength = Len(editOrganization.Text)
    End Sub

    Private Sub optServer1_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles optServer1.CheckedChanged
        If eventSender.Checked Then
            UpdateForm(True)
        End If
    End Sub

    Private Sub optServer2_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles optServer2.CheckedChanged
        If eventSender.Checked Then
            UpdateForm(True)
        End If
    End Sub

    Private Sub editRelayServer_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles editRelayServer.TextChanged
        UpdateForm(True)
    End Sub

    Private Sub editRelayServer_Enter(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles editRelayServer.Enter
        editRelayServer.SelectionStart = 0
        editRelayServer.SelectionLength = Len(editRelayServer.Text)
    End Sub

    Private Sub editRelayPort_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles editRelayPort.TextChanged
        UpdateForm(True)
    End Sub

    Private Sub editRelayPort_Enter(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles editRelayPort.Enter
        editRelayPort.SelectionStart = 0
        editRelayPort.SelectionLength = Len(editRelayPort.Text)
    End Sub

    Private Sub cmdOK_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdOK.Click
        UpdateForm(True)

        If g_bRelayMessages And Len(g_strRelayServer) = 0 Then
            MsgBox("A relay server host name or IP address must be specified", MsgBoxStyle.Exclamation)
            editRelayServer.Focus()
            Exit Sub
        End If

        SaveOptions()
        Me.Close()
    End Sub

    Private Sub cmdCancel_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdCancel.Click
        Me.Close()
    End Sub

    Private Sub cmdApply_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdApply.Click
        UpdateForm(True)

        If g_bRelayMessages And Len(g_strRelayServer) = 0 Then
            MsgBox("A relay server host name or IP address must be specified", MsgBoxStyle.Exclamation)
            editRelayServer.Focus()
            Exit Sub
        End If

        SaveOptions()
        cmdApply.Enabled = False
    End Sub

    Private Sub UpdateForm(ByVal bValidate As Boolean)
        Dim bModified As Boolean
        Static bUpdating As Boolean

        If bUpdating Then Exit Sub
        bUpdating = True

        If bValidate Then
            If editSenderName.Text <> g_strSenderName Then bModified = True
            If editSenderAddress.Text <> g_strSenderAddress Then bModified = True
            If editOrganization.Text <> g_strOrganization Then bModified = True

            g_strSenderName = Trim(editSenderName.Text)
            g_strSenderAddress = Trim(editSenderAddress.Text)
            g_strOrganization = Trim(editOrganization.Text)
            g_bAuthenticate = False

            If optServer1.Checked = True Then
                If g_bRelayMessages = True Then bModified = True
                g_bRelayMessages = False
            Else
                If g_bRelayMessages = False Then bModified = True
                g_bRelayMessages = True
            End If

            If g_bRelayMessages Then
                If editRelayServer.Text <> g_strRelayServer Then bModified = True
                If Val(editRelayPort.Text) <> g_nRelayPort Then bModified = True

                g_strRelayServer = Trim(editRelayServer.Text)
                g_nRelayPort = Val(editRelayPort.Text)
                g_strUserName = Trim(editUserName.Text)
                g_strPassword = Trim(editPassword.Text)

                If Len(g_strUserName) > 0 And Len(g_strPassword) > 0 Then
                    g_bAuthenticate = True
                End If
            End If

            cmdApply.Enabled = bModified
        Else
            editSenderName.Text = g_strSenderName
            editSenderAddress.Text = g_strSenderAddress
            editOrganization.Text = g_strOrganization

            If g_bRelayMessages Then
                optServer1.Checked = False
                optServer2.Checked = True
            Else
                optServer1.Checked = True
                optServer2.Checked = False
            End If

            editRelayServer.Text = g_strRelayServer
            editRelayPort.Text = CStr(g_nRelayPort)
            editUserName.Text = g_strUserName
            editPassword.Text = g_strPassword
        End If

        lblRelayServer.Enabled = g_bRelayMessages
        lblRelayPort.Enabled = g_bRelayMessages
        lblUserName.Enabled = g_bRelayMessages
        lblPassword.Enabled = g_bRelayMessages

        editRelayServer.Enabled = g_bRelayMessages
        editRelayPort.Enabled = g_bRelayMessages
        editUserName.Enabled = g_bRelayMessages
        editPassword.Enabled = g_bRelayMessages

        bUpdating = False
    End Sub
End Class