' SocketTools 10 Build 1468
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'
Option Strict Off
Option Explicit On

Imports SocketTools.FtpClient

Friend Class formMain
    Inherits System.Windows.Forms.Form
#Region "Windows Form Designer generated code "
    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()
    End Sub
    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal Disposing As Boolean)
        If Disposing Then
            If Not components Is Nothing Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(Disposing)
    End Sub
    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer
    Public ToolTip1 As System.Windows.Forms.ToolTip
    Public WithEvents optText As System.Windows.Forms.RadioButton
    Public WithEvents optBinary As System.Windows.Forms.RadioButton
    Public WithEvents frameMode As System.Windows.Forms.GroupBox
    Public WithEvents cmdView As System.Windows.Forms.Button
    Public WithEvents cmdClose As System.Windows.Forms.Button
    Public WithEvents listFiles As System.Windows.Forms.ListBox
    Public WithEvents cmdDownload As System.Windows.Forms.Button
    Public WithEvents cmdList As System.Windows.Forms.Button
    Public WithEvents editDirectory As System.Windows.Forms.TextBox
    Public WithEvents cmdConnect As System.Windows.Forms.Button
    Public WithEvents lblDirectory As System.Windows.Forms.Label
    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.
    'Do not modify it using the code editor.
    Friend WithEvents sbInfo As System.Windows.Forms.StatusBar
    Friend WithEvents pbTransfer As System.Windows.Forms.ProgressBar
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Me.ToolTip1 = New System.Windows.Forms.ToolTip(Me.components)
        Me.frameMode = New System.Windows.Forms.GroupBox
        Me.optText = New System.Windows.Forms.RadioButton
        Me.optBinary = New System.Windows.Forms.RadioButton
        Me.cmdView = New System.Windows.Forms.Button
        Me.cmdClose = New System.Windows.Forms.Button
        Me.listFiles = New System.Windows.Forms.ListBox
        Me.cmdDownload = New System.Windows.Forms.Button
        Me.cmdList = New System.Windows.Forms.Button
        Me.editDirectory = New System.Windows.Forms.TextBox
        Me.cmdConnect = New System.Windows.Forms.Button
        Me.lblDirectory = New System.Windows.Forms.Label
        Me.sbInfo = New System.Windows.Forms.StatusBar
        Me.pbTransfer = New System.Windows.Forms.ProgressBar
        Me.frameMode.SuspendLayout()
        Me.SuspendLayout()
        '
        'frameMode
        '
        Me.frameMode.BackColor = System.Drawing.SystemColors.Control
        Me.frameMode.Controls.Add(Me.optText)
        Me.frameMode.Controls.Add(Me.optBinary)
        Me.frameMode.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.frameMode.ForeColor = System.Drawing.SystemColors.ControlText
        Me.frameMode.Location = New System.Drawing.Point(396, 220)
        Me.frameMode.Name = "frameMode"
        Me.frameMode.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.frameMode.Size = New System.Drawing.Size(81, 61)
        Me.frameMode.TabIndex = 10
        Me.frameMode.TabStop = False
        Me.frameMode.Text = "Mode"
        '
        'optText
        '
        Me.optText.BackColor = System.Drawing.SystemColors.Control
        Me.optText.Cursor = System.Windows.Forms.Cursors.Default
        Me.optText.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.optText.ForeColor = System.Drawing.SystemColors.ControlText
        Me.optText.Location = New System.Drawing.Point(8, 40)
        Me.optText.Name = "optText"
        Me.optText.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.optText.Size = New System.Drawing.Size(57, 13)
        Me.optText.TabIndex = 12
        Me.optText.TabStop = True
        Me.optText.Text = "Text"
        '
        'optBinary
        '
        Me.optBinary.BackColor = System.Drawing.SystemColors.Control
        Me.optBinary.Checked = True
        Me.optBinary.Cursor = System.Windows.Forms.Cursors.Default
        Me.optBinary.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.optBinary.ForeColor = System.Drawing.SystemColors.ControlText
        Me.optBinary.Location = New System.Drawing.Point(8, 20)
        Me.optBinary.Name = "optBinary"
        Me.optBinary.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.optBinary.Size = New System.Drawing.Size(65, 17)
        Me.optBinary.TabIndex = 11
        Me.optBinary.TabStop = True
        Me.optBinary.Text = "Binary"
        '
        'cmdView
        '
        Me.cmdView.BackColor = System.Drawing.SystemColors.Control
        Me.cmdView.Cursor = System.Windows.Forms.Cursors.Default
        Me.cmdView.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.cmdView.ForeColor = System.Drawing.SystemColors.ControlText
        Me.cmdView.Location = New System.Drawing.Point(396, 108)
        Me.cmdView.Name = "cmdView"
        Me.cmdView.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.cmdView.Size = New System.Drawing.Size(81, 25)
        Me.cmdView.TabIndex = 9
        Me.cmdView.Text = "View"
        '
        'cmdClose
        '
        Me.cmdClose.BackColor = System.Drawing.SystemColors.Control
        Me.cmdClose.Cursor = System.Windows.Forms.Cursors.Default
        Me.cmdClose.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.cmdClose.ForeColor = System.Drawing.SystemColors.ControlText
        Me.cmdClose.Location = New System.Drawing.Point(396, 140)
        Me.cmdClose.Name = "cmdClose"
        Me.cmdClose.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.cmdClose.Size = New System.Drawing.Size(81, 25)
        Me.cmdClose.TabIndex = 8
        Me.cmdClose.Text = "Close"
        '
        'listFiles
        '
        Me.listFiles.BackColor = System.Drawing.SystemColors.Window
        Me.listFiles.Cursor = System.Windows.Forms.Cursors.Default
        Me.listFiles.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.listFiles.ForeColor = System.Drawing.SystemColors.WindowText
        Me.listFiles.ItemHeight = 14
        Me.listFiles.Location = New System.Drawing.Point(12, 44)
        Me.listFiles.Name = "listFiles"
        Me.listFiles.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.listFiles.Size = New System.Drawing.Size(365, 228)
        Me.listFiles.TabIndex = 6
        '
        'cmdDownload
        '
        Me.cmdDownload.BackColor = System.Drawing.SystemColors.Control
        Me.cmdDownload.Cursor = System.Windows.Forms.Cursors.Default
        Me.cmdDownload.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.cmdDownload.ForeColor = System.Drawing.SystemColors.ControlText
        Me.cmdDownload.Location = New System.Drawing.Point(396, 76)
        Me.cmdDownload.Name = "cmdDownload"
        Me.cmdDownload.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.cmdDownload.Size = New System.Drawing.Size(81, 25)
        Me.cmdDownload.TabIndex = 5
        Me.cmdDownload.Text = "Download"
        '
        'cmdList
        '
        Me.cmdList.BackColor = System.Drawing.SystemColors.Control
        Me.cmdList.Cursor = System.Windows.Forms.Cursors.Default
        Me.cmdList.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.cmdList.ForeColor = System.Drawing.SystemColors.ControlText
        Me.cmdList.Location = New System.Drawing.Point(396, 44)
        Me.cmdList.Name = "cmdList"
        Me.cmdList.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.cmdList.Size = New System.Drawing.Size(81, 25)
        Me.cmdList.TabIndex = 4
        Me.cmdList.Text = "List Files"
        '
        'editDirectory
        '
        Me.editDirectory.AcceptsReturn = True
        Me.editDirectory.AutoSize = False
        Me.editDirectory.BackColor = System.Drawing.SystemColors.Window
        Me.editDirectory.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.editDirectory.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.editDirectory.ForeColor = System.Drawing.SystemColors.WindowText
        Me.editDirectory.Location = New System.Drawing.Point(64, 12)
        Me.editDirectory.MaxLength = 0
        Me.editDirectory.Name = "editDirectory"
        Me.editDirectory.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.editDirectory.Size = New System.Drawing.Size(313, 21)
        Me.editDirectory.TabIndex = 2
        Me.editDirectory.Text = ""
        '
        'cmdConnect
        '
        Me.cmdConnect.BackColor = System.Drawing.SystemColors.Control
        Me.cmdConnect.Cursor = System.Windows.Forms.Cursors.Default
        Me.cmdConnect.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.cmdConnect.ForeColor = System.Drawing.SystemColors.ControlText
        Me.cmdConnect.Location = New System.Drawing.Point(396, 12)
        Me.cmdConnect.Name = "cmdConnect"
        Me.cmdConnect.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.cmdConnect.Size = New System.Drawing.Size(81, 25)
        Me.cmdConnect.TabIndex = 0
        Me.cmdConnect.Text = "Connect"
        '
        'lblDirectory
        '
        Me.lblDirectory.BackColor = System.Drawing.SystemColors.Control
        Me.lblDirectory.Cursor = System.Windows.Forms.Cursors.Default
        Me.lblDirectory.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblDirectory.ForeColor = System.Drawing.SystemColors.ControlText
        Me.lblDirectory.Location = New System.Drawing.Point(12, 16)
        Me.lblDirectory.Name = "lblDirectory"
        Me.lblDirectory.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.lblDirectory.Size = New System.Drawing.Size(49, 13)
        Me.lblDirectory.TabIndex = 1
        Me.lblDirectory.Text = "&Directory:"
        '
        'sbInfo
        '
        Me.sbInfo.Location = New System.Drawing.Point(0, 292)
        Me.sbInfo.Name = "sbInfo"
        Me.sbInfo.Size = New System.Drawing.Size(487, 22)
        Me.sbInfo.TabIndex = 11
        '
        'pbTransfer
        '
        Me.pbTransfer.Location = New System.Drawing.Point(272, 292)
        Me.pbTransfer.Name = "pbTransfer"
        Me.pbTransfer.Size = New System.Drawing.Size(200, 20)
        Me.pbTransfer.TabIndex = 12
        '
        'formMain
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.BackColor = System.Drawing.SystemColors.Control
        Me.ClientSize = New System.Drawing.Size(487, 314)
        Me.Controls.Add(Me.pbTransfer)
        Me.Controls.Add(Me.sbInfo)
        Me.Controls.Add(Me.frameMode)
        Me.Controls.Add(Me.cmdView)
        Me.Controls.Add(Me.cmdClose)
        Me.Controls.Add(Me.listFiles)
        Me.Controls.Add(Me.cmdDownload)
        Me.Controls.Add(Me.cmdList)
        Me.Controls.Add(Me.editDirectory)
        Me.Controls.Add(Me.cmdConnect)
        Me.Controls.Add(Me.lblDirectory)
        Me.Cursor = System.Windows.Forms.Cursors.Default
        Me.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        Me.Location = New System.Drawing.Point(3, 22)
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.Name = "formMain"
        Me.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "SocketTools ListFiles Example"
        Me.frameMode.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub
#End Region

    Private Const ftpParentDirectory As Integer = -1

    Private WithEvents ftpClient As New SocketTools.FtpClient
    Private ftpFileList() As SocketTools.FtpClient.FileInformation
    Private nFileCount As Integer

    Private Sub UpdateForm(ByVal bEnabled As Boolean)
        If ftpClient.IsConnected Then
            cmdConnect.Text = "Disconnect"
            cmdConnect.Enabled = True
        Else
            cmdConnect.Text = "Connect"
            cmdConnect.Enabled = True
        End If

        cmdList.Enabled = bEnabled
        cmdDownload.Enabled = bEnabled
        cmdView.Enabled = bEnabled
        editDirectory.Enabled = bEnabled
    End Sub

    Private Sub Connect()
        Dim dlgConnect As New formConnect
        Dim nOptions As Integer
        Dim bConnected As Boolean

        If ftpClient.IsConnected Then Exit Sub

        listFiles.Items.Clear()
        editDirectory.Text = ""

        ' Show the connection dialog and get the information
        ' needed to call the Connect method
        dlgConnect.ShowDialog()
        If dlgConnect.Canceled Then Exit Sub

        cmdConnect.Enabled = False

        bConnected = ftpClient.Connect(dlgConnect.HostName, _
                                       dlgConnect.RemotePort, _
                                       dlgConnect.UserName, _
                                       dlgConnect.Password, _
                                       dlgConnect.Account, _
                                       dlgConnect.Timeout, _
                                       dlgConnect.Options)

        If Not bConnected Then
            MsgBox(ftpClient.LastErrorString, MsgBoxStyle.Exclamation)
            UpdateForm(False)
            Exit Sub
        End If

        UpdateFileList()
        UpdateForm(True)
    End Sub

    Private Sub UpdateFileList()
        Dim fileInfo As SocketTools.FtpClient.FileInformation
        Dim strDirectory As String
        Dim strFileName As String
        Dim bResult As Boolean

        ' Update the form and clear the listbox while we are
        ' retrieving the file list from the server
        UpdateForm(False)
        listFiles.Items.Clear()
        sbInfo.Text = ""

        ' Clear the current list of files and reset the count
        nFileCount = 0
        ReDim ftpFileList(nFileCount)

        ' Update the current working directory that is displayed
        ftpClient.GetDirectory(strDirectory)
        editDirectory.Text = strDirectory

        ' Open the current working directory; note that it would
        ' be possible to specify wildcards here if desired
        If Not ftpClient.OpenDirectory() Then
            MsgBox(ftpClient.LastErrorString, MsgBoxStyle.Exclamation)
            UpdateForm(True)
            Exit Sub
        End If

        ' The first entry in the file list will be the parent
        ' directory; this will allow clients to navigate up
        ' the file system
        listFiles.Items.Add("[..]")

        bResult = ftpClient.GetFirstFile(fileInfo)

        Do While bResult
            If fileInfo.FileName <> "." And fileInfo.FileName <> ".." Then
                ftpFileList(nFileCount) = fileInfo

                If fileInfo.IsDirectory Then
                    strFileName = "[" + fileInfo.FileName + "]"
                Else
                    strFileName = fileInfo.FileName
                End If

                listFiles.Items.Add(strFileName)

                ' Increase the size of the ftpFileList array and then
                ' return information about the next file
                nFileCount = nFileCount + 1
                ReDim Preserve ftpFileList(nFileCount)
            End If
            bResult = ftpClient.GetNextFile(fileInfo)
        Loop

        ftpClient.CloseDirectory()
        UpdateForm(True)
    End Sub

    Private Sub ftpClient_OnProgress(ByVal sender As Object, ByVal e As SocketTools.FtpClient.ProgressEventArgs) Handles ftpClient.OnProgress
        pbTransfer.Value = e.Percent
    End Sub

    Private Sub listFiles_SelectedIndexChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles listFiles.SelectedIndexChanged
        Dim nIndex As Integer

        If nFileCount > 0 Then
            nIndex = listFiles.SelectedIndex - 1

            ' If the index value is ftpParentDirectory then this
            ' is not an actual file in our file list
            If nIndex = ftpParentDirectory Then
                sbInfo.Text = ""
                Exit Sub
            End If

            If ftpFileList(nIndex).IsDirectory Then
                sbInfo.Text = ftpFileList(nIndex).FileName & " is a directory"
            Else
                sbInfo.Text = ftpFileList(nIndex).FileName + ", " + CStr(ftpFileList(nIndex).FileSize) + " bytes"
            End If
        End If
    End Sub

    Private Sub listFiles_DoubleClick(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles listFiles.DoubleClick
        Dim nIndex As Integer
        Dim bIsDirectory As Boolean
        Dim strDirectory As String

        If listFiles.SelectedIndex = -1 Then Exit Sub

        nIndex = listFiles.SelectedIndex - 1
        If nIndex = ftpParentDirectory Then
            bIsDirectory = True
            strDirectory = ".."
        Else
            bIsDirectory = ftpFileList(nIndex).IsDirectory
            If bIsDirectory Then
                strDirectory = ftpFileList(nIndex).FileName
            End If
        End If

        If bIsDirectory Then
            UpdateForm(False)

            If Not ftpClient.ChangeDirectory(strDirectory) Then
                MsgBox(ftpClient.LastErrorString, MsgBoxStyle.Exclamation)
                UpdateForm(True)
                Exit Sub
            End If

            UpdateFileList()
        Else
            ' If a binary transfer mode has been selected, presume
            ' the user wants to store the file; otherwise display
            ' the contents of the file
            If optBinary.Checked Then
                DownloadFile()
            Else
                ViewFile()
            End If
        End If
    End Sub

    Private Sub DownloadFile()
        Dim saveDialog As New SaveFileDialog
        Dim hFile As Integer
        Dim strLocalFile As String
        Dim strRemoteFile As String
        Dim nIndex As Integer

        If listFiles.SelectedIndex = -1 Then Exit Sub

        nIndex = listFiles.SelectedIndex - 1
        If ftpFileList(nIndex).IsDirectory Then
            MsgBox("The selected file is a directory", MsgBoxStyle.Exclamation)
            Exit Sub
        End If

        strRemoteFile = ftpFileList(nIndex).FileName

        saveDialog.FileName = strRemoteFile
        saveDialog.Filter = "All Files (*.*)|*.*"
        saveDialog.OverwritePrompt = True
        saveDialog.CheckPathExists = True

        If saveDialog.ShowDialog() <> DialogResult.OK Then
            Exit Sub
        End If

        strLocalFile = saveDialog.FileName

        UpdateForm(False)
        pbTransfer.Value = 0

        If optBinary.Checked Then
            ftpClient.FileType = FtpFileType.fileBinary
        Else
            ftpClient.FileType = FtpFileType.fileText
        End If

        If ftpClient.GetFile(strLocalFile, strRemoteFile) Then
            MsgBox("Download completed successfully", MsgBoxStyle.Information)
        Else
            MsgBox(ftpClient.LastErrorString, MsgBoxStyle.Exclamation)
        End If

        pbTransfer.Value = 0
        UpdateForm(True)
    End Sub

    Private Sub ViewFile()
        Dim dlgViewFile As New formViewFile
        Dim strFileName As String
        Dim strBuffer As String
        Dim nIndex As Integer
        Dim nResult As Integer

        If listFiles.SelectedIndex = -1 Then Exit Sub
        nIndex = listFiles.SelectedIndex - 1

        If ftpFileList(nIndex).IsDirectory Then
            MsgBox("The selected file is a directory", MsgBoxStyle.Exclamation)
            Exit Sub
        End If

        strFileName = ftpFileList(nIndex).FileName

        If optBinary.Checked Then
            nResult = MsgBox("Are you sure you want to view a binary file?", MsgBoxStyle.YesNo + MsgBoxStyle.Question)
            If nResult = MsgBoxResult.No Then Exit Sub
            ftpClient.FileType = FtpFileType.fileBinary
        Else
            ftpClient.FileType = FtpFileType.fileText
        End If

        UpdateForm(False)
        pbTransfer.Value = 0

        If Not ftpClient.GetData(strFileName, strBuffer) Then
            MsgBox(ftpClient.LastErrorString, MsgBoxStyle.Exclamation)
            UpdateForm(True)
            Exit Sub
        End If

        pbTransfer.Value = 0

        ' Display the contents of the file that was downloaded
        dlgViewFile.Text = strFileName
        dlgViewFile.editText.Text = strBuffer
        dlgViewFile.ShowDialog()

        UpdateForm(True)
    End Sub

    Private Sub Disconnect()
        If ftpClient.IsConnected Then ftpClient.Disconnect()

        listFiles.Items.Clear()
        editDirectory.Text = ""
        sbInfo.Text = ""

        UpdateForm(False)
    End Sub

    Private Sub formMain_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
        UpdateForm(False)
    End Sub

    Private Sub editDirectory_Enter(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles editDirectory.Enter
        editDirectory.SelectionStart = 0
        editDirectory.SelectionLength = Len(editDirectory.Text)
    End Sub

    Private Sub cmdConnect_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdConnect.Click
        If ftpClient.IsConnected Then
            Disconnect()
        Else
            Connect()
        End If
    End Sub

    Private Sub cmdList_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdList.Click
        Dim strDirectory As String

        strDirectory = Trim(editDirectory.Text)
        If Len(strDirectory) = 0 Then
            MsgBox("Please enter a directory name", MsgBoxStyle.Information)
            editDirectory.Focus()
            Exit Sub
        End If

        UpdateForm(False)

        If Not ftpClient.ChangeDirectory(strDirectory) Then
            MsgBox(ftpClient.LastErrorString, MsgBoxStyle.Exclamation)
            UpdateForm(True)
            Exit Sub
        End If

        UpdateFileList()
    End Sub

    Private Sub cmdDownload_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdDownload.Click
        DownloadFile()
    End Sub

    Private Sub cmdView_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdView.Click
        ViewFile()
    End Sub

    Private Sub cmdClose_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdClose.Click
        Me.Close()
    End Sub
End Class