// SocketTools 10 Build 1468
// Copyright 2023 Catalyst Development Corporation
// All rights reserved
// 
// This file is licensed to you pursuant to the terms of the
// product license agreement included with the original software,
// and is protected by copyright law and international treaties.
// Unauthorized reproduction or distribution may result in severe
// criminal penalties.
// 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Data;
using System.Drawing;
using System.Diagnostics;
using System.Windows.Forms;
namespace SendMail
{
	// Use the Visual Basic GetSetting and SetSetting methods so that there's
	// compatibility with the Visual Basic examples
	[Microsoft.VisualBasic.CompilerServices.StandardModule]
    sealed public class modOptions 
    { 
        private const string KEY_PRODUCT = "SocketTools Examples"; 
        
        public static string g_strSenderName; 
        public static string g_strSenderAddress; 
        public static string g_strOrganization; 
        public static bool g_bRelayMessages; 
        public static string g_strRelayServer; 
        public static int g_nRelayPort; 
        public static string g_strUserName; 
        public static string g_strPassword; 
        public static bool g_bAuthenticate; 
        
        public static void LoadOptions() 
        { 
            g_strSenderName = Interaction.GetSetting( KEY_PRODUCT, System.Reflection.Assembly.GetExecutingAssembly().GetName().Name, "SenderName", "" ); 
            g_strSenderAddress = Interaction.GetSetting( KEY_PRODUCT, System.Reflection.Assembly.GetExecutingAssembly().GetName().Name, "SenderAddress", "" ); 
            g_strOrganization = Interaction.GetSetting( KEY_PRODUCT, System.Reflection.Assembly.GetExecutingAssembly().GetName().Name, "Organization", "" ); 
            g_bRelayMessages = bool.Parse( Interaction.GetSetting( KEY_PRODUCT, System.Reflection.Assembly.GetExecutingAssembly().GetName().Name, "RelayMessages", "True" ) ); 
            g_strRelayServer = Interaction.GetSetting( KEY_PRODUCT, System.Reflection.Assembly.GetExecutingAssembly().GetName().Name, "RelayServer", "" ); 
            g_nRelayPort = int.Parse( Interaction.GetSetting( KEY_PRODUCT, System.Reflection.Assembly.GetExecutingAssembly().GetName().Name, "RelayPort", "25" ) ); 
            g_strUserName = Interaction.GetSetting( KEY_PRODUCT, System.Reflection.Assembly.GetExecutingAssembly().GetName().Name, "UserName", "" ); 
            g_strPassword = ""; //  Clear password
            g_bAuthenticate = false; 
        } 
        
        public static void SaveOptions() 
        { 
            Interaction.SaveSetting( KEY_PRODUCT, System.Reflection.Assembly.GetExecutingAssembly().GetName().Name, "SenderName", g_strSenderName ); 
            Interaction.SaveSetting( KEY_PRODUCT, System.Reflection.Assembly.GetExecutingAssembly().GetName().Name, "SenderAddress", g_strSenderAddress ); 
            Interaction.SaveSetting( KEY_PRODUCT, System.Reflection.Assembly.GetExecutingAssembly().GetName().Name, "Organization", g_strOrganization ); 
            Interaction.SaveSetting( KEY_PRODUCT, System.Reflection.Assembly.GetExecutingAssembly().GetName().Name, "RelayMessages", System.Convert.ToString( g_bRelayMessages ) ); 
            Interaction.SaveSetting( KEY_PRODUCT, System.Reflection.Assembly.GetExecutingAssembly().GetName().Name, "RelayServer", g_strRelayServer ); 
            Interaction.SaveSetting( KEY_PRODUCT, System.Reflection.Assembly.GetExecutingAssembly().GetName().Name, "RelayPort", System.Convert.ToString( g_nRelayPort ) ); 
            Interaction.SaveSetting( KEY_PRODUCT, System.Reflection.Assembly.GetExecutingAssembly().GetName().Name, "UserName", g_strUserName ); 
        } 
    } 
} 
