// SocketTools 10 Build 1468
// Copyright 2023 Catalyst Development Corporation
// All rights reserved
// 
// This file is licensed to you pursuant to the terms of the
// product license agreement included with the original software,
// and is protected by copyright law and international treaties.
// Unauthorized reproduction or distribution may result in severe
// criminal penalties.
// 

using System;
using System.Collections;
using System.Data;
using System.Drawing;
using System.Diagnostics;
using System.Windows.Forms;
using Microsoft.VisualBasic;

namespace WebTransfer
{
    internal class Form1 : System.Windows.Forms.Form 
    { 
        #region "Windows Form Designer generated code "
        public Form1() : base() 
        { 
            // This call is required by the Windows Form Designer.
            InitializeComponent(); 
        } 

        // Form overrides dispose to clean up the component list.
        protected override void Dispose( bool Disposing ) 
        { 
            if ( Disposing ) 
            { 
                if ( !( components == null ) ) 
                { 
                    components.Dispose(); 
                } 
            } 
            base.Dispose( Disposing ); 
        } 
        
        // Required by the Windows Form Designer
        private System.ComponentModel.IContainer components; 
        public System.Windows.Forms.ToolTip ToolTip1; 
        public System.Windows.Forms.Button cmdClose; 
        public System.Windows.Forms.Button cmdUpload; 
        public System.Windows.Forms.Button cmdDownload; 
        public System.Windows.Forms.TextBox editOutput; 
        public System.Windows.Forms.TextBox editRemoteFile; 
        public System.Windows.Forms.TextBox editLocalFile; 
        public System.Windows.Forms.Label lblTransfer; 
        public System.Windows.Forms.Label Label7; 
        public System.Windows.Forms.Label Label6; 
        public System.Windows.Forms.Label Label5; 
        public System.Windows.Forms.GroupBox frameTransfer; 
        public System.Windows.Forms.CheckBox chkSecure; 
        public System.Windows.Forms.TextBox editPassword; 
        public System.Windows.Forms.TextBox editUserName; 
        public System.Windows.Forms.TextBox editRemotePort; 
        public System.Windows.Forms.TextBox editRemoteHost; 
        public System.Windows.Forms.Label Label4; 
        public System.Windows.Forms.Label Label3; 
        public System.Windows.Forms.Label Label2; 
        public System.Windows.Forms.Label Label1; 
        public System.Windows.Forms.GroupBox frameConnection; 
        // NOTE: The following procedure is required by the Windows Form Designer
        // It can be modified using the Windows Form Designer.
        // Do not modify it using the code editor.
        internal System.Windows.Forms.ProgressBar ProgressBar1; 
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() 
        { 
            this.components = new System.ComponentModel.Container(); 
            this.ToolTip1 = new System.Windows.Forms.ToolTip( this.components ); 
            this.cmdClose = new System.Windows.Forms.Button(); 
            this.cmdUpload = new System.Windows.Forms.Button(); 
            this.cmdDownload = new System.Windows.Forms.Button(); 
            this.editOutput = new System.Windows.Forms.TextBox(); 
            this.frameTransfer = new System.Windows.Forms.GroupBox(); 
            this.ProgressBar1 = new System.Windows.Forms.ProgressBar(); 
            this.editRemoteFile = new System.Windows.Forms.TextBox(); 
            this.editLocalFile = new System.Windows.Forms.TextBox(); 
            this.lblTransfer = new System.Windows.Forms.Label(); 
            this.Label7 = new System.Windows.Forms.Label(); 
            this.Label6 = new System.Windows.Forms.Label(); 
            this.Label5 = new System.Windows.Forms.Label(); 
            this.frameConnection = new System.Windows.Forms.GroupBox(); 
            this.chkSecure = new System.Windows.Forms.CheckBox(); 
            this.editPassword = new System.Windows.Forms.TextBox(); 
            this.editUserName = new System.Windows.Forms.TextBox(); 
            this.editRemotePort = new System.Windows.Forms.TextBox(); 
            this.editRemoteHost = new System.Windows.Forms.TextBox(); 
            this.Label4 = new System.Windows.Forms.Label(); 
            this.Label3 = new System.Windows.Forms.Label(); 
            this.Label2 = new System.Windows.Forms.Label(); 
            this.Label1 = new System.Windows.Forms.Label(); 
            this.frameTransfer.SuspendLayout(); 
            this.frameConnection.SuspendLayout(); 
            this.SuspendLayout(); 
            // 
            // cmdClose
            // 
            this.cmdClose.BackColor = System.Drawing.SystemColors.Control; 
            this.cmdClose.Cursor = System.Windows.Forms.Cursors.Default; 
            this.cmdClose.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.cmdClose.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.cmdClose.Location = new System.Drawing.Point( 404, 92 ); 
            this.cmdClose.Name = "cmdClose"; 
            this.cmdClose.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.cmdClose.Size = new System.Drawing.Size( 97, 29 ); 
            this.cmdClose.TabIndex = 20; 
            this.cmdClose.Text = "Close"; 
            // 
            // cmdUpload
            // 
            this.cmdUpload.BackColor = System.Drawing.SystemColors.Control; 
            this.cmdUpload.Cursor = System.Windows.Forms.Cursors.Default; 
            this.cmdUpload.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.cmdUpload.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.cmdUpload.Location = new System.Drawing.Point( 404, 56 ); 
            this.cmdUpload.Name = "cmdUpload"; 
            this.cmdUpload.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.cmdUpload.Size = new System.Drawing.Size( 97, 29 ); 
            this.cmdUpload.TabIndex = 19; 
            this.cmdUpload.Text = "Upload"; 
            // 
            // cmdDownload
            // 
            this.cmdDownload.BackColor = System.Drawing.SystemColors.Control; 
            this.cmdDownload.Cursor = System.Windows.Forms.Cursors.Default; 
            this.cmdDownload.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.cmdDownload.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.cmdDownload.Location = new System.Drawing.Point( 404, 20 ); 
            this.cmdDownload.Name = "cmdDownload"; 
            this.cmdDownload.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.cmdDownload.Size = new System.Drawing.Size( 97, 29 ); 
            this.cmdDownload.TabIndex = 18; 
            this.cmdDownload.Text = "Download"; 
            // 
            // editOutput
            // 
            this.editOutput.AcceptsReturn = true; 
            this.editOutput.AutoSize = false; 
            this.editOutput.BackColor = System.Drawing.SystemColors.Window; 
            this.editOutput.Cursor = System.Windows.Forms.Cursors.IBeam; 
            this.editOutput.Font = new System.Drawing.Font( "Courier New", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.editOutput.ForeColor = System.Drawing.SystemColors.WindowText; 
            this.editOutput.Location = new System.Drawing.Point( 12, 236 ); 
            this.editOutput.MaxLength = 0; 
            this.editOutput.Multiline = true; 
            this.editOutput.Name = "editOutput"; 
            this.editOutput.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.editOutput.ScrollBars = System.Windows.Forms.ScrollBars.Both; 
            this.editOutput.Size = new System.Drawing.Size( 377, 113 ); 
            this.editOutput.TabIndex = 17; 
            this.editOutput.Text = ""; 
            this.editOutput.WordWrap = false; 
            // 
            // frameTransfer
            // 
            this.frameTransfer.BackColor = System.Drawing.SystemColors.Control; 
            this.frameTransfer.Controls.Add( this.ProgressBar1 ); 
            this.frameTransfer.Controls.Add( this.editRemoteFile ); 
            this.frameTransfer.Controls.Add( this.editLocalFile ); 
            this.frameTransfer.Controls.Add( this.lblTransfer ); 
            this.frameTransfer.Controls.Add( this.Label7 ); 
            this.frameTransfer.Controls.Add( this.Label6 ); 
            this.frameTransfer.Controls.Add( this.Label5 ); 
            this.frameTransfer.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.frameTransfer.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.frameTransfer.Location = new System.Drawing.Point( 12, 128 ); 
            this.frameTransfer.Name = "frameTransfer"; 
            this.frameTransfer.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.frameTransfer.Size = new System.Drawing.Size( 377, 101 ); 
            this.frameTransfer.TabIndex = 10; 
            this.frameTransfer.TabStop = false; 
            this.frameTransfer.Text = "File Transfer"; 
            // 
            // ProgressBar1
            // 
            this.ProgressBar1.Location = new System.Drawing.Point( 72, 72 ); 
            this.ProgressBar1.Name = "ProgressBar1"; 
            this.ProgressBar1.Size = new System.Drawing.Size( 205, 21 ); 
            this.ProgressBar1.TabIndex = 22; 
            // 
            // editRemoteFile
            // 
            this.editRemoteFile.AcceptsReturn = true; 
            this.editRemoteFile.AutoSize = false; 
            this.editRemoteFile.BackColor = System.Drawing.SystemColors.Window; 
            this.editRemoteFile.Cursor = System.Windows.Forms.Cursors.IBeam; 
            this.editRemoteFile.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.editRemoteFile.ForeColor = System.Drawing.SystemColors.WindowText; 
            this.editRemoteFile.Location = new System.Drawing.Point( 72, 44 ); 
            this.editRemoteFile.MaxLength = 0; 
            this.editRemoteFile.Name = "editRemoteFile"; 
            this.editRemoteFile.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.editRemoteFile.Size = new System.Drawing.Size( 205, 21 ); 
            this.editRemoteFile.TabIndex = 14; 
            this.editRemoteFile.Text = ""; 
            // 
            // editLocalFile
            // 
            this.editLocalFile.AcceptsReturn = true; 
            this.editLocalFile.AutoSize = false; 
            this.editLocalFile.BackColor = System.Drawing.SystemColors.Window; 
            this.editLocalFile.Cursor = System.Windows.Forms.Cursors.IBeam; 
            this.editLocalFile.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.editLocalFile.ForeColor = System.Drawing.SystemColors.WindowText; 
            this.editLocalFile.Location = new System.Drawing.Point( 72, 16 ); 
            this.editLocalFile.MaxLength = 0; 
            this.editLocalFile.Name = "editLocalFile"; 
            this.editLocalFile.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.editLocalFile.Size = new System.Drawing.Size( 205, 21 ); 
            this.editLocalFile.TabIndex = 12; 
            this.editLocalFile.Text = ""; 
            // 
            // lblTransfer
            // 
            this.lblTransfer.BackColor = System.Drawing.SystemColors.Control; 
            this.lblTransfer.Cursor = System.Windows.Forms.Cursors.Default; 
            this.lblTransfer.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.lblTransfer.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.lblTransfer.Location = new System.Drawing.Point( 284, 76 ); 
            this.lblTransfer.Name = "lblTransfer"; 
            this.lblTransfer.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.lblTransfer.Size = new System.Drawing.Size( 85, 13 ); 
            this.lblTransfer.TabIndex = 21; 
            // 
            // Label7
            // 
            this.Label7.BackColor = System.Drawing.SystemColors.Control; 
            this.Label7.Cursor = System.Windows.Forms.Cursors.Default; 
            this.Label7.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.Label7.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.Label7.Location = new System.Drawing.Point( 8, 76 ); 
            this.Label7.Name = "Label7"; 
            this.Label7.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.Label7.Size = new System.Drawing.Size( 53, 13 ); 
            this.Label7.TabIndex = 15; 
            this.Label7.Text = "Progress:"; 
            // 
            // Label6
            // 
            this.Label6.BackColor = System.Drawing.SystemColors.Control; 
            this.Label6.Cursor = System.Windows.Forms.Cursors.Default; 
            this.Label6.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.Label6.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.Label6.Location = new System.Drawing.Point( 8, 48 ); 
            this.Label6.Name = "Label6"; 
            this.Label6.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.Label6.Size = new System.Drawing.Size( 65, 13 ); 
            this.Label6.TabIndex = 13; 
            this.Label6.Text = "&Remote File:"; 
            // 
            // Label5
            // 
            this.Label5.BackColor = System.Drawing.SystemColors.Control; 
            this.Label5.Cursor = System.Windows.Forms.Cursors.Default; 
            this.Label5.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.Label5.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.Label5.Location = new System.Drawing.Point( 8, 20 ); 
            this.Label5.Name = "Label5"; 
            this.Label5.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.Label5.Size = new System.Drawing.Size( 59, 17 ); 
            this.Label5.TabIndex = 11; 
            this.Label5.Text = "&Local File:"; 
            // 
            // frameConnection
            // 
            this.frameConnection.BackColor = System.Drawing.SystemColors.Control; 
            this.frameConnection.Controls.Add( this.chkSecure ); 
            this.frameConnection.Controls.Add( this.editPassword ); 
            this.frameConnection.Controls.Add( this.editUserName ); 
            this.frameConnection.Controls.Add( this.editRemotePort ); 
            this.frameConnection.Controls.Add( this.editRemoteHost ); 
            this.frameConnection.Controls.Add( this.Label4 ); 
            this.frameConnection.Controls.Add( this.Label3 ); 
            this.frameConnection.Controls.Add( this.Label2 ); 
            this.frameConnection.Controls.Add( this.Label1 ); 
            this.frameConnection.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.frameConnection.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.frameConnection.Location = new System.Drawing.Point( 12, 12 ); 
            this.frameConnection.Name = "frameConnection"; 
            this.frameConnection.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.frameConnection.Size = new System.Drawing.Size( 377, 109 ); 
            this.frameConnection.TabIndex = 0; 
            this.frameConnection.TabStop = false; 
            this.frameConnection.Text = "Connection"; 
            // 
            // chkSecure
            // 
            this.chkSecure.BackColor = System.Drawing.SystemColors.Control; 
            this.chkSecure.Cursor = System.Windows.Forms.Cursors.Default; 
            this.chkSecure.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.chkSecure.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.chkSecure.Location = new System.Drawing.Point( 288, 52 ); 
            this.chkSecure.Name = "chkSecure"; 
            this.chkSecure.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.chkSecure.Size = new System.Drawing.Size( 65, 13 ); 
            this.chkSecure.TabIndex = 9; 
            this.chkSecure.Text = "Secure"; 
            // 
            // editPassword
            // 
            this.editPassword.AcceptsReturn = true; 
            this.editPassword.AutoSize = false; 
            this.editPassword.BackColor = System.Drawing.SystemColors.Window; 
            this.editPassword.Cursor = System.Windows.Forms.Cursors.IBeam; 
            this.editPassword.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.editPassword.ForeColor = System.Drawing.SystemColors.WindowText; 
            this.editPassword.Location = new System.Drawing.Point( 72, 76 ); 
            this.editPassword.MaxLength = 0; 
            this.editPassword.Name = "editPassword"; 
            this.editPassword.PasswordChar = Microsoft.VisualBasic.Strings.ChrW( 42 ); 
            this.editPassword.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.editPassword.Size = new System.Drawing.Size( 205, 21 ); 
            this.editPassword.TabIndex = 8; 
            this.editPassword.Text = ""; 
            // 
            // editUserName
            // 
            this.editUserName.AcceptsReturn = true; 
            this.editUserName.AutoSize = false; 
            this.editUserName.BackColor = System.Drawing.SystemColors.Window; 
            this.editUserName.Cursor = System.Windows.Forms.Cursors.IBeam; 
            this.editUserName.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.editUserName.ForeColor = System.Drawing.SystemColors.WindowText; 
            this.editUserName.Location = new System.Drawing.Point( 72, 48 ); 
            this.editUserName.MaxLength = 0; 
            this.editUserName.Name = "editUserName"; 
            this.editUserName.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.editUserName.Size = new System.Drawing.Size( 205, 21 ); 
            this.editUserName.TabIndex = 6; 
            this.editUserName.Text = ""; 
            // 
            // editRemotePort
            // 
            this.editRemotePort.AcceptsReturn = true; 
            this.editRemotePort.AutoSize = false; 
            this.editRemotePort.BackColor = System.Drawing.SystemColors.Window; 
            this.editRemotePort.Cursor = System.Windows.Forms.Cursors.IBeam; 
            this.editRemotePort.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.editRemotePort.ForeColor = System.Drawing.SystemColors.WindowText; 
            this.editRemotePort.Location = new System.Drawing.Point( 316, 20 ); 
            this.editRemotePort.MaxLength = 0; 
            this.editRemotePort.Name = "editRemotePort"; 
            this.editRemotePort.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.editRemotePort.Size = new System.Drawing.Size( 37, 21 ); 
            this.editRemotePort.TabIndex = 4; 
            this.editRemotePort.Text = "80"; 
            // 
            // editRemoteHost
            // 
            this.editRemoteHost.AcceptsReturn = true; 
            this.editRemoteHost.AutoSize = false; 
            this.editRemoteHost.BackColor = System.Drawing.SystemColors.Window; 
            this.editRemoteHost.Cursor = System.Windows.Forms.Cursors.IBeam; 
            this.editRemoteHost.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.editRemoteHost.ForeColor = System.Drawing.SystemColors.WindowText; 
            this.editRemoteHost.Location = new System.Drawing.Point( 72, 20 ); 
            this.editRemoteHost.MaxLength = 0; 
            this.editRemoteHost.Name = "editRemoteHost"; 
            this.editRemoteHost.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.editRemoteHost.Size = new System.Drawing.Size( 205, 21 ); 
            this.editRemoteHost.TabIndex = 2; 
            this.editRemoteHost.Text = ""; 
            // 
            // Label4
            // 
            this.Label4.BackColor = System.Drawing.SystemColors.Control; 
            this.Label4.Cursor = System.Windows.Forms.Cursors.Default; 
            this.Label4.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.Label4.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.Label4.Location = new System.Drawing.Point( 8, 80 ); 
            this.Label4.Name = "Label4"; 
            this.Label4.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.Label4.Size = new System.Drawing.Size( 53, 13 ); 
            this.Label4.TabIndex = 7; 
            this.Label4.Text = "&Password:"; 
            // 
            // Label3
            // 
            this.Label3.BackColor = System.Drawing.SystemColors.Control; 
            this.Label3.Cursor = System.Windows.Forms.Cursors.Default; 
            this.Label3.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.Label3.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.Label3.Location = new System.Drawing.Point( 288, 24 ); 
            this.Label3.Name = "Label3"; 
            this.Label3.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.Label3.Size = new System.Drawing.Size( 29, 13 ); 
            this.Label3.TabIndex = 3; 
            this.Label3.Text = "&Port:"; 
            // 
            // Label2
            // 
            this.Label2.BackColor = System.Drawing.SystemColors.Control; 
            this.Label2.Cursor = System.Windows.Forms.Cursors.Default; 
            this.Label2.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.Label2.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.Label2.Location = new System.Drawing.Point( 8, 52 ); 
            this.Label2.Name = "Label2"; 
            this.Label2.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.Label2.Size = new System.Drawing.Size( 63, 13 ); 
            this.Label2.TabIndex = 5; 
            this.Label2.Text = "&User Name:"; 
            // 
            // Label1
            // 
            this.Label1.BackColor = System.Drawing.SystemColors.Control; 
            this.Label1.Cursor = System.Windows.Forms.Cursors.Default; 
            this.Label1.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.Label1.ForeColor = System.Drawing.SystemColors.ControlText; 
            this.Label1.Location = new System.Drawing.Point( 8, 24 ); 
            this.Label1.Name = "Label1"; 
            this.Label1.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.Label1.Size = new System.Drawing.Size( 64, 13 ); 
            this.Label1.TabIndex = 1; 
            this.Label1.Text = "&Host Name:"; 
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size( 5, 13 ); 
            this.BackColor = System.Drawing.SystemColors.Control; 
            this.ClientSize = new System.Drawing.Size( 518, 356 ); 
            this.Controls.Add( this.cmdClose ); 
            this.Controls.Add( this.cmdUpload ); 
            this.Controls.Add( this.cmdDownload ); 
            this.Controls.Add( this.editOutput ); 
            this.Controls.Add( this.frameTransfer ); 
            this.Controls.Add( this.frameConnection ); 
            this.Cursor = System.Windows.Forms.Cursors.Default; 
            this.Font = new System.Drawing.Font( "Arial", 8.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, System.Convert.ToByte( 0 ) ); 
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog; 
            this.Location = new System.Drawing.Point( 3, 22 ); 
            this.MaximizeBox = false; 
            this.MinimizeBox = false; 
            this.Name = "Form1"; 
            this.RightToLeft = System.Windows.Forms.RightToLeft.No; 
            this.ShowInTaskbar = false; 
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen; 
            this.Text = "SocketTools WebTransfer Example"; 
            this.frameTransfer.ResumeLayout( false ); 
            this.frameConnection.ResumeLayout( false ); 
            this.ResumeLayout( false ); 
            
            // events handled by chkSecure_CheckStateChanged
            chkSecure.CheckStateChanged += new System.EventHandler( chkSecure_CheckStateChanged ); 
            // events handled by Form1_Load
            base.Load += new System.EventHandler( Form1_Load ); 
            // events handled by Form1_Closed
            base.Closed += new System.EventHandler( Form1_Closed ); 
            // events handled by editOutput_KeyPress
            editOutput.KeyPress += new System.Windows.Forms.KeyPressEventHandler( editOutput_KeyPress ); 
            // events handled by editRemoteHost_Enter
            editRemoteHost.Enter += new System.EventHandler( editRemoteHost_Enter ); 
            // events handled by editRemotePort_Enter
            editRemotePort.Enter += new System.EventHandler( editRemotePort_Enter ); 
            // events handled by editUserName_Enter
            editUserName.Enter += new System.EventHandler( editUserName_Enter ); 
            // events handled by editPassword_Enter
            editPassword.Enter += new System.EventHandler( editPassword_Enter ); 
            // events handled by editLocalFile_Enter
            editLocalFile.Enter += new System.EventHandler( editLocalFile_Enter ); 
            // events handled by editRemoteFile_Enter
            editRemoteFile.Enter += new System.EventHandler( editRemoteFile_Enter ); 
            // events handled by cmdDownload_Click
            cmdDownload.Click += new System.EventHandler( cmdDownload_Click ); 
            // events handled by cmdUpload_Click
            cmdUpload.Click += new System.EventHandler( cmdUpload_Click ); 
            // events handled by cmdClose_Click
            cmdClose.Click += new System.EventHandler( cmdClose_Click ); 
            // events handled by httpClient_OnCommand
            httpClient.OnCommand += new SocketTools.HttpClient.OnCommandEventHandler( httpClient_OnCommand ); 
            // events handled by httpClient_OnProgress
            httpClient.OnProgress += new SocketTools.HttpClient.OnProgressEventHandler( httpClient_OnProgress ); 
        } 
        
		[STAThread]
		public static void Main()
		{
			Application.Run( new Form1() );
		}

		#endregion 
        
        public SocketTools.HttpClient httpClient = new SocketTools.HttpClient(); 
        
        private void UpdateForm( bool bEnabled ) 
        { 
            cmdDownload.Enabled = bEnabled; 
            cmdUpload.Enabled = bEnabled; 
            cmdClose.Enabled = bEnabled; 
        } 
        
        
        private void chkSecure_CheckStateChanged( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            if ( chkSecure.CheckState == System.Windows.Forms.CheckState.Checked ) 
            { 
                editRemotePort.Text = System.Convert.ToString( SocketTools.HttpClient.httpPortSecure ); 
            } 
            else 
            { 
                editRemotePort.Text = System.Convert.ToString( SocketTools.HttpClient.httpPortDefault ); 
            } 
        } 
        
        
        private void Form1_Load( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            if ( !( httpClient.Initialize() ) ) 
            { 
                Interaction.MsgBox( "Unable to initialize SocketTools component", MsgBoxStyle.Exclamation, null ); 
                System.Environment.Exit( 0 ); 
            } 
            
            UpdateForm( true ); 
        } 
        
        
        private void Form1_Closed( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            httpClient.Uninitialize(); 
        } 
        
        
        private void editOutput_KeyPress( System.Object eventSender, System.Windows.Forms.KeyPressEventArgs eventArgs ) 
        { 
            short KeyAscii = System.Convert.ToInt16(  System.Convert.ToInt32( eventArgs.KeyChar ) ); 
            if ( KeyAscii != 3 )
             { 
                KeyAscii = 0; } 
            
            if ( KeyAscii == 0 ) 
            { 
                eventArgs.Handled = true; 
            } 
        } 
        
        
        private void editRemoteHost_Enter( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            editRemoteHost.SelectionStart = 0; 
            editRemoteHost.SelectionLength = editRemoteHost.Text.Length; 
        } 
        
        
        private void editRemotePort_Enter( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            editRemotePort.SelectionStart = 0; 
            editRemotePort.SelectionLength = editRemotePort.Text.Length; 
        } 
        
        
        private void editUserName_Enter( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            editUserName.SelectionStart = 0; 
            editUserName.SelectionLength = editUserName.Text.Length; 
        } 
        
        
        private void editPassword_Enter( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            editPassword.SelectionStart = 0; 
            editPassword.SelectionLength = editPassword.Text.Length; 
        } 
        
        
        private void editLocalFile_Enter( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            editLocalFile.SelectionStart = 0; 
            editLocalFile.SelectionLength = editLocalFile.Text.Length; 
        } 
        
        
        private void editRemoteFile_Enter( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            editRemoteFile.SelectionStart = 0; 
            editRemoteFile.SelectionLength = editRemoteFile.Text.Length; 
        } 
        
        
        private void cmdDownload_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            string strRemoteHost = null; 
            int nRemotePort = 0; 
            string strLocalFile = null; 
            string strRemoteFile = null; 
            
            strRemoteHost =  editRemoteHost.Text.Trim(); 
            if ( strRemoteHost.Length == 0 ) 
            { 
                Interaction.MsgBox( "Please enter the name of the server", MsgBoxStyle.Information, null ); 
                editRemoteHost.Focus(); 
                return; 
            } 
            
            nRemotePort = int.Parse( editRemotePort.Text ); 
            if ( nRemotePort < 1 | nRemotePort > 65535 ) 
            { 
                Interaction.MsgBox( "Please enter a valid port number", MsgBoxStyle.Information, null ); 
                editRemotePort.Focus(); 
                return; 
            } 
            
            strLocalFile = editLocalFile.Text.Trim(); 
            if ( strLocalFile.Length == 0 ) 
            { 
                Interaction.MsgBox( "Please enter a file name", MsgBoxStyle.Information, null ); 
                editLocalFile.Focus(); 
                return; 
            } 
            
            strRemoteFile = editRemoteFile.Text.Trim(); 
            if ( strRemoteFile.Length == 0 ) 
            { 
                Interaction.MsgBox( "Please enter a file name", MsgBoxStyle.Information, null ); 
                editRemoteFile.Focus(); 
                return; 
            } 
            
            httpClient.HostName = strRemoteHost; 
            httpClient.RemotePort = nRemotePort; 
            httpClient.UserName = editUserName.Text.Trim(); 
            httpClient.Password = editPassword.Text.Trim(); 
            httpClient.Timeout = 15; 
            
            if ( chkSecure.CheckState == System.Windows.Forms.CheckState.Checked ) 
            { 
                httpClient.Secure = true; 
            } 
            
            editOutput.Text = ""; 
            ProgressBar1.Value = 0; 
            UpdateForm( false ); 
            
            if ( !( httpClient.Connect() ) ) 
            { 
                Interaction.MsgBox( httpClient.LastErrorString, MsgBoxStyle.Exclamation, null ); 
                UpdateForm( true ); 
                return; 
            } 
            
            editOutput.AppendText( "GET " + strRemoteFile + "\r\n" ); 
            
            if ( httpClient.GetFile( strLocalFile, strRemoteFile ) ) 
            { 
                Interaction.MsgBox( "Download completed successfully", MsgBoxStyle.Information, null ); 
            } 
            else 
            { 
                Interaction.MsgBox( httpClient.LastErrorString, MsgBoxStyle.Exclamation, null ); 
            } 
            
            httpClient.Disconnect(); 
            ProgressBar1.Value = 0; 
            UpdateForm( true ); 
        } 
        
        
        private void cmdUpload_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            string strRemoteHost = null; 
            int nRemotePort = 0; 
            string strLocalFile = null; 
            string strRemoteFile = null; 
            
            strRemoteHost =  editRemoteHost.Text.Trim(); 
            if ( strRemoteHost.Length == 0 ) 
            { 
                Interaction.MsgBox( "Please enter the name of the server", MsgBoxStyle.Information, null ); 
                editRemoteHost.Focus(); 
                return; 
            } 
            
            nRemotePort = int.Parse( editRemotePort.Text ); 
            if ( nRemotePort < 1 | nRemotePort > 65535 ) 
            { 
                Interaction.MsgBox( "Please enter a valid port number", MsgBoxStyle.Information, null ); 
                editRemotePort.Focus(); 
                return; 
            } 
            
            strLocalFile = editLocalFile.Text.Trim(); 
            if ( strLocalFile.Length == 0 ) 
            { 
                Interaction.MsgBox( "Please enter a file name", MsgBoxStyle.Information, null ); 
                editLocalFile.Focus(); 
                return; 
            } 
            
            strRemoteFile = editRemoteFile.Text.Trim(); 
            if ( strRemoteFile.Length == 0 ) 
            { 
                Interaction.MsgBox( "Please enter a file name", MsgBoxStyle.Information, null ); 
                editRemoteFile.Focus(); 
                return; 
            } 
            
            editOutput.Text = ""; 
            ProgressBar1.Value = 0; 
            UpdateForm( false ); 
            
            httpClient.HostName = strRemoteHost; 
            httpClient.RemotePort = nRemotePort; 
            httpClient.UserName =  editUserName.Text.Trim(); 
            httpClient.Password =  editPassword.Text.Trim(); 
            httpClient.Timeout = 15; 
            
            if ( chkSecure.CheckState == System.Windows.Forms.CheckState.Checked ) 
            { 
                httpClient.Secure = true; 
            } 
            
            editOutput.Text = ""; 
            ProgressBar1.Value = 0; 
            UpdateForm( false ); 
            
            if ( !( httpClient.Connect() ) ) 
            { 
                Interaction.MsgBox( httpClient.LastErrorString, MsgBoxStyle.Exclamation, null ); 
                UpdateForm( true ); 
                return; 
            } 
            
            editOutput.AppendText( "PUT " + strRemoteFile + "\r\n" ); 
            
            if ( httpClient.PutFile( strLocalFile, strRemoteFile ) ) 
            { 
                Interaction.MsgBox( "Upload completed successfully", MsgBoxStyle.Information, null ); 
            } 
            else 
            { 
                Interaction.MsgBox( httpClient.LastErrorString, MsgBoxStyle.Exclamation, null ); 
            } 
            
            httpClient.Disconnect(); 
            ProgressBar1.Value = 0; 
            UpdateForm( true ); 
        } 
        
        
        private void cmdClose_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            this.Close(); 
        } 
        
        
        private void httpClient_OnCommand( object sender, SocketTools.HttpClient.CommandEventArgs e ) 
        { 
            editOutput.AppendText( System.Convert.ToString( e.ResultCode ) + " " + e.ResultString + "\r\n" ); 
        } 
        
        
        private void httpClient_OnProgress( object sender, SocketTools.HttpClient.ProgressEventArgs e ) 
        { 
            ProgressBar1.Value = e.Percent; 
            lblTransfer.Text = e.BytesCopied + " bytes"; 
        } 
    } 
} 
