//   SocketTools 10 .NET Edition
//   Copyright 2023 Catalyst Development Corporation
//   All rights reserved
// 
//   This file is licensed to you pursuant to the terms of the
//   product license agreement included with the original software,
//   and is protected by copyright law and international treaties.
//   Unauthorized reproduction or distribution may result in severe
//   criminal penalties.
// 

using System;
using System.Collections;
using System.Data;
using System.Drawing;
using System.Diagnostics;
using System.Windows.Forms;
using Microsoft.VisualBasic;

namespace WhoIs
{
    internal class formWhoIs : System.Windows.Forms.Form 
    { 
        #region "Windows Form Designer generated code "
        public formWhoIs() : base() 
        { 
            // This call is required by the Windows Form Designer.
            InitializeComponent(); 
        } 

        // Form overrides dispose to clean up the component list.
        protected override void Dispose( bool Disposing ) 
        { 
            if ( Disposing ) 
            { 
                if ( !( components == null ) ) 
                { 
                    components.Dispose(); 
                } 
            } 
            base.Dispose( Disposing ); 
        } 
        
        // Required by the Windows Form Designer
        private System.ComponentModel.IContainer components; 
        public System.Windows.Forms.ToolTip ToolTip1; 
        public System.Windows.Forms.ComboBox comboSearch; 
        public System.Windows.Forms.TextBox editKeyword; 
        public System.Windows.Forms.TextBox editHostName; 
        public System.Windows.Forms.TextBox viewOutput; 
        public System.Windows.Forms.Button cmdAction; 
        public System.Windows.Forms.Label staticSearch; 
        public System.Windows.Forms.Label staticKeyword; 
        public System.Windows.Forms.Label staticHostName; 
        // NOTE: The following procedure is required by the Windows Form Designer
        // It can be modified using the Windows Form Designer.
        // Do not modify it using the code editor.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() 
        { 
			this.components = new System.ComponentModel.Container();
			this.ToolTip1 = new System.Windows.Forms.ToolTip(this.components);
			this.comboSearch = new System.Windows.Forms.ComboBox();
			this.editKeyword = new System.Windows.Forms.TextBox();
			this.editHostName = new System.Windows.Forms.TextBox();
			this.viewOutput = new System.Windows.Forms.TextBox();
			this.cmdAction = new System.Windows.Forms.Button();
			this.staticSearch = new System.Windows.Forms.Label();
			this.staticKeyword = new System.Windows.Forms.Label();
			this.staticHostName = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// comboSearch
			// 
			this.comboSearch.BackColor = System.Drawing.SystemColors.Window;
			this.comboSearch.Cursor = System.Windows.Forms.Cursors.Default;
			this.comboSearch.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboSearch.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.comboSearch.ForeColor = System.Drawing.SystemColors.WindowText;
			this.comboSearch.Location = new System.Drawing.Point(66, 58);
			this.comboSearch.Name = "comboSearch";
			this.comboSearch.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.comboSearch.Size = new System.Drawing.Size(145, 22);
			this.comboSearch.TabIndex = 7;
			// 
			// editKeyword
			// 
			this.editKeyword.AcceptsReturn = true;
			this.editKeyword.AutoSize = false;
			this.editKeyword.BackColor = System.Drawing.SystemColors.Window;
			this.editKeyword.Cursor = System.Windows.Forms.Cursors.IBeam;
			this.editKeyword.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.editKeyword.ForeColor = System.Drawing.SystemColors.WindowText;
			this.editKeyword.Location = new System.Drawing.Point(66, 34);
			this.editKeyword.MaxLength = 0;
			this.editKeyword.Name = "editKeyword";
			this.editKeyword.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.editKeyword.Size = new System.Drawing.Size(445, 19);
			this.editKeyword.TabIndex = 5;
			this.editKeyword.Text = "test.sockettools.com";
			this.editKeyword.TextChanged += new System.EventHandler(this.editKeyword_TextChanged);
			// 
			// editHostName
			// 
			this.editHostName.AcceptsReturn = true;
			this.editHostName.AutoSize = false;
			this.editHostName.BackColor = System.Drawing.SystemColors.Window;
			this.editHostName.Cursor = System.Windows.Forms.Cursors.IBeam;
			this.editHostName.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.editHostName.ForeColor = System.Drawing.SystemColors.WindowText;
			this.editHostName.Location = new System.Drawing.Point(66, 10);
			this.editHostName.MaxLength = 0;
			this.editHostName.Name = "editHostName";
			this.editHostName.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.editHostName.Size = new System.Drawing.Size(445, 19);
			this.editHostName.TabIndex = 2;
			this.editHostName.Text = "whois.networksolutions.com";
			this.editHostName.TextChanged += new System.EventHandler(this.editHostName_TextChanged);
			// 
			// viewOutput
			// 
			this.viewOutput.AcceptsReturn = true;
			this.viewOutput.AutoSize = false;
			this.viewOutput.BackColor = System.Drawing.SystemColors.Window;
			this.viewOutput.Cursor = System.Windows.Forms.Cursors.IBeam;
			this.viewOutput.Font = new System.Drawing.Font("Courier New", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.viewOutput.ForeColor = System.Drawing.SystemColors.WindowText;
			this.viewOutput.Location = new System.Drawing.Point(8, 86);
			this.viewOutput.MaxLength = 0;
			this.viewOutput.Multiline = true;
			this.viewOutput.Name = "viewOutput";
			this.viewOutput.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.viewOutput.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.viewOutput.Size = new System.Drawing.Size(517, 209);
			this.viewOutput.TabIndex = 1;
			this.viewOutput.Text = "";
			this.viewOutput.WordWrap = false;
			// 
			// cmdAction
			// 
			this.cmdAction.BackColor = System.Drawing.SystemColors.Control;
			this.cmdAction.Cursor = System.Windows.Forms.Cursors.Default;
			this.cmdAction.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.cmdAction.ForeColor = System.Drawing.SystemColors.ControlText;
			this.cmdAction.Location = new System.Drawing.Point(228, 304);
			this.cmdAction.Name = "cmdAction";
			this.cmdAction.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.cmdAction.Size = new System.Drawing.Size(85, 25);
			this.cmdAction.TabIndex = 0;
			this.cmdAction.Text = "Query";
			this.cmdAction.Click += new System.EventHandler(this.cmdAction_Click);
			// 
			// staticSearch
			// 
			this.staticSearch.BackColor = System.Drawing.SystemColors.Control;
			this.staticSearch.Cursor = System.Windows.Forms.Cursors.Default;
			this.staticSearch.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.staticSearch.ForeColor = System.Drawing.SystemColors.ControlText;
			this.staticSearch.Location = new System.Drawing.Point(8, 62);
			this.staticSearch.Name = "staticSearch";
			this.staticSearch.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.staticSearch.Size = new System.Drawing.Size(49, 13);
			this.staticSearch.TabIndex = 6;
			this.staticSearch.Text = "Search:";
			// 
			// staticKeyword
			// 
			this.staticKeyword.AutoSize = true;
			this.staticKeyword.BackColor = System.Drawing.SystemColors.Control;
			this.staticKeyword.Cursor = System.Windows.Forms.Cursors.Default;
			this.staticKeyword.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.staticKeyword.ForeColor = System.Drawing.SystemColors.ControlText;
			this.staticKeyword.Location = new System.Drawing.Point(8, 36);
			this.staticKeyword.Name = "staticKeyword";
			this.staticKeyword.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.staticKeyword.Size = new System.Drawing.Size(45, 16);
			this.staticKeyword.TabIndex = 4;
			this.staticKeyword.Text = "Domain:";
			// 
			// staticHostName
			// 
			this.staticHostName.AutoSize = true;
			this.staticHostName.BackColor = System.Drawing.SystemColors.Control;
			this.staticHostName.Cursor = System.Windows.Forms.Cursors.Default;
			this.staticHostName.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.staticHostName.ForeColor = System.Drawing.SystemColors.ControlText;
			this.staticHostName.Location = new System.Drawing.Point(8, 12);
			this.staticHostName.Name = "staticHostName";
			this.staticHostName.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.staticHostName.Size = new System.Drawing.Size(39, 16);
			this.staticHostName.TabIndex = 3;
			this.staticHostName.Text = "Server:";
			// 
			// formWhoIs
			// 
			this.AcceptButton = this.cmdAction;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.Control;
			this.ClientSize = new System.Drawing.Size(535, 336);
			this.Controls.Add(this.comboSearch);
			this.Controls.Add(this.editKeyword);
			this.Controls.Add(this.editHostName);
			this.Controls.Add(this.viewOutput);
			this.Controls.Add(this.cmdAction);
			this.Controls.Add(this.staticSearch);
			this.Controls.Add(this.staticKeyword);
			this.Controls.Add(this.staticHostName);
			this.Cursor = System.Windows.Forms.Cursors.Default;
			this.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.ForeColor = System.Drawing.SystemColors.WindowText;
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Location = new System.Drawing.Point(266, 207);
			this.Name = "formWhoIs";
			this.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "SocketTools WhoIs Example";
			this.Load += new System.EventHandler(this.formWhoIs_Load);
			this.Closed += new System.EventHandler(this.formWhoIs_Closed);
			this.ResumeLayout(false);

		} 
        
		[STAThread]
		public static void Main()
		{
			Application.Run( new formWhoIs() );
		}

		#endregion 
        
        public SocketTools.WhoisClient whoisClient = new SocketTools.WhoisClient(); 
        
        private void formWhoIs_Load( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            if ( !( whoisClient.Initialize() ) ) 
            { 
                Interaction.MsgBox( "Unable to initialize SocketTools component", MsgBoxStyle.Exclamation, null ); 
                System.Environment.Exit( 0 ); 
            } 
            
            comboSearch.Items.Insert( 0, "Any Record" ); 
            comboSearch.Items.Insert( 1, "Handle" ); 
            comboSearch.Items.Insert( 2, "Name" ); 
            comboSearch.Items.Insert( 3, "Mailbox" ); 
            comboSearch.SelectedIndex = 0; 
        } 
        
        
        private void formWhoIs_Closed( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            whoisClient.Uninitialize(); 
        } 
        
        
        private void cmdAction_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            string strBuffer = null; string strLine = null; 
            int nLength = 0; int nIndex = 0; 
            
            whoisClient.HostName =  editHostName.Text.Trim(); 
            whoisClient.RemotePort = System.Convert.ToInt32( double.Parse( System.Convert.ToString( SocketTools.WhoisClient.whoisPortDefault ) ) ); 
            whoisClient.Keyword =  editKeyword.Text.Trim(); 
            whoisClient.SearchType = ( ( SocketTools.WhoisClient.WhoisSearchType )( comboSearch.SelectedIndex ) ); 
            whoisClient.Timeout = 10; //  seconds
            
            viewOutput.Text = ""; 
            
            if ( !( whoisClient.Connect() ) ) 
            { 
                Interaction.MsgBox( whoisClient.LastErrorString, MsgBoxStyle.Exclamation, null ); 
                return; 
            } 
            
            if ( !( whoisClient.Search() ) ) 
            { 
                Interaction.MsgBox( whoisClient.LastErrorString, MsgBoxStyle.Exclamation, null ); 
                return; 
            } 
            
            do 
            { 
                nLength = whoisClient.Read( ref strBuffer, 1024 ); 
                if ( nLength < 1 )
					break;

                //  Because the output from a UNIX server will typically only
                //  terminate lines of text with a linefeed, we need to convert
                //  that to a carriage-return/linefeed pair so that it is
                //  displayed correctly in the text box
                
                nIndex = strBuffer.IndexOf(  System.Convert.ToChar( 10 ) ); 
                while ( nIndex > -1 ) 
                { 
                    strLine = Strings.Mid( strBuffer, 1, nIndex ); 
                    strBuffer =  strBuffer.Substring( nIndex + 1 ); 
                    nIndex = strBuffer.IndexOf(  System.Convert.ToChar( 10 ) ); 
                    viewOutput.AppendText( strLine +  System.Convert.ToChar( 10 ) ); 
                } 
                
                viewOutput.AppendText( strBuffer ); 
            } 
            while ( true ); 
            
            whoisClient.Disconnect(); 
            cmdAction.Enabled = true; 
            return; 
        }

		private void editKeyword_TextChanged(object sender, System.EventArgs e)
		{
		
		}

		private void editHostName_TextChanged(object sender, System.EventArgs e)
		{
		
		} 
    } 
} 
