' SocketTools 10 Build 1468
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'
Option Strict Off
Option Explicit On

Imports SocketTools
Imports SocketTools.InternetDialer

Friend Class formMain
    Inherits System.Windows.Forms.Form

#Region "Windows Form Designer generated code "
    Public Sub New()
        MyBase.New()
        'This call is required by the Windows Form Designer.
        InitializeComponent()
    End Sub
    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal Disposing As Boolean)
        If Disposing Then
            If Not components Is Nothing Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(Disposing)
    End Sub
    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer
    Public ToolTip1 As System.Windows.Forms.ToolTip
    Public WithEvents cmdAction As System.Windows.Forms.Button
    Public WithEvents editPhoneNumber As System.Windows.Forms.TextBox
    Public WithEvents comboPhoneEntry As System.Windows.Forms.ComboBox
    Public WithEvents editDomain As System.Windows.Forms.TextBox
    Public WithEvents editPassword As System.Windows.Forms.TextBox
    Public WithEvents editUserName As System.Windows.Forms.TextBox
    Public WithEvents labelStatus As System.Windows.Forms.Label
    Public WithEvents staticNumber As System.Windows.Forms.Label
    Public WithEvents staticSystem As System.Windows.Forms.Label
    Public WithEvents staticDomain As System.Windows.Forms.Label
    Public WithEvents staticPassword As System.Windows.Forms.Label
    Public WithEvents staticUserName As System.Windows.Forms.Label
    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Me.ToolTip1 = New System.Windows.Forms.ToolTip(Me.components)
        Me.cmdAction = New System.Windows.Forms.Button
        Me.editPhoneNumber = New System.Windows.Forms.TextBox
        Me.comboPhoneEntry = New System.Windows.Forms.ComboBox
        Me.editDomain = New System.Windows.Forms.TextBox
        Me.editPassword = New System.Windows.Forms.TextBox
        Me.editUserName = New System.Windows.Forms.TextBox
        Me.labelStatus = New System.Windows.Forms.Label
        Me.staticNumber = New System.Windows.Forms.Label
        Me.staticSystem = New System.Windows.Forms.Label
        Me.staticDomain = New System.Windows.Forms.Label
        Me.staticPassword = New System.Windows.Forms.Label
        Me.staticUserName = New System.Windows.Forms.Label
        Me.SuspendLayout()
        '
        'cmdAction
        '
        Me.cmdAction.BackColor = System.Drawing.SystemColors.Control
        Me.cmdAction.Cursor = System.Windows.Forms.Cursors.Default
        Me.cmdAction.Font = New System.Drawing.Font("Arial", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.cmdAction.ForeColor = System.Drawing.SystemColors.ControlText
        Me.cmdAction.Location = New System.Drawing.Point(116, 132)
        Me.cmdAction.Name = "cmdAction"
        Me.cmdAction.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.cmdAction.Size = New System.Drawing.Size(93, 27)
        Me.cmdAction.TabIndex = 10
        Me.cmdAction.Text = "&Connect"
        '
        'editPhoneNumber
        '
        Me.editPhoneNumber.AcceptsReturn = True
        Me.editPhoneNumber.AutoSize = False
        Me.editPhoneNumber.BackColor = System.Drawing.Color.White
        Me.editPhoneNumber.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.editPhoneNumber.Font = New System.Drawing.Font("Arial", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.editPhoneNumber.ForeColor = System.Drawing.SystemColors.WindowText
        Me.editPhoneNumber.Location = New System.Drawing.Point(74, 32)
        Me.editPhoneNumber.MaxLength = 0
        Me.editPhoneNumber.Name = "editPhoneNumber"
        Me.editPhoneNumber.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.editPhoneNumber.Size = New System.Drawing.Size(241, 21)
        Me.editPhoneNumber.TabIndex = 3
        Me.editPhoneNumber.Text = ""
        '
        'comboPhoneEntry
        '
        Me.comboPhoneEntry.BackColor = System.Drawing.Color.White
        Me.comboPhoneEntry.Cursor = System.Windows.Forms.Cursors.Default
        Me.comboPhoneEntry.Font = New System.Drawing.Font("Arial", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.comboPhoneEntry.ForeColor = System.Drawing.SystemColors.WindowText
        Me.comboPhoneEntry.Location = New System.Drawing.Point(74, 8)
        Me.comboPhoneEntry.Name = "comboPhoneEntry"
        Me.comboPhoneEntry.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.comboPhoneEntry.Size = New System.Drawing.Size(241, 22)
        Me.comboPhoneEntry.TabIndex = 1
        '
        'editDomain
        '
        Me.editDomain.AcceptsReturn = True
        Me.editDomain.AutoSize = False
        Me.editDomain.BackColor = System.Drawing.SystemColors.Window
        Me.editDomain.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.editDomain.Font = New System.Drawing.Font("Arial", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.editDomain.ForeColor = System.Drawing.SystemColors.WindowText
        Me.editDomain.Location = New System.Drawing.Point(74, 104)
        Me.editDomain.MaxLength = 0
        Me.editDomain.Name = "editDomain"
        Me.editDomain.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.editDomain.Size = New System.Drawing.Size(241, 21)
        Me.editDomain.TabIndex = 9
        Me.editDomain.Text = ""
        '
        'editPassword
        '
        Me.editPassword.AcceptsReturn = True
        Me.editPassword.AutoSize = False
        Me.editPassword.BackColor = System.Drawing.SystemColors.Window
        Me.editPassword.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.editPassword.Font = New System.Drawing.Font("Arial", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.editPassword.ForeColor = System.Drawing.SystemColors.WindowText
        Me.editPassword.Location = New System.Drawing.Point(74, 80)
        Me.editPassword.MaxLength = 0
        Me.editPassword.Name = "editPassword"
        Me.editPassword.PasswordChar = Microsoft.VisualBasic.ChrW(42)
        Me.editPassword.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.editPassword.Size = New System.Drawing.Size(241, 21)
        Me.editPassword.TabIndex = 7
        Me.editPassword.Text = ""
        '
        'editUserName
        '
        Me.editUserName.AcceptsReturn = True
        Me.editUserName.AutoSize = False
        Me.editUserName.BackColor = System.Drawing.SystemColors.Window
        Me.editUserName.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.editUserName.Font = New System.Drawing.Font("Arial", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.editUserName.ForeColor = System.Drawing.SystemColors.WindowText
        Me.editUserName.Location = New System.Drawing.Point(74, 56)
        Me.editUserName.MaxLength = 0
        Me.editUserName.Name = "editUserName"
        Me.editUserName.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.editUserName.Size = New System.Drawing.Size(241, 21)
        Me.editUserName.TabIndex = 5
        Me.editUserName.Text = ""
        '
        'labelStatus
        '
        Me.labelStatus.BackColor = System.Drawing.SystemColors.Control
        Me.labelStatus.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.labelStatus.Cursor = System.Windows.Forms.Cursors.Default
        Me.labelStatus.Font = New System.Drawing.Font("Arial", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.labelStatus.ForeColor = System.Drawing.SystemColors.ControlText
        Me.labelStatus.Location = New System.Drawing.Point(0, 164)
        Me.labelStatus.Name = "labelStatus"
        Me.labelStatus.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.labelStatus.Size = New System.Drawing.Size(325, 19)
        Me.labelStatus.TabIndex = 11
        Me.labelStatus.Text = "Disconnected"
        '
        'staticNumber
        '
        Me.staticNumber.AutoSize = True
        Me.staticNumber.BackColor = System.Drawing.Color.Transparent
        Me.staticNumber.Cursor = System.Windows.Forms.Cursors.Default
        Me.staticNumber.Font = New System.Drawing.Font("Arial", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.staticNumber.ForeColor = System.Drawing.SystemColors.ControlText
        Me.staticNumber.Location = New System.Drawing.Point(10, 36)
        Me.staticNumber.Name = "staticNumber"
        Me.staticNumber.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.staticNumber.Size = New System.Drawing.Size(48, 16)
        Me.staticNumber.TabIndex = 2
        Me.staticNumber.Text = "&Number:"
        '
        'staticSystem
        '
        Me.staticSystem.AutoSize = True
        Me.staticSystem.BackColor = System.Drawing.Color.Transparent
        Me.staticSystem.Cursor = System.Windows.Forms.Cursors.Default
        Me.staticSystem.Font = New System.Drawing.Font("Arial", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.staticSystem.ForeColor = System.Drawing.SystemColors.ControlText
        Me.staticSystem.Location = New System.Drawing.Point(10, 12)
        Me.staticSystem.Name = "staticSystem"
        Me.staticSystem.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.staticSystem.Size = New System.Drawing.Size(45, 16)
        Me.staticSystem.TabIndex = 0
        Me.staticSystem.Text = "&System:"
        '
        'staticDomain
        '
        Me.staticDomain.AutoSize = True
        Me.staticDomain.BackColor = System.Drawing.Color.Transparent
        Me.staticDomain.Cursor = System.Windows.Forms.Cursors.Default
        Me.staticDomain.Font = New System.Drawing.Font("Arial", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.staticDomain.ForeColor = System.Drawing.SystemColors.ControlText
        Me.staticDomain.Location = New System.Drawing.Point(10, 108)
        Me.staticDomain.Name = "staticDomain"
        Me.staticDomain.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.staticDomain.Size = New System.Drawing.Size(46, 16)
        Me.staticDomain.TabIndex = 8
        Me.staticDomain.Text = "&Domain:"
        '
        'staticPassword
        '
        Me.staticPassword.AutoSize = True
        Me.staticPassword.BackColor = System.Drawing.Color.Transparent
        Me.staticPassword.Cursor = System.Windows.Forms.Cursors.Default
        Me.staticPassword.Font = New System.Drawing.Font("Arial", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.staticPassword.ForeColor = System.Drawing.SystemColors.ControlText
        Me.staticPassword.Location = New System.Drawing.Point(10, 84)
        Me.staticPassword.Name = "staticPassword"
        Me.staticPassword.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.staticPassword.Size = New System.Drawing.Size(57, 16)
        Me.staticPassword.TabIndex = 6
        Me.staticPassword.Text = "&Password:"
        '
        'staticUserName
        '
        Me.staticUserName.AutoSize = True
        Me.staticUserName.BackColor = System.Drawing.Color.Transparent
        Me.staticUserName.Cursor = System.Windows.Forms.Cursors.Default
        Me.staticUserName.Font = New System.Drawing.Font("Arial", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.staticUserName.ForeColor = System.Drawing.SystemColors.ControlText
        Me.staticUserName.Location = New System.Drawing.Point(10, 60)
        Me.staticUserName.Name = "staticUserName"
        Me.staticUserName.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.staticUserName.Size = New System.Drawing.Size(60, 16)
        Me.staticUserName.TabIndex = 4
        Me.staticUserName.Text = "&Username:"
        '
        'formMain
        '
        Me.AcceptButton = Me.cmdAction
        Me.AutoScaleBaseSize = New System.Drawing.Size(6, 13)
        Me.BackColor = System.Drawing.SystemColors.Control
        Me.ClientSize = New System.Drawing.Size(325, 183)
        Me.Controls.Add(Me.cmdAction)
        Me.Controls.Add(Me.editPhoneNumber)
        Me.Controls.Add(Me.comboPhoneEntry)
        Me.Controls.Add(Me.editDomain)
        Me.Controls.Add(Me.editPassword)
        Me.Controls.Add(Me.editUserName)
        Me.Controls.Add(Me.labelStatus)
        Me.Controls.Add(Me.staticNumber)
        Me.Controls.Add(Me.staticSystem)
        Me.Controls.Add(Me.staticDomain)
        Me.Controls.Add(Me.staticPassword)
        Me.Controls.Add(Me.staticUserName)
        Me.Cursor = System.Windows.Forms.Cursors.Default
        Me.Font = New System.Drawing.Font("Arial", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.ForeColor = System.Drawing.SystemColors.WindowText
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        Me.Location = New System.Drawing.Point(293, 260)
        Me.MaximizeBox = False
        Me.Name = "formMain"
        Me.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "SocketTools Dialer Example"
        Me.ResumeLayout(False)

    End Sub
#End Region

    Dim WithEvents rasDialer As New SocketTools.InternetDialer
    Dim g_bFormModified As Boolean

    Private Sub formMain_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
        Dim strLicenseKey As String
        Dim nEntry As Integer

        ' Create an instance of the object and initialize it with
        ' the runtime license key; this key is created whenever the
        ' product is installed with a serial number.
        '
        ' To determine what your runtime key is, check the csrtkey10.bas
        ' module in the Include folder where SocketTools was installed

        strLicenseKey = "" ' An empty string is used for evaluation

        If Not rasDialer.Initialize(strLicenseKey) Then
            MsgBox("Unable to initialize SocketTools component", MsgBoxStyle.Exclamation)
            End
        End If

        ' Automatically inherit any existing dial-up networking connection
        rasDialer.AutoConnect = True

        'Initialize list of phone book entries
        'The Dialer control already has this information when initially loaded
        For nEntry = 0 To rasDialer.PhoneBookEntries - 1
            comboPhoneEntry.Items.Add(rasDialer.PhoneBookEntry(nEntry))
        Next

        'Default to the first entry in the list
        If rasDialer.PhoneBookEntries > 0 Then
            comboPhoneEntry.Text = comboPhoneEntry.Items.Item(0)
        End If

        If rasDialer.IsConnected Then
            comboPhoneEntry.Text = rasDialer.EntryName
            labelStatus.Text = "Connected"
        Else
            labelStatus.Text = "Disconnected"
        End If

        Me.Show()

        Call comboPhoneEntry_SelectedIndexChanged(comboPhoneEntry, New System.EventArgs)
        UpdateForm(False)
    End Sub

    Private Sub formMain_Closed(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Closed
        rasDialer.Uninitialize()
    End Sub

    Private Sub cmdAction_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdAction.Click
        ' When clicking Connect, we setup the properties and initiate
        ' the dialup connection

        If rasDialer.Status = DialerStatus.statusUnused Then
            If g_bFormModified Then
                rasDialer.PhoneNumber = Trim(editPhoneNumber.Text)
                rasDialer.UserName = Trim(editUserName.Text)
                rasDialer.Password = Trim(editPassword.Text)
                rasDialer.UserDomain = Trim(editDomain.Text)
            End If

            If Not rasDialer.Connect() Then
                MsgBox("Unable to connect to " & rasDialer.EntryName, MsgBoxStyle.Exclamation, System.Reflection.Assembly.GetExecutingAssembly.GetName.Name)
            End If
        Else
            cmdAction.Enabled = False
            labelStatus.Text = "Disconnecting..."
            labelStatus.Refresh()

            rasDialer.Disconnect()

            labelStatus.Text = "Disconnected"
            labelStatus.Refresh()
        End If

        UpdateForm()
    End Sub

    Private Sub comboPhoneEntry_SelectedIndexChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles comboPhoneEntry.SelectedIndexChanged
        If Len(comboPhoneEntry.Text) > 0 Then
            rasDialer.EntryName = comboPhoneEntry.Text
            editPhoneNumber.Text = rasDialer.PhoneNumber
            editUserName.Text = rasDialer.UserName
            editPassword.Text = rasDialer.Password
            editDomain.Text = rasDialer.UserDomain
        End If
        UpdateForm(False)
        If cmdAction.Enabled Then cmdAction.Focus()
    End Sub

    Private Sub editDomain_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles editDomain.TextChanged
        UpdateForm(True)
    End Sub

    Private Sub editDomain_Enter(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles editDomain.Enter
        editDomain.SelectionStart = 0
        editDomain.SelectionLength = Len(editDomain.Text)
    End Sub

    Private Sub editPassword_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles editPassword.TextChanged
        UpdateForm(True)
    End Sub

    Private Sub editPassword_Enter(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles editPassword.Enter
        editPassword.SelectionStart = 0
        editPassword.SelectionLength = Len(editPassword.Text)
    End Sub

    Private Sub editPhoneNumber_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles editPhoneNumber.TextChanged
        UpdateForm(True)
    End Sub

    Private Sub editPhoneNumber_Enter(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles editPhoneNumber.Enter
        editPhoneNumber.SelectionStart = 0
        editPhoneNumber.SelectionLength = Len(editPhoneNumber.Text)
    End Sub

    Private Sub editUserName_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles editUserName.TextChanged
        UpdateForm(True)
    End Sub

    Private Sub editUserName_Enter(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles editUserName.Enter
        editUserName.SelectionStart = 0
        editUserName.SelectionLength = Len(editUserName.Text)
    End Sub

    Private Sub rasDialer_OnConnect(ByVal sender As Object, ByVal e As System.EventArgs) Handles rasDialer.OnConnect
        labelStatus.Text = "Connected"
        UpdateForm()
    End Sub

    Private Sub rasDialer_OnDisconnect(ByVal sender As Object, ByVal e As System.EventArgs) Handles rasDialer.OnDisconnect
        rasDialer.Disconnect()
        labelStatus.Text = "Disconnected"
        UpdateForm()
    End Sub

    Private Sub rasDialer_OnError(ByVal sender As Object, ByVal e As SocketTools.InternetDialer.ErrorEventArgs) Handles rasDialer.OnError
        rasDialer.Disconnect()
        MsgBox(e.Description, MsgBoxStyle.Exclamation, System.Reflection.Assembly.GetExecutingAssembly.GetName.Name)
        labelStatus.Text = e.Description
        UpdateForm()
    End Sub

    Private Sub rasDialer_OnStatus(ByVal sender As Object, ByVal e As SocketTools.InternetDialer.StatusEventArgs) Handles rasDialer.OnStatus
        'Status event generated when dialing state changes
        'This is meant to indicate the progress during the dialing operation
        labelStatus.Text = e.Description
        UpdateForm()
    End Sub

    Private Sub rasDialer_OnTimeout(ByVal sender As Object, ByVal e As System.EventArgs) Handles rasDialer.OnTimeout
        System.Diagnostics.Debug.WriteLine("OnTimeout")
        rasDialer.Disconnect()
        labelStatus.Text = "Unable to connect to " & rasDialer.EntryName
        UpdateForm()
    End Sub

    Private Sub UpdateForm(Optional ByVal bModified As Object = Nothing)

        If Not IsNothing(bModified) Then
            g_bFormModified = CBool(bModified)
        End If

        If rasDialer.Status = DialerStatus.statusUnused Then
            comboPhoneEntry.Enabled = True
            editPhoneNumber.Enabled = True
            editUserName.Enabled = True
            editPassword.Enabled = True
            editDomain.Enabled = True

            If rasDialer.PhoneBookEntries > 0 And Len(editUserName.Text) > 0 And Len(editPassword.Text) > 0 Then
                cmdAction.Enabled = True
                cmdAction.Text = "&Connect"
            Else
                cmdAction.Enabled = False
                cmdAction.Text = "&Connect"
            End If
        Else
            comboPhoneEntry.Enabled = False
            editPhoneNumber.Enabled = False
            editUserName.Enabled = False
            editPassword.Enabled = False
            editDomain.Enabled = False

            If rasDialer.IsConnected Then
                cmdAction.Enabled = True
                cmdAction.Text = "&Disconnect"
            Else
                cmdAction.Enabled = True
                cmdAction.Text = "Cancel"
            End If
        End If

    End Sub
End Class