//   SocketTools 10 .NET Edition
//   Copyright 2023 Catalyst Development Corporation
//   All rights reserved
// 
//   This file is licensed to you pursuant to the terms of the
//   product license agreement included with the original software,
//   and is protected by copyright law and international treaties.
//   Unauthorized reproduction or distribution may result in severe
//   criminal penalties.
// 

using System;
using System.Collections;
using System.Data;
using System.Drawing;
using System.Diagnostics;
using System.Windows.Forms;
using Microsoft.VisualBasic;

namespace ListMail
{
    internal class formMain : System.Windows.Forms.Form 
    { 
        public SocketTools.ImapClient imapClient = new SocketTools.ImapClient(); 
        
        #region "Windows Form Designer generated code "
        public formMain() : base() 
        { 
            // This call is required by the Windows Form Designer.
            InitializeComponent(); 
        } 

        // Form overrides dispose to clean up the component list.
        protected override void Dispose( bool Disposing ) 
        { 
            if ( Disposing ) 
            { 
                if ( !( components == null ) ) 
                { 
                    components.Dispose(); 
                } 
            } 
            base.Dispose( Disposing ); 
        } 
        
        // Required by the Windows Form Designer
        private System.ComponentModel.IContainer components; 
        public System.Windows.Forms.ToolTip ToolTip1; 
        public System.Windows.Forms.Button cmdRefresh; 
        public System.Windows.Forms.ComboBox comboMailbox; 
        public System.Windows.Forms.TextBox editTimeout; 
        public System.Windows.Forms.Button cmdView; 
        public System.Windows.Forms.TextBox editPassword; 
        public System.Windows.Forms.TextBox editUserName; 
        public System.Windows.Forms.TextBox editHostName; 
        public System.Windows.Forms.Button cmdConnect; 
        public System.Windows.Forms.TextBox editHostPort; 
        public System.Windows.Forms.TextBox textMessage; 
        public System.Windows.Forms.Label lblMailbox; 
        public System.Windows.Forms.Label lblTimeout; 
        public System.Windows.Forms.Label lblStatus; 
        public System.Windows.Forms.Label lblPassword; 
        public System.Windows.Forms.Label lblUserName; 
        public System.Windows.Forms.Label lblPort; 
        public System.Windows.Forms.Label lblServer; 
        // NOTE: The following procedure is required by the Windows Form Designer
        // It can be modified using the Windows Form Designer.
        // Do not modify it using the code editor.
        internal System.Windows.Forms.ListView listMessages; 
        internal System.Windows.Forms.ColumnHeader ColumnHeader1; 
        internal System.Windows.Forms.ColumnHeader ColumnHeader2; 
        internal System.Windows.Forms.ColumnHeader ColumnHeader3; 
        internal System.Windows.Forms.ColumnHeader ColumnHeader4; 
        internal System.Windows.Forms.ProgressBar ProgressBar1; 
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() 
        { 
			this.components = new System.ComponentModel.Container();
			this.ToolTip1 = new System.Windows.Forms.ToolTip(this.components);
			this.cmdRefresh = new System.Windows.Forms.Button();
			this.comboMailbox = new System.Windows.Forms.ComboBox();
			this.editTimeout = new System.Windows.Forms.TextBox();
			this.cmdView = new System.Windows.Forms.Button();
			this.editPassword = new System.Windows.Forms.TextBox();
			this.editUserName = new System.Windows.Forms.TextBox();
			this.editHostName = new System.Windows.Forms.TextBox();
			this.cmdConnect = new System.Windows.Forms.Button();
			this.editHostPort = new System.Windows.Forms.TextBox();
			this.textMessage = new System.Windows.Forms.TextBox();
			this.lblMailbox = new System.Windows.Forms.Label();
			this.lblTimeout = new System.Windows.Forms.Label();
			this.lblStatus = new System.Windows.Forms.Label();
			this.lblPassword = new System.Windows.Forms.Label();
			this.lblUserName = new System.Windows.Forms.Label();
			this.lblPort = new System.Windows.Forms.Label();
			this.lblServer = new System.Windows.Forms.Label();
			this.listMessages = new System.Windows.Forms.ListView();
			this.ColumnHeader1 = new System.Windows.Forms.ColumnHeader();
			this.ColumnHeader2 = new System.Windows.Forms.ColumnHeader();
			this.ColumnHeader3 = new System.Windows.Forms.ColumnHeader();
			this.ColumnHeader4 = new System.Windows.Forms.ColumnHeader();
			this.ProgressBar1 = new System.Windows.Forms.ProgressBar();
			this.SuspendLayout();
			// 
			// cmdRefresh
			// 
			this.cmdRefresh.BackColor = System.Drawing.SystemColors.Control;
			this.cmdRefresh.Cursor = System.Windows.Forms.Cursors.Default;
			this.cmdRefresh.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.cmdRefresh.ForeColor = System.Drawing.SystemColors.ControlText;
			this.cmdRefresh.Location = new System.Drawing.Point(520, 36);
			this.cmdRefresh.Name = "cmdRefresh";
			this.cmdRefresh.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.cmdRefresh.Size = new System.Drawing.Size(81, 25);
			this.cmdRefresh.TabIndex = 13;
			this.cmdRefresh.Text = "Refresh";
			this.cmdRefresh.Click += new System.EventHandler(this.cmdRefresh_Click);
			// 
			// comboMailbox
			// 
			this.comboMailbox.BackColor = System.Drawing.SystemColors.Window;
			this.comboMailbox.Cursor = System.Windows.Forms.Cursors.Default;
			this.comboMailbox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboMailbox.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.comboMailbox.ForeColor = System.Drawing.SystemColors.WindowText;
			this.comboMailbox.Location = new System.Drawing.Point(76, 68);
			this.comboMailbox.Name = "comboMailbox";
			this.comboMailbox.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.comboMailbox.Size = new System.Drawing.Size(165, 22);
			this.comboMailbox.Sorted = true;
			this.comboMailbox.TabIndex = 11;
			this.comboMailbox.SelectedIndexChanged += new System.EventHandler(this.comboMailbox_SelectedIndexChanged);
			// 
			// editTimeout
			// 
			this.editTimeout.AcceptsReturn = true;
			this.editTimeout.AutoSize = false;
			this.editTimeout.BackColor = System.Drawing.SystemColors.Window;
			this.editTimeout.Cursor = System.Windows.Forms.Cursors.IBeam;
			this.editTimeout.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.editTimeout.ForeColor = System.Drawing.SystemColors.WindowText;
			this.editTimeout.Location = new System.Drawing.Point(408, 12);
			this.editTimeout.MaxLength = 0;
			this.editTimeout.Name = "editTimeout";
			this.editTimeout.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.editTimeout.Size = new System.Drawing.Size(37, 21);
			this.editTimeout.TabIndex = 5;
			this.editTimeout.Text = "30";
			// 
			// cmdView
			// 
			this.cmdView.BackColor = System.Drawing.SystemColors.Control;
			this.cmdView.Cursor = System.Windows.Forms.Cursors.Default;
			this.cmdView.Enabled = false;
			this.cmdView.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.cmdView.ForeColor = System.Drawing.SystemColors.ControlText;
			this.cmdView.Location = new System.Drawing.Point(520, 68);
			this.cmdView.Name = "cmdView";
			this.cmdView.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.cmdView.Size = new System.Drawing.Size(81, 25);
			this.cmdView.TabIndex = 14;
			this.cmdView.Text = "View";
			this.cmdView.Click += new System.EventHandler(this.cmdView_Click);
			// 
			// editPassword
			// 
			this.editPassword.AcceptsReturn = true;
			this.editPassword.AutoSize = false;
			this.editPassword.BackColor = System.Drawing.SystemColors.Window;
			this.editPassword.Cursor = System.Windows.Forms.Cursors.IBeam;
			this.editPassword.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.editPassword.ForeColor = System.Drawing.SystemColors.WindowText;
			this.editPassword.Location = new System.Drawing.Point(312, 40);
			this.editPassword.MaxLength = 0;
			this.editPassword.Name = "editPassword";
			this.editPassword.PasswordChar = '*';
			this.editPassword.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.editPassword.Size = new System.Drawing.Size(165, 21);
			this.editPassword.TabIndex = 9;
			this.editPassword.Text = "";
			// 
			// editUserName
			// 
			this.editUserName.AcceptsReturn = true;
			this.editUserName.AutoSize = false;
			this.editUserName.BackColor = System.Drawing.SystemColors.Window;
			this.editUserName.Cursor = System.Windows.Forms.Cursors.IBeam;
			this.editUserName.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.editUserName.ForeColor = System.Drawing.SystemColors.WindowText;
			this.editUserName.Location = new System.Drawing.Point(76, 40);
			this.editUserName.MaxLength = 0;
			this.editUserName.Name = "editUserName";
			this.editUserName.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.editUserName.Size = new System.Drawing.Size(165, 21);
			this.editUserName.TabIndex = 7;
			this.editUserName.Text = "";
			// 
			// editHostName
			// 
			this.editHostName.AcceptsReturn = true;
			this.editHostName.AutoSize = false;
			this.editHostName.BackColor = System.Drawing.SystemColors.Window;
			this.editHostName.Cursor = System.Windows.Forms.Cursors.IBeam;
			this.editHostName.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.editHostName.ForeColor = System.Drawing.SystemColors.WindowText;
			this.editHostName.Location = new System.Drawing.Point(76, 12);
			this.editHostName.MaxLength = 0;
			this.editHostName.Name = "editHostName";
			this.editHostName.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.editHostName.Size = new System.Drawing.Size(165, 21);
			this.editHostName.TabIndex = 1;
			this.editHostName.Text = "";
			// 
			// cmdConnect
			// 
			this.cmdConnect.BackColor = System.Drawing.SystemColors.Control;
			this.cmdConnect.Cursor = System.Windows.Forms.Cursors.Default;
			this.cmdConnect.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.cmdConnect.ForeColor = System.Drawing.SystemColors.ControlText;
			this.cmdConnect.Location = new System.Drawing.Point(520, 4);
			this.cmdConnect.Name = "cmdConnect";
			this.cmdConnect.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.cmdConnect.Size = new System.Drawing.Size(81, 25);
			this.cmdConnect.TabIndex = 12;
			this.cmdConnect.Text = "Connect";
			this.cmdConnect.Click += new System.EventHandler(this.cmdConnect_Click);
			// 
			// editHostPort
			// 
			this.editHostPort.AcceptsReturn = true;
			this.editHostPort.AutoSize = false;
			this.editHostPort.BackColor = System.Drawing.SystemColors.Window;
			this.editHostPort.Cursor = System.Windows.Forms.Cursors.IBeam;
			this.editHostPort.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.editHostPort.ForeColor = System.Drawing.SystemColors.WindowText;
			this.editHostPort.Location = new System.Drawing.Point(312, 12);
			this.editHostPort.MaxLength = 0;
			this.editHostPort.Name = "editHostPort";
			this.editHostPort.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.editHostPort.Size = new System.Drawing.Size(37, 21);
			this.editHostPort.TabIndex = 3;
			this.editHostPort.Text = "143";
			// 
			// textMessage
			// 
			this.textMessage.AcceptsReturn = true;
			this.textMessage.AutoSize = false;
			this.textMessage.BackColor = System.Drawing.SystemColors.Window;
			this.textMessage.Cursor = System.Windows.Forms.Cursors.IBeam;
			this.textMessage.Font = new System.Drawing.Font("Courier New", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.textMessage.ForeColor = System.Drawing.SystemColors.WindowText;
			this.textMessage.Location = new System.Drawing.Point(4, 100);
			this.textMessage.MaxLength = 0;
			this.textMessage.Multiline = true;
			this.textMessage.Name = "textMessage";
			this.textMessage.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.textMessage.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.textMessage.Size = new System.Drawing.Size(601, 345);
			this.textMessage.TabIndex = 16;
			this.textMessage.Text = "";
			this.textMessage.Visible = false;
			this.textMessage.WordWrap = false;
			// 
			// lblMailbox
			// 
			this.lblMailbox.BackColor = System.Drawing.SystemColors.Control;
			this.lblMailbox.Cursor = System.Windows.Forms.Cursors.Default;
			this.lblMailbox.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblMailbox.ForeColor = System.Drawing.SystemColors.ControlText;
			this.lblMailbox.Location = new System.Drawing.Point(12, 72);
			this.lblMailbox.Name = "lblMailbox";
			this.lblMailbox.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.lblMailbox.Size = new System.Drawing.Size(61, 13);
			this.lblMailbox.TabIndex = 10;
			this.lblMailbox.Text = "Mailbox:";
			// 
			// lblTimeout
			// 
			this.lblTimeout.BackColor = System.Drawing.SystemColors.Control;
			this.lblTimeout.Cursor = System.Windows.Forms.Cursors.Default;
			this.lblTimeout.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblTimeout.ForeColor = System.Drawing.SystemColors.ControlText;
			this.lblTimeout.Location = new System.Drawing.Point(360, 16);
			this.lblTimeout.Name = "lblTimeout";
			this.lblTimeout.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.lblTimeout.Size = new System.Drawing.Size(47, 13);
			this.lblTimeout.TabIndex = 4;
			this.lblTimeout.Text = "Timeout:";
			// 
			// lblStatus
			// 
			this.lblStatus.BackColor = System.Drawing.SystemColors.Control;
			this.lblStatus.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.lblStatus.Cursor = System.Windows.Forms.Cursors.Default;
			this.lblStatus.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblStatus.ForeColor = System.Drawing.SystemColors.ControlText;
			this.lblStatus.Location = new System.Drawing.Point(4, 452);
			this.lblStatus.Name = "lblStatus";
			this.lblStatus.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.lblStatus.Size = new System.Drawing.Size(373, 21);
			this.lblStatus.TabIndex = 17;
			// 
			// lblPassword
			// 
			this.lblPassword.BackColor = System.Drawing.SystemColors.Control;
			this.lblPassword.Cursor = System.Windows.Forms.Cursors.Default;
			this.lblPassword.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblPassword.ForeColor = System.Drawing.SystemColors.ControlText;
			this.lblPassword.Location = new System.Drawing.Point(252, 44);
			this.lblPassword.Name = "lblPassword";
			this.lblPassword.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.lblPassword.Size = new System.Drawing.Size(58, 13);
			this.lblPassword.TabIndex = 8;
			this.lblPassword.Text = "Password:";
			// 
			// lblUserName
			// 
			this.lblUserName.BackColor = System.Drawing.SystemColors.Control;
			this.lblUserName.Cursor = System.Windows.Forms.Cursors.Default;
			this.lblUserName.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblUserName.ForeColor = System.Drawing.SystemColors.ControlText;
			this.lblUserName.Location = new System.Drawing.Point(12, 44);
			this.lblUserName.Name = "lblUserName";
			this.lblUserName.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.lblUserName.Size = new System.Drawing.Size(64, 13);
			this.lblUserName.TabIndex = 6;
			this.lblUserName.Text = "User Name:";
			// 
			// lblPort
			// 
			this.lblPort.BackColor = System.Drawing.SystemColors.Control;
			this.lblPort.Cursor = System.Windows.Forms.Cursors.Default;
			this.lblPort.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblPort.ForeColor = System.Drawing.SystemColors.ControlText;
			this.lblPort.Location = new System.Drawing.Point(252, 16);
			this.lblPort.Name = "lblPort";
			this.lblPort.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.lblPort.Size = new System.Drawing.Size(64, 13);
			this.lblPort.TabIndex = 2;
			this.lblPort.Text = "Server Port:";
			// 
			// lblServer
			// 
			this.lblServer.BackColor = System.Drawing.SystemColors.Control;
			this.lblServer.Cursor = System.Windows.Forms.Cursors.Default;
			this.lblServer.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblServer.ForeColor = System.Drawing.SystemColors.ControlText;
			this.lblServer.Location = new System.Drawing.Point(12, 16);
			this.lblServer.Name = "lblServer";
			this.lblServer.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.lblServer.Size = new System.Drawing.Size(63, 13);
			this.lblServer.TabIndex = 0;
			this.lblServer.Text = "Mail Server:";
			// 
			// listMessages
			// 
			this.listMessages.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						   this.ColumnHeader1,
																						   this.ColumnHeader2,
																						   this.ColumnHeader3,
																						   this.ColumnHeader4});
			this.listMessages.FullRowSelect = true;
			this.listMessages.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
			this.listMessages.Location = new System.Drawing.Point(4, 100);
			this.listMessages.MultiSelect = false;
			this.listMessages.Name = "listMessages";
			this.listMessages.Size = new System.Drawing.Size(601, 345);
			this.listMessages.TabIndex = 18;
			this.listMessages.View = System.Windows.Forms.View.Details;
			this.listMessages.DoubleClick += new System.EventHandler(this.listMessages_DoubleClick);
			// 
			// ColumnHeader1
			// 
			this.ColumnHeader1.Text = "";
			this.ColumnHeader1.Width = 30;
			// 
			// ColumnHeader2
			// 
			this.ColumnHeader2.Text = "From";
			this.ColumnHeader2.Width = 150;
			// 
			// ColumnHeader3
			// 
			this.ColumnHeader3.Text = "Subject";
			this.ColumnHeader3.Width = 250;
			// 
			// ColumnHeader4
			// 
			this.ColumnHeader4.Text = "Date";
			this.ColumnHeader4.Width = 150;
			// 
			// ProgressBar1
			// 
			this.ProgressBar1.Location = new System.Drawing.Point(378, 452);
			this.ProgressBar1.Name = "ProgressBar1";
			this.ProgressBar1.Size = new System.Drawing.Size(228, 21);
			this.ProgressBar1.TabIndex = 19;
			// 
			// formMain
			// 
			this.AcceptButton = this.cmdConnect;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.Control;
			this.ClientSize = new System.Drawing.Size(611, 475);
			this.Controls.Add(this.ProgressBar1);
			this.Controls.Add(this.listMessages);
			this.Controls.Add(this.cmdRefresh);
			this.Controls.Add(this.comboMailbox);
			this.Controls.Add(this.editTimeout);
			this.Controls.Add(this.cmdView);
			this.Controls.Add(this.editPassword);
			this.Controls.Add(this.editUserName);
			this.Controls.Add(this.editHostName);
			this.Controls.Add(this.cmdConnect);
			this.Controls.Add(this.editHostPort);
			this.Controls.Add(this.textMessage);
			this.Controls.Add(this.lblMailbox);
			this.Controls.Add(this.lblTimeout);
			this.Controls.Add(this.lblStatus);
			this.Controls.Add(this.lblPassword);
			this.Controls.Add(this.lblUserName);
			this.Controls.Add(this.lblPort);
			this.Controls.Add(this.lblServer);
			this.Cursor = System.Windows.Forms.Cursors.Default;
			this.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Location = new System.Drawing.Point(275, 205);
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "formMain";
			this.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.StartPosition = System.Windows.Forms.FormStartPosition.Manual;
			this.Text = "SocketTools ListMail Example";
			this.Load += new System.EventHandler(this.formMain_Load);
			this.ResumeLayout(false);

		} 
        
		[STAThread]
		public static void Main()
		{
			Application.Run( new formMain() );
		}
		
		#endregion 
        
        private void formMain_Load( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            if ( !( imapClient.Initialize() ) ) 
            { 
                Interaction.MsgBox( "Unable to initialize SocketTools component", MsgBoxStyle.Exclamation, null ); 
                System.Environment.Exit( 0 ); 
            } 
            
            cmdConnect.Enabled = true; 
            cmdRefresh.Enabled = false; 
            cmdView.Enabled = false; 
            
            comboMailbox.Enabled = false; 
            textMessage.Visible = false; 
            listMessages.Visible = true; 
            
            ProgressBar1.Minimum = 0; 
            ProgressBar1.Maximum = 100; 
            ProgressBar1.Value = 0; 
        } 
        
        
        private void cmdConnect_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            string strHostName = null; 
            string strHostPort = null; 
            string strTimeout = null; 
            string strUserName = null; 
            string strPassword = null; 
            int nHostPort = 0; 
            int nTimeout = 0; 
            int nIndex = 0; 
            int nInbox = 0; 
            
            if ( imapClient.IsConnected ) 
            { 
                //  Disconnect from mail server
                imapClient.Disconnect(); 
                
                //  Update user interface
                comboMailbox.Items.Clear(); 
                comboMailbox.Enabled = false; 
                listMessages.Items.Clear(); 
                listMessages.Visible = true; 
                textMessage.Text = ""; 
                textMessage.Visible = false; 
                
                cmdRefresh.Enabled = false; 
                cmdView.Enabled = false; 
                cmdView.Text = "View"; 
                cmdConnect.Text = "Connect"; 
                return; 
            } 
            
            strHostName = editHostName.Text.Trim();
            if (  strHostName.Length == 0 ) 
            { 
                Interaction.MsgBox( "Please specify the server host name or address", MsgBoxStyle.Information, null ); 
                editHostName.Text = ""; 
                editHostName.Focus(); 
                return; 
            } 
            
            strHostPort =  editHostPort.Text.Trim(); 
            if (  strHostPort.Length > 0 ) 
            { 
                nHostPort = System.Convert.ToInt32( Conversion.Val( strHostPort ) ); 
                if ( nHostPort < 0 | nHostPort > 65535 ) 
                { 
                    Interaction.MsgBox( "Please specify a valid port number", MsgBoxStyle.Exclamation, null ); 
                    editHostPort.Text = ""; 
                    editHostPort.Focus(); 
                    return; 
                } 
                else if ( nHostPort == 0 ) 
                { 
                    nHostPort = SocketTools.ImapClient.imapPortDefault; 
                    editHostPort.Text = System.Convert.ToString( nHostPort ); 
                } 
            } 
            else 
            { 
                Interaction.MsgBox( "Please specify a server port number", MsgBoxStyle.Information, null ); 
                editHostPort.Text = ""; 
                editHostPort.Focus(); 
                return; 
            } 
            
            strTimeout =  editTimeout.Text.Trim(); 
            if ( strTimeout.Length > 0 ) 
            { 
                nTimeout = System.Convert.ToInt32( Conversion.Val( strTimeout ) ); 
                editTimeout.Text = System.Convert.ToString( nTimeout ); 
            } 
            else 
            { 
                Interaction.MsgBox( "Please specify a timeout value in seconds", MsgBoxStyle.Information, null ); 
                editTimeout.Text = ""; 
                editTimeout.Focus(); 
                return; 
            } 
            
            strUserName =  editUserName.Text.Trim(); 
            if ( strUserName.Length == 0 ) 
            { 
                Interaction.MsgBox( "Please specify a user name", MsgBoxStyle.Information, null ); 
                editUserName.Text = ""; 
                editUserName.Focus(); 
                return; 
            } 
            
            strPassword =  editPassword.Text.Trim(); 
            if (  strPassword.Length == 0 ) 
            { 
                Interaction.MsgBox( "Please specify a password", MsgBoxStyle.Information, null ); 
                editPassword.Text = ""; 
                editPassword.Focus(); 
                return; 
            } 
            
            cmdConnect.Enabled = false; 
            
            if ( !( imapClient.Connect( strHostName, nHostPort, strUserName, strPassword, nTimeout ) ) ) 
            { 
                lblStatus.Text = imapClient.LastErrorString; 
                Interaction.MsgBox( imapClient.LastErrorString, MsgBoxStyle.Exclamation, null ); 
                cmdConnect.Enabled = true; 
                return; 
            } 
            
            comboMailbox.Items.Clear(); 
            
            if ( imapClient.Mailboxes == 0 ) 
            { 
                Interaction.MsgBox( "There are no mailboxes available", MsgBoxStyle.Exclamation, null ); 
                imapClient.Disconnect(); 
                cmdConnect.Enabled = true; 
                return; 
            } 
            
            for ( nIndex=0; nIndex <= imapClient.Mailboxes - 1; nIndex++ ) 
            { 
                comboMailbox.Items.Add( imapClient.Mailbox[ nIndex ] ); 
            } 
            
            nInbox = -1; 
            for ( nIndex=0; nIndex <= comboMailbox.Items.Count - 1; nIndex++ ) 
            { 
                if ( string.Compare( System.Convert.ToString( comboMailbox.Items[ nIndex ] ), "Inbox", true ) == 0 ) 
                { 
                    nInbox = nIndex; 
                    break;
                } 
                
            } 
            
            comboMailbox.Enabled = true; 
            comboMailbox.SelectedIndex = nInbox; 
            cmdConnect.Text = "Disconnect"; 
        } 
        
        
        private void cmdRefresh_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            int nMessageCount = 0; 
            int nMessage = 0; 
            string strFrom = null; 
            string strSubject = null; 
            string strDate = null; 
            System.Windows.Forms.ListViewItem lvItem = null; 
            
            cmdConnect.Enabled = false; 
            cmdRefresh.Enabled = false; 
            cmdView.Enabled = false; 
            comboMailbox.Enabled = false; 
            
            nMessageCount = imapClient.MessageCount; 
            
            listMessages.Items.Clear(); 
            if ( nMessageCount > 0 )
             { 
                ProgressBar1.Maximum = nMessageCount; } 
            
            ProgressBar1.Value = 0; 
            
            for ( nMessage=1; nMessage <= nMessageCount; nMessage++ ) 
            { 
                lblStatus.Text = "Checking message " + nMessage + " of " + nMessageCount; 
                lblStatus.Refresh(); 
                
                strFrom = ""; 
                strSubject = ""; 
                strDate = ""; 
                
                imapClient.GetHeader( nMessage, 0, "From", ref strFrom ); 
                imapClient.GetHeader( nMessage, 0, "Subject", ref strSubject ); 
                imapClient.GetHeader( nMessage, 0, "Date", ref strDate ); 
                
                lvItem = listMessages.Items.Add( System.Convert.ToString( nMessage ) ); 
                lvItem.SubItems.Add( strFrom ); 
                lvItem.SubItems.Add( strSubject ); 
                lvItem.SubItems.Add( strDate ); 
                
                ProgressBar1.Value = nMessage; 
                System.Windows.Forms.Application.DoEvents(); 
            } 
            
            lblStatus.Text = "You have " + nMessageCount + " messages in this mailbox"; 
            lblStatus.Refresh(); 
            
            ProgressBar1.Value = 0; 
            ProgressBar1.Maximum = 100; 
            
            cmdConnect.Enabled = true; 
            cmdRefresh.Enabled = true; 
            cmdView.Enabled = true; 
            comboMailbox.Enabled = true; 
        } 
        
        
        private void cmdView_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            int nMessage = 0; 
            string strMessage = null; 
            System.Windows.Forms.ListViewItem lvItem = null; 
            
            if ( cmdView.Text == "View" ) 
            { 
                lvItem = listMessages.SelectedItems[ 0 ]; 
                nMessage = int.Parse( lvItem.Text ); 
                
                lblStatus.Text = "Retrieving message " + nMessage + " from server"; 
                lblStatus.Refresh(); 
                
                cmdConnect.Enabled = false; 
                cmdRefresh.Enabled = false; 
                cmdView.Enabled = false; 
                ProgressBar1.Maximum = 100; 
                ProgressBar1.Value = 0; 
                
                if ( !( imapClient.GetMessage( nMessage, 0, ref strMessage ) ) ) 
                { 
                    lblStatus.Text = imapClient.LastErrorString; 
                    Interaction.MsgBox( imapClient.LastErrorString, MsgBoxStyle.Exclamation, null ); 
                    cmdConnect.Enabled = true; 
                    cmdView.Enabled = true; 
                    cmdRefresh.Enabled = true; 
                    ProgressBar1.Value = 0; 
                    return; 
                } 
                
                cmdConnect.Enabled = true; 
                cmdView.Enabled = true; 
                cmdView.Text = "Close"; 
                ProgressBar1.Value = 0; 
                listMessages.Visible = false; 
                textMessage.Text = strMessage; 
                textMessage.Visible = true; 
                textMessage.SelectionLength = 0; 
                textMessage.Focus(); 
                lblStatus.Text = "Viewing message " + nMessage + " (" +  strMessage.Length.ToString() + " bytes)"; 
            } 
            else 
            { 
                cmdView.Text = "View"; 
                cmdRefresh.Enabled = true; 
                textMessage.Text = ""; 
                textMessage.Visible = false; 
                listMessages.Visible = true; 
                listMessages.Focus(); 
                lblStatus.Text = ""; 
            } 
        } 
        
        
        private void comboMailbox_SelectedIndexChanged( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            string strMailbox = null; 
            
            if ( cmdView.Text != "View" ) 
            { 
                cmdView_Click( cmdView, new System.EventArgs() ); 
            } 
            
            strMailbox = comboMailbox.Text; 
            
            if ( !( imapClient.SelectMailbox( strMailbox ) ) ) 
            { 
                lblStatus.Text = imapClient.LastErrorString; 
                Interaction.MsgBox( imapClient.LastErrorString, MsgBoxStyle.Exclamation, null ); 
                comboMailbox.SelectedIndex = -1; 
                return; 
            } 
            
            cmdRefresh_Click( cmdRefresh, new System.EventArgs() ); 
        } 
        
        
        private void listMessages_DoubleClick( object sender, System.EventArgs e ) 
        { 
            if ( listMessages.Items.Count > 0 & cmdView.Enabled ) 
            { 
                cmdView_Click( cmdView, new System.EventArgs() ); 
            } 
        } 
        
        
        private void imapClient_OnProgress( object sender, SocketTools.ImapClient.ProgressEventArgs e ) 
        { 
            ProgressBar1.Value = e.Percent; 
        } 
    } 
} 
