// SocketTools 10 Build 1468
// Copyright 2023 Catalyst Development Corporation
// All rights reserved
// 
// This file is licensed to you pursuant to the terms of the
// product license agreement included with the original software,
// and is protected by copyright law and international treaties.
// Unauthorized reproduction or distribution may result in severe
// criminal penalties.

using System;
using System.Collections;
using System.Data;
using System.Drawing;
using System.Diagnostics;
using System.Windows.Forms;
using Microsoft.VisualBasic;

namespace Resolve
{
    internal class Form1 : System.Windows.Forms.Form 
    { 
        #region "Windows Form Designer generated code "
        public Form1() : base() 
        { 
            // This call is required by the Windows Form Designer.
            InitializeComponent(); 
        } 

        // Form overrides dispose to clean up the component list.
        protected override void Dispose( bool Disposing ) 
        { 
            if ( Disposing ) 
            { 
                if ( !( components == null ) ) 
                { 
                    components.Dispose(); 
                } 
            } 
            base.Dispose( Disposing ); 
        } 
        
        // Required by the Windows Form Designer
        private System.ComponentModel.IContainer components; 
        public System.Windows.Forms.ToolTip ToolTip1; 
        public System.Windows.Forms.Button cmdClose; 
        public System.Windows.Forms.Button cmdQuery; 
        public System.Windows.Forms.ListBox listMailServers; 
        public System.Windows.Forms.TextBox editHostName; 
        public System.Windows.Forms.TextBox editHostAddress; 
        public System.Windows.Forms.Label Label5; 
        public System.Windows.Forms.Label Label3; 
        public System.Windows.Forms.Label Label4; 
        public System.Windows.Forms.GroupBox Frame2; 
        public System.Windows.Forms.TextBox editNameServer2; 
        public System.Windows.Forms.TextBox editNameServer1; 
        public System.Windows.Forms.Label Label2; 
        public System.Windows.Forms.Label Label1; 
        public System.Windows.Forms.GroupBox Frame1; 
        // NOTE: The following procedure is required by the Windows Form Designer
        // It can be modified using the Windows Form Designer.
        // Do not modify it using the code editor.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() 
        { 
			this.components = new System.ComponentModel.Container();
			this.ToolTip1 = new System.Windows.Forms.ToolTip(this.components);
			this.cmdClose = new System.Windows.Forms.Button();
			this.cmdQuery = new System.Windows.Forms.Button();
			this.Frame2 = new System.Windows.Forms.GroupBox();
			this.listMailServers = new System.Windows.Forms.ListBox();
			this.editHostName = new System.Windows.Forms.TextBox();
			this.editHostAddress = new System.Windows.Forms.TextBox();
			this.Label5 = new System.Windows.Forms.Label();
			this.Label3 = new System.Windows.Forms.Label();
			this.Label4 = new System.Windows.Forms.Label();
			this.Frame1 = new System.Windows.Forms.GroupBox();
			this.editNameServer2 = new System.Windows.Forms.TextBox();
			this.editNameServer1 = new System.Windows.Forms.TextBox();
			this.Label1 = new System.Windows.Forms.Label();
			this.Label2 = new System.Windows.Forms.Label();
			this.Frame2.SuspendLayout();
			this.Frame1.SuspendLayout();
			this.SuspendLayout();
			// 
			// cmdClose
			// 
			this.cmdClose.BackColor = System.Drawing.SystemColors.Control;
			this.cmdClose.Cursor = System.Windows.Forms.Cursors.Default;
			this.cmdClose.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.cmdClose.ForeColor = System.Drawing.SystemColors.ControlText;
			this.cmdClose.Location = new System.Drawing.Point(189, 256);
			this.cmdClose.Name = "cmdClose";
			this.cmdClose.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.cmdClose.Size = new System.Drawing.Size(77, 25);
			this.cmdClose.TabIndex = 8;
			this.cmdClose.Text = "Close";
			this.cmdClose.Click += new System.EventHandler(this.cmdClose_Click);
			// 
			// cmdQuery
			// 
			this.cmdQuery.BackColor = System.Drawing.SystemColors.Control;
			this.cmdQuery.Cursor = System.Windows.Forms.Cursors.Default;
			this.cmdQuery.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.cmdQuery.ForeColor = System.Drawing.SystemColors.ControlText;
			this.cmdQuery.Location = new System.Drawing.Point(92, 256);
			this.cmdQuery.Name = "cmdQuery";
			this.cmdQuery.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.cmdQuery.Size = new System.Drawing.Size(77, 25);
			this.cmdQuery.TabIndex = 7;
			this.cmdQuery.Text = "Query";
			this.cmdQuery.Click += new System.EventHandler(this.cmdQuery_Click);
			// 
			// Frame2
			// 
			this.Frame2.BackColor = System.Drawing.SystemColors.Control;
			this.Frame2.Controls.Add(this.listMailServers);
			this.Frame2.Controls.Add(this.editHostName);
			this.Frame2.Controls.Add(this.editHostAddress);
			this.Frame2.Controls.Add(this.Label5);
			this.Frame2.Controls.Add(this.Label3);
			this.Frame2.Controls.Add(this.Label4);
			this.Frame2.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Frame2.ForeColor = System.Drawing.SystemColors.ControlText;
			this.Frame2.Location = new System.Drawing.Point(8, 100);
			this.Frame2.Name = "Frame2";
			this.Frame2.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.Frame2.Size = new System.Drawing.Size(341, 145);
			this.Frame2.TabIndex = 0;
			this.Frame2.TabStop = false;
			this.Frame2.Text = "&Domain Information";
			// 
			// listMailServers
			// 
			this.listMailServers.BackColor = System.Drawing.SystemColors.Window;
			this.listMailServers.Cursor = System.Windows.Forms.Cursors.Default;
			this.listMailServers.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.listMailServers.ForeColor = System.Drawing.SystemColors.WindowText;
			this.listMailServers.ItemHeight = 14;
			this.listMailServers.Location = new System.Drawing.Point(88, 80);
			this.listMailServers.Name = "listMailServers";
			this.listMailServers.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.listMailServers.Size = new System.Drawing.Size(233, 46);
			this.listMailServers.TabIndex = 6;
			this.listMailServers.SelectedIndexChanged += new System.EventHandler(this.listMailServers_SelectedIndexChanged);
			// 
			// editHostName
			// 
			this.editHostName.AcceptsReturn = true;
			this.editHostName.AutoSize = false;
			this.editHostName.BackColor = System.Drawing.SystemColors.Window;
			this.editHostName.Cursor = System.Windows.Forms.Cursors.IBeam;
			this.editHostName.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.editHostName.ForeColor = System.Drawing.SystemColors.WindowText;
			this.editHostName.Location = new System.Drawing.Point(88, 24);
			this.editHostName.MaxLength = 0;
			this.editHostName.Name = "editHostName";
			this.editHostName.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.editHostName.Size = new System.Drawing.Size(233, 21);
			this.editHostName.TabIndex = 2;
			this.editHostName.Text = "microsoft.com";
			this.editHostName.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.editHostName_KeyPress);
			this.editHostName.Enter += new System.EventHandler(this.editHostName_Enter);
			// 
			// editHostAddress
			// 
			this.editHostAddress.AcceptsReturn = true;
			this.editHostAddress.AutoSize = false;
			this.editHostAddress.BackColor = System.Drawing.SystemColors.Window;
			this.editHostAddress.Cursor = System.Windows.Forms.Cursors.IBeam;
			this.editHostAddress.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.editHostAddress.ForeColor = System.Drawing.SystemColors.WindowText;
			this.editHostAddress.Location = new System.Drawing.Point(88, 52);
			this.editHostAddress.MaxLength = 0;
			this.editHostAddress.Name = "editHostAddress";
			this.editHostAddress.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.editHostAddress.Size = new System.Drawing.Size(233, 21);
			this.editHostAddress.TabIndex = 4;
			this.editHostAddress.Text = "";
			this.editHostAddress.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.editHostAddress_KeyPress);
			this.editHostAddress.Enter += new System.EventHandler(this.editHostAddress_Enter);
			// 
			// Label5
			// 
			this.Label5.BackColor = System.Drawing.SystemColors.Control;
			this.Label5.Cursor = System.Windows.Forms.Cursors.Default;
			this.Label5.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label5.ForeColor = System.Drawing.SystemColors.ControlText;
			this.Label5.Location = new System.Drawing.Point(8, 80);
			this.Label5.Name = "Label5";
			this.Label5.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.Label5.Size = new System.Drawing.Size(74, 17);
			this.Label5.TabIndex = 5;
			this.Label5.Text = "Mail Servers:";
			// 
			// Label3
			// 
			this.Label3.BackColor = System.Drawing.SystemColors.Control;
			this.Label3.Cursor = System.Windows.Forms.Cursors.Default;
			this.Label3.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label3.ForeColor = System.Drawing.SystemColors.ControlText;
			this.Label3.Location = new System.Drawing.Point(8, 28);
			this.Label3.Name = "Label3";
			this.Label3.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.Label3.Size = new System.Drawing.Size(68, 17);
			this.Label3.TabIndex = 1;
			this.Label3.Text = "Host &Name:";
			// 
			// Label4
			// 
			this.Label4.BackColor = System.Drawing.SystemColors.Control;
			this.Label4.Cursor = System.Windows.Forms.Cursors.Default;
			this.Label4.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label4.ForeColor = System.Drawing.SystemColors.ControlText;
			this.Label4.Location = new System.Drawing.Point(8, 56);
			this.Label4.Name = "Label4";
			this.Label4.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.Label4.Size = new System.Drawing.Size(78, 17);
			this.Label4.TabIndex = 3;
			this.Label4.Text = "Host &Address:";
			// 
			// Frame1
			// 
			this.Frame1.BackColor = System.Drawing.SystemColors.Control;
			this.Frame1.Controls.Add(this.editNameServer2);
			this.Frame1.Controls.Add(this.editNameServer1);
			this.Frame1.Controls.Add(this.Label1);
			this.Frame1.Controls.Add(this.Label2);
			this.Frame1.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Frame1.ForeColor = System.Drawing.SystemColors.ControlText;
			this.Frame1.Location = new System.Drawing.Point(8, 8);
			this.Frame1.Name = "Frame1";
			this.Frame1.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.Frame1.Size = new System.Drawing.Size(337, 85);
			this.Frame1.TabIndex = 9;
			this.Frame1.TabStop = false;
			this.Frame1.Text = "Name &Servers";
			// 
			// editNameServer2
			// 
			this.editNameServer2.AcceptsReturn = true;
			this.editNameServer2.AutoSize = false;
			this.editNameServer2.BackColor = System.Drawing.SystemColors.Window;
			this.editNameServer2.Cursor = System.Windows.Forms.Cursors.IBeam;
			this.editNameServer2.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.editNameServer2.ForeColor = System.Drawing.SystemColors.WindowText;
			this.editNameServer2.Location = new System.Drawing.Point(88, 48);
			this.editNameServer2.MaxLength = 0;
			this.editNameServer2.Name = "editNameServer2";
			this.editNameServer2.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.editNameServer2.Size = new System.Drawing.Size(233, 21);
			this.editNameServer2.TabIndex = 13;
			this.editNameServer2.Text = "";
			this.editNameServer2.Leave += new System.EventHandler(this.editNameServer2_Leave);
			// 
			// editNameServer1
			// 
			this.editNameServer1.AcceptsReturn = true;
			this.editNameServer1.AutoSize = false;
			this.editNameServer1.BackColor = System.Drawing.SystemColors.Window;
			this.editNameServer1.Cursor = System.Windows.Forms.Cursors.IBeam;
			this.editNameServer1.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.editNameServer1.ForeColor = System.Drawing.SystemColors.WindowText;
			this.editNameServer1.Location = new System.Drawing.Point(88, 20);
			this.editNameServer1.MaxLength = 0;
			this.editNameServer1.Name = "editNameServer1";
			this.editNameServer1.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.editNameServer1.Size = new System.Drawing.Size(233, 21);
			this.editNameServer1.TabIndex = 11;
			this.editNameServer1.Text = "";
			this.editNameServer1.Leave += new System.EventHandler(this.editNameServer1_Leave);
			// 
			// Label1
			// 
			this.Label1.BackColor = System.Drawing.SystemColors.Control;
			this.Label1.Cursor = System.Windows.Forms.Cursors.Default;
			this.Label1.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label1.ForeColor = System.Drawing.SystemColors.ControlText;
			this.Label1.Location = new System.Drawing.Point(8, 24);
			this.Label1.Name = "Label1";
			this.Label1.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.Label1.Size = new System.Drawing.Size(84, 17);
			this.Label1.TabIndex = 10;
			this.Label1.Text = "Name Server &1:";
			// 
			// Label2
			// 
			this.Label2.BackColor = System.Drawing.SystemColors.Control;
			this.Label2.Cursor = System.Windows.Forms.Cursors.Default;
			this.Label2.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label2.ForeColor = System.Drawing.SystemColors.ControlText;
			this.Label2.Location = new System.Drawing.Point(8, 52);
			this.Label2.Name = "Label2";
			this.Label2.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.Label2.Size = new System.Drawing.Size(84, 17);
			this.Label2.TabIndex = 12;
			this.Label2.Text = "Name Server &2:";
			// 
			// Form1
			// 
			this.AcceptButton = this.cmdQuery;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.Control;
			this.ClientSize = new System.Drawing.Size(358, 290);
			this.Controls.Add(this.cmdClose);
			this.Controls.Add(this.cmdQuery);
			this.Controls.Add(this.Frame2);
			this.Controls.Add(this.Frame1);
			this.Cursor = System.Windows.Forms.Cursors.Default;
			this.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Location = new System.Drawing.Point(3, 22);
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "Form1";
			this.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "SocketTools Resolve Example";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.Closed += new System.EventHandler(this.Form1_Closed);
			this.Frame2.ResumeLayout(false);
			this.Frame1.ResumeLayout(false);
			this.ResumeLayout(false);

		} 
        
		[STAThread]
		public static void Main()
		{
			Application.Run( new Form1() );
		}
		
		#endregion 
        
        private SocketTools.DnsClient dnsClient = new SocketTools.DnsClient(); 
        
        private void Form1_Load( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            //  Initialize the text controls with the default nameservers
            //  which are configured for the local system; when the control
            //  is first loaded, it will automatically check the local
            //  system configuration
            if ( !( dnsClient.Initialize() ) ) 
            { 
                Interaction.MsgBox( "Unable to initialize SocketTools class", MsgBoxStyle.Exclamation, null ); 
                System.Environment.Exit( 0 ); 
            } 
            
            editNameServer1.Text = dnsClient.NameServer[ 0 ]; 
            editNameServer2.Text = dnsClient.NameServer[ 1 ]; 
        } 
        
        
        private void Form1_Closed( object sender, System.EventArgs e ) 
        { 
            dnsClient.Uninitialize(); 
        } 
        
        
        private void editNameServer1_Leave( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            //  The user may have changed the nameserver IP address;
            //  update the NameServer property array
            dnsClient.NameServer[ 0 ] = editNameServer1.Text; 
        } 
        
        
        private void editNameServer2_Leave( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            //  The user may have changed the nameserver IP address;
            //  update the NameServer property array
            dnsClient.NameServer[ 1 ] = editNameServer2.Text; 
        } 
        
        
        private void editHostAddress_Enter( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            editHostAddress.SelectionStart = 0; 
            editHostAddress.SelectionLength = editHostAddress.Text.Length; 
        } 
        
        
        private void editHostAddress_KeyPress( System.Object eventSender, System.Windows.Forms.KeyPressEventArgs eventArgs ) 
        { 
            short KeyAscii = System.Convert.ToInt16(  System.Convert.ToInt32( eventArgs.KeyChar ) ); 
            editHostName.Text = ""; 
            if ( KeyAscii == 0 ) 
            { 
                eventArgs.Handled = true; 
            } 
        } 
        
        
        private void editHostName_Enter( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            editHostName.SelectionStart = 0; 
            editHostName.SelectionLength = editHostName.Text.Length; 
        } 
        
        
        private void editHostName_KeyPress( System.Object eventSender, System.Windows.Forms.KeyPressEventArgs eventArgs ) 
        { 
            short KeyAscii = System.Convert.ToInt16(  System.Convert.ToInt32( eventArgs.KeyChar ) ); 
            editHostAddress.Text = ""; 
            if ( KeyAscii == 0 ) 
            { 
                eventArgs.Handled = true; 
            } 
        } 
        
        
        private void listMailServers_SelectedIndexChanged( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            editHostName.Text = listMailServers.Text; 
            editHostAddress.Text = ""; 
        } 
        
        
        private void cmdQuery_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            string strHostName = null; 
            string strHostAddress = null; 
            string strMailHost = null; 
            string[] strDomain = null; 
            int nIndex = 0; 
            bool bResult = false; 
            
            cmdQuery.Enabled = false; 
            listMailServers.Items.Clear(); 
            
            strHostName =  editHostName.Text.Trim(); 
            strHostAddress =  editHostAddress.Text.Trim(); 
            
            if ( strHostName.Length > 0 ) 
            { 
                
                //  The user has entered a host name, so perform a
                //  standard query for an Address record
                
                bResult = dnsClient.Query( strHostName, SocketTools.DnsClient.RecordType.recordAddress, ref strHostAddress ); 
                if ( bResult == false ) 
                { 
                    Interaction.MsgBox( dnsClient.LastErrorString, MsgBoxStyle.Exclamation, null ); 
                    cmdQuery.Enabled = true; 
                    editHostName.Focus(); 
                    return; 
                } 
                
                //  The query was successful and the IP address was
                //  returned in the strHostAddress variable
                
                editHostAddress.Text = strHostAddress; 
                
            } 
            else if ( strHostAddress.Length > 0 ) 
            { 
                
                //  The user has entered an IP address, so perform a
                //  reverse DNS lookup by querying for the PTR record
                
                bResult = dnsClient.Query( strHostAddress, SocketTools.DnsClient.RecordType.recordPTR, ref strHostName ); 
                if ( bResult == false ) 
                { 
                    Interaction.MsgBox( dnsClient.LastErrorString, MsgBoxStyle.Exclamation, null ); 
                    cmdQuery.Enabled = true; 
                    editHostAddress.Focus(); 
                    return; 
                } 
                
                //  The query was successful and the host name was
                //  returned in the strHostName variable; note that
                //  it is not uncommon for an address to not have a
                //  PTR record
                
                editHostName.Text = strHostName; 
            } 
            else 
            { 
                //  The user needs to enter a host name or address
                
                Interaction.MsgBox( "Please enter a host name or IP address", MsgBoxStyle.Information, null ); 
                cmdQuery.Enabled = true; 
                editHostName.Focus(); 
                return; 
            } 
            
            //  Determine if there are any mail exchanges for this
            //  domain
            
            if ( strHostName.Length > 0 ) 
            { 
                
                //  Create the mail server host name by splitting the
                //  the host name
                
                strMailHost = ""; 
                strDomain =  strHostName.Split( '.' ); 
                
                nIndex = Information.UBound( strDomain, 1 ); 
                if ( nIndex > 0 ) 
                { 
                    strMailHost = strDomain[ nIndex - 1 ] + "." + strDomain[ nIndex ]; 
                } 
                
                //  Set the HostName property to the domain name and
                //  then enumerate the mail exchanges for that domain
                
                dnsClient.HostName = strMailHost; 
                for ( nIndex=0; nIndex <= dnsClient.MailExchanges - 1; nIndex++ ) 
                { 
                    listMailServers.Items.Add( dnsClient.MailExchange[ nIndex ] ); 
                } 
            } 
            
            cmdQuery.Enabled = true; 
            editHostName.Focus(); 
        } 
        
        
        private void cmdClose_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            this.Close(); 
        } 
    } 
} 
