// SocketTools 10 Build 1468
// Copyright 2023 Catalyst Development Corporation
// All rights reserved
// 
// This file is licensed to you pursuant to the terms of the
// product license agreement included with the original software,
// and is protected by copyright law and international treaties.
// Unauthorized reproduction or distribution may result in severe
// criminal penalties.

using System;
using System.Collections;
using System.Data;
using System.Drawing;
using System.Diagnostics;
using System.Windows.Forms;
using Microsoft.VisualBasic;
using SocketTools;

namespace TraceRoute
{
    internal class Form1 : System.Windows.Forms.Form 
    { 
        #region "Windows Form Designer generated code "
        public Form1() : base() 
        { 
            // This call is required by the Windows Form Designer.
            InitializeComponent();

            // Events handled by icmpClient_OnTrace
            icmpClient.OnTrace += new SocketTools.IcmpClient.OnTraceEventHandler(icmpClient_OnTrace1);
        } 

        // Form overrides dispose to clean up the component list.
        protected override void Dispose( bool Disposing ) 
        { 
            if ( Disposing ) 
            { 
                if ( !( components == null ) ) 
                { 
                    components.Dispose(); 
                } 
            } 
            base.Dispose( Disposing ); 
        } 
        
        // Required by the Windows Form Designer
        private System.ComponentModel.IContainer components; 
        public System.Windows.Forms.ToolTip ToolTip1; 
        public System.Windows.Forms.StatusBar StatusBar1; 
        public System.Windows.Forms.ListView ListView1; 
        public System.Windows.Forms.Button Command1; 
        public System.Windows.Forms.TextBox Text1; 
        public System.Windows.Forms.Label Label1; 
        // NOTE: The following procedure is required by the Windows Form Designer
        // It can be modified using the Windows Form Designer.
        // Do not modify it using the code editor.
        internal System.Windows.Forms.ImageList ImageList1; 
        internal System.Windows.Forms.ColumnHeader ColumnHeader1; 
        internal System.Windows.Forms.ColumnHeader ColumnHeader2; 
        internal System.Windows.Forms.ColumnHeader ColumnHeader3; 
        internal System.Windows.Forms.ColumnHeader ColumnHeader4; 
        internal System.Windows.Forms.ColumnHeader ColumnHeader5; 
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() 
        { 
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Form1));
            this.ToolTip1 = new System.Windows.Forms.ToolTip(this.components);
            this.StatusBar1 = new System.Windows.Forms.StatusBar();
            this.ListView1 = new System.Windows.Forms.ListView();
            this.ColumnHeader1 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
            this.ColumnHeader2 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
            this.ColumnHeader3 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
            this.ColumnHeader4 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
            this.ColumnHeader5 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
            this.ImageList1 = new System.Windows.Forms.ImageList(this.components);
            this.Command1 = new System.Windows.Forms.Button();
            this.Text1 = new System.Windows.Forms.TextBox();
            this.Label1 = new System.Windows.Forms.Label();
            this.SuspendLayout();
            // 
            // StatusBar1
            // 
            this.StatusBar1.Location = new System.Drawing.Point(0, 260);
            this.StatusBar1.Name = "StatusBar1";
            this.StatusBar1.Size = new System.Drawing.Size(479, 19);
            this.StatusBar1.TabIndex = 4;
            // 
            // ListView1
            // 
            this.ListView1.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
            this.ColumnHeader1,
            this.ColumnHeader2,
            this.ColumnHeader3,
            this.ColumnHeader4,
            this.ColumnHeader5});
            this.ListView1.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
            this.ListView1.LabelWrap = false;
            this.ListView1.Location = new System.Drawing.Point(0, 40);
            this.ListView1.MultiSelect = false;
            this.ListView1.Name = "ListView1";
            this.ListView1.Size = new System.Drawing.Size(317, 141);
            this.ListView1.SmallImageList = this.ImageList1;
            this.ListView1.TabIndex = 3;
            this.ListView1.UseCompatibleStateImageBehavior = false;
            this.ListView1.View = System.Windows.Forms.View.Details;
            // 
            // ColumnHeader1
            // 
            this.ColumnHeader1.Text = "Hop";
            this.ColumnHeader1.Width = 40;
            // 
            // ColumnHeader2
            // 
            this.ColumnHeader2.Text = "Address";
            this.ColumnHeader2.Width = 200;
            // 
            // ColumnHeader3
            // 
            this.ColumnHeader3.Text = "Average";
            // 
            // ColumnHeader4
            // 
            this.ColumnHeader4.Text = "Maximum";
            // 
            // ColumnHeader5
            // 
            this.ColumnHeader5.Text = "Minimum";
            // 
            // ImageList1
            // 
            this.ImageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("ImageList1.ImageStream")));
            this.ImageList1.TransparentColor = System.Drawing.Color.Transparent;
            this.ImageList1.Images.SetKeyName(0, "");
            this.ImageList1.Images.SetKeyName(1, "");
            this.ImageList1.Images.SetKeyName(2, "");
            this.ImageList1.Images.SetKeyName(3, "");
            this.ImageList1.Images.SetKeyName(4, "");
            // 
            // Command1
            // 
            this.Command1.BackColor = System.Drawing.SystemColors.Control;
            this.Command1.Cursor = System.Windows.Forms.Cursors.Default;
            this.Command1.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.Command1.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.Command1.ForeColor = System.Drawing.SystemColors.ControlText;
            this.Command1.Location = new System.Drawing.Point(320, 6);
            this.Command1.Name = "Command1";
            this.Command1.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.Command1.Size = new System.Drawing.Size(85, 25);
            this.Command1.TabIndex = 2;
            this.Command1.Text = "Trace";
            this.Command1.UseVisualStyleBackColor = false;
            this.Command1.Click += new System.EventHandler(this.Command1_Click);
            // 
            // Text1
            // 
            this.Text1.AcceptsReturn = true;
            this.Text1.BackColor = System.Drawing.SystemColors.Window;
            this.Text1.Cursor = System.Windows.Forms.Cursors.IBeam;
            this.Text1.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.Text1.ForeColor = System.Drawing.SystemColors.WindowText;
            this.Text1.Location = new System.Drawing.Point(52, 9);
            this.Text1.MaxLength = 0;
            this.Text1.Name = "Text1";
            this.Text1.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.Text1.Size = new System.Drawing.Size(257, 21);
            this.Text1.TabIndex = 1;
            this.Text1.Text = "test.sockettools.com";
            this.Text1.TextChanged += new System.EventHandler(this.Text1_TextChanged);
            this.Text1.Enter += new System.EventHandler(this.Text1_Enter);
            this.Text1.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.Text1_KeyPress);
            // 
            // Label1
            // 
            this.Label1.BackColor = System.Drawing.SystemColors.Control;
            this.Label1.Cursor = System.Windows.Forms.Cursors.Default;
            this.Label1.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.Label1.ForeColor = System.Drawing.SystemColors.ControlText;
            this.Label1.Location = new System.Drawing.Point(5, 13);
            this.Label1.Name = "Label1";
            this.Label1.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.Label1.Size = new System.Drawing.Size(55, 15);
            this.Label1.TabIndex = 0;
            this.Label1.Text = "System:";
            // 
            // Form1
            // 
            this.AcceptButton = this.Command1;
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.BackColor = System.Drawing.SystemColors.Control;
            this.ClientSize = new System.Drawing.Size(479, 279);
            this.Controls.Add(this.StatusBar1);
            this.Controls.Add(this.ListView1);
            this.Controls.Add(this.Command1);
            this.Controls.Add(this.Text1);
            this.Controls.Add(this.Label1);
            this.Cursor = System.Windows.Forms.Cursors.Default;
            this.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.Location = new System.Drawing.Point(4, 23);
            this.Name = "Form1";
            this.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "SocketTools TraceRoute Example";
            this.Closed += new System.EventHandler(this.Form1_Closed);
            this.Load += new System.EventHandler(this.Form1_Load);
            this.Resize += new System.EventHandler(this.Form1_Resize);
            this.ResumeLayout(false);

        } 
                
		[STAThread]
		public static void Main()
		{
            Application.EnableVisualStyles();
            Application.DoEvents();
			Application.Run( new Form1() );
		}

        #endregion 
        
        public SocketTools.IcmpClient icmpClient = new SocketTools.IcmpClient(); 
        
        private const int iconGreen = 0; 
        private const int iconBlue = 1; 
        private const int iconYellow = 2; 
        private const int iconRed = 3; 
        private const int iconBlack = 4; 
        
        private void Form1_Load( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            if ( !( icmpClient.Initialize() ) ) 
            { 
                Interaction.MsgBox( "Unable to initialize SocketTools component", MsgBoxStyle.Exclamation, null ); 
                System.Environment.Exit( 0 ); 
            } 
            
            ListView1.Width = ClientRectangle.Width - ListView1.Left; 
            ListView1.Height = ClientRectangle.Height - ( StatusBar1.Height + ListView1.Top ); 
        } 
        
        
        private void Form1_Closed( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            icmpClient.Uninitialize(); 
        } 
        
        
        private void Form1_Resize( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            ListView1.Width = ClientRectangle.Width - ListView1.Left; 
            ListView1.Height = ClientRectangle.Height - ( StatusBar1.Height + ListView1.Top ); 
        } 
        
        
        private void Text1_Enter( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            Text1.SelectionStart = 0; 
            Text1.SelectionLength = Text1.Text.Length; 
        } 
        
        
        private void Text1_TextChanged( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            Command1.Enabled = Text1.Text.Length > 0; 
        } 
        
        
        private void Text1_KeyPress( System.Object eventSender, System.Windows.Forms.KeyPressEventArgs eventArgs ) 
        { 
            short KeyAscii = System.Convert.ToInt16(  System.Convert.ToInt32( eventArgs.KeyChar ) ); 
            if ( KeyAscii == System.Convert.ToDouble( System.Windows.Forms.Keys.Space ) ) 
            { 
                Interaction.Beep(); 
                KeyAscii = 0; 
            } 
            if ( KeyAscii == 0 ) 
            { 
                eventArgs.Handled = true; 
            } 
        } 
        
        
        private void Command1_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            int nResult = 0; 
            
            Command1.Enabled = false; 
            ListView1.Items.Clear(); 
            
            icmpClient.AutoResolve = true; 
            nResult = icmpClient.TraceRoute( Text1.Text ); 
            
            Command1.Enabled = true; 
        } 
        
        
        private void icmpClient_OnTrace1( object sender, SocketTools.IcmpClient.TraceEventArgs e ) 
        { 
            System.Windows.Forms.ListViewItem listItem = null; 
            int nIcon = 0; 
            
            if ( e.Replies == 0 ) 
            { 
                nIcon = iconBlack; 
            } 
            else 
            { 
                if ( e.TripAverage < 100 ) 
                { 
                    nIcon = iconGreen; 
                } 
                else if ( e.TripAverage >= 100 & e.TripAverage <= 299 ) 
                { 
                    nIcon = iconBlue; 
                } 
                else if ( e.TripAverage >= 300 & e.TripAverage <= 499 ) 
                { 
                    nIcon = iconYellow; 
                } 
                else if ( e.TripAverage >= 500 ) 
                { 
                    nIcon = iconRed; 
                } 
            } 
            
            listItem = ListView1.Items.Add( System.Convert.ToString( e.TraceHop ), nIcon ); 
            listItem.SubItems.Add( e.HostName ); 
            listItem.SubItems.Add( System.Convert.ToString( e.TripAverage ) ); 
            listItem.SubItems.Add( System.Convert.ToString( e.TripMaximum ) ); 
            listItem.SubItems.Add( System.Convert.ToString( e.TripMinimum ) ); 
            ListView1.Refresh(); 
            System.Windows.Forms.Application.DoEvents(); 
        } 
    } 
} 
