// SocketTools 10 Build 1468
// Copyright 2023 Catalyst Development Corporation
// All rights reserved
// 
// This file is licensed to you pursuant to the terms of the
// product license agreement included with the original software,
// and is protected by copyright law and international treaties.
// Unauthorized reproduction or distribution may result in severe
// criminal penalties.
// 

using System;
using System.Collections;
using System.Data;
using System.Drawing;
using System.Diagnostics;
using System.Windows.Forms;
using Microsoft.VisualBasic;
using SocketTools;

using Protocol = SocketTools.SocketWrench.SocketProtocol;
using ErrorCode = SocketTools.SocketWrench.ErrorCode;

namespace ServerIP
{
    internal class formMain : System.Windows.Forms.Form 
    { 
        #region '"Windows Form Designer generated code "' 
        public formMain() : base() 
        { 
            // This call is required by the Windows Form Designer.
            InitializeComponent(); 
        } 
        // Form overrides dispose to clean up the component list.
        protected override void Dispose( bool Disposing ) 
        { 
            if ( Disposing ) 
            { 
                if ( !( components == null ) ) 
                { 
                    components.Dispose(); 
                } 
            } 
            base.Dispose( Disposing ); 
        } 
        
        // Required by the Windows Form Designer
        private System.ComponentModel.IContainer components; 
        public System.Windows.Forms.ToolTip ToolTip1; 
        public System.Windows.Forms.Button cmdClose; 
        public System.Windows.Forms.Button cmdStart; 
        public System.Windows.Forms.ListBox listOutput; 
        public System.Windows.Forms.TextBox editPort; 
        public System.Windows.Forms.ComboBox comboAddress; 
        public System.Windows.Forms.Label labelPort; 
        public System.Windows.Forms.Label labelAddress; 
        // NOTE: The following procedure is required by the Windows Form Designer
        // It can be modified using the Windows Form Designer.
        // Do not modify it using the code editor.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() 
        { 
            this.components = new System.ComponentModel.Container();
            this.ToolTip1 = new System.Windows.Forms.ToolTip(this.components);
            this.cmdClose = new System.Windows.Forms.Button();
            this.cmdStart = new System.Windows.Forms.Button();
            this.listOutput = new System.Windows.Forms.ListBox();
            this.editPort = new System.Windows.Forms.TextBox();
            this.comboAddress = new System.Windows.Forms.ComboBox();
            this.labelPort = new System.Windows.Forms.Label();
            this.labelAddress = new System.Windows.Forms.Label();
            this.SuspendLayout();
            // 
            // cmdClose
            // 
            this.cmdClose.BackColor = System.Drawing.SystemColors.Control;
            this.cmdClose.Cursor = System.Windows.Forms.Cursors.Default;
            this.cmdClose.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.cmdClose.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.cmdClose.ForeColor = System.Drawing.SystemColors.ControlText;
            this.cmdClose.Location = new System.Drawing.Point(209, 245);
            this.cmdClose.Name = "cmdClose";
            this.cmdClose.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.cmdClose.Size = new System.Drawing.Size(90, 30);
            this.cmdClose.TabIndex = 6;
            this.cmdClose.Text = "Close";
            this.cmdClose.UseVisualStyleBackColor = false;
            this.cmdClose.Click += new System.EventHandler(this.cmdClose_Click);
            // 
            // cmdStart
            // 
            this.cmdStart.BackColor = System.Drawing.SystemColors.Control;
            this.cmdStart.Cursor = System.Windows.Forms.Cursors.Default;
            this.cmdStart.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.cmdStart.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.cmdStart.ForeColor = System.Drawing.SystemColors.ControlText;
            this.cmdStart.Location = new System.Drawing.Point(105, 245);
            this.cmdStart.Name = "cmdStart";
            this.cmdStart.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.cmdStart.Size = new System.Drawing.Size(90, 30);
            this.cmdStart.TabIndex = 5;
            this.cmdStart.Text = "Start";
            this.cmdStart.UseVisualStyleBackColor = false;
            this.cmdStart.Click += new System.EventHandler(this.cmdStart_Click);
            // 
            // listOutput
            // 
            this.listOutput.BackColor = System.Drawing.SystemColors.Window;
            this.listOutput.Cursor = System.Windows.Forms.Cursors.Default;
            this.listOutput.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.listOutput.ForeColor = System.Drawing.SystemColors.WindowText;
            this.listOutput.ItemHeight = 14;
            this.listOutput.Location = new System.Drawing.Point(8, 48);
            this.listOutput.Name = "listOutput";
            this.listOutput.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.listOutput.Size = new System.Drawing.Size(385, 186);
            this.listOutput.TabIndex = 4;
            this.listOutput.TabStop = false;
            // 
            // editPort
            // 
            this.editPort.AcceptsReturn = true;
            this.editPort.BackColor = System.Drawing.SystemColors.Window;
            this.editPort.Cursor = System.Windows.Forms.Cursors.IBeam;
            this.editPort.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.editPort.ForeColor = System.Drawing.SystemColors.WindowText;
            this.editPort.Location = new System.Drawing.Point(344, 12);
            this.editPort.MaxLength = 0;
            this.editPort.Name = "editPort";
            this.editPort.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.editPort.Size = new System.Drawing.Size(49, 21);
            this.editPort.TabIndex = 3;
            this.editPort.Text = "5001";
            this.editPort.Enter += new System.EventHandler(this.editPort_Enter);
            // 
            // comboAddress
            // 
            this.comboAddress.BackColor = System.Drawing.SystemColors.Window;
            this.comboAddress.Cursor = System.Windows.Forms.Cursors.Default;
            this.comboAddress.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.comboAddress.ForeColor = System.Drawing.SystemColors.WindowText;
            this.comboAddress.Location = new System.Drawing.Point(64, 12);
            this.comboAddress.Name = "comboAddress";
            this.comboAddress.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.comboAddress.Size = new System.Drawing.Size(213, 22);
            this.comboAddress.TabIndex = 1;
            // 
            // labelPort
            // 
            this.labelPort.BackColor = System.Drawing.SystemColors.Control;
            this.labelPort.Cursor = System.Windows.Forms.Cursors.Default;
            this.labelPort.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.labelPort.ForeColor = System.Drawing.SystemColors.ControlText;
            this.labelPort.Location = new System.Drawing.Point(308, 16);
            this.labelPort.Name = "labelPort";
            this.labelPort.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.labelPort.Size = new System.Drawing.Size(27, 13);
            this.labelPort.TabIndex = 2;
            this.labelPort.Text = "&Port:";
            // 
            // labelAddress
            // 
            this.labelAddress.BackColor = System.Drawing.SystemColors.Control;
            this.labelAddress.Cursor = System.Windows.Forms.Cursors.Default;
            this.labelAddress.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.labelAddress.ForeColor = System.Drawing.SystemColors.ControlText;
            this.labelAddress.Location = new System.Drawing.Point(12, 16);
            this.labelAddress.Name = "labelAddress";
            this.labelAddress.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.labelAddress.Size = new System.Drawing.Size(49, 13);
            this.labelAddress.TabIndex = 0;
            this.labelAddress.Text = "Address:";
            // 
            // formMain
            // 
            this.AcceptButton = this.cmdStart;
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.BackColor = System.Drawing.SystemColors.Control;
            this.ClientSize = new System.Drawing.Size(404, 282);
            this.Controls.Add(this.cmdClose);
            this.Controls.Add(this.cmdStart);
            this.Controls.Add(this.listOutput);
            this.Controls.Add(this.editPort);
            this.Controls.Add(this.comboAddress);
            this.Controls.Add(this.labelPort);
            this.Controls.Add(this.labelAddress);
            this.Cursor = System.Windows.Forms.Cursors.Default;
            this.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
            this.Location = new System.Drawing.Point(3, 29);
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "formMain";
            this.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.Text = "ServerIP";
            this.Load += new System.EventHandler(this.formMain_Load);
            this.ResumeLayout(false);

        } 
        
		[STAThread]
		public static void Main()
		{
            Application.EnableVisualStyles();
            Application.DoEvents();
			Application.Run( new formMain() );
		}
		#endregion 

        private SocketTools.SocketWrench Socket = new SocketTools.SocketWrench(); 
        
        // 
        //  Configuration values for the UDP server
        // 
        private const string srvLocalAddress = "0.0.0.0"; 
        private const int srvLocalPort = 8195; 
        private const int srvBufferSize = 128; 
        private const int srvTimeout = 10; 
        private const int srvOptions = 0; 
        
        private void formMain_Load( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            int nIndex = 0; 
            
			// Define the event handler for the OnRead event
			Socket.OnRead += new System.EventHandler( Socket_OnRead ); 
			
			//  Initialize the comboAddress control with the available
            //  addresses that the socket can be bound to
            
            if ( Socket.AdapterCount == 0 ) 
            { 
                comboAddress.SelectedIndex = -1; 
            } 
            else 
            { 
                for ( nIndex=0; nIndex<=Socket.AdapterCount - 1; nIndex++ ) 
                { 
                    comboAddress.Items.Add( Socket.AdapterAddress[ nIndex ] ); 
                } 
                comboAddress.SelectedIndex = 0; 
            } 
        } 
        
        private void editPort_Enter( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            editPort.SelectionStart = 0; 
            editPort.SelectionLength = editPort.Text.Length; 
        } 
        
        private void cmdStart_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            string strAddress = null; 
            int nPort = 0; 
            bool bResult = false; 
            
            if ( Socket.Handle == -1 ) 
            { 
                
                strAddress =  comboAddress.Text.Trim();
                if (! ValidAddress( ref strAddress ))
                { 
                    MessageBox.Show( "Please specify a valid IP address", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation );
                    comboAddress.SelectedIndex = 0; 
                    comboAddress.Focus(); 
                    return; 
                } 
                
                nPort = Int32.Parse( editPort.Text ); 
                if ( nPort < 1 | nPort > 65535 ) 
                { 
                    MessageBox.Show( "Please specify a valid port number", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation );
                    editPort.Text = ""; 
                    editPort.Focus(); 
                    return; 
                } 
                
                //  Use the Bind method to create the socket and bind it to the
                //  specified address and port number
                
                Socket.Blocking = false; 
                bResult = Socket.Bind( srvLocalAddress, srvLocalPort, SocketTools.SocketWrench.SocketProtocol.socketDatagram, ( ( SocketTools.SocketWrench.SocketOptions )( srvOptions ) ) ); 
                
                if ( bResult == false ) 
                { 
                    MessageBox.Show( Socket.LastErrorString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation );
                    return; 
                } 
                
                listOutput.Items.Clear(); 
                cmdStart.Text = "Stop"; 
                comboAddress.Enabled = false; 
                editPort.Enabled = false; 
            } 
            else 
            { 
                Socket.Disconnect(); 
                listOutput.Items.Clear(); 
                cmdStart.Text = "Start"; 
                comboAddress.Enabled = true; 
                editPort.Enabled = true; 
            } 
        } 
        
        private void cmdClose_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            this.Close(); 
        } 
        
        private void Socket_OnRead( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            string strAddress = null; 
            int nPort = 0; 
            string strBuffer = null; 
            int nResult = 0; 
            
            //  Read the datagram sent to us by the remote host
            //  and discard it, we only need their IP address and
            //  port number
            
            nResult = Socket.ReadFrom( ref strBuffer, srvBufferSize, ref strAddress, ref nPort ); 
            if ( nResult == -1 ) 
            { 
                Output( "Error " + Socket.LastError + ": " + Socket.LastErrorString ); 
                return; 
            } 
            
            //  Send a datagram back to the peer with the IP address
            //  and port number we have specified; this uses the WriteEx
            //  method since it allows us to easily specify the remote
            //  address and port

            strBuffer =  comboAddress.Text.Trim() + ":" +  editPort.Text.Trim();
            nResult = Socket.WriteTo( strBuffer, strBuffer.Length , strAddress, nPort ); 
            if ( nResult == -1 ) 
            { 
                Output( "Error " + Socket.LastError + ": " + Socket.LastErrorString ); 
                return; 
            } 
            
            Output( "Sent address " + strBuffer + " to " + strAddress + " on port " + nPort ); 
        } 
        
        private void Output( string strMessage ) 
        { 
            listOutput.Items.Add( strMessage ); 
            listOutput.SelectedIndex = listOutput.Items.Count - 1; 
            listOutput.SetSelected( listOutput.SelectedIndex, false ); 
        } 
        
		private bool ValidAddress( ref string strAddress ) 
		{ 
			string[] strValue = null; 
			string strResult = null; 
			int nValue = 0; 
			int nIndex = 0; 
            
			strValue =  strAddress.Split( '.' ); 

			if ( strValue.Length != 4 )
				return false;
            
			for ( nIndex = 0; nIndex < 4; nIndex++ ) 
			{ 
				nValue = Int32.Parse( strValue[ nIndex ] ); 
				if ( nValue < 0 | nValue > 255 )
					return false;
                
				strResult += nValue.ToString();

				if ( nIndex < 3 )
					strResult += ".";
			} 
            
			if ( strResult != "0.0.0.0" & strResult != "255.255.255.255" ) 
			{ 
				strAddress = strResult; 
				return true;
			} 

			return false;
		} 
	} 
} 
