// SocketTools 10 Build 1468
// Copyright 2023 Catalyst Development Corporation
// All rights reserved
// 
// This file is licensed to you pursuant to the terms of the
// product license agreement included with the original software,
// and is protected by copyright law and international treaties.
// Unauthorized reproduction or distribution may result in severe
// criminal penalties.
// 
using System;
using System.Collections;
using System.Data;
using System.Drawing;
using System.Diagnostics;
using System.Windows.Forms;

namespace AsyncIO
{
    internal class formMain : System.Windows.Forms.Form 
    { 
        
        #region '"Windows Form Designer generated code "' 
        public formMain() : base() 
        { 
            // This call is required by the Windows Form Designer.
            InitializeComponent(); 
            
            // Add any initialization after the InitializeComponent() call
            // Events handled by Socket_OnConnect
            Socket.OnConnect += new System.EventHandler(Socket_OnConnect);
            // Events handled by Socket_OnDisconnect
            Socket.OnDisconnect += new System.EventHandler(Socket_OnDisconnect);
            // Events handled by Socket_OnRead
            Socket.OnRead += new System.EventHandler(Socket_OnRead);
            // Events handled by Socket_OnWrite
            Socket.OnWrite += new System.EventHandler(Socket_OnWrite);
            // Events handled by Timer_Tick
            Timer.Tick += new System.EventHandler(Timer_Tick);
        } 
        // Form overrides dispose to clean up the component list.
        protected override void Dispose( bool Disposing ) 
        { 
            if ( Disposing ) 
            { 
                if ( !( components == null ) ) 
                { 
                    components.Dispose(); 
                } 
            } 
            base.Dispose( Disposing ); 
        } 
        
        // Required by the Windows Form Designer
        private System.ComponentModel.IContainer components; 
        public System.Windows.Forms.ToolTip ToolTip1; 
        public System.Windows.Forms.TextBox editBufferSize; 
        public System.Windows.Forms.TextBox editBufferTotal; 
        public System.Windows.Forms.TextBox editRemotePort; 
        public System.Windows.Forms.TextBox editHostName; 
        public System.Windows.Forms.Button cmdAction; 
        public System.Windows.Forms.Label labelStatus; 
        // NOTE: The following procedure is required by the Windows Form Designer
        // It can be modified using the Windows Form Designer.
        // Do not modify it using the code editor.
        internal System.Windows.Forms.Timer Timer; 
        public System.Windows.Forms.Label labelBufferSize; 
        public System.Windows.Forms.Label labelBytes; 
        public System.Windows.Forms.Label labelRemotePort; 
        public System.Windows.Forms.Label labelHostName; 
        internal System.Windows.Forms.Label labelTimeout; 
        internal System.Windows.Forms.TextBox editTimeout; 

        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() 
        { 
            this.components = new System.ComponentModel.Container();
            this.ToolTip1 = new System.Windows.Forms.ToolTip(this.components);
            this.editBufferSize = new System.Windows.Forms.TextBox();
            this.editBufferTotal = new System.Windows.Forms.TextBox();
            this.editRemotePort = new System.Windows.Forms.TextBox();
            this.editHostName = new System.Windows.Forms.TextBox();
            this.cmdAction = new System.Windows.Forms.Button();
            this.labelBufferSize = new System.Windows.Forms.Label();
            this.labelBytes = new System.Windows.Forms.Label();
            this.labelRemotePort = new System.Windows.Forms.Label();
            this.labelHostName = new System.Windows.Forms.Label();
            this.labelStatus = new System.Windows.Forms.Label();
            this.Timer = new System.Windows.Forms.Timer(this.components);
            this.labelTimeout = new System.Windows.Forms.Label();
            this.editTimeout = new System.Windows.Forms.TextBox();
            this.SuspendLayout();
            // 
            // editBufferSize
            // 
            this.editBufferSize.AcceptsReturn = true;
            this.editBufferSize.BackColor = System.Drawing.SystemColors.Window;
            this.editBufferSize.Cursor = System.Windows.Forms.Cursors.IBeam;
            this.editBufferSize.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.editBufferSize.ForeColor = System.Drawing.SystemColors.WindowText;
            this.editBufferSize.Location = new System.Drawing.Point(48, 40);
            this.editBufferSize.MaxLength = 0;
            this.editBufferSize.Name = "editBufferSize";
            this.editBufferSize.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.editBufferSize.Size = new System.Drawing.Size(49, 21);
            this.editBufferSize.TabIndex = 5;
            this.editBufferSize.Text = "4096";
            this.editBufferSize.Enter += new System.EventHandler(this.editBufferSize_Enter);
            // 
            // editBufferTotal
            // 
            this.editBufferTotal.AcceptsReturn = true;
            this.editBufferTotal.BackColor = System.Drawing.SystemColors.Window;
            this.editBufferTotal.Cursor = System.Windows.Forms.Cursors.IBeam;
            this.editBufferTotal.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.editBufferTotal.ForeColor = System.Drawing.SystemColors.WindowText;
            this.editBufferTotal.Location = new System.Drawing.Point(152, 40);
            this.editBufferTotal.MaxLength = 0;
            this.editBufferTotal.Name = "editBufferTotal";
            this.editBufferTotal.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.editBufferTotal.Size = new System.Drawing.Size(49, 21);
            this.editBufferTotal.TabIndex = 7;
            this.editBufferTotal.Text = "100";
            this.editBufferTotal.Enter += new System.EventHandler(this.editBufferTotal_Enter);
            // 
            // editRemotePort
            // 
            this.editRemotePort.AcceptsReturn = true;
            this.editRemotePort.BackColor = System.Drawing.SystemColors.Window;
            this.editRemotePort.Cursor = System.Windows.Forms.Cursors.IBeam;
            this.editRemotePort.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.editRemotePort.ForeColor = System.Drawing.SystemColors.WindowText;
            this.editRemotePort.Location = new System.Drawing.Point(268, 12);
            this.editRemotePort.MaxLength = 0;
            this.editRemotePort.Name = "editRemotePort";
            this.editRemotePort.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.editRemotePort.Size = new System.Drawing.Size(33, 21);
            this.editRemotePort.TabIndex = 3;
            this.editRemotePort.Text = "7";
            this.editRemotePort.Enter += new System.EventHandler(this.editRemotePort_Enter);
            // 
            // editHostName
            // 
            this.editHostName.AcceptsReturn = true;
            this.editHostName.BackColor = System.Drawing.SystemColors.Window;
            this.editHostName.Cursor = System.Windows.Forms.Cursors.IBeam;
            this.editHostName.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.editHostName.ForeColor = System.Drawing.SystemColors.WindowText;
            this.editHostName.Location = new System.Drawing.Point(48, 12);
            this.editHostName.MaxLength = 0;
            this.editHostName.Name = "editHostName";
            this.editHostName.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.editHostName.Size = new System.Drawing.Size(177, 21);
            this.editHostName.TabIndex = 1;
            this.editHostName.Enter += new System.EventHandler(this.editHostName_Enter);
            // 
            // cmdAction
            // 
            this.cmdAction.BackColor = System.Drawing.SystemColors.Control;
            this.cmdAction.Cursor = System.Windows.Forms.Cursors.Default;
            this.cmdAction.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.cmdAction.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.cmdAction.ForeColor = System.Drawing.SystemColors.ControlText;
            this.cmdAction.Location = new System.Drawing.Point(117, 100);
            this.cmdAction.Name = "cmdAction";
            this.cmdAction.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.cmdAction.Size = new System.Drawing.Size(81, 29);
            this.cmdAction.TabIndex = 10;
            this.cmdAction.Text = "Test";
            this.cmdAction.UseVisualStyleBackColor = false;
            this.cmdAction.Click += new System.EventHandler(this.cmdAction_Click);
            // 
            // labelBufferSize
            // 
            this.labelBufferSize.AutoSize = true;
            this.labelBufferSize.BackColor = System.Drawing.SystemColors.Control;
            this.labelBufferSize.Cursor = System.Windows.Forms.Cursors.Default;
            this.labelBufferSize.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.labelBufferSize.ForeColor = System.Drawing.SystemColors.ControlText;
            this.labelBufferSize.Location = new System.Drawing.Point(8, 44);
            this.labelBufferSize.Name = "labelBufferSize";
            this.labelBufferSize.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.labelBufferSize.Size = new System.Drawing.Size(41, 14);
            this.labelBufferSize.TabIndex = 4;
            this.labelBufferSize.Text = "Buffer:";
            // 
            // labelBytes
            // 
            this.labelBytes.AutoSize = true;
            this.labelBytes.BackColor = System.Drawing.SystemColors.Control;
            this.labelBytes.Cursor = System.Windows.Forms.Cursors.Default;
            this.labelBytes.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.labelBytes.ForeColor = System.Drawing.SystemColors.ControlText;
            this.labelBytes.Location = new System.Drawing.Point(108, 44);
            this.labelBytes.Name = "labelBytes";
            this.labelBytes.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.labelBytes.Size = new System.Drawing.Size(45, 14);
            this.labelBytes.TabIndex = 6;
            this.labelBytes.Text = "KBytes:";
            // 
            // labelRemotePort
            // 
            this.labelRemotePort.AutoSize = true;
            this.labelRemotePort.BackColor = System.Drawing.SystemColors.Control;
            this.labelRemotePort.Cursor = System.Windows.Forms.Cursors.Default;
            this.labelRemotePort.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.labelRemotePort.ForeColor = System.Drawing.SystemColors.ControlText;
            this.labelRemotePort.Location = new System.Drawing.Point(235, 16);
            this.labelRemotePort.Name = "labelRemotePort";
            this.labelRemotePort.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.labelRemotePort.Size = new System.Drawing.Size(29, 14);
            this.labelRemotePort.TabIndex = 2;
            this.labelRemotePort.Text = "Port:";
            // 
            // labelHostName
            // 
            this.labelHostName.AutoSize = true;
            this.labelHostName.BackColor = System.Drawing.SystemColors.Control;
            this.labelHostName.Cursor = System.Windows.Forms.Cursors.Default;
            this.labelHostName.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.labelHostName.ForeColor = System.Drawing.SystemColors.ControlText;
            this.labelHostName.Location = new System.Drawing.Point(8, 16);
            this.labelHostName.Name = "labelHostName";
            this.labelHostName.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.labelHostName.Size = new System.Drawing.Size(32, 14);
            this.labelHostName.TabIndex = 0;
            this.labelHostName.Text = "Host:";
            // 
            // labelStatus
            // 
            this.labelStatus.BackColor = System.Drawing.SystemColors.Control;
            this.labelStatus.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
            this.labelStatus.Cursor = System.Windows.Forms.Cursors.Default;
            this.labelStatus.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.labelStatus.ForeColor = System.Drawing.SystemColors.ControlText;
            this.labelStatus.Location = new System.Drawing.Point(0, 140);
            this.labelStatus.Name = "labelStatus";
            this.labelStatus.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.labelStatus.Size = new System.Drawing.Size(313, 21);
            this.labelStatus.TabIndex = 11;
            // 
            // Timer
            // 
            this.Timer.Interval = 1000;
            // 
            // labelTimeout
            // 
            this.labelTimeout.Location = new System.Drawing.Point(215, 45);
            this.labelTimeout.Name = "labelTimeout";
            this.labelTimeout.Size = new System.Drawing.Size(50, 15);
            this.labelTimeout.TabIndex = 8;
            this.labelTimeout.Text = "Timeout:";
            // 
            // editTimeout
            // 
            this.editTimeout.Location = new System.Drawing.Point(268, 40);
            this.editTimeout.Name = "editTimeout";
            this.editTimeout.Size = new System.Drawing.Size(33, 20);
            this.editTimeout.TabIndex = 9;
            this.editTimeout.Text = "10";
            // 
            // formMain
            // 
            this.AcceptButton = this.cmdAction;
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.BackColor = System.Drawing.SystemColors.Control;
            this.ClientSize = new System.Drawing.Size(315, 162);
            this.Controls.Add(this.editTimeout);
            this.Controls.Add(this.labelTimeout);
            this.Controls.Add(this.editBufferSize);
            this.Controls.Add(this.editBufferTotal);
            this.Controls.Add(this.editRemotePort);
            this.Controls.Add(this.editHostName);
            this.Controls.Add(this.cmdAction);
            this.Controls.Add(this.labelBufferSize);
            this.Controls.Add(this.labelBytes);
            this.Controls.Add(this.labelRemotePort);
            this.Controls.Add(this.labelHostName);
            this.Controls.Add(this.labelStatus);
            this.Cursor = System.Windows.Forms.Cursors.Default;
            this.Font = new System.Drawing.Font("Arial", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
            this.Location = new System.Drawing.Point(210, 185);
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "formMain";
            this.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "SocketTools AsyncIO";
            this.ResumeLayout(false);
            this.PerformLayout();

        } 
        
		[STAThread]
		public static void Main()
		{
            Application.EnableVisualStyles();
            Application.DoEvents();
			Application.Run(new formMain());
		}
        #endregion 

        private SocketTools.SocketWrench Socket = new SocketTools.SocketWrench(); 
        
        private string m_strBuffer; //  Global data I/O buffer
        private int m_nBufferSize; //  Size of the I/O buffer
        private int m_nBufferTotal; //  Total number of bytes to read/write
        private int m_nBytesIn; //  Number of bytes read
        private int m_nBytesOut; //  Number of bytes written
        private int m_nTimerStart; //  Timer start value in ticks
        private int m_nTimerEnd; //  Timer end value in ticks
        
        // 
        //  Return the current tick count, which is the number of milliseconds
        //  that the system has been running; this function has a granularity
        //  of approximately 10 milliseconds
        // 
        [System.Runtime.InteropServices.DllImport("Kernel32")]
        private static extern int GetTickCount(); 
        
        private void cmdAction_Click( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            int nIndex = 0, nValue = 0; 
            
            // 
            //  Intialize the globals
            // 
            m_nBufferSize = Int32.Parse(editBufferSize.Text); 
            m_nBufferTotal = Int32.Parse(editBufferTotal.Text) * 1024;
            m_strBuffer = ""; 
            m_nBytesIn = 0; 
            m_nBytesOut = 0; 
            m_nTimerStart = 0; 
            m_nTimerEnd = 0; 
            
            // 
            //  Validate the values specified by the user
            // 
            if ( m_nBufferSize < 32 | m_nBufferSize > 16384 ) 
            { 
                MessageBox.Show("An invalid buffer size was specified", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation); 
                editBufferSize.Focus(); 
                return; 
            } 
            
            if ( m_nBufferTotal < 1 ) 
            { 
                MessageBox.Show("A minimum value of 1K bytes must be specified", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation); 
                editBufferTotal.Focus(); 
                return; 
            } 
            
            if ( editHostName.Text.Length == 0 ) 
            { 
                MessageBox.Show("No server hostname was specified", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation); 
                editHostName.Focus(); 
                return; 
            } 
            
            if ( editRemotePort.Text.Length == 0 ) 
            { 
                MessageBox.Show("An invalid port number was specified", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                editRemotePort.Focus(); 
                return; 
            } 
            
            if ( editTimeout.Text.Length == 0 ) 
            { 
                MessageBox.Show("An invalid timeout period was specified", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                editRemotePort.Focus(); 
                return; 
            } 
            
            // 
            //  Create a buffer that contains random bytes; note
            //  that we do this in order to create a more 'real world'
            //  test; using a simple repeating pattern that is easily
            //  compressed will skew the results on dial-up lines
            // 
			System.Random rndByte = new System.Random();
            for ( nIndex=0; nIndex<=m_nBufferSize - 1; nIndex++ ) 
            { 
                nValue = System.Convert.ToInt32(rndByte.Next(254) + 1 ); 
                m_strBuffer = m_strBuffer +  System.Convert.ToChar(nValue); 
            } 
            
            cmdAction.Enabled = false; 
            
            // 
            //  Initialize the socket class
            // 
            Socket.Blocking = false; 
            
            // 
            //  Establish the connection; note that since this is an
            //  asynchronous socket, we are not actually connected to
            //  the server until the Connect event fires
            // 
            if (! Socket.Connect(editHostName.Text, Int32.Parse(editRemotePort.Text)))
            { 
                labelStatus.Text = Socket.LastErrorString; 
				MessageBox.Show(Socket.LastErrorString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                cmdAction.Enabled = true; 
                return; 
            } 
            
            Timer.Interval = Int32.Parse(editTimeout.Text) * 1000; 
            Timer.Enabled = true; 
            
            labelStatus.Text = ""; 
        } 
        
        private void editBufferSize_Enter( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            editBufferSize.SelectionStart = 0; 
            editBufferSize.SelectionLength = editBufferSize.Text.Length; 
        } 
        
        private void editBufferTotal_Enter( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            editBufferTotal.SelectionStart = 0; 
            editBufferTotal.SelectionLength = editBufferTotal.Text.Length;
        } 
        
        private void editHostName_Enter( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            editHostName.SelectionStart = 0; 
            editHostName.SelectionLength = editHostName.Text.Length;
        } 
        
        private void editRemotePort_Enter( System.Object eventSender, System.EventArgs eventArgs ) 
        { 
            editRemotePort.SelectionStart = 0; 
            editRemotePort.SelectionLength = editRemotePort.Text.Length; 
        } 
        
        private void Socket_OnConnect(object sender, System.EventArgs e) 
        { 
            // 
            //  The connection to the server has completed
            // 
            m_nTimerStart = GetTickCount(); 
        } 
        
        
        private void Socket_OnDisconnect( object sender, System.EventArgs e ) 
        { 
            // 
            //  The remote host has closed the connection for some reason;
            //  disconnect and update the the status label
            // 
            Socket.Disconnect(); 
            labelStatus.Text = "Remote host closed connection"; 
            cmdAction.Enabled = true; 
        } 
        
        
        private void Socket_OnRead( object sender, System.EventArgs e ) 
        { 
            string strBuffer = null; 
            int nRead = 0; 
            double dblTimeElapsed = 0; 
            double dblTransferRate = 0; 
            
            // 
            //  This event fires when there is data available to be
            //  read. This event will fire after the first block of
            //  data has been written and returned by the echo server.
            //  We read all of the available data until the Read method
            //  returns a value less than 1. A return value of 0 means
            //  that the socket is closed; a value of -1 indicates
            //  that there is no more data available to read at that
            //  time, and we should exit and wait for the Read event
            //  to fire again
            // 
            while ( m_nBytesIn < m_nBufferTotal ) 
            { 
                // 
                //  Read up to m_nBufferSize bytes of data from the
                //  remote host
                // 
                nRead = Socket.Read( ref strBuffer, m_nBufferSize ); 
                if ( nRead < 1 ) 
                { 
                    break;
                } 
                else 
                { 
                    m_nBytesIn = m_nBytesIn + nRead; 
                    // 
                    //  If we have read all of the available data, then
                    //  the test has completed; get the tick count,
                    //  disconnect the socket and update the status label
                    // 
                    if ( m_nBytesIn >= m_nBufferTotal ) 
                    { 
                        Timer.Enabled = false; 
                        Socket.Disconnect(); 
                        
                        // 
                        //  Update the status label control with the elapsed time
                        //  and the transfer rate
                        // 
                        m_nTimerEnd = GetTickCount(); 
                        dblTimeElapsed = System.Convert.ToDouble( m_nTimerEnd - m_nTimerStart ) / 1000.0; 
                        dblTransferRate = ( System.Convert.ToDouble( m_nBytesIn + m_nBytesOut ) / 1024.0 ) / dblTimeElapsed; 
                        
                        labelStatus.Text = String.Format("{0:F2} seconds, {1:F2} kb/s", dblTimeElapsed, dblTransferRate);
                        cmdAction.Enabled = true; 
                        break;
                    } 
                } 
            } 
            
            Timer.Enabled = false; 
        } 
        
        private void Socket_OnWrite( object sender, System.EventArgs e ) 
        { 
            int nWrite = 0; 
            
            // 
            //  The Write event fires whenever data can be written
            //  to the socket. This event will fire immediately after
            //  the Connect event, which indicates that the socket is
            //  writable. If the socket's output buffer becomes full,
            //  the Write function will return -1, at which point we
            //  must stop writing until another Write event fires.
            // 
            while ( m_nBytesOut < m_nBufferTotal ) 
            { 
                nWrite = Socket.Write( m_strBuffer, m_nBufferSize ); 
                if ( nWrite == -1 ) 
                    break;
                else 
                { 
                    m_nBytesOut = m_nBytesOut + nWrite; 
                    if ( m_nBytesOut >= m_nBufferTotal )
                        break;
                } 
            } 
            
            Timer.Enabled = true; 
        } 
        
        private void Timer_Tick( object sender, System.EventArgs e ) 
        { 
            Timer.Enabled = false; 
            Socket.Disconnect(); 
            labelStatus.Text = m_nBytesOut + " bytes sent, " + m_nBytesIn + " bytes received"; 
            MessageBox.Show("The timeout period has elapsed", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            cmdAction.Enabled = true; 
        } 
    } 
} 
